SystemOrganization addCategory: #'NewCompiler-Syntax'!
SystemOrganization addCategory: #'NewCompiler-Bytecodes'!
SystemOrganization addCategory: #'NewCompiler-IR'!
SystemOrganization addCategory: #'NewCompiler-Semantics'!
SystemOrganization addCategory: #'NewCompiler-Extras'!
SystemOrganization addCategory: #'NewCompiler-Tests'!
SystemOrganization addCategory: #'NewCompiler-Standalone'!
SystemOrganization addCategory: #'NewCompiler-Hacks'!
SystemOrganization addCategory: #'NewCompiler-NodesExt'!

!RBAssignmentNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/7/2009 13:10'!
analyseTempsWithin: scopeBlock "<BlockNode>"  rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"
	"N.B.  since assigment happens _after_ the value is evaluated the value is sent the message _first_."
	value analyseTempsWithin: scopeBlock rootNode: rootNode assignmentPools: assignmentPools.
	variable beingAssignedToAnalyseTempsWithin: scopeBlock rootNode: rootNode assignmentPools: assignmentPools! !

!RBAssignmentNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	^self variable firstToken! !

!RBAssignmentNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	^self value lastToken! !

!RBAssignmentNode methodsFor: '*newcompiler' stamp: 'ms 7/3/2007 21:06'!
isClosureEnvironmentCreation

	^self value isMessage 
		ifTrue: [self value isClosureEnvironmentCreation]
		ifFalse: [false]! !

!RBAssignmentNode methodsFor: '*newcompiler' stamp: 'ms 7/30/2007 13:52'!
isTempClosureRegistration

	^variable binding isCaptured
		and:[value isVariable]
		and:[value binding = variable binding sourceTemp]! !

!RBPragmaNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/11/2010 16:47'!
primitive
	| args aPrimitiveNode module name spec|
	args :=  (self arguments
			collect: [ :each | each value ]) asArray.

	((self isPrimitive) and: [ args first isString ])
		ifTrue: [name := args at: 1.
				 module := args at: 2 ifAbsent: [ nil ].
     		spec := (Array 
						with: (module ifNotNil: [ module asSymbol ])
						with: name asSymbol
						with: 0 with: 0).
				^PrimitiveNode new
							num: 117;
							spec: spec;
							yourself]
		ifFalse: [^PrimitiveNode null].
	^PrimitiveNode null	
	! !

!RBCascadeNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/11/2009 19:29'!
analyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>" 
	messages do: [:each | each analyseTempsWithin: scopeBlock rootNode: rootNode assignmentPools: assignmentPools ]! !

!RBCascadeNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	^self messages first firstToken! !

!RBCascadeNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	^self messages last lastToken! !

!RBArrayNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/22/2009 11:21'!
analyseTempsWithin: scopeBlock "<BlockNode>"  rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"

	statements do: [:each | each analyseTempsWithin: scopeBlock rootNode: rootNode assignmentPools: assignmentPools ]! !

!RBArrayNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken

	self statements 
		ifEmpty:[^nil] 
		ifNotEmpty:[| stat | 
		     		stat := self statements copy.
			 		[stat first firstToken = nil] 
							whileTrue: [stat removeFirst.
										stat ifEmpty:[^nil]].
					^stat first firstToken]! !

!RBArrayNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken

	self statements 
		ifEmpty:[^nil] 
		ifNotEmpty:[ | stat | 
				      stat := OrderedCollection newFrom: self statements.
					 [stat last lastToken = nil] 
							whileTrue: [stat removeLast.
										stat ifEmpty:[^nil]].
					^stat last lastToken]! !

!CompiledMethod methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/25/2009 13:44'!
ast
	"Return the node for self"
	
	^ self parseTree! !

!CompiledMethod methodsFor: '*newcompiler' stamp: 'ajh 3/2/2003 13:51'!
ir

	^ BytecodeDecompiler new decompile: self! !

!CompiledMethod methodsFor: '*newcompiler' stamp: 'JB 3/25/2010 13:21'!
primitiveNode

	| primNode n |
	primNode := PrimitiveNode new num: (n := self primitive).
	(n = 117 or: [n = 120]) ifTrue: [
		primNode spec: (self literalAt: 1)].
	^ primNode! !

Compiler subclass: #ClosureCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Standalone'!

!ClosureCompiler class methodsFor: 'accessing' stamp: 'marcusdenker 9/29/2009 10:10'!
parserClass
	^Parser2
		! !

!ClosureCompiler methodsFor: 'public access' stamp: 'md 8/18/2008 10:08'!
compile: textOrStream in: aClass classified: aCategory notifying: aRequestor ifFail: failBlock 
	"Answer a MethodNode for the argument, textOrStream. If the 
	MethodNode can not be created, notify the argument, aRequestor; if 
	aRequestor is nil, evaluate failBlock instead. The MethodNode is the root 
	of a parse tree. It can be told to generate a CompiledMethod to be 
	installed in the method dictionary of the argument, aClass."
	
	| methodNode |
	self from: textOrStream
		class: aClass
		classified: aCategory 
		context: nil
		notifying: aRequestor.
	methodNode := self translate: sourceStream noPattern: false ifFail: failBlock.
	^methodNode.
! !

!ClosureCompiler methodsFor: 'public access' stamp: 'pmm 2/2/2007 18:07'!
evaluate: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock
	"Compiles the sourceStream into a parse tree, then generates code into a 
	method. This method is then installed in the receiver's class so that it 
	can be invoked. In other words, if receiver is not nil, then the text can 
	refer to instance variables of that receiver (the Inspector uses this). If 
	aContext is not nil, the text can refer to temporaries in that context (the 
	Debugger uses this). If aRequestor is not nil, then it will receive a 
	notify:at: message before the attempt to evaluate is aborted. Finally, the 
	compiled method is invoked from here as DoIt or (in the case of 
	evaluation in aContext) DoItIn:. The method is subsequently removed 
	from the class, but this will not get done if the invocation causes an 
	error which is terminated. Such garbage can be removed by executing: 
	Smalltalk allBehaviorsDo: [:cl | cl removeSelector: #DoIt; removeSelector: 
	#DoItIn:]."

	
		^ self evaluate2: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock! !

!ClosureCompiler methodsFor: 'private' stamp: 'JorgeRessia 12/21/2009 13:54'!
translate: aStream noPattern: noPattern ifFail: failBlock
	|aMethodNode|
	aMethodNode := RBParser
     parseMethod: aStream contents
     onError: [ :msg :pos | self error: msg ].
	[aMethodNode verifyIn: class] on: SemanticWarning do: [:ex | ex correctIn: requestor].
	^aMethodNode ! !

!Compiler class methodsFor: '*newcompiler-override' stamp: 'md 11/11/2007 15:09'!
closureDecompilerClass
	^Decompiler2! !

!Compiler class methodsFor: '*newcompiler-override' stamp: 'md 3/5/2006 17:03'!
closureParserClass
	^Parser2! !

!Compiler class methodsFor: '*newcompiler' stamp: 'md 2/27/2006 16:32'!
initialize

	Preferences
		addPreference: #compileUseNewCompiler
		category: #compiler
		default: false
		balloonHelp: 'If true, the new compiler is used for compiling methods. Only newly compiled methods will be affected by this preference.'
! !

!Compiler methodsFor: '*newcompiler' stamp: 'md 7/24/2007 14:49'!
compileDoIt: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock log: log
	"Compiles the sourceStream into a parse tree, then generates code into a method.  This method is then wrapped in a block with the receiver or context as the sole free variable which the method refers to.  If requestor is not nil, then it will receive a notify:at: message if there is a compile error, followed by the failBlock being executed."

	| scope parser blockNode method source |
	source := textOrStream readStream.
	scope := aContext
		ifNotNil: [aContext doItScope]
		ifNil: [receiver class parseScope instanceScope].
	parser := Parser2 new.
	blockNode := parser
			parse: source
			class: scope
			noPattern: true
			notifying: aRequestor
			ifFail: [^ failBlock value].
	method := blockNode generate.
	method selector: #DoIt.
		
	log ifTrue: [
		method putSource: source contents
			fromParseNode: blockNode
			inFile: 2 
			withPreamble: [:file | file cr]].

	^ BlockClosure new
		env: (aContext ifNil: [receiver]);
		method: method;
		yourself! !

!Compiler methodsFor: '*newcompiler' stamp: 'ms 1/7/2007 01:58'!
evaluate2: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock logged: logFlag

	^ (self compileDoIt: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: [^ failBlock value] log: logFlag) value! !

!Compiler methodsFor: '*newcompiler' stamp: 'MarcusDenker 3/29/2010 13:24'!
parse: textOrStream
	^self parse: textOrStream in: nil notifying: nil! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:02'!
actualScope
	"Answer the actual scope for the receiver.  If this is an unoptimized block then it is its
	 actual scope, but if this is an optimized block then the actual scope is some outer block."
	^self actualScopeIfOptimized ifNil: [self]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:31'!
actualScopeIfOptimized
	^self propertyAt: #actualScopeIfOptimized ifAbsent: [nil]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 4/9/2010 16:13'!
addHoistedTemps: additionalTemporaries "<SequenceableCollection>"
	additionalTemporaries do:
		[:temp|
		temp definingScope ifNil:
			[temp definingScope: self]].
	body temporaries: ((body temporaries isNil or: [body temporaries isEmpty])
					ifTrue: [additionalTemporaries copy]
					ifFalse:
						[body temporaries last isIndirectTempVector
							ifTrue: [body temporaries allButLast, additionalTemporaries, { body temporaries last }]
							ifFalse: [body temporaries, additionalTemporaries]])! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:37'!
addLocalsToPool: locals "<Set of: TempVariableNode>"
	self localsPool isNil ifTrue:
		[self localsPool: IdentitySet new].
	self localsPool addAll: locals! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'TestRunner 1/10/2010 10:29'!
addRemoteTemp: aTempVariableNode rootNode: rootNode "<MethodNode>" 
	"Add aTempVariableNode to my actualScope's sequence of
	 remote temps.  If I am an optimized block then the actual
	 scope is my actualScopeIfOptimized, otherwise it is myself."
	body temporaries isArray ifTrue:
		[body temporaries: body temporaries asOrderedCollection].
	self flag: 'here if the remoteTempNode is nil then this is another temp that has to be indexed inside the temp array'.
	self remoteTempNode isNil 
		ifTrue: [self remoteTempNode: (RBRemoteVectorNode new
								name: self remoteTempNodeName
								index: arguments size + body temporaries size
								scope: 0).
		self remoteTempNode rootNode: self.
		self actualScopeIfOptimized
			ifNil:
				[body temporaries addLast: self remoteTempNode.
				 "remoteTempNode definingScope: self"]
			ifNotNil: [self actualScopeIfOptimized addHoistedTemps: { self remoteTempNode }]].
	self remoteTempNode addRemoteTemp: aTempVariableNode.
	"use remove:ifAbsent: because the deferred analysis for optimized
	 loops can result in the temp has already been hoised into the root."
	body temporaries remove: aTempVariableNode ifAbsent: [].
	^self remoteTempNode! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 17:59'!
analyseArguments: methodArguments temporaries: methodTemporaries rootNode: rootNode "<MethodNode>" "^<Sequence of: <TempVarNade>>"
	"Top level entry-point for analysing temps within the hierarchy of blocks in the receiver's method.
	 Answer the (possibly modified) sequence of temp vars.
	 Need to hoist temps out of macro-optimized blocks into their actual blocks.
	 Need to note reads and writes to temps from blocks other than their actual blocks to determine
	 whether blocks can be local (simple slots within a block/method context) or remote (slots in
	 indirection vectors that are shared between contexts by sharing indirection vectors).

	 The algorithm is based on numbering temporary reads and writes and block extents.
	 The index used for numbering starts at zero and is incremented on every block entry
	 and block exit.  So the following
		| a b blk r1 r2 t |
		a := 1. b := 2. t := 0.
		blk := [ | s | s := a + b. t := t + s].
		r1 := blk value.
		b := -100.
		r2 := blk value.
		r1 -> r2 -> t
	is numbered as
		method block 0 to: 6:
		| a b blk r1 r2 t |
		a w@1 := 1. b w@1 := 2. t w@1 := 0.
		blk w@5 := [entry@2 | s |
					 t  w@3 := t r@3 + a r@3 + b r@3
					] exit@4.
		r1 w@5 := blk r@5 value.
		b w@5 := nil.
		r2 w@5 := blk r@5 value.
		r1 r@5 -> r2 r@5 -> t r@5
	So:
		b and blk cannot be copied because for both there exists a write @5 that follows a
			read @4 within block 2 through 4
		t must be remote because there exists a write @3 within block (2 to: 4)
	Complications are introduced by optimized blocks.  In the following temp is written to
	after it is closed over by [ temp ] since the inlined block is executed more than once.
		| temp coll |
		coll := OrderedCollection new.
		1 to: 5 do: [ :index | 
			temp := index. 
			coll add: [ temp ] ].
		self assert: (coll collect: [:ea| ea value]) asArray = #(5 5 5 5 5)
	In the following i is local to the block and must be initialized each time around the loop
	but if the block is inlined it must be declared at method level.
		| col |
		col := OrderedCollection new.
		1 to: 3 do: [ :each | | i | i := each. col add: [ i ]. i := i + 1 ].
		self assert: (col collect: [ :each | each value ]) asArray = #(2 3 4)" 
	self assert: (arguments isEmpty or: [arguments hasEqualElements: methodArguments]).
	arguments := methodArguments asArray. "won't change"
	self assert: (body temporaries isNil or: [body temporaries isEmpty or: [body temporaries hasEqualElements: methodTemporaries]]).
	body temporaries: ( OrderedCollection withAll: methodTemporaries ).

	"self assert: optimized not." "the top-level block should not be optimized."
	self flag: 'the definition of the scopes has to be executed like this because the RBVariableNodes are not unique and thus problems
	may arise with the naming of the temps when later the closure analysis is performed. Until we have a better solution we solve it this way.'.
	self setDefiningScopeForVariableNodes.
	self analyseTempsWithin: self rootNode: rootNode assignmentPools: Dictionary new.

	"The top-level block needs to reindex temporaries since analysis may have rearranged them.
	 This happens when temps are made remote and/or a remote node is added."
	
	self flag: 'I do not know what this is for'.
	"body temporaries withIndexDo:
	[:temp :offsetPlusOne| temp isIndirectTempVector 
										ifTrue: [temp index: arguments size + offsetPlusOne - 1]
										ifFalse: [(scope lookupVar: temp name) index: arguments size + offsetPlusOne - 1]]."

	"Answer the (possibly modified) sequence of temps."
	^body temporaries asArray! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/25/2009 19:12'!
analyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>" 
	| effectiveScope blockStart |

	effectiveScope := self optimized
						ifTrue: [self actualScopeIfOptimized: scopeBlock]
						ifFalse: [self].

	"arguments ifNotNil:
		[arguments do: [:temp| temp definingScope: self]].
	body temporaries ifNotNil:
		[body temporaries do: [:temp| temp definingScope: self]]."
	
	
	self optimized ifFalse: "if optimized this isn't an actual scope"
		[rootNode noteBlockEntry:
			[:entryNumber|
			 self blockExtent: ( (blockStart := entryNumber) to: 0 )]].

	"Need to enumerate a copy because closure analysis can add a statement
	 via ifHasRemoteTempNodeEnsureInitializationStatementExists:."
	body statements copy do:
		[:statement|
		 statement analyseTempsWithin: effectiveScope rootNode: rootNode assignmentPools: assignmentPools].
	self optimized ifFalse: "if optimized this isn't an actual scope"
		[rootNode noteBlockExit:
			[:exitNumber|
			 self blockExtent: (blockStart to: exitNumber)]].

	"Now that the analysis is done move any temps that need to be moved."
	self postNumberingProcessTempsWithin: effectiveScope rootNode: rootNode.

	"This is simply a nicety for compiler developers..."
	body temporaries do:
		[:temp|
		(temp isIndirectTempVector and: [temp name includes: $?]) ifTrue:
			[temp name: temp definingScope remoteTempNodeName]]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'ms 6/17/2007 16:21'!
asBlock

	^ (RBBlockNode
		arguments: self arguments
		body: body)
		scope: self scope;
		privIR: self ir
		! !

!RBMethodNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	^self selectorParts first! !

!RBMethodNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	^self body lastToken ifNil:[^(RBPatternMethodNode selectorParts: self selectorParts arguments: self arguments) lastToken]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:04'!
blockExtent "^<Interval>"
	^self propertyAt: #blockExtent ifAbsent: [nil]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/25/2009 19:08'!
blockExtent: anInterval
	^self propertyAt: #blockExtent put: anInterval! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'ajh 6/28/2004 13:52'!
compiledMethod

	^ self ir compiledMethod! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 18:16'!
definingScopeSetter
	^self propertyAt: #definingScopeSetter: ifAbsent: [nil]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 18:15'!
definingScopeSetter: anASTDefiningScopeSetter
	^self propertyAt: #definingScopeSetter: put: anASTDefiningScopeSetter! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:34'!
ensureClosureAnalysisDone

	self blockExtent ifNil: 
		[	body temporaries ifNil: [body temporaries: OrderedCollection new].
			self optimized: false.
			body temporaries: ( self analyseArguments: arguments temporaries: body temporaries rootNode: self )]! !

!RBMethodNode methodsFor: '*newcompiler-semantics' stamp: 'ajh 7/8/2004 20:56'!
freeNames
	"Filter out hidden ones that have space in there name such as 'top env'"

	^ ((self freeVars collect: [:var | var name])
		reject: [:name | name includes: $ ]) asSortedCollection! !

!RBMethodNode methodsFor: '*newcompiler-semantics' stamp: 'md 4/13/2007 15:09'!
freeVars
	"Return children variable node bindings that refer to variables outside my scope (ignoring global vars)"

	| freeVars |
	freeVars := Set new.
	self scope: self owningScope.
	self nodesDo: [:node | | var |
		(node isVariable or: [node isReturn and: [node binding notNil]]) ifTrue: [
			var := node binding.
			(self scope hasOuter: var scope) ifTrue: [
				var isGlobal ifFalse: [
					freeVars add: var]]]].
	^ freeVars! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'md 2/21/2006 14:42'!
generate
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."

	^self generate: #(0 0 0 0)! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'ajh 3/10/2003 20:21'!
generate: trailer

	^ self generateIR compiledMethodWith: trailer! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jb 3/31/2010 16:51'!
generateIR
	VariableNodeData resetData.
	self identifyBlocksUniquely.
	self ensureClosureAnalysisDone.
	self updateScopesWithRemoteTemps.
	self ir: (ASTTranslator new
			visitNode: self;
			ir).
	^self ir! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'pmm 8/16/2006 21:34'!
generateWith: trailer using: aCompiledMethodClass

	^ self generateIR compiledMethodWith: trailer using: aCompiledMethodClass! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/3/2010 09:03'!
identifyBlocksUniquely
	ASTBlocksUniqueIdentifier new for: self! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:19'!
ifHasRemoteTempNodeEnsureInitializationStatementExists: rootNode
	"If a remoteTempNode has been added ensure a statement exists to initialize it."
	self flag: 'this is quite strange - analyze'.
	self remoteTempNode ~~ nil ifTrue: 
		[(body statements notEmpty
		  and: [body statements first isAssignment
		  and: [body statements first variable isTemp
		  and: [body statements first variable isIndirectTempVector]]])
			ifTrue: "If this is a decompiled tree, or if a temporary has been added later in
					the analysis then there already is a temp vector initialization node."
				[(body statements first variable ~~ self remoteTempNode) ifTrue:
					[body statements first variable become: self remoteTempNode].
				 body statements first value numElements: self remoteTempNode remoteTemps size]
			ifFalse:
				[body statements addFirst: (self remoteTempNode nodeToInitialize)]].! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:30'!
ir

	^ self propertyAt: #ir ifAbsent: [self generateIR].! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 19:05'!
ir: aIRMethodNode

	^ self propertyAt: #ir put: aIRMethodNode.! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 22:19'!
isChildOf: aNode
	^false! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'TestRunner 12/27/2009 11:28'!
isInsideOptimizedBlock
	^false! !

!RBMethodNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
lastTokenOfPatternMethod
	
	^self arguments ifEmpty: [^self selectorParts last] ifNotEmpty: [ ^self arguments last token]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/21/2009 16:36'!
localsPool
	^self propertyAt: #localsPool ifAbsentPut: [IdentitySet new]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:44'!
locationCounter
	^ self propertyAt: #locationCounter ifAbsent: [nil].! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:21'!
locationCounter: anInteger
	self propertyAt: #locationCounter put: anInteger! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/4/2009 13:19'!
noteBlockEntry: aBlock 
	"Evaluate aBlock with the numbering for the block entry."
	self locationCounter isNil ifTrue:
		[self locationCounter: -1].
	aBlock value: (self locationCounter + 1).
	self locationCounter: (self locationCounter + 2)! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/4/2009 13:19'!
noteBlockExit: aBlock
	"Evaluate aBlock with the numbering for the block exit."
	aBlock value: (self locationCounter + 1).
	self locationCounter: (self locationCounter + 2)! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 12:27'!
optimized
	^self propertyAt: #optimized ifAbsent: [ ^false ]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:20'!
optimized: aBoolean

	self propertyAt: #optimized put: aBoolean.! !

!RBMethodNode methodsFor: '*newcompiler-semantics' stamp: 'ajh 6/30/2004 14:07'!
owningBlock

	^ self! !

!RBMethodNode methodsFor: '*newcompiler-semantics' stamp: 'md 4/8/2007 17:58'!
owningScope

	^ self scope! !

!RBMethodNode methodsFor: '*newcompiler-decorating' stamp: 'ms 5/28/2007 11:47'!
peekAfterComment

	| tokenStream token countNewLine |
	self afterComment ifNil:[
		countNewLine := 0.
		self afterComment: OrderedCollection new.
		tokenStream := (SqueakTokenStream forwardOn: self lastTokenOfPatternMethod) selectCommentNewLine.
		[tokenStream atEnd 
			ifFalse: [
				token := tokenStream next.
				token isNewLine 
				ifTrue: [countNewLine := countNewLine + 1.]. 
		 		(countNewLine = 2)]
			ifTrue:[true]] 
				whileFalse: [token isComment ifTrue:[self afterComment add: token eatToken]].
		self afterComment do: [:each | self comments add: (each start to: each stop)]
	].
	^self afterComment
	
	! !

!RBMethodNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/4/2007 17:41'!
peekBeforeComment
	| tokenStream token |
	self beforeComment ifNil: 
			[
			self beforeComment: OrderedCollection new.
			tokenStream := (SqueakTokenStream backwardOn: self firstToken) 
						selectCommentNewLine.
			[token := tokenStream next.
			token isNil] 
					whileFalse: 
						[token isComment ifTrue: [self beforeComment add: token eatToken]].
			self beforeComment do: [:each | self comments add: (each start to: each stop)]].
	^ self beforeComment! !

!RBMethodNode methodsFor: '*newcompiler-decorating' stamp: 'ms 5/28/2007 12:02'!
peekInsideComment
	
	| tokenStream token |
	self insideComment ifNil:[
		self insideComment: OrderedCollection new.
		tokenStream := (SqueakTokenStream forwardOn: self firstToken).
		[tokenStream atEnd 
			ifFalse:[
				token := tokenStream next.
				false]
			ifTrue:[true]]
				whileFalse: [(token isComment and:[token notEaten]) 
								ifTrue:[self insideComment add: token eatToken]].
		self insideComment do: [:each | self comments add: (each start to: each stop)]
	].
	^self insideComment! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/21/2009 16:37'!
postNumberingProcessTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>"
	"A temp can be local (and copied) if it is not written to after it is captured.
	 A temp cannot be local if it is written to remotely.
	 Need to enumerate a copy of the temporaries because any temps becoming remote
	 will be removed from temporaries in analyseClosure: (and a single remote temp node
	 will get added)"
	body temporaries copy do:
		[:each|
		each isIndirectTempVector ifFalse:
			[each analyseClosure: rootNode]].

	"If this is an optimized node we need to hoist temporaries up into the relevant block scope."
	self optimized ifTrue:
		[self optimizedBlockHoistTempsInto: scopeBlock].

	"Now we may have added a remoteTempNode.  So we need a statement to initialize it."
	"self ifHasRemoteTempNodeEnsureInitializationStatementExists: rootNode."

	"Now add all arguments and locals to the pool so that copiedValues can be computed during sizing."
	rootNode
		addLocalsToPool: arguments;
		addLocalsToPool: body temporaries! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/11/2010 16:47'!
primitiveNode
	^self propertyAt: #primitiveNode ifAbsentPut: [PrimitiveNode null]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/11/2010 17:38'!
primitiveNode: aPrimitiveNode
	| primitiveNode |
	primitiveNode := self primitiveNode.
      (primitiveNode isNil
              or: [ primitiveNode num = 0 ]
              or: [ primitiveNode num = aPrimitiveNode num ])
                      ifTrue: [ self propertyAt: #primitiveNode put: aPrimitiveNode ]
                      ifFalse: [ self notify: 'Ambigous primitives' ]
! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:15'!
privIR: irMethod

	irMethod ifNil: [^self removeProperty: #ir ifAbsent: []].
	self propertyAt: #ir put: irMethod.! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 18:55'!
properties
	^self propertyAt: #methodProperties ifAbsentPut: [MethodProperties  new]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 18:56'!
properties: aMethodeProperties 
	^self propertyAt: #methodProperties put: aMethodeProperties! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:34'!
referencedValuesWithinBlockExtent: anInterval 
	^(self localsPool select:
		[:temp| 
		 temp isReferencedWithinBlockExtent: anInterval]) collect:
			[:temp|
			temp isRemote ifTrue: [temp remoteNode] ifFalse: [temp]]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:32'!
remoteTempNode
	^ self propertyAt: #remoteTempNode ifAbsent: [nil].! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:33'!
remoteTempNode: aRemoteTempNode
	^self propertyAt: #remoteTempNode put: aRemoteTempNode! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:35'!
remoteTempNodeName 
	"Answer a useful name for a RemoteTempVectorNode in the receiver."
	| prefix scope extent |
	prefix := self actualScopeIfOptimized ifNil: ['<'] ifNotNil: [ '<...'].
	scope := self.
	[extent := self blockExtent.
	 extent == nil
	 and: [scope actualScope ~~ scope]] whileTrue:
		[scope := scope actualScope].
	^extent
		ifNil: [prefix, '?-?>']
		ifNotNil:
			[prefix, extent first printString, '-',
				(extent last isZero
					ifTrue: ['?']
					ifFalse: [extent last printString]), '>']! !

!RBMethodNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/22/2009 10:29'!
scope
	|scope |
	scope := self propertyAt: #scope ifAbsent: [nil].
	^ scope ifNil: [
		self verifyIn: nil parseScope.
		self propertyAt: #scope.
	  ]! !

!RBMethodNode methodsFor: '*newcompiler-semantics' stamp: 'JorgeRessia 11/24/2009 18:48'!
scope: aSemMethodScope

	self propertyAt: #scope put: aSemMethodScope.! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 4/9/2010 16:06'!
setDefiningScopeForVariableNodes

	self definingScopeSetter: ASTDefiningScopeSetter new.
	ASTDefiningScopeSetter new setVariableNodesIn: self.
	! !

!RBMethodNode methodsFor: '*newcompiler-debugging' stamp: 'ms 11/22/2007 00:20'!
sourceMap
	"Return a mapping from bytecode pcs to source code ranges"
	source ifNil: [
		"No source, use decompile string as source to map from"
		^(self class parserClass new
			parse: self decompileString
			class: self scope classEncoding) sourceMap	
	].
	^ self ir sourceMap asSortedCollection! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'md 2/27/2006 17:50'!
sourceText: aText
	self flag: #fixme! !

!RBMethodNode methodsFor: '*newcompiler-debugging' stamp: 'ajh 6/29/2004 16:06'!
tempNames
	"All temp names in context order"

	^ self scope tempVars allButFirst "without self" collect: [:var | var name]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/3/2010 09:01'!
uniqueIdentifier
	^self propertyAt: #uniqueIdentifier ifAbsent: [nil]! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/3/2010 09:00'!
uniqueIdentifier: anInteger
	^self propertyAt: #uniqueIdentifier put: anInteger! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/13/2009 20:12'!
updateScopesWithRemoteTemps
	ASTClosureScopeReindexer new reindexTempsIn: self! !

!RBMethodNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/11/2009 14:56'!
verifyIn: classOrScope
	"Look up vars in classOrScope.  My tree will be annotated with bindings to LexicalScopes and ScopeVars."

	ASTChecker new
		scope: classOrScope parseScope;
		visitNode: self.
		
	"Preferences compileBlocksAsClosures ifFalse: [ 
		NonClosureScopeFixer new visitNode: self.
	]"! !

RBProgramNode subclass: #RBDoItNode
	instanceVariableNames: 'body source scope ir byteSurgeon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBDoItNode class methodsFor: 'instance creation' stamp: 'ajh 3/11/2003 19:08'!
body: aSequenceNode

	^ self new body: aSequenceNode! !

!RBDoItNode methodsFor: 'comparing' stamp: 'lr 10/18/2009 16:03'!
= anObject 
	self == anObject ifTrue: [ ^ true ].
	self class = anObject class ifFalse: [ ^ false ].
	self body = anObject body ifFalse: [ ^ false ].
	^ true! !

!RBDoItNode methodsFor: 'visitor' stamp: 'ajh 2/26/2003 18:31'!
acceptVisitor: aProgramNodeVisitor 
	^aProgramNodeVisitor acceptDoItNode: self! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
addNode: aNode 
	^body addNode: aNode! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
addReturn
	body addReturn! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
addSelfReturn
	^body addSelfReturn! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ms 7/3/2007 13:39'!
arguments

	^#()! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
body
	^body! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
body: stmtsNode 
	body := stmtsNode.
	body parent: self! !

!RBDoItNode methodsFor: 'accessing' stamp: 'md 6/29/2005 12:21'!
byteSurgeon
	byteSurgeon ifNil: [byteSurgeon := false].
	^byteSurgeon! !

!RBDoItNode methodsFor: 'accessing' stamp: 'md 6/29/2005 12:20'!
byteSurgeon: boolean
	byteSurgeon := boolean.! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:28'!
children
	^ {self body}! !

!RBDoItNode methodsFor: '*newcompiler' stamp: 'ajh 6/28/2004 13:52'!
compiledMethod

	^ self ir compiledMethod! !

!RBDoItNode methodsFor: 'matching' stamp: 'ajh 2/26/2003 18:24'!
copyInContext: aDictionary 
	^(self class new)
		body: (body copyInContext: aDictionary);
		source: (aDictionary at: '-source-');
		yourself! !

!RBDoItNode methodsFor: 'comparing' stamp: 'ajh 2/26/2003 18:35'!
equalTo: anObject withMapping: aDictionary 
	self class = anObject class ifFalse: [^false].
	(self body equalTo: anObject body withMapping: aDictionary) 
		ifFalse: [^false].
	^self primitiveSources = anObject primitiveSources! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:56'!
freeNames
	"Filter out hidden ones that have space in there name such as 'top env'"

	^ ((self freeVars collect: [:var | var name])
		reject: [:name | name includes: $ ]) asSortedCollection! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 7/8/2004 20:59'!
freeVars
	"Return children variable node bindings that refer to variables outside my scope (ignoring global vars)"

	| freeVars |
	freeVars := Set new.
	scope := self owningScope.
	self nodesDo: [:node | | var |
		(node isVariable or: [node isReturn and: [node binding notNil]]) ifTrue: [
			var := node binding.
			(scope hasOuter: var scope) ifTrue: [
				var isGlobal ifFalse: [
					freeVars add: var]]]].
	^ freeVars! !

!RBDoItNode methodsFor: '*newcompiler' stamp: 'md 2/21/2006 14:41'!
generate
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."

	^self generate: #(0 0 0 0)! !

!RBDoItNode methodsFor: '*newcompiler' stamp: 'ajh 3/10/2003 20:23'!
generate: trailer

	^ self generateIR compiledMethodWith: trailer! !

!RBDoItNode methodsFor: '*newcompiler' stamp: 'ms 11/21/2007 22:57'!
generateIR

	^ ir := ASTTranslator new
		visitNode: self;
		ir! !

!RBDoItNode methodsFor: '*newcompiler' stamp: 'pmm 8/16/2006 21:34'!
generateWith: trailer using: aCompiledMethodClass

	^ self generateIR compiledMethodWith: trailer using: aCompiledMethodClass! !

!RBDoItNode methodsFor: 'comparing' stamp: 'ajh 2/26/2003 18:36'!
hash
	^ self body hash! !

!RBDoItNode methodsFor: '*newcompiler' stamp: 'ajh 3/10/2003 20:25'!
ir

	^ ir ifNil: [self generateIR]! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 6/29/2004 14:11'!
isDoIt

	^ true! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 2/26/2003 18:22'!
isLast: aNode 
	^body isLast: aNode! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 2/26/2003 18:22'!
lastIsReturn
	^body lastIsReturn! !

!RBDoItNode methodsFor: 'matching' stamp: 'ajh 2/26/2003 18:28'!
match: aNode inContext: aDictionary 
	self class == aNode class ifFalse: [^false].
	aDictionary at: '-source-' put: aNode source.
	^ body match: aNode body inContext: aDictionary! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 6/30/2004 14:07'!
owningBlock

	^ self! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 3/13/2003 04:25'!
owningScope

	^ scope! !

!RBDoItNode methodsFor: 'copying' stamp: 'lr 10/18/2009 15:40'!
postCopy
	super postCopy.
	self body: self body copy! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
primitiveSources
	^self tags 
		collect: [:each | self source copyFrom: each first to: each last]! !

!RBDoItNode methodsFor: 'printing' stamp: 'ajh 2/26/2003 18:22'!
printOn: aStream
	aStream nextPutAll: self formattedCode! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 2/26/2003 18:22'!
references: aVariableName 
	^body references: aVariableName! !

!RBDoItNode methodsFor: 'replacing' stamp: 'ajh 2/26/2003 18:57'!
replaceNode: aNode withNode: anotherNode
	aNode == body ifTrue: [self body: anotherNode].
! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 3/16/2003 08:33'!
scope

	^ scope ifNil: [
		self verifyIn: nil parseScope.
		scope
	  ]! !

!RBDoItNode methodsFor: 'semantics' stamp: 'ajh 3/17/2003 15:34'!
scope: aSemScope

	scope := aSemScope! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
source
	^source! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
source: anObject
	source := anObject! !

!RBDoItNode methodsFor: 'debugging' stamp: 'ms 11/22/2007 00:20'!
sourceMap
	"Return a mapping from bytecode pcs to source code ranges"

	^ self ir sourceMap 	asSortedCollection! !

!RBDoItNode methodsFor: 'printing' stamp: 'ajh 6/29/2004 14:31'!
sourceText

	^ (self source ifNil: [self formattedCode]) asText! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
start
	^1! !

!RBDoItNode methodsFor: 'accessing' stamp: 'ajh 2/26/2003 18:22'!
stop
	^source size! !

!RBDoItNode methodsFor: 'accessing' stamp: 'jorgeRessia 11/22/2009 10:14'!
tags
	^ self propertyAt: #tags ifAbsent: [#()].
! !

!RBDoItNode methodsFor: 'accessing' stamp: 'jorgeRessia 11/22/2009 10:15'!
tags: aCollectionOfIntervals 
	aCollectionOfIntervals ifNil: [^self removeProperty: #tags ifAbsent: []].
	self propertyAt: #tags put: aCollectionOfIntervals.! !

!RBDoItNode methodsFor: 'debugging' stamp: 'ajh 6/29/2004 16:06'!
tempNames
	"All temp names in context order"

	^ self scope tempVars allButFirst "without receiver" collect: [:var | var name]! !

!RBDoItNode methodsFor: 'testing' stamp: 'ajh 2/26/2003 18:22'!
uses: aNode 
	^body == aNode and: [aNode lastIsReturn]! !

!RBDoItNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/11/2009 14:56'!
verifyIn: classOrScope
	"Look up vars in classOrScope.  My tree will be annotated with bindings to LexicalScopes and ScopeVars."

	ASTChecker new
		scope: classOrScope parseScope;
		visitNode: self.
		
	"Preferences compileBlocksAsClosures ifFalse: [ 
		NonClosureScopeFixer new visitNode: self.
	]"
	! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'ms 10/27/2006 14:38'!
addComment
	"add comment on the tree"

	ASTCommenter new
		visitNode: self! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/6/2007 19:55'!
afterComment
	^ self propertyAt: #afterComment ifAbsent: [nil]! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/6/2007 19:56'!
afterComment: aString
	aString ifNil: [^self removeProperty: #afterComment ifAbsent: []].
	self propertyAt: #afterComment put: aString.! !

!RBProgramNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken

	^self subclassResponsibility! !

!RBProgramNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken

	^self subclassResponsibility! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/6/2007 19:57'!
beforeComment
	^ self propertyAt: #beforeComment ifAbsent: [nil]! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/6/2007 19:58'!
beforeComment: anOrderedCollection
	anOrderedCollection ifNil: [^self removeProperty: #beforeComment ifAbsent: []].
	self propertyAt: #beforeComment put: anOrderedCollection.! !

!RBProgramNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
debugHighlightStart

	^ self start! !

!RBProgramNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
debugHighlightStop

	^ self stop! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
decompileString

	^ self formattedCode! !

!RBProgramNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/27/2009 10:43'!
enclosingBlock
	|enclosingBlock|
	enclosingBlock := self parent.
	enclosingBlock ifNil: [^self].
	[ enclosingBlock isMethod or: [enclosingBlock isBlock ]] whileFalse: [ enclosingBlock := enclosingBlock parent].
	^enclosingBlock! !

!RBProgramNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
firstToken

	^self propertyAt: #firstToken ifAbsent: [self basicFirstToken].! !

!RBProgramNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
firstToken: aToken

	self propertyAt: #firstToken put: aToken.! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/6/2007 19:58'!
insideComment
	^ self propertyAt: #insideComment ifAbsent: [nil]! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/6/2007 19:58'!
insideComment: aCollection
	aCollection ifNil: [^self removeProperty: #insideComment ifAbsent: []].
	self propertyAt: #insideComment put: aCollection.! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isCaseBranch

	^ false! !

!RBProgramNode methodsFor: '*newcompiler' stamp: 'ms 7/27/2007 20:49'!
isClosureEnvironmentCreation

	^false! !

!RBProgramNode methodsFor: '*newcompiler' stamp: 'ms 7/3/2007 21:14'!
isClosureEnvironmentRegistration

	^false! !

!RBProgramNode methodsFor: '*newcompiler' stamp: 'ms 7/27/2007 20:50'!
isClosureRegistrationAndCreation

	^false! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isDup

	^ false! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isGoto

	^ false! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isIf

	^ false! !

!RBProgramNode methodsFor: '*newcompiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInline

	^ false! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isLabel

	^ false! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isPop

	^ false! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isPseudo

	^ false! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isPseudoSend

	^ false! !

!RBProgramNode methodsFor: '*newcompiler' stamp: 'ms 7/29/2007 02:40'!
isSelfClosureRegistration

	^false! !

!RBProgramNode methodsFor: '*newcompiler-decompiling' stamp: 'jorgeRessia 11/20/2009 16:40'!
isSend

	^ false! !

!RBProgramNode methodsFor: '*newcompiler-testing' stamp: 'jorgeRessia 11/20/2009 16:40'!
isTemp

	^false! !

!RBProgramNode methodsFor: '*newcompiler' stamp: 'ms 7/30/2007 13:46'!
isTempClosureRegistration

	^false! !

!RBProgramNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
lastToken

	^self propertyAt: #lastToken ifAbsent: [self basicLastToken].! !

!RBProgramNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
lastToken: aToken

	self propertyAt: #lastToken put: aToken.! !

!RBProgramNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
owningBlock

	^ parent owningBlock! !

!RBProgramNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
owningScope

	^ parent owningScope! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'ms 5/28/2007 11:35'!
peekAfterComment
	
	| tokenStream token |
	self afterComment ifNil:[
		self afterComment: OrderedCollection new.
		tokenStream := (SqueakTokenStream forwardOn: self lastToken next).
		[tokenStream atEnd 
			ifFalse: [
				token := tokenStream next.
				token isNewLine or: [token isSignificant] or:[token isEaten]]
			ifTrue:[true]]
				whileFalse: [
					token isComment ifTrue:[self afterComment add: token eatToken.] 
					].
		self afterComment do: [:each | self comments add: (each start to: each stop)]
	].
	^self afterComment! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'ms 5/10/2007 11:42'!
peekAfterCommentUntil: aToken
	
	| tokenStream token |
	self afterComment ifNil:[
		self afterComment: OrderedCollection new.
		tokenStream := (SqueakTokenStream forwardOn: self lastToken) selectCommentNewLine.
		[token := tokenStream next.
		 aToken = token or:[tokenStream atEnd or:[token isNewLine]]] 
				whileFalse: [self afterComment add: token eatToken].
		self afterComment do: [:each | self comments add: (each start to: each stop)]
	].
	^self afterComment! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'ms 5/28/2007 14:04'!
peekBeforeComment
	| tokenStream token countNewLine |
	self beforeComment ifNil: 
			[countNewLine := 0.
			self beforeComment: OrderedCollection new.
			tokenStream := (SqueakTokenStream backwardOn: self firstToken) selectCommentNewLineWithPipe.
			[tokenStream atEnd 
				ifFalse:[ 
					token := tokenStream next.
					token isNewLine ifTrue: [countNewLine := countNewLine + 1].
					(countNewLine > 0 and: [token value = '|']) or: (token isSignificant) or: [tokenStream atEnd]]
				ifTrue:[true]] 
					whileFalse: 
						[token isComment ifTrue: [self beforeComment add: token eatToken]].
			self beforeComment do: [:each | self comments add: (each start to: each stop)]].
	^ self beforeComment! !

!RBProgramNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/4/2007 17:43'!
peekInsideComment
	
	| tokenStream token |
	self insideComment ifNil:[
		self insideComment: OrderedCollection new.
		tokenStream := (SqueakTokenStream forwardOn: self firstToken).
		[token := tokenStream next.
		 token = self lastToken or:[tokenStream atEnd]]
				whileFalse: [(token isComment and:[token notEaten]) 
								ifTrue:[self insideComment add: token eatToken]].
		self insideComment do: [:each | self comments add: (each start to: each stop)]
	].
	^self insideComment! !

!RBProgramNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/9/2009 16:49'!
rootNode
	|rootNode|
	rootNode := self parent.
	rootNode ifNil: [^self].
	[ rootNode isMethod ] whileFalse: [ rootNode := rootNode parent].
	^rootNode! !

RBProgramNode subclass: #RBPseudoNode
	instanceVariableNames: 'mapInstr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBPseudoNode commentStamp: 'ajh 6/27/2004 15:13' prior: 0!
Used by IRDecompiler to represent intermediate nodes that eventually get reduced to real parse nodes.!

RBPseudoNode subclass: #RBPseudoBlockNode
	instanceVariableNames: 'block successor arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBPseudoBlockNode methodsFor: 'accessing' stamp: 'md 11/17/2004 12:20'!
arguments
	^arguments! !

!RBPseudoBlockNode methodsFor: 'accessing' stamp: 'md 11/17/2004 12:20'!
arguments: aCollection
	arguments := aCollection! !

!RBPseudoBlockNode methodsFor: 'accessing' stamp: 'md 10/21/2004 14:58'!
block
	^ block.! !

!RBPseudoBlockNode methodsFor: 'accessing' stamp: 'md 10/21/2004 14:59'!
block: aSeqNum
	block := aSeqNum.! !

!RBPseudoBlockNode methodsFor: 'testing' stamp: 'md 10/21/2004 15:01'!
isBlock
	^true.! !

!RBPseudoBlockNode methodsFor: 'accessing' stamp: 'md 10/21/2004 14:59'!
successor
	^successor.! !

!RBPseudoBlockNode methodsFor: 'accessing' stamp: 'md 10/21/2004 14:59'!
successor: aSeqNum
	successor := aSeqNum.! !

RBPseudoNode subclass: #RBPseudoDupNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBPseudoDupNode methodsFor: 'testing' stamp: 'ajh 3/2/2003 23:24'!
isDup

	^ true! !

RBPseudoNode subclass: #RBPseudoGotoNode
	instanceVariableNames: 'destination forValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBPseudoGotoNode methodsFor: 'accessing' stamp: 'ajh 3/3/2003 21:20'!
destination

	^ destination! !

!RBPseudoGotoNode methodsFor: 'accessing' stamp: 'ajh 3/9/2003 13:44'!
destination: seqNum

	destination := seqNum! !

!RBPseudoGotoNode methodsFor: 'as yet unclassified' stamp: 'ajh 3/20/2003 01:16'!
forValue
	"true if sequence before me is for value, false if for effect"

	^ forValue and: [self isRet not]! !

!RBPseudoGotoNode methodsFor: 'accessing' stamp: 'ajh 3/4/2003 22:18'!
forValue: boolean
	"true if sequence before me is for value, false if for effect"

	forValue := boolean! !

!RBPseudoGotoNode methodsFor: 'testing' stamp: 'ajh 3/2/2003 23:23'!
isGoto

	^ true! !

!RBPseudoGotoNode methodsFor: 'testing' stamp: 'ajh 3/20/2003 19:05'!
isRet
	"is return"

	^ self destination = #return! !

RBPseudoNode subclass: #RBPseudoIfNode
	instanceVariableNames: 'boolean destination otherwise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBPseudoIfNode methodsFor: 'accessing' stamp: 'ajh 3/3/2003 21:20'!
boolean

	^ boolean! !

!RBPseudoIfNode methodsFor: 'accessing' stamp: 'ajh 3/1/2003 23:08'!
boolean: bool

	boolean := bool! !

!RBPseudoIfNode methodsFor: 'accessing' stamp: 'ajh 3/3/2003 21:20'!
destination

	^ destination! !

!RBPseudoIfNode methodsFor: 'accessing' stamp: 'ajh 3/9/2003 13:45'!
destination: seqNum

	destination := seqNum! !

!RBPseudoIfNode methodsFor: 'testing' stamp: 'ajh 3/1/2003 20:13'!
isIf

	^ true! !

!RBPseudoIfNode methodsFor: 'accessing' stamp: 'ajh 3/3/2003 21:20'!
otherwise

	^ otherwise! !

!RBPseudoIfNode methodsFor: 'accessing' stamp: 'ajh 3/2/2003 23:19'!
otherwise: instructionSequence

	otherwise := instructionSequence! !

RBPseudoNode subclass: #RBPseudoLabelNode
	instanceVariableNames: 'destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBPseudoLabelNode methodsFor: 'accessing' stamp: 'ajh 3/3/2003 21:21'!
destination

	^ destination! !

!RBPseudoLabelNode methodsFor: 'accessing' stamp: 'ajh 3/9/2003 13:45'!
destination: seqNum

	destination := seqNum! !

!RBPseudoLabelNode methodsFor: 'testing' stamp: 'ajh 3/2/2003 23:23'!
isLabel

	^ true! !

!RBPseudoNode methodsFor: 'visitor' stamp: 'ajh 3/17/2003 00:25'!
acceptVisitor: aProgramNodeVisitor
	^ aProgramNodeVisitor acceptPseudoNode: self! !

!RBPseudoNode methodsFor: 'testing' stamp: 'md 10/21/2004 15:01'!
isBlock
	^false.! !

!RBPseudoNode methodsFor: 'testing' stamp: 'ajh 3/3/2003 18:41'!
isPseudo

	^ true! !

!RBPseudoNode methodsFor: 'accessing' stamp: 'ajh 3/20/2003 17:20'!
mapInstr

	^ mapInstr! !

!RBPseudoNode methodsFor: 'accessing' stamp: 'ajh 3/20/2003 17:19'!
mapInstr: irInstr

	mapInstr := irInstr! !

RBPseudoNode subclass: #RBPseudoPopNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBPseudoPopNode methodsFor: 'testing' stamp: 'ajh 3/2/2003 23:23'!
isPop

	^ true! !

RBPseudoNode subclass: #RBPseudoSendNode
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!RBPseudoSendNode methodsFor: 'accessing' stamp: 'md 11/15/2004 18:07'!
arguments
	^arguments! !

!RBPseudoSendNode methodsFor: 'accessing' stamp: 'md 11/15/2004 18:07'!
arguments: aCollection
	arguments:= aCollection.! !

!RBPseudoSendNode methodsFor: 'testing' stamp: 'ajh 3/23/2003 22:23'!
isPseudoSend

	^ true! !

!RBPseudoSendNode methodsFor: 'testing' stamp: 'ms 7/12/2007 13:20'!
isSend

	^ true! !

!RBPseudoSendNode methodsFor: 'accessing' stamp: 'ajh 3/23/2003 22:23'!
selector

	^ selector! !

!RBPseudoSendNode methodsFor: 'accessing' stamp: 'ajh 3/23/2003 22:23'!
selector: aSelector

	selector := aSelector! !

TestCase subclass: #ASTCheckAssignmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!ASTCheckAssignmentTest methodsFor: 'tests' stamp: 'JB 3/25/2010 13:05'!
testIsAssagning

	| rbMethod |
	rbMethod := RBParser parseMethod: 'foo | b | b:= 3'.
	self assert: (ASTCheckAssignment check: rbMethod assagnmentTo: rbMethod body temporaries first).
	rbMethod := RBParser parseMethod: 'foo | b | [b:= 3]'.
	self assert: (ASTCheckAssignment check: rbMethod assagnmentTo: rbMethod body temporaries first)! !

TestCase subclass: #BytecodeDecompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!BytecodeDecompilerTest methodsFor: 'examples' stamp: 'md 2/24/2005 15:04'!
exampleWhileTrue
	"Override the superclass for performance reasons."
	| index firstIndex lastIndex aBlock array |
	index := firstIndex.  
	[index <= lastIndex]
		whileTrue:
			[aBlock value: (array at: index).
			index := index + 1]! !

!BytecodeDecompilerTest methodsFor: 'tests' stamp: 'md 2/24/2005 15:20'!
testDecompilerOrderedCollectionDo
	| cm decompiledIR  |
	cm := OrderedCollection>>#do:.

	decompiledIR := BytecodeDecompiler new decompile: cm.

	self shouldnt: [decompiledIR compiledMethodWith: #(0)] raise: Error.! !

!BytecodeDecompilerTest methodsFor: 'tests' stamp: 'md 2/24/2005 15:26'!
testWhileTrue
	| cm decompiledIR aCompiledMethod |
	cm := (self class)>>#testWhileTrue.

	decompiledIR := BytecodeDecompiler new decompile: cm.
	
	self shouldnt: [aCompiledMethod := decompiledIR compiledMethodWith: #(0)] raise: Error.! !

TestCase subclass: #BytecodeGeneratorTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'md 3/7/2008 19:30'!
testExample
	| cm |
	
	cm := BytecodeGenerator new
		numArgs: 1;
		pushInstVar: 2;
		pushTemp: 1;
		send: #>;
		if: false goto: #else;
		pushLiteral: 'yes';
		returnTop;
		label: #else;
		pushLiteral: 'no';
		returnTop;
		compiledMethod.

	a := 2.
	self assert: (cm isKindOf: CompiledMethod).
	self assert: (cm valueWithReceiver: self arguments: #(1)) = 'yes' .
	self assert: (cm valueWithReceiver: self arguments: #(3)) = 'no' .	
	^cm
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'JB 3/25/2010 13:27'!
testGoTo
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		goto: #return;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 16:55'!
testPopTop
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		popTop;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <87> pop
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 13:45'!
testPushClosureCopyNumCopiedValuesNumArgsJumpSize
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushClosureCopyNumCopiedValues: 1 numArgs: 1 jumpSize: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isKindOf: CompiledMethod).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <8F 11 00 01> closureNumCopied: 1 numArgs: 1 bytes 17 to 17
17 	<7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 14:02'!
testPushClosureCopyNumCopiedValuesNumArgsJumpSizeOutOfRange

	self should: [ BytecodeGenerator new
					numArgs: 0;
					pushClosureCopyNumCopiedValues: 1 numArgs: 1 jumpSize: 65536 ] 
		raise: Error 
		withExceptionDo: [:exception | self assert: (exception messageText = 'block size jumpSize out of range 0-65535')]
! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 14:03'!
testPushClosureCopyNumCopiedValuesNumArgsOutOfRangeJumpSize

	self should: [ BytecodeGenerator new
					numArgs: 0;
					pushClosureCopyNumCopiedValues: 1 numArgs: 16 jumpSize: 1 ] 
		raise: Error 
		withExceptionDo: [:exception | self assert: (exception messageText = 'num args out of range 0-15')]
! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 14:03'!
testPushClosureCopyNumCopiedValuesOutOfRangeNumArgsJumpSize

	self should: [ BytecodeGenerator new
					numArgs: 0;
					pushClosureCopyNumCopiedValues: 16 numArgs: 1 jumpSize: 1 ] 
		raise: Error 
		withExceptionDo: [:exception | self assert: (exception messageText = 'num copied out of range 0-15')]
! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 10:53'!
testPushConsArray
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushConsArray: 1;
		returnTop;
		compiledMethod.

	a := 2.
	self assert: (cm isKindOf: CompiledMethod).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <8A 81> pop 1 into (Array new: 1)
15 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:07'!
testPushDup
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushDup;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <88> dup
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:09'!
testPushInstVar
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushInstVar: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <00> pushRcvr: 0
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:12'!
testPushLiteral
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushLiteral: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <76> pushConstant: 1
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:19'!
testPushLiteralVariable
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushLiteralVariable: (LookupKey key: '1');
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '17 <40> pushLit: 1
18 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 11:40'!
testPushNewArray
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushNewArray: 1;
		returnTop;
		compiledMethod.

	a := 2.
	self assert: (cm isKindOf: CompiledMethod).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <8A 01> push: (Array new: 1)
15 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:20'!
testPushReceiver
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushReceiver;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <70> self
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 11:43'!
testPushRemoteTempInVectorAt
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushRemoteTemp: 1 inVectorAt: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isKindOf: CompiledMethod).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <8C 01 01> pushTemp: 1 inVectorAt: 1
16 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 12:12'!
testPushRemoteTempInVectorAtOutOfRange
	| cm stream |
	
	self should: [ BytecodeGenerator new
					numArgs: 0;
					pushRemoteTemp: 1 inVectorAt: 257 ] 
		raise: Error 
		withExceptionDo: [:exception | self assert: (exception messageText = 'tempVectorIndex is out of range 0 to 255')]
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 12:11'!
testPushRemoteTempOutOfRangeInVectorAt
	| cm stream |
	
	self should: [ BytecodeGenerator new
					numArgs: 0;
					pushRemoteTemp: 257 inVectorAt: 1 ] 
		raise: Error 
		withExceptionDo: [:exception | self assert: (exception messageText = 'remoteTempIndex is out of range 0 to 255')]
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:21'!
testPushTemp
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushTemp: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <10> pushTemp: 0
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:23'!
testPushThisContext
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		pushThisContext ;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <89> pushThisContext: 
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:25'!
testRemoteReturn
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		remoteReturn;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '17 <E0> send: privRemoteReturnTo:
18 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:26'!
testReturnConstant
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		returnConstant: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = 'Quick return 1'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:29'!
testReturnInstVar
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		returnInstVar: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = 'Quick return field 0 (0-based)'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:30'!
testReturnReceiver
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		returnReceiver;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = 'Quick return self'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:30'!
testReturnTop
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:31'!
testSend
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		send: #a;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '17 <D0> send: a
18 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:32'!
testSendToSuperOf
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		send: #a toSuperOf: Object;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '17 <85 00> superSend: a
19 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:33'!
testStoreInstVar
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		storeInstVar: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <81 00> storeIntoRcvr: 0
15 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:36'!
testStoreIntoLiteralVariable
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		storeIntoLiteralVariable: (LookupKey key: '1');
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '17 <81 C0> storeIntoLit: 1
19 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 11:29'!
testStorePopInstVar
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		storePopInstVar: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <60> popIntoRcvr: 0
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:40'!
testStorePopIntoLiteralVariable
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		storePopIntoLiteralVariable: (LookupKey key: '1');
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '17 <82 C0> popIntoLit: 1
19 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:41'!
testStorePopTemp
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		storePopTemp: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <68> popIntoTemp: 0
14 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 12:13'!
testStoreRemoteTempInVectorAt
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		storeRemoteTemp: 1 inVectorAt: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isKindOf: CompiledMethod).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <8D 01 01> storeIntoTemp: 1 inVectorAt: 1
16 <7C> returnTop
'
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 12:15'!
testStoreRemoteTempInVectorAtOutOfRange
	| cm stream |
	
	self should: [ BytecodeGenerator new
					numArgs: 0;
					storeRemoteTemp: 1 inVectorAt: 257 ] 
		raise: Error 
		withExceptionDo: [:exception | self assert: (exception messageText = 'tempVectorIndex out of range 0 to 255')]
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/29/2009 12:16'!
testStoreRemoteTempOutOfRangeInVectorAt
	| cm stream |
	
	self should: [ BytecodeGenerator new
					numArgs: 0;
					storeRemoteTemp: 257 inVectorAt: 1 ] 
		raise: Error 
		withExceptionDo: [:exception | self assert: (exception messageText = 'remoteTempIndex out of range 0 to 255')]
	! !

!BytecodeGeneratorTest methodsFor: 'tests' stamp: 'jre 9/9/2009 17:42'!
testStoreTemp
	| cm stream |
	
	cm := BytecodeGenerator new
		numArgs: 0;
		storeTemp: 1;
		returnTop;
		compiledMethod.

	self assert: (cm isCompiledMethod ).
	stream := String streamContents: [:str | cm longPrintOn: str ].
	self assert: stream asString = '13 <81 40> storeIntoTemp: 0
15 <7C> returnTop
'
	! !

TestCase subclass: #ClosureCompilerTest2
	instanceVariableNames: 'iVar'
	classVariableNames: 'Test'
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!ClosureCompilerTest2 class methodsFor: 'as yet unclassified' stamp: 'md 10/19/2004 12:24'!
Test
	^Test! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 21:04'!
exampleAndAnd1
	^1 = 1 and: [ 2 = 2 ] and: [ 3 = 3 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 20:57'!
exampleAndAnd2
	^1 = 1 and: [ 2 = 2 ] and: [ 2 = 3 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 20:58'!
exampleAndAnd3
	^1 = 2 and: [ 2 = 2 ] and: [ 3 = 3 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 20:59'!
exampleAndAnd4
	^1 = 1 and: [ 2 = 3 ] and: [ 3 = 3 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 20:58'!
exampleAndAnd5
	^1 = 2 and: [ 2 = 3 ] and: [ 3 = 4 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/24/2006 20:17'!
exampleAndAnd6
	^1 = 2 and: [ 2 = 3 ] and: [ 3 = 4 ] and: [ 1 / 0 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 11:15'!
exampleBlockExternal
	| t |
	t := 1.
	^[t] value.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 15:39'!
exampleBlockExternal2
	| t1 t2 |
	t1 :=  t2 := 1.
	^[t1 + t2] value.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 15:38'!
exampleBlockExternalArg
	| t  |
	t := 1.
	^[:a | t + a] value: 1.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 15:40'!
exampleBlockExternalNested
	| t s |
	t := s := 1.
	^[[s] value +   t   ] value.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'ms 7/31/2007 00:30'!
exampleBlockInternal
	
	^[ | t | t := 1. t] value! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/19/2006 13:30'!
exampleIfNotNilDo
	^1 even ifNotNilDo: [ :arg | arg not ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/19/2006 13:32'!
exampleIfNotNilDoReturnNil
	^nil ifNotNilDo: [ :arg | arg not ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'marcusdenker 9/29/2009 09:50'!
exampleIfNotNilReturnNil
	^nil ifNotNil: [ :arg | arg not ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 21:00'!
exampleOrOr1
	^1 = 1 or: [ 2 = 2 ] or: [ 3 = 3 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 21:00'!
exampleOrOr2
	^1 = 1 or: [ 2 = 2 ] or: [ 2 = 3 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 21:00'!
exampleOrOr3
	^1 = 2 or: [ 2 = 2 ] or: [ 3 = 3 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 21:00'!
exampleOrOr4
	^1 = 1 or: [ 2 = 3 ] or: [ 3 = 3 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/20/2006 21:00'!
exampleOrOr5
	^1 = 2 or: [ 2 = 3 ] or: [ 3 = 4 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'pmm 7/24/2006 20:17'!
exampleOrOr6
	^1 = 2 or: [ 2 = 3 ] or: [ 3 = 4 ] or: [ 4 = 4 ] or: [ 1 / 0 ]! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/14/2004 17:45'!
exampleReturn1
	^1! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 09:21'!
exampleSimpleBlock
	^[1].! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 11:08'!
exampleSimpleBlockArgument1
	^[:a | a ] value: 1.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 11:09'!
exampleSimpleBlockArgument2
	^[:a :b | a + b ] value: 1 value: 1.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 11:09'!
exampleSimpleBlockArgument3
	^[:a :b :c | a + b + c ] value: 1 value: 1 value: 1.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 11:09'!
exampleSimpleBlockArgument4
	^[:a :b :c :d | a + b + c  + d] value: 1 value: 1 value: 1 value: 1. ! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/15/2004 11:11'!
exampleSimpleBlockArgument5
	^[:a :b :c :d :e| a + b + c  + d + e] valueWithArguments: #(1 1 1 1 1). ! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 11/11/2004 14:22'!
exampleSimpleBlockLocal
	^[ :each | | t |  t:= each. t   ] value: 5.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 11/11/2004 14:42'!
exampleSimpleBlockLocalIf
	^true ifTrue: [ | hallo |  hallo := 1 . hallo].! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 11/11/2004 14:56'!
exampleSimpleBlockLocalIfNested
	^true ifTrue: [| hallo |  [  hallo := 1 . hallo] value] .! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 11/11/2004 15:47'!
exampleSimpleBlockLocalWhile
	|a|
	a := true.
	^[: b | [a] whileTrue: [ | hallo |  a := false. hallo := 1 . hallo]]value: 1.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 11/11/2004 17:37'!
exampleSimpleBlockNested
	| a match dict | 

	a  := #(a b c d).
	dict := Dictionary new.


	a doWithIndex: [:each :index |
		(match := a indexOf: each) > 0 ifTrue:
			[dict at: index put: (a at: match)]].

	^ dict.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/16/2004 21:26'!
exampleSimpleBlockiVar
	^[iVar] value.! !

!ClosureCompilerTest2 methodsFor: 'examples' stamp: 'md 10/16/2004 20:20'!
exampleiVar
	iVar := 1.
	^iVar.! !

!ClosureCompilerTest2 methodsFor: 'running' stamp: 'md 10/16/2004 21:28'!
setUp
	iVar := 1.! !

!ClosureCompilerTest2 methodsFor: 'tests' stamp: 'pmm 7/24/2006 20:18'!
testAndAnd

	self assert: self exampleAndAnd1.
	self deny: self exampleAndAnd2.
	self deny: self exampleAndAnd3.
	self deny: self exampleAndAnd4.
	self deny: self exampleAndAnd5.
	self shouldnt: [ self exampleAndAnd6 ] raise: ZeroDivide! !

!ClosureCompilerTest2 methodsFor: 'tests - bugs' stamp: 'marcus.denker 10/6/2008 10:11'!
testBackJump

	| src ast method |
	src :=  JPEGReadWriter  sourceCodeAt: #idctBlockInt:qt:.
	
	ast := ClosureCompiler new parse: src in: JPEGReadWriter notifying: nil.

	method := ast ir compiledMethod.! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:15'!
testBlockExternal

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleBlockExternal.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.
	self assert: (method valueWithReceiver: self arguments: #()) = 1.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:15'!
testBlockExternal2

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleBlockExternal2.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.
	self assert: (method valueWithReceiver: self arguments: #()) = 2.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:16'!
testBlockExternalArg

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleBlockExternalArg.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.
	self assert: (method valueWithReceiver: self arguments: #()) = 2.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:16'!
testBlockExternalNested

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleBlockExternalNested.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.
	self assert: (method valueWithReceiver: self arguments: #()) = 2.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:16'!
testBlockInternal

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleBlockInternal.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.
	self assert: (method valueWithReceiver: self arguments: #()) = 1.
! !

!ClosureCompilerTest2 methodsFor: 'tests - bugs' stamp: 'marcus.denker 10/6/2008 10:16'!
testClassVar

	| src ast method |
	src :=  Float class sourceCodeAt: #nan.
	
	ast := ClosureCompiler new parse: src in: Float class notifying: nil.


	self shouldnt: [ method := ast ir compiledMethod] raise: Error.
	self assert: (method valueWithReceiver: nil arguments: #()) isNaN.! !

!ClosureCompilerTest2 methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:16'!
testCompile

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleReturn1.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.
	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: nil arguments: #()) = 1.! !

!ClosureCompilerTest2 methodsFor: 'tests' stamp: 'pmm 7/19/2006 13:31'!
testIfNotNilDo

	self assert: self exampleIfNotNilDo! !

!ClosureCompilerTest2 methodsFor: 'tests' stamp: 'pmm 7/19/2006 13:33'!
testIfNotNilDoReturnNil

	self assert: self exampleIfNotNilDoReturnNil isNil! !

!ClosureCompilerTest2 methodsFor: 'tests' stamp: 'pmm 7/19/2006 13:33'!
testIfNotNilReturnNil

	self assert: self exampleIfNotNilReturnNil isNil! !

!ClosureCompilerTest2 methodsFor: 'tests - bugs' stamp: 'marcus.denker 10/6/2008 10:16'!
testMinusEndOfLine
	| src  |

	src :=  'test ^#-'.

	self shouldnt: [ ClosureCompiler new parse: src in: self class notifying: nil] raise: Error.
	! !

!ClosureCompilerTest2 methodsFor: 'tests' stamp: 'pmm 7/24/2006 20:19'!
testOrOr

	self assert: self exampleOrOr1.
	self assert: self exampleOrOr2.
	self assert: self exampleOrOr3.
	self assert: self exampleOrOr4.
	self deny: self exampleOrOr5.
	self shouldnt: [ self exampleOrOr6 ] raise: ZeroDivide! !

!ClosureCompilerTest2 methodsFor: 'tests - bugs' stamp: 'marcus.denker 10/6/2008 10:16'!
testParseSymbolColon
	| src  |

	src :=  'test ^#:'.
	self shouldnt: [Compiler new parse: src in: self class notifying: nil] raise: Error.
	self shouldnt: [ClosureCompiler new parse: src in: self class notifying: nil] raise: Error.
	! !

!ClosureCompilerTest2 methodsFor: 'tests - bugs' stamp: 'marcus.denker 10/6/2008 10:16'!
testScannExponent
	| src  |

	src :=  'test ^1.0e-14'.
	self shouldnt: [Compiler new parse: src in: self class notifying: nil] raise: Error.
	self shouldnt: [ClosureCompiler new parse: src in: self class notifying: nil] raise: Error.
	! !

!ClosureCompilerTest2 methodsFor: 'tests - bugs' stamp: 'marcus.denker 10/6/2008 10:16'!
testScannExponent2
	| src  |

	src :=  'test ^#(2r1e26 2r111e26)'.
	self shouldnt: [Compiler new parse: src in: self class notifying: nil] raise: Error.
	self shouldnt: [ClosureCompiler new parse: src in: self class notifying: nil] raise: Error.
	! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 6/9/2009 16:29'!
testSimpleBloccNested

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockNested.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.
	self assert: (method valueWithReceiver: self arguments: #()) = ClosureCompilerTest2 new exampleSimpleBlockNested.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:16'!
testSimpleBlock

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlock.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) value = 1.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:16'!
testSimpleBlockArgument1

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockArgument1.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = 1.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:16'!
testSimpleBlockArgument2

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockArgument2.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = 2.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:17'!
testSimpleBlockArgument3

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockArgument3.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = 3.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:17'!
testSimpleBlockArgument4

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockArgument4.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = 4.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:17'!
testSimpleBlockArgument5

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockArgument5.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = 5.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:17'!
testSimpleBlockLocal

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockLocal.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = 5.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:17'!
testSimpleBlockLocalIf

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockLocalIf.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = 1.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'jre 9/29/2009 14:45'!
testSimpleBlockLocalIfNested

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockLocalIfNested.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.
	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = 1.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:19'!
testSimpleBlockLocalWhile

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockLocalWhile.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.

	self assert: (method valueWithReceiver: self arguments: #()) = nil.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:19'!
testSimpleBlockiVar

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleSimpleBlockiVar.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.
	self assert: (method valueWithReceiver: self arguments: #()) = 1.
! !

!ClosureCompilerTest2 methodsFor: 'testing - oldBlocks' stamp: 'marcus.denker 10/6/2008 10:19'!
testSimpleiVar

	| src ast ir method |

	src :=  self class sourceCodeAt: #exampleiVar.
	
	ast := ClosureCompiler new parse: src in: self class notifying: nil.

	ir := ast ir.
	method := ir compiledMethod.
	
	self assert: (method valueWithReceiver: self arguments: #()) = 1.
! !

TestCase subclass: #ClosureExecutionTests
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/5/2009 13:36'!
assertValues: anArray
	| values |
	values := collection collect: [ :each | each value ].
	self 
		assert: anArray asArray = values asArray
		description: 'Expected: ' , anArray asArray printString , 
			', but got ' , values asArray printString! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/5/2009 13:37'!
methodArgument: anObject
	^ [ anObject ]
	! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/5/2009 13:37'!
setUp
	super setUp.
	collection := OrderedCollection new! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 15:19'!
testBlockArgument
	| block block1 block2 |
	block := [ :arg | | temp | temp := arg. [ temp ] ].
	block1 := block value: 1.
	block2 := block value: 2.
	self assert: block1 value = 1.
	self assert: block2 value = 2! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 15:24'!
testBlockTemp
	| block block1 block2 |
	block := [ :arg | [ arg ] ].
	block1 := block value: 1.
	block2 := block value: 2.
	self assert: block1 value = 1.
	self assert: block2 value = 2! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 15:26'!
testMethodArgument
	| temp block |
	temp := 0.
	block := [ [ temp ] ].
	temp := 1.
	block := block value.
	temp := 2.
	self assert: block value = 2! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 15:26'!
testMethodTemp
	| block1 block2 |
	block1 := self methodArgument: 1.
	block2 := self methodArgument: 2.
	self assert: block1 value = 1.
	self assert: block2 value = 2! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 1/1/2010 13:11'!
testMethodWithOptimizedBlocksA
	| s c |
	s := self isNil
			ifTrue: [| a | a := 'isNil'. a]
			ifFalse: [| a | a := 'notNil'. a].
	c := String new: s size.
	1 to: s size do:
		[:i| c at: i put: (s at: i)].
	self assert: (c = 'notNil')! !

!ClosureExecutionTests methodsFor: 'scoping-test' stamp: 'JorgeRessia 12/20/2009 10:13'!
testNestedBlockScoping

	| b c z |
	b := [:a | 
			z := 2.
			z + a].
	c := [:a |
			z + a].
	^ (b value: 2) + (c value: 1)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 15:27'!
testToDoArgument
	1 to: 5 do: [ :index |
		collection add: [ index ] ].
	self assertValues: #(1 2 3 4 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 15:48'!
testToDoArgumentNotInlined
	| block |
	block := [ :index |
		collection add: [ index ] ].
	1 to: 5 do: block.
	self assertValues: #(1 2 3 4 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 16:57'!
testToDoInsideTemp
	1 to: 5 do: [ :index | 
		| temp | 
		temp := index. 
		collection add: [ temp ] ].
	self assertValues: #(1 2 3 4 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 17:00'!
testToDoInsideTempNotInlined
	| block |
	block := [ :index | 
		| temp | 
		temp := index. 
		collection add: [ temp ] ].
	1 to: 5 do: block.
	self assertValues: #(1 2 3 4 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 17:01'!
testToDoOutsideTemp
	| temp |
	1 to: 5 do: [ :index | 
		temp := index. 
		collection add: [ temp ] ].
	self assertValues: #(5 5 5 5 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 17:01'!
testToDoOutsideTempNotInlined
	| block temp |
	block := [ :index | 
		temp := index. 
		collection add: [ temp ] ].
	1 to: 5 do: block.
	self assertValues: #(5 5 5 5 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 17:49'!
testWhileModificationAfter
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [
		collection add: [ index ].
		index := index + 1 ].
	self assertValues: #(5 5 5 5 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 17:50'!
testWhileModificationAfterNotInlined
	| index block |
	index := 0.
	block := [ 
		collection add: [ index ].
		index := index + 1 ].
	[ index < 5 ] whileTrue: block.
	self assertValues: #(5 5 5 5 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 17:50'!
testWhileModificationBefore
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [ 
		index := index + 1.
		collection add: [ index ] ].
	self assertValues: #(5 5 5 5 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 17:51'!
testWhileModificationBeforeNotInlined
	| index block |
	index := 0.
	block := [ 
		index := index + 1.
		collection add: [ index ] ].
	[ index < 5 ] whileTrue: block.
	self assertValues: #(5 5 5 5 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/11/2009 17:52'!
testWhileWithTemp
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [
		| temp |
		temp := index := index + 1.
		collection add: [ temp ] ].
	self assertValues: #(1 2 3 4 5)! !

!ClosureExecutionTests methodsFor: 'utilities' stamp: 'JorgeRessia 12/10/2009 21:18'!
testWhileWithTempNotInlined
	| index block |
	index := 0.
	block := [
		| temp |
		temp := index := index + 1.
		collection add: [ temp ] ].
	[ index < 5 ] whileTrue: block.
	self assertValues: #(1 2 3 4 5)! !

TestCase subclass: #CompilationEquivalencyTest
	instanceVariableNames: 'knownHeaderFailures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!CompilationEquivalencyTest methodsFor: 'tests' stamp: 'JorgeRessia 1/7/2010 16:21'!
addWarning: aString
	self halt.
	Transcript show: aString; cr.! !

!CompilationEquivalencyTest methodsFor: 'tests' stamp: 'JorgeRessia 1/4/2010 15:52'!
assertClass: aClass
	aClass selectors asSortedCollection
		do: [ :each | self assertClass: aClass selector: each ]
		displayingProgress: aClass name! !

!CompilationEquivalencyTest methodsFor: 'tests' stamp: 'JorgeRessia 1/4/2010 16:03'!
assertClass: aClass selector: aSelector
	| metodNode sourceCode aCompiledMethod aClosureCompiledMethod anotherDecompiledMethod aDecompiledMethod|

	" skip trait methods, due to a trait bug "
	(aClass includesLocalSelector: aSelector)
		ifFalse: [ ^ self ].
		
	" skip the float class, due to a bug in CompiledMethod>>#= "
	(aClass = Float class or: [ aClass traits notEmpty ])
		ifTrue: [ ^ self ].

	aCompiledMethod := (Compiler new 
								compile: (aClass sourceCodeAt: aSelector)
								in: aClass
								classified: nil
								notifying: self
								ifFail: nil)
								generate.
	
	aClosureCompiledMethod := (ClosureCompiler new 
								compile: (aClass sourceCodeAt: aSelector)
								in: aClass
								classified: nil
								notifying: self
								ifFail: nil)
								generate.
	
	aDecompiledMethod := Decompiler new decompile: aSelector in: aClass method: aCompiledMethod.
	anotherDecompiledMethod := Decompiler new decompile: aSelector in: aClass method: aClosureCompiledMethod.
				
	self 
		assert: aDecompiledMethod asString = anotherDecompiledMethod asString
		description: aClass name , '>>#' , aSelector
		resumable: true! !

!CompilationEquivalencyTest methodsFor: 'test-headers' stamp: 'JorgeRessia 1/8/2010 15:22'!
assertHeadersFor: aClass
	(self headerSelectorsFor: aClass )
		do: [ :each | self assertHeadersFor: aClass in: each ]
		displayingProgress: aClass name! !

!CompilationEquivalencyTest methodsFor: 'test-headers' stamp: 'JorgeRessia 1/8/2010 16:56'!
assertHeadersFor: aClass in: aSelector
	| metodNode sourceCode aCompiledMethod aClosureCompiledMethod|

	" skip trait methods, due to a trait bug "
	(aClass includesLocalSelector: aSelector)
		ifFalse: [ ^ self ].
		
	" skip the float class, due to a bug in CompiledMethod>>#= "
	(aClass = Float class or: [ aClass traits notEmpty ])
		ifTrue: [ ^ self ].

	
	aCompiledMethod := (Compiler new 
								compile: (aClass sourceCodeAt: aSelector)
								in: aClass
								classified: nil
								notifying: self
								ifFail: nil)
								generate.
	(aCompiledMethod isQuick) ifTrue: [^self].
	
	aClosureCompiledMethod := (ClosureCompiler new 
								compile: (aClass sourceCodeAt: aSelector)
								in: aClass
								classified: nil
								notifying: self
								ifFail: nil)
								generate.
	(aCompiledMethod header = aClosureCompiledMethod header) ifFalse: [ 	Transcript show: (aClass name , '>>#' , aSelector); cr. ].
	"self 
		assert: aCompiledMethod header = aClosureCompiledMethod header
		description: aClass name , '>>#' , aSelector
		resumable: true"! !

!CompilationEquivalencyTest methodsFor: 'test-literals' stamp: 'JorgeRessia 1/7/2010 15:52'!
assertLiteralsFor: aClass
	aClass selectors asSortedCollection
		do: [ :each | self assertLiteralsFor: aClass in: each ]
		displayingProgress: aClass name! !

!CompilationEquivalencyTest methodsFor: 'test-literals' stamp: 'JorgeRessia 1/7/2010 15:55'!
assertLiteralsFor: aClass in: aSelector
	| metodNode sourceCode aCompiledMethod aClosureCompiledMethod|

	" skip trait methods, due to a trait bug "
	(aClass includesLocalSelector: aSelector)
		ifFalse: [ ^ self ].
		
	" skip the float class, due to a bug in CompiledMethod>>#= "
	(aClass = Float class or: [ aClass traits notEmpty ])
		ifTrue: [ ^ self ].

	aCompiledMethod := (Compiler new 
								compile: (aClass sourceCodeAt: aSelector)
								in: aClass
								classified: nil
								notifying: self
								ifFail: nil)
								generate.
	
	aClosureCompiledMethod := (ClosureCompiler new 
								compile: (aClass sourceCodeAt: aSelector)
								in: aClass
								classified: nil
								notifying: self
								ifFail: nil)
								generate.
	
	self 
		assert: aCompiledMethod allLiterals = aClosureCompiledMethod allLiterals
		description: aClass name , '>>#' , aSelector
		resumable: true! !

!CompilationEquivalencyTest methodsFor: 'tests' stamp: 'JorgeRessia 1/4/2010 15:58'!
assertTests
	"self new assertTests"
		
	(TestCase withAllSubclasses reject: [:each | each = TestCase])
		do: [ :class | self assertClass: class ]
		displayingProgress: 'Testing all tests'! !

!CompilationEquivalencyTest methodsFor: 'test-headers' stamp: 'JorgeRessia 1/8/2010 16:45'!
headerSelectorsFor: aClass 

	^aClass selectors asSortedCollection removeAll: (knownHeaderFailures at: aClass ifAbsent: [#()]); yourself.
	! !

!CompilationEquivalencyTest methodsFor: 'test-headers' stamp: 'JorgeRessia 1/8/2010 16:52'!
initializeKnownHeaderFailures

	knownHeaderFailures := Dictionary new.
	
	knownHeaderFailures at: AColorSelectorMorph put: (OrderedCollection with: #defaultFillStyle). "Push array"
	knownHeaderFailures at: ASTCheckAssignmentTest put: (OrderedCollection with: #testIsAssagning). "SqueakParser Undefined"
	knownHeaderFailures at: ASTFixDecompileBlockScope put: (OrderedCollection with: #acceptVariableNode:). "SqueakToken Undefined"

	
! !

!CompilationEquivalencyTest methodsFor: 'tests' stamp: 'JorgeRessia 1/4/2010 15:53'!
newCompilerClass

	^ClosureCompiler! !

!CompilationEquivalencyTest methodsFor: 'tests' stamp: 'JorgeRessia 1/4/2010 15:53'!
oldCompilerClass

	^Compiler! !

!CompilationEquivalencyTest methodsFor: 'tests' stamp: 'JorgeRessia 1/7/2010 16:05'!
test
	
	| aCompiledMethod aClosureCompiledMethod bytecode index codeString closureBytecode anotherDecompiledMethod aDecompiledMethod|
	codeString := 'isAbstract
	^ (Smalltalk hasClassNamed: #MczInstaller) not'.
	aCompiledMethod := (Compiler new 
									compile: codeString
									in: JorgeTest
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
	
		aClosureCompiledMethod := (ClosureCompiler new 
									compile: codeString
									in: JorgeTest
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
		aDecompiledMethod := Decompiler new decompile: #isAbstract in: JorgeTest method: aCompiledMethod.
		anotherDecompiledMethod := Decompiler new decompile: #isAbstract in: JorgeTest method: aClosureCompiledMethod.
	self assert: aDecompiledMethod asString = anotherDecompiledMethod asString! !

!CompilationEquivalencyTest methodsFor: 'test-headers' stamp: 'JorgeRessia 1/8/2010 15:26'!
testHeaders
	"self new testHeaders"
	
	self initializeKnownHeaderFailures.
	
	Smalltalk allClasses
		do: [ :class | self assertHeadersFor: class ]
		displayingProgress: 'Testing all tests'! !

!CompilationEquivalencyTest methodsFor: 'test-literals' stamp: 'JorgeRessia 1/8/2010 16:42'!
testLiterals
	"self new assertTests"
		
	"(TestCase withAllSubclasses reject: [:each | each = TestCase])
		do: [ :class | self assertLiteralsFor: class ]
		displayingProgress: 'Testing all tests'"! !

TestCase subclass: #EmitIfNilTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:19'!
testIfNilIfNotNil0Arg
	
	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new parse: 'test ^5 ifNil: [#foo] ifNotNil: [#bar]' in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new parse: 'test ^nil ifNil: [#foo] ifNotNil: [#bar]' in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) == #bar.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == #foo
! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:19'!
testIfNilIfNotNil0ArgAsVar

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new parse: 'test | block1 block2 | block1 := [#foo]. block2 := [#bar]. ^5 ifNil: block1 ifNotNil: block2' in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new parse: 'test | block1 block2 | block1 := [#foo]. block2 := [#bar]. ^nil ifNil: block1 ifNotNil: block2' in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) == #bar.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == #foo! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:19'!
testIfNilIfNotNil1Arg

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new parse: 'test ^5 ifNil: [#foo] ifNotNil: [:a | a printString]' in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new parse: 'test ^nil ifNil: [#foo] ifNotNil: [:a | a printString]' in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) = '5'.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == #foo! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:19'!
testIfNilIfNotNil1ArgAsVar

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new 
									parse: 'test | block1 block2 | block1 := [#foo]. block2 := [:a | a printString]. ^5 ifNil: block1 ifNotNil: block2' 
									in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new 
									parse: 'test | block1 block2 | block1 := [#foo]. block2 := [:a | a printString]. ^nil ifNil: block1 ifNotNil: block2' 
									in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) = '5'.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == #foo! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:20'!
testIfNotNil0Arg

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new 
									parse: 'test ^5 ifNotNil: [#foo]' 
									in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new 
									parse: 'test ^nil ifNotNil: [#foo]' 
									in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) == #foo.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == nil! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:20'!
testIfNotNil0ArgAsVar

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new 
									parse: 'test | block | block := [#foo]. ^5 ifNotNil: block' 
									in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new 
									parse: 'test | block | block := [#foo]. ^nil ifNotNil: block' 
									in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) == #foo.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == nil! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:20'!
testIfNotNil1Arg

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new 
									parse: 'test | block | block := [:a | a printString]. ^5 ifNotNil: block' 
									in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new 
									parse: 'test | block | block := [:a | a printString]. ^nil ifNotNil: block' 
									in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) = '5'.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == nil! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:12'!
testIfNotNilIfNil0Arg
	
	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new parse: 'test ^5 ifNotNil: [#bar] ifNil: [#foo]' in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new parse: 'test ^nil ifNotNil: [#bar] ifNil: [#foo]' in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) == #bar.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == #foo
! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:12'!
testIfNotNilIfNil0ArgAsVar

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new parse: 'test | block1 block2 | block1 := [#foo]. block2 := [#bar]. ^5 ifNotNil: block2 ifNil: block1' in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new parse: 'test | block1 block2 | block1 := [#foo]. block2 := [#bar]. ^nil ifNotNil: block2 ifNil: block1' in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) == #bar.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == #foo! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:12'!
testIfNotNilIfNil1Arg

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new parse: 'test ^5 ifNotNil: [:a | a printString] ifNil: [#foo]' in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new parse: 'test ^nil ifNotNil: [:a | a printString] ifNil: [#foo]' in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) = '5'.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == #foo! !

!EmitIfNilTest methodsFor: 'tests' stamp: 'marcus.denker 10/6/2008 10:12'!
testIfNotNilIfNil1ArgAsVar

	| notNilNode nilNode |
	self shouldnt: [ notNilNode := ClosureCompiler new 
									parse: 'test | block1 block2 | block1 := [#foo]. block2 := [:a | a printString]. ^5 ifNotNil: block2 ifNil: block1' 
									in: self class notifying: nil] raise: Error.
	self shouldnt: [ nilNode := ClosureCompiler new 
									parse: 'test | block1 block2 | block1 := [#foo]. block2 := [:a | a printString]. ^nil ifNotNil: block2 ifNil: block1' 
									in: self class notifying: nil] raise: Error.
	self assert: (notNilNode generate valueWithReceiver: self arguments:#()) = '5'.
	self assert: (nilNode generate valueWithReceiver: self arguments:#()) == #foo! !

TestCase subclass: #IRBuilderTest
	instanceVariableNames: ''
	classVariableNames: 'TestToPush'
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!IRBuilderTest class methodsFor: 'as yet unclassified' stamp: 'ms 7/12/2006 18:43'!
testToPush
	^TestToPush! !

!IRBuilderTest class methodsFor: 'as yet unclassified' stamp: 'ms 7/12/2006 18:43'!
testToPush: anObject

	TestToPush := anObject! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/15/2007 00:07'!
expectedFailures

	^ #()! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 7/12/2006 23:50'!
isThisEverCalled
	"Redefinition for testing the #send:toSuperOf:"
! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:37'!
testDup

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: 3;
		pushDup;
		
		send: #=;
		
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = true).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:46'!
testInstVar

	| irMethod aCompiledMethod irBuilder |
	irBuilder := IRBuilder new
		numRargs: 1;
		addTemps: #(self).		"receiver and args declarations"
	Preferences compileBlocksAsClosures ifTrue:[
		irBuilder pushReceiver].
	irBuilder
		pushInstVar: 1.
	Preferences compileBlocksAsClosures ifTrue:[
		irBuilder pushReceiver].
	irMethod := irBuilder
		pushInstVar: 2;
		send: #+;
		
		returnTop;
		ir.

	aCompiledMethod := irMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: (3@4) arguments: #() ) = 7).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:51'!
testJumpAheadTo

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushTemp: #self	;
			
		jumpAheadTo: #end;
		pushLiteral: 3;
		jumpAheadTarget: #end;	
		
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = nil).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:35'!
testJumpAheadToIf

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushTemp: #self	;
		pushLiteral: true;
		
		"jumpAhaedTo pop the first element of thz stack"
		jumpAheadTo: #end if: true;
		pushLiteral: 3;
		jumpAheadTarget: #end;	
		
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = nil).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:51'!
testJumpBackTo

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushTemp: #self	;
		pushLiteral: false;
		jumpBackTarget: #begin;
		
		"jumpAhaedTo pop the first element of the stack"
		jumpAheadTo: #end if: true;
		pushLiteral: true;
		jumpBackTo: #begin;
		jumpAheadTarget: #end;	
		
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = nil).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:35'!
testLiteralArray

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: #(test 4 you); 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = #(test 4 you)).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:36'!
testLiteralBoolean

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: true; 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = true).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:36'!
testLiteralCharacter

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: $e; 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = $e).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:37'!
testLiteralFloat

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: 2.0; 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2.0).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:37'!
testLiteralInteger

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: 2; 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:51'!
testLiteralNil

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: nil; 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: 4 arguments: #() ) = nil).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:51'!
testLiteralString

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: 'hello'; 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = 'hello').

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:52'!
testLiteralSymbole

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteral: #you; 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = #you).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:52'!
testLiteralVariableClass

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteralVariable: Object binding;	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = Object).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:52'!
testLiteralVariableClassVariable

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteralVariable: (DateAndTime bindingOf: #LocalTimeZone); 	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = DateAndTime localTimeZone).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:52'!
testLiteralVariableGlobale

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
			
		pushLiteralVariable: (Smalltalk associationAt: #Smalltalk);	
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = Smalltalk).

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 5/14/2007 23:52'!
testPopTop

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushTemp: #self	;
			
		pushLiteral: false;
		popTop;
		
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = nil).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'jorgeRessia 10/1/2009 16:30'!
testPushClosureCopyNumCopiedValuesNumArgsJumpSize

	| irBuilder |
	irBuilder := IRBuilder new
		numRargs: 1;
		pushClosureCopyNumCopiedValues: 1 numArgs: 2 jumpSize: 3;
		yourself.
		
	self assert: irBuilder currentSequence sequence size = 1.
	self assert: irBuilder currentSequence sequence first class = IRPushClosureCopy.
	self assert: irBuilder currentSequence sequence first numCopiedValues = 1.
	self assert: irBuilder currentSequence sequence first numArgs = 2.
	self assert: irBuilder currentSequence sequence first jumpSize = 3.
! !

!IRBuilderTest methodsFor: 'testing' stamp: 'jb 3/25/2010 14:33'!
testPushConsArray

	| iRMethod aCompiledMethod receiver |
	iRMethod := IRBuilder new
		numRargs: 1;
		pushConsArray: 1;
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.
	
	receiver :=  (5@8).

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
	self assert: (((aCompiledMethod valueWithReceiver: receiver arguments: #()) at:1)== receiver).
! !

!IRBuilderTest methodsFor: 'testing' stamp: 'jorgeRessia 10/1/2009 14:25'!
testPushReceiver

	| iRMethod aCompiledMethod receiver |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushReceiver;
		returnTop;
		ir.


	aCompiledMethod := iRMethod compiledMethod.
	
	receiver :=  (5@8).

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: receiver arguments: #() ) == receiver).
! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 7/12/2006 23:33'!
testPushTempArgument

	| iRMethod aCompiledMethod  |
	iRMethod := IRBuilder new
		numRargs: 3;
		addTemps: #(self a b);		"receiver and args declarations"
		pushTemp: #a;
		pushTemp: #b;
		send: #+;
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.


	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #(2 8) ) = 10).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 7/12/2006 23:33'!
testPushTempSelf

	| iRMethod aCompiledMethod |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushTemp: #self;
		send: #class;
		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.


	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) == UndefinedObject).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 7/12/2006 23:33'!
testPushTempTemp

	| iRMethod aCompiledMethod  |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self a);		"receiver and args declarations"
	
		pushTemp: #a;

		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.


	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: 5 arguments: #() ) = nil).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 7/12/2006 23:33'!
testPushThisContext

	| iRMethod aCompiledMethod  |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self a);		"receiver and args declarations"
	
		pushThisContext;
		send: #receiver;

		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.


	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: 5 arguments: #() ) = 5).
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 7/12/2006 23:41'!
testSendSuper

	| iRMethod aCompiledMethod  |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
	
		pushReceiver;
		send: #isThisEverCalled toSuperOf: IRBuilderTest;

		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.


	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self should: [(aCompiledMethod valueWithReceiver: (IRBuilderTest new) arguments: #())] raise: Halt.
	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 7/12/2006 23:34'!
testStorIntoVariable

	| iRMethod aCompiledMethod  |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
	
		pushLiteral: 4;
		storeIntoLiteralVariable: (IRBuilderTest bindingOf: #TestToPush);

		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.


	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     aCompiledMethod valueWithReceiver: nil arguments: #().
	self assert: (IRBuilderTest testToPush = 4).
	IRBuilderTest testToPush: nil.

	! !

!IRBuilderTest methodsFor: 'testing' stamp: 'ms 7/12/2006 23:48'!
testStoreTemp

	| iRMethod aCompiledMethod  |
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self a);		"receiver and args declarations"
	
		pushLiteral: 34;
		storeTemp: #a;
		popTop;
		pushTemp: #a;

		returnTop;
		ir.

	aCompiledMethod := iRMethod compiledMethod.

	self assert: (aCompiledMethod isKindOf: CompiledMethod).
     self assert: ((aCompiledMethod valueWithReceiver: nil arguments: #() ) = 34).
	! !

TestCase subclass: #IRDecompilerFromImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!IRDecompilerFromImageTest methodsFor: 'utils' stamp: 'ms 9/6/2007 01:26'!
assertDecompile: selector from: aClassName

	| originalCM ast |
	Smalltalk at: aClassName ifPresent: [:class |
		class compileAll.
		originalCM := class compiledMethodAt: selector ifAbsent:[
			self error:'Original compiled method not found in ', class name].
		ast := self decompileToAST: selector in: class.
		self assert: ast compiledMethod = originalCM]! !

!IRDecompilerFromImageTest methodsFor: 'utils' stamp: 'ms 9/6/2007 02:01'!
assertDecompile: selector fromClass: aClassName

	| originalCM ast |
	Smalltalk at: aClassName ifPresent: [:class |
		class class compileAll.
		originalCM := class class compiledMethodAt: selector ifAbsent:[
			self error:'Original compiled method not found in ', class class name].
		ast := self decompileToAST: selector in: class class.
		self assert: ast compiledMethod = originalCM]! !

!IRDecompilerFromImageTest methodsFor: 'utils' stamp: 'ms 9/6/2007 01:18'!
decompileToAST: aSelector in: aClass

	| ir ird |
	ir := (aClass compiledMethodAt: aSelector) ir.
	ird := IRDecompiler new.
	ird scope: aClass parseScope newMethodScope.
	^ird decompileIR: ir.! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/6/2007 20:46'!
testBlockClosureTestExempleClosure

	self assertDecompile: #exempleClosure from: #BlockClosureTest ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/6/2007 11:41'!
testBrowserRenameCategory

	self assertDecompile: #renameCategory from: #Browser ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/8/2007 02:50'!
testClassSharing

	self assertDecompile: #sharing: from: #Class ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/8/2007 03:01'!
testColor

	self assertDecompile: #alpha from: #Color ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/7/2007 22:09'!
testECVarTypeGuesserGetClassFromTypeSuggestingName

	self assertDecompile: #getClassFromTypeSuggestingName: fromClass: #ECVarTypeGuesser ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/8/2007 14:57'!
testFloatClassNan

	self assertDecompile: #nan fromClass: #Float ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/7/2007 19:42'!
testInstructionCompaireCompaireWith

	self assertDecompile: #compaireWith: from: #InstructionCompaire ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/6/2007 01:29'!
testIntegerDiv

	self assertDecompile: #// from: #Integer ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/8/2007 15:36'!
testMCConfigurationDepsSatisfyingVersionDoDisplayingProgress

	self assertDecompile: #depsSatisfying:versionDo:displayingProgress: from: #MCConfiguration ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/6/2007 01:30'!
testParagraphEditorSelectWord

	self assertDecompile: #selectWord from: #ParagraphEditor ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/6/2007 02:00'!
testProjectClassSweep

	self assertDecompile: #sweep: fromClass: #Project ! !

!IRDecompilerFromImageTest methodsFor: 'tests' stamp: 'ms 9/6/2007 01:30'!
testStringWithSeparatorsCompacted

	self assertDecompile: #withSeparatorsCompacted from: #String ! !

TestCase subclass: #IRDecompilerTest
	instanceVariableNames: 'ivarA ivarB'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!IRDecompilerTest commentStamp: '<historical>' prior: 0!
This class tests decompilation if IR Nodes to RB Nodes (class IRDecompiler) !

!IRDecompilerTest class methodsFor: 'tests' stamp: 'ms 7/13/2007 00:47'!
exampleClassVar

	ClassVar := 7! !

!IRDecompilerTest methodsFor: 'utils' stamp: 'marcus.denker 10/6/2008 10:12'!
assertSameCompiledMethod: aSelector

	| ir1 src ird ir2 |

	src :=  self class sourceCodeAt: aSelector.
	ir1 := (ClosureCompiler new parse: src in: self class notifying: nil) ir.
	ir2 := (ClosureCompiler new parse: src in: self class notifying: nil) ir.
	ird := IRDecompiler new.
	ird scope: self class parseScope newMethodScope.
	self assert: (ird decompileIR: ir1) compiledMethod = ir2 compiledMethod! !

!IRDecompilerTest methodsFor: 'utils' stamp: 'ms 9/6/2007 01:16'!
decompileToAST: aSelector

	| ir ird |
	ir := (self class compiledMethodAt: aSelector) ir.
	ird := IRDecompiler new.
	ird scope: self class parseScope newMethodScope.
	^ird decompileIR: ir.! !

!IRDecompilerTest methodsFor: 'utils' stamp: 'ms 7/13/2007 00:49'!
decompileToASTClass: aSelector

	| ir ird |

	
	ir := (self class class compiledMethodAt: aSelector) ir.
	ird := IRDecompiler new.
	ird scope: self class class parseScope newMethodScope.
	^ird decompileIR: ir.! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:35'!
exampleAndAndAndAndFalse
	^1 = 1 and: [ 2 = 2 ] and: [3 = 3] and: [4 = 4] and: [6 = 5]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:36'!
exampleAndAndAndAndTrue
	^1 = 1 and: [ 2 = 2 ] and: [3 = 3] and: [4 = 4] and: [5 = 5]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:35'!
exampleAndAndAndFalse
	^1 = 1 and: [ 2 = 2 ] and: [3 = 3] and: [5 = 4]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:35'!
exampleAndAndAndTrue
	^1 = 1 and: [ 2 = 2 ] and: [3 = 3] and: [4 = 4]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:37'!
exampleAndAndFalse
	^1 = 1 and: [ 2 = 2 ] and: [4 = 3]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:33'!
exampleAndAndTrue
	^1 = 1 and: [ 2 = 2 ] and: [3 = 3]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:32'!
exampleAndFalse
	^1 = 1 and: [ 3 = 2 ]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:32'!
exampleAndTrue
	^1 = 1 and: [ 2 = 2 ]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/20/2007 11:46'!
exampleArrayNode
	^{3 + 4. 7. 6 gcd: 3}! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:42'!
exampleAssignment1
	
	| a |
	a := 3.
	^a! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:43'!
exampleAssignment2
	
	| a b |
	b := a := 3.
	^a + b! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/16/2007 19:19'!
exampleBinaryMessage
	^(3 @ 4 + 3) * 7! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/15/2007 11:55'!
exampleBlockAgrument
	^[:a| | b | 
		b := 3.
		a + b].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'md 11/15/2004 16:08'!
exampleBlockParam
	^[:a| a].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/16/2007 21:31'!
exampleBlockReturn: a 
	| ttttt |
	ttttt := $d.
	[:t | ^ ttttt] value: 2! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/1/2007 20:04'!
exampleBlockSelf
	"IRDecompilerTest>>#exampleBlockSelf"
	^[self].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/30/2007 14:00'!
exampleCaptureArg: a
	
	^[:each | a + each] value: 4! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 8/8/2007 19:56'!
exampleCaptureNestedTemp
	
	| a b |
	b := 2.
	[:s | [ a := s.
	b := a + 3 + b] value] value: 2.
	^b! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 8/8/2007 00:38'!
exampleCaptureTemp
	
	| a b |
	b := 2.
	[a := 2.
	b := a + 3 + b] value.
	^b! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/20/2007 01:16'!
exampleCascade
	^OrderedCollection new add: 3; add: 4; sum! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/12/2007 13:17'!
exampleCaseOf

	3 caseOf: {
		[4] -> [3].
		[3] -> [^7]
	}.
	^4! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/12/2007 13:27'!
exampleCaseOf2

	3 caseOf: {
		[4] -> [^3].
		[3] -> [^7]
	}! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/12/2007 13:30'!
exampleCaseOf3

	3 caseOf: {
		[4] -> [^3].
		[3] -> [^7]
	} otherwise: [1]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/12/2007 13:31'!
exampleCaseOf4

	3 caseOf: {
		[4] -> [^3].
		[3] -> [^7]
	} otherwise: [^1]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/13/2007 16:59'!
exampleCaseOf5

	| a |
	5 caseOf: {
		[4] -> [^3].
		[3] -> [^7]
	} otherwise: [a := 7 + 4].
	^a! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/19/2007 11:28'!
exampleCaseOf6

	3 caseOf: {
		[4] -> [ivarA := 3].
		[3] -> [ivarA := 7]
	} otherwise: [].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/19/2007 12:36'!
exampleCaseOf7

	3 caseOf: {
		[4] -> [ivarA := 3].
		[3] -> [ivarA := 7]
	} otherwise: [].
	ivarB := 7.
	#(1 2 3) collect: [:each | each].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/13/2007 00:40'!
exampleClassVar
	ClassVar := 7! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 00:51'!
exampleDo

	| a |
	a := 0.
	#(4 3) do: [:each | a := each + a ].
	^a! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 00:53'!
exampleDo2

	| a |
	a := 0.
	#(4 3) do: [:each | [:e | a := e + a] value: each].
	^a! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 00:56'!
exampleDo3

	| a |
	a := 0.
	#(4 3 2 1) do: [:each | each >= 3 ifTrue: [a := each + a]].
	^a! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 00:57'!
exampleDo4

	| a |
	a := 3.
	#(4 3 2 1) do: [:each | each >= 3 ifTrue: [^a := each + a]]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 01:40'!
exampleDo5

	| a |
	a := 3.
	#(4 3 2 1) do: [:each | each < 4 ifFalse: [^a := each + a]]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/10/2007 18:36'!
exampleGlobalVar
	^Smalltalk allClasses size! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 11:04'!
exampleIf

	^ true ifTrue: [4 + 3].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 11:06'!
exampleIf2

	false ifFalse: [^4 + 3].
	^8! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/14/2007 20:50'!
exampleIf3

	[false ifFalse: [false ifFalse: [^7]]] value.
	^8! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/15/2007 22:55'!
exampleIfNil
	
	^nil ifNil:[7]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/19/2007 18:44'!
exampleIfNil2
	
	| a |
	a := nil ifNil:[6].
	a factorial.
	^a + 1! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/23/2007 17:08'!
exampleIfNil3
	
	
	| a |
	#(1 2 3) do: [:each | nil ifNil: [a := 7]].
	^a! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/15/2007 23:19'!
exampleIfNilIfNotNil
	
	^nil ifNil:[7] ifNotNil: [3]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/24/2007 11:57'!
exampleIfNilIfNotNil2
	
	| f |
	 f:= nil ifNil:[7] ifNotNil: [].
	^f - 1 + 1! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 11:25'!
exampleIfThen

	^ true ifTrue: [4 + 3] ifFalse: [8].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 11:29'!
exampleIfThen2

	| a |
	a := 7.
	^ true ifTrue: [a] ifFalse: [8].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 11:51'!
exampleIfThen3

	| a |
	a := (3 + 4) asInteger.
	^ (a = 7) ifTrue: [
		#(1 2  3 4) do: [:each | ivarA - each].
		a factorial] ifFalse: [#(1 2  3 4) do: [:each | ivarA - each]. 9].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 16:33'!
exampleIfThen3: g

	| a |
	a := g asInteger.
	7 asInteger = 7 
		ifTrue: [
			ivarA factorial] 
		ifFalse: [
			ivarA factorial].! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/19/2007 15:49'!
exampleIfThen4

	#(1 2 3 ) do: [:each |
		true ifTrue:[ivarA := 7]
		].
	^7! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 9/4/2007 02:01'!
exampleIfWhile

	| b |
	[false ifFalse:[true ifTrue: [b := 4 + 3. false]
		ifFalse:[false]]] whileTrue.

	^b
! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/12/2007 16:00'!
exampleKeywordMessage
	"IRDecompilerTest >>#exampleKeywordMessage"
	^((1 to: 4) collect: [:each | each * 3]) inject: 0 into: [:sum :elem | sum + elem]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 23:32'!
exampleNestedBlock1
	^ 
	[:a | 
	| b |
	b := 3.
	a value + b] 
			value: [
				[| a |
				a := 2 + 2.
				a] value]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/3/2007 15:31'!
exampleNestedBlock2
	"IRDecompilerTest >> # exampleNestedBlock2"
	^ 
	[:a | 
	| b |
	b := 3.
	a value + b] 
		value: [ | c|
			c := 2.
				[| a |
				a := 1 + c.
				[| d | 
				d := 1.
				d + a] value] value]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/26/2007 01:30'!
exampleNestedBlock3

	| b c |
	b := [:a | 2 + a].
	c := [:a | 3 + a].
	^ (b value: 1) + (c value: 1)! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/1/2007 20:36'!
exampleNestedBlock4
	"IRDecompilerTest>>#exampleNestedBlock4"
	| b c |
	b := [:a | | z |
			z := 2.
			z + a].
	c := [:a | | z |
		 	z := 3.	
			z + a].
	^ (b value: 1) + (c value: 1)! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/26/2007 01:35'!
exampleNestedBlock5

	| b c z |
	b := [:a | 
			z := 2.
			z + a].
	c := [:a |
			z + a].
	^ (b value: 2) + (c value: 1)! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/12/2007 22:44'!
exampleNestedBlock6

	ivarA := 0.
	#(4 7) do: [:each |
		[ivarA < each] whileTrue: [ivarA := ivarA + 1].
		ivarA isInteger ifFalse: [self halt]
		]
	! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:38'!
exampleOrFalse
	^2 = 1 or: [ 3 = 2 ]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/15/2007 01:53'!
exampleOrIfNil
	
	^Array with: (false or: [nil ifNil:[true]])! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:38'!
exampleOrOrFalse
	^2 = 1 or: [ 3 = 2 ] or: [4 = 3]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:39'!
exampleOrOrOrFalse
	^2 = 1 or: [ 3 = 2 ] or: [4 = 3] or: [5 = 4]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:39'!
exampleOrOrOrOrFalse
	^2 = 1 or: [ 3 = 2 ] or: [4 = 3] or: [5 = 4] or: [6 = 5]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:39'!
exampleOrOrOrOrTrue
	^2 = 1 or: [ 3 = 2 ] or: [4 = 3] or: [5 = 4] or: [5 = 5]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:39'!
exampleOrOrOrTrue
	^2 = 1 or: [ 3 = 2 ] or: [4 = 3] or: [4 = 4]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:38'!
exampleOrOrTrue
	^2 = 1 or: [ 3 = 2 ] or: [3 = 3]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/17/2007 15:37'!
exampleOrTrue
	^1 = 1 or: [ 3 = 2 ]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/20/2007 01:25'!
examplePushConstant
	^ 7! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 11:09'!
examplePushInstVar
	^ivarA factorial! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/11/2007 11:12'!
examplePushInstVar2
	^[ivarA factorial] value! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 6/20/2007 01:22'!
examplePushLiteral
	^OrderedCollection new! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 10:38'!
exampleQuickFalse

	^false! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 16:48'!
exampleQuickIVarA
	"IRDecompilerTest>>#exampleQuickIVarA"
	^ivarA! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 16:49'!
exampleQuickIVarB
	"IRDecompilerTest>>#exampleQuickIVarB"
	^ivarB! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 16:41'!
exampleQuickMinusOne
	"IRDecompilerTest>>#exampleQuickMinusOne"
	^-1! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 10:38'!
exampleQuickNil

	^nil! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 16:40'!
exampleQuickOne
	"IRDecompilerTest>>#exampleQuickOne"
	^1! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 10:39'!
exampleQuickSelf

	^self! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 10:39'!
exampleQuickTrue

	^true! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 16:39'!
exampleQuickTwo

	^2! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 16:47'!
exampleQuickZero
	"IRDecompilerTest>>#exampleQuickZero"
	^0! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/10/2007 19:02'!
exampleSelfInBlock
	
	^[self class] value! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/13/2007 01:19'!
exampleSend
	
	| a b |
	a := #(3 4) inject: 0 into: [:p :s | p + s].
	b := #(3 4) inject: 0 into: [:p :s | p + s].
	^a + b! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/2/2007 10:25'!
exampleSimpleBlock
	^[1]! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/10/2007 17:45'!
exampleStorInstVar
	^ivarA := 7! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/10/2007 17:34'!
exampleSuper
	^super class! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/29/2007 02:05'!
exampleSuper2
	
	| a |
	a := super class new.
	self haltIf:[super class ~= a class].
	^super class ~= a class! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/14/2007 22:09'!
exampleThisContext

	[^thisContext] value! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/13/2007 01:31'!
exampleToDo

	| a |
	a := 0.
	1 to: 4 do: [:each | a := each + a ].
	^a! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 5/16/2007 19:14'!
exampleUnaryMessage
	^4 factorial! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/15/2007 01:00'!
exampleVar
	
	| b |
	b := 0.
	nil ifNil:[| a |
		a := 3.
		b := a + b].
	[:a | b := b + a] value: 4.
	^b! !

!IRDecompilerTest methodsFor: 'examples' stamp: 'ms 7/12/2007 22:10'!
exampleWhileTrue
	
	| a |
	a := 0.
	[a < 7] whileTrue: [a := a + 1].
	^a! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 10:37'!
expectedFailures
	^#()! !

!IRDecompilerTest methodsFor: 'utils' stamp: 'ms 7/13/2007 00:41'!
setUp
	
	ivarA := 10.
	ivarB := 11.
	ClassVar := 17.
	self class compileAll.
	self class class compileAll! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:34'!
testDecompileAnd
	"self debug: #testDecompileAnd"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleAndFalse]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = false.
	
	self shouldnt: [ast := self decompileToAST: #exampleAndTrue]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = true! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:35'!
testDecompileAndAnd
	"self debug: #testDecompileAnd"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleAndAndFalse]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = false.
	
	self shouldnt: [ast := self decompileToAST: #exampleAndAndTrue]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = true! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:36'!
testDecompileAndAndAnd
	"self debug: #testDecompileAnd"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleAndAndAndFalse]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = false.
	
	self shouldnt: [ast := self decompileToAST: #exampleAndAndAndTrue]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = true! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:36'!
testDecompileAndAndAndAnd
	"self debug: #testDecompileAnd"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleAndAndAndAndFalse]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = false.
	
	self shouldnt: [ast := self decompileToAST: #exampleAndAndAndAndTrue]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = true! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/26/2007 01:26'!
testDecompileArrayNode
	"self debug: #testDecompileArrayNode"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleArrayNode]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = #(7 7 3)! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:43'!
testDecompileAssignment1
	"self debug: #testDecompileAssignment1"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleAssignment1]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 3! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:43'!
testDecompileAssignment2
	"self debug: #testDecompileAssignment1"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleAssignment2]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 6! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/16/2007 19:20'!
testDecompileBinaryMessage

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleBinaryMessage] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = (42@49). 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:34'!
testDecompileBlock

	| ast  |

	self shouldnt:[ast := self decompileToAST: #exampleSimpleBlock] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) value = 1. ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/16/2007 21:31'!
testDecompileBlockArgument
	"self debug: #testDecompileBlockParam"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleBlockAgrument]
		raise: Error.
	self assert: ((ast compiledMethod valueWithReceiver: nil arguments: #()) value: 4) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:34'!
testDecompileBlockParam
	"self debug: #testDecompileBlockParam"
	| ast |
	
	self shouldnt:[ast := self decompileToAST: #exampleBlockParam] raise: Error.
	self assert: ((ast compiledMethod valueWithReceiver: nil arguments: #()) value: 2) = 2. ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/10/2007 13:25'!
testDecompileBlockReturn
	"self debug: #testDecompileBlockParam"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleBlockReturn:]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #(3 )) = $d! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:34'!
testDecompileBlockSelf

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleBlockSelf] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) value = self. ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/30/2007 14:01'!
testDecompileCaptureArg

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleCaptureArg:] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #(3)) == 7 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 8/8/2007 20:05'!
testDecompileCaptureNestedTemp

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaptureNestedTemp] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 8/8/2007 00:38'!
testDecompileCaptureTemp

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaptureTemp] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/20/2007 01:16'!
testDecompileCascade

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleCascade] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/12/2007 13:00'!
testDecompileCaseOf
	"self debug: #testDecompileCaseOf"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaseOf]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7 ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/12/2007 13:27'!
testDecompileCaseOf2
	"self debug: #testDecompileCaseOf2"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaseOf2]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7 ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/12/2007 13:32'!
testDecompileCaseOf3
	"self debug: #testDecompileCaseOf3"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaseOf3]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7 ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/12/2007 13:32'!
testDecompileCaseOf4
	"self debug: #testDecompileCaseOf4"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaseOf4]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7 ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/13/2007 17:00'!
testDecompileCaseOf5
	"self debug: #testDecompileCaseOf5"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaseOf5]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 11 ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/19/2007 11:27'!
testDecompileCaseOf6
	"self debug: #testDecompileCaseOf6"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaseOf6]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == self.
	self assert: ivarA == 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/19/2007 12:37'!
testDecompileCaseOf7
	"self debug: #testDecompileCaseOf6"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleCaseOf7]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == self.
	self assert: ivarA == 7.
	self assert: ivarB == 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/13/2007 00:50'!
testDecompileClassClassVar
	"self debug: #testDecompileCaseOf4"

	| ast |
	self shouldnt: [ast := self decompileToASTClass: #exampleClassVar]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self class arguments: #()) == self class.
	self assert: ClassVar == 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/13/2007 00:43'!
testDecompileClassVar
	"self debug: #testDecompileCaseOf4"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleClassVar]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == self.
	self assert: ClassVar == 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 00:51'!
testDecompileDo

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleDo] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 00:53'!
testDecompileDo2

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleDo2] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 00:56'!
testDecompileDo3

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleDo3] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 00:58'!
testDecompileDo4

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleDo4] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 01:40'!
testDecompileDo5

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleDo5] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/10/2007 18:37'!
testDecompileGlobalVar
	"self debug: #testDecompileGlobalVar"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleGlobalVar]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = Smalltalk allClasses size! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 11:05'!
testDecompileIf2

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIf2] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/14/2007 20:45'!
testDecompileIf3

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIf3] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/15/2007 22:55'!
testDecompileIfNil

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIfNil] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/19/2007 18:45'!
testDecompileIfNil2

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIfNil2] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/19/2007 18:46'!
testDecompileIfNil3

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIfNil3] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/15/2007 23:20'!
testDecompileIfNilIfNotNil

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIfNilIfNotNil] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/15/2007 23:24'!
testDecompileIfNilIfNotNil2

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIfNilIfNotNil2] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 11:25'!
testDecompileIfThen

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIfThen] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 11:32'!
testDecompileIfThen2

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIfThen2] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 11:51'!
testDecompileIfThen3

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleIfThen3] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 7 factorial! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 11:58'!
testDecompileIfThen3Arg

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleIfThen3:] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #(7)) = self! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/19/2007 15:50'!
testDecompileIfThen4

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleIfThen4] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 7.
	self assert: ivarA == 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/13/2007 01:04'!
testDecompileIfTrue

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleIf] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 9/4/2007 02:03'!
testDecompileIfWhile

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleIfWhile]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/10/2007 12:13'!
testDecompileKeywordMessage

	| ast |
	self shouldnt:[ast := self decompileToAST: #exampleKeywordMessage] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 30. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 23:39'!
testDecompileNestedBlock1
	"self debug: #testDecompileNestedBlock1"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleNestedBlock1]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 23:39'!
testDecompileNestedBlock2
	"self debug: #testDecompileNestedBlock1"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleNestedBlock2]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/26/2007 01:32'!
testDecompileNestedBlock3
	"self debug: #testDecompileNestedBlock3"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleNestedBlock3]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/26/2007 03:05'!
testDecompileNestedBlock4
	"self debug: #testDecompileNestedBlock4"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleNestedBlock4]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/26/2007 02:14'!
testDecompileNestedBlock5
	"self debug: #testDecompileNestedBlock5"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleNestedBlock5]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/12/2007 22:30'!
testDecompileNestedBlock6
	"self debug: #testDecompileNestedBlock6"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleNestedBlock6]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == self.
	self assert: ivarA == 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:40'!
testDecompileOr
	"self debug: #testDecompileAnd"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleOrFalse]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = false.
	
	self shouldnt: [ast := self decompileToAST: #exampleOrTrue]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = true! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/15/2007 23:32'!
testDecompileOrIfNil

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleOrIfNil] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = #(true). 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:40'!
testDecompileOrOr
	"self debug: #testDecompileAnd"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleOrOrFalse]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = false.
	
	self shouldnt: [ast := self decompileToAST: #exampleOrOrTrue]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = true! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:40'!
testDecompileOrOrOr
	"self debug: #testDecompileAnd"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleOrOrOrFalse]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = false.
	
	self shouldnt: [ast := self decompileToAST: #exampleOrOrOrTrue]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = true! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/17/2007 15:40'!
testDecompileOrOrOrOr
	"self debug: #testDecompileAnd"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleOrOrOrOrFalse]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = false.
	
	self shouldnt: [ast := self decompileToAST: #exampleOrOrOrOrTrue]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = true! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/20/2007 01:26'!
testDecompilePushConstant

	| ast |

	self shouldnt:[ast := self decompileToAST: #examplePushConstant] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 11:11'!
testDecompilePushInstVar
	"self debug: #testDecompilePushInstVar"

	| ast |
	self shouldnt: [ast := self decompileToAST: #examplePushInstVar] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 3628800.! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/11/2007 11:13'!
testDecompilePushInstVar2
	"self debug: #testDecompilePushInstVar"

	| ast |
	self shouldnt: [ast := self decompileToAST: #examplePushInstVar2] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 3628800.! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 6/20/2007 01:22'!
testDecompilePushLiteral

	| ast |

	self shouldnt:[ast := self decompileToAST: #examplePushLiteral] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) class == OrderedCollection. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:43'!
testDecompileQuickFalse

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickFalse] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == false. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:50'!
testDecompileQuickIVar

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickIVarA] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 10. 
	
	self shouldnt:[ast := self decompileToAST: #exampleQuickIVarB] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 11. ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:43'!
testDecompileQuickMinusOne

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickMinusOne] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == -1. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:44'!
testDecompileQuickNil

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickNil] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == nil. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:44'!
testDecompileQuickOne

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickOne] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 1. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:43'!
testDecompileQuickSelf

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickSelf] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == self. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:44'!
testDecompileQuickTrue

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickTrue] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == true. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:44'!
testDecompileQuickTwo

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickTwo] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 2. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/2/2007 16:44'!
testDecompileQuickZero

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleQuickZero] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 0. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/10/2007 19:03'!
testDecompileSelfInBlock
	"self debug: #testDecompileAssignment1"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleSelfInBlock]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == IRDecompilerTest ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/13/2007 01:22'!
testDecompileSend
	"self debug: #testDecompileSend"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleSend] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: nil arguments: #()) = 14! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/10/2007 17:45'!
testDecompileStorInstVar
	"self debug: #testDecompileBlockParam"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleStorInstVar]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = 7.
	self assert: ivarA = 7! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/29/2007 02:05'!
testDecompileSuper
	"self debug: #testDecompileSuper"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleSuper]
		raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) = IRDecompilerTest! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/29/2007 02:41'!
testDecompileSuper2
	"self debug: #testDecompileSuper2"

	| ast |
	self shouldnt: [ast := self decompileToAST: #exampleSuper2] raise: Error.
	self deny: (ast compiledMethod valueWithReceiver: self arguments: #())! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/14/2007 22:11'!
testDecompileThisContext
	"self debug: #testDecompileThisContext"
	| ast |
	
	self shouldnt:[ast := self decompileToAST: #exampleThisContext] raise: Error.
	self assert: ((ast compiledMethod valueWithReceiver: nil arguments: #()) isKindOf: ContextPart). ! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/13/2007 01:32'!
testDecompileToDo

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleToDo] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 10. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 5/16/2007 19:14'!
testDecompileUnaryMessage

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleUnaryMessage] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 24. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/15/2007 01:00'!
testDecompileVar

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleVar] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

!IRDecompilerTest methodsFor: 'testing' stamp: 'ms 7/12/2007 22:08'!
testDecompileWhileTrue

	| ast |

	self shouldnt:[ast := self decompileToAST: #exampleWhileTrue] raise: Error.
	self assert: (ast compiledMethod valueWithReceiver: self arguments: #()) == 7. 
	! !

TestCase subclass: #IRTransformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!IRTransformTest methodsFor: 'testing' stamp: 'md 10/13/2004 14:09'!
testAdd
	
	| iRMethod aCompiledMethod |

	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		returnTop;
		ir.

	(iRMethod allSequences last) last delete.
	(iRMethod allSequences last) last delete.

	(iRMethod allSequences last)
			add: (IRInstruction pushLiteral: 2).

	(iRMethod allSequences last)
			add: (IRInstruction returnTop).

	aCompiledMethod := iRMethod compiledMethod.
	self should: [(aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2].
! !

!IRTransformTest methodsFor: 'testing' stamp: 'md 10/13/2004 14:09'!
testAddBefore
	
	| iRMethod aCompiledMethod ret |

	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		returnTop;
		ir.

	(iRMethod allSequences last) last delete.
	(iRMethod allSequences last) last delete.

	ret :=  (IRInstruction returnTop).

	(iRMethod allSequences last)
			add: ret.

	(iRMethod allSequences last)
			add: (IRInstruction pushLiteral: 2) before: ret.

	aCompiledMethod := iRMethod compiledMethod.
	self should: [(aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2].
! !

!IRTransformTest methodsFor: 'testing' stamp: 'md 10/13/2004 14:09'!
testAddIntructions
	
	| iRMethod aCompiledMethod |

	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		returnTop;
		ir.

	(iRMethod allSequences last) last delete.
	(iRMethod allSequences last) last delete.

	(iRMethod allSequences last)
			addInstructions: {(IRInstruction pushLiteral: 2). (IRInstruction returnTop)}.

	aCompiledMethod := iRMethod compiledMethod.
	self should: [(aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2].
! !

!IRTransformTest methodsFor: 'testing' stamp: 'md 10/12/2004 16:31'!
testAddIntructionsBefore
	
	| iRMethod aCompiledMethod push |

	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		returnTop;
		ir.

	push := (iRMethod allSequences last) at: (iRMethod allSequences size - 1) .

	(iRMethod allSequences last)
			addInstructions: {(IRInstruction pushLiteral: 2). (IRInstruction returnTop)} before: push.

	aCompiledMethod := iRMethod compiledMethod.
	self should: [(aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2].
! !

!IRTransformTest methodsFor: 'testing' stamp: 'md 10/13/2004 11:08'!
testAddIntructionsBeforeFromLList
	
	| iRMethod aCompiledMethod push llist col |

	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		returnTop;
		ir.

	push := (iRMethod allSequences last) at: (iRMethod allSequences size - 1) .

	llist := LinkedList new.
	llist add: (IRInstruction pushLiteral: 2).
	llist add: (IRInstruction returnTop).

	col := llist asOrderedCollection.

	(iRMethod allSequences last)
			addInstructions:  col before: push.

	aCompiledMethod := iRMethod compiledMethod.
	self should: [(aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2].
! !

!IRTransformTest methodsFor: 'testing' stamp: 'md 10/13/2004 14:09'!
testDelete
	
	| iRMethod aCompiledMethod |

	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		pushLiteral: 2;	
		returnTop;
		ir.

	((iRMethod allSequences last) 
		detect: [:each | each isConstant: [:c | c == 2]]) delete.
			

	aCompiledMethod := iRMethod compiledMethod.
	self should: [(aCompiledMethod valueWithReceiver: nil arguments: #() ) = 1].
! !

!IRTransformTest methodsFor: 'testing' stamp: 'ms 7/13/2006 10:13'!
testReplace
	| iRMethod aCompiledMethod |
	
	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		returnTop;
		ir.
	
	(iRMethod allSequences last at: 1) 
			replaceWith: (IRInstruction pushLiteral: 2).

	aCompiledMethod := iRMethod compiledMethod.
	self should: [(aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2].
! !

!IRTransformTest methodsFor: 'testing' stamp: 'md 2/22/2005 11:58'!
testReplaceInstr
	
	| iRMethod aCompiledMethod |

	iRMethod := IRBuilder new
		numRargs: 1;
		addTemps: #(self);		"receiver and args declarations"
		pushLiteral: 1;				
		returnTop;
		ir.
	
	(iRMethod allSequences last at: 1) 
			replaceWithInstructions: {(IRInstruction pushLiteral: 2)}.

	aCompiledMethod := iRMethod compiledMethod.
	self should: [(aCompiledMethod valueWithReceiver: nil arguments: #() ) = 2].
! !

TestCase subclass: #NewCompilerWithChangesFunctionalTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:10'!
testBlockArgument
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'testBlockArgument
													| block block1 block2 |
													block := [ :arg | | temp | temp := arg. [ temp ] ].
													block1 := block value: 1.
													block2 := block value: 2.
													self assert: block1 value = 1.
													self assert: block2 value = 2'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '17 <8F 01 00 0B> closureNumCopied: 0 numArgs: 1 bytes 21 to 31'.
	self assert: (bytecode at: (index := index + 1)) = '21 	<73> pushConstant: nil'.
	self assert: (bytecode at: (index := index + 1)) = '22 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '23 	<69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '24 	<11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '25 	<8F 10 00 02> closureNumCopied: 1 numArgs: 0 bytes 29 to 30'.
	self assert: (bytecode at: (index := index + 1)) = '29 		<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '30 		<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '31 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) =	'32 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) =	'33 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '34 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '35 <CA> send: value:'.
	self assert: (bytecode at: (index := index + 1)) = '36 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '37 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '38 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '39 <CA> send: value:'.
	self assert: (bytecode at: (index := index + 1)) = '40 <6A> popIntoTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '41 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '42 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '43 <C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '44 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '45 <B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '46 <E0> send: assert:'.
	self assert: (bytecode at: (index := index + 1)) = '47 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '48 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '49 <12> pushTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '50 <C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '51 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '52 <B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '53 <E0> send: assert:'.
	self assert: (bytecode at: (index := index + 1)) = '54 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '55 <78> returnSelf'.
	! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'test - block returning' stamp: 'JorgeRessia 4/9/2010 16:10'!
testBlockReturning
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'open
	(self announcements at: self index ifAbsent: [ ^ self ]) 
		open'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '29 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '30 <D0> send: announcements'.
	self assert: (bytecode at: (index := index + 1)) = '31 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '32 <D1> send: index'.
	self assert: (bytecode at: (index := index + 1)) = '33 <8F 00 00 01> closureNumCopied: 0 numArgs: 0 bytes 37 to 37'.
	self assert: (bytecode at: (index := index + 1)) = '37 	<78> returnSelf'.
	self assert: (bytecode at: (index := index + 1)) = '38 <F2> send: at:ifAbsent:'.
	self assert: (bytecode at: (index := index + 1)) = '39 <D3> send: open'.
	self assert: (bytecode at: (index := index + 1)) = '40 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '41 <78> returnSelf'.

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:10'!
testBlockTemp
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'testBlockTemp
	| block block1 block2 |
	block := [ :arg | [ arg ] ].
	block1 := block value: 1.
	block2 := block value: 2.
	self assert: block1 value = 1.
	self assert: block2 value = 2'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '17 <8F 01 00 08> closureNumCopied: 0 numArgs: 1 bytes 21 to 28'.
self assert: (bytecode at: (index := index + 1)) = '21 	<10> pushTemp: 0'.
self assert: (bytecode at: (index := index + 1)) = '22 	<8F 10 00 02> closureNumCopied: 1 numArgs: 0 bytes 26 to 27'.
self assert: (bytecode at: (index := index + 1)) = '26 		<10> pushTemp: 0'.
self assert: (bytecode at: (index := index + 1)) = '27 		<7D> blockReturn'.
self assert: (bytecode at: (index := index + 1)) = '28 	<7D> blockReturn'.
self assert: (bytecode at: (index := index + 1)) = '29 <68> popIntoTemp: 0'.
self assert: (bytecode at: (index := index + 1)) = '30 <10> pushTemp: 0'.
self assert: (bytecode at: (index := index + 1)) = '31 <76> pushConstant: 1'.
self assert: (bytecode at: (index := index + 1)) = '32 <CA> send: value:'.
self assert: (bytecode at: (index := index + 1)) = '33 <69> popIntoTemp: 1'.
self assert: (bytecode at: (index := index + 1)) = '34 <10> pushTemp: 0'.
self assert: (bytecode at: (index := index + 1)) = '35 <77> pushConstant: 2'.
self assert: (bytecode at: (index := index + 1)) = '36 <CA> send: value:'.
self assert: (bytecode at: (index := index + 1)) = '37 <6A> popIntoTemp: 2'.
self assert: (bytecode at: (index := index + 1)) = '38 <70> self'.
self assert: (bytecode at: (index := index + 1)) = '39 <11> pushTemp: 1'.
self assert: (bytecode at: (index := index + 1)) = '40 <C9> send: value'.
self assert: (bytecode at: (index := index + 1)) = '41 <76> pushConstant: 1'.
self assert: (bytecode at: (index := index + 1)) = '42 <B6> send: ='.
self assert: (bytecode at: (index := index + 1)) = '43 <E0> send: assert:'.
self assert: (bytecode at: (index := index + 1)) = '44 <87> pop'.
self assert: (bytecode at: (index := index + 1)) = '45 <70> self'.
self assert: (bytecode at: (index := index + 1)) = '46 <12> pushTemp: 2'.
self assert: (bytecode at: (index := index + 1)) = '47 <C9> send: value'.
self assert: (bytecode at: (index := index + 1)) = '48 <77> pushConstant: 2'.
self assert: (bytecode at: (index := index + 1)) = '49 <B6> send: ='.
self assert: (bytecode at: (index := index + 1)) = '50 <E0> send: assert:'.
self assert: (bytecode at: (index := index + 1)) = '51 <87> pop'.
self assert: (bytecode at: (index := index + 1)) = '52 <78> returnSelf'.

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'other-tests' stamp: 'JorgeRessia 4/9/2010 16:10'!
testCategorizeUsingRulesDefinedInPreferences
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testCategorizeUsingRulesDefinedInPreferences
	
	| previousRuleGlobalName previousRulesAccessSelector |

	previousRuleGlobalName := Preferences valueOfPreference: #rulesGlobalName.
	previousRulesAccessSelector := Preferences valueOfPreference: #rulesAccessSelector.
	
	[
		Preferences setPreference: #rulesGlobalName toValue: self globalWithTestingRules.
		Preferences setPreference: #rulesAccessSelector toValue: 1.
		self assertCategorizationOfAllMethodsWith: AutomaticMethodCategorizer new
	] ensure: [
		Preferences setPreference: #rulesGlobalName toValue: previousRuleGlobalName.
		Preferences setPreference: #rulesAccessSelector toValue: previousRulesAccessSelector
	]
	
'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '49 <40> pushLit: Preferences'. "here the old compiler is <41>"
	self assert: (bytecode at: (index := index + 1)) = '50 <21> pushConstant: #rulesGlobalName'."here the old compiler is <21>"
	self assert: (bytecode at: (index := index + 1)) = '51 <E2> send: valueOfPreference:'."here the old compiler is <E0>"
	self assert: (bytecode at: (index := index + 1)) = '52 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '53 <40> pushLit: Preferences'."here the old compiler is <41>"
	self assert: (bytecode at: (index := index + 1)) = '54 <23> pushConstant: #rulesAccessSelector'.
	self assert: (bytecode at: (index := index + 1)) = '55 <E2> send: valueOfPreference:'. "here the old compiler is <E0>"
	self assert: (bytecode at: (index := index + 1)) = '56 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '57 <8F 00 00 10> closureNumCopied: 0 numArgs: 0 bytes 61 to 76'.
	self assert: (bytecode at: (index := index + 1)) = '61 	<40> pushLit: Preferences'."here the old compiler is <41>"
	self assert: (bytecode at: (index := index + 1)) = '62 	<21> pushConstant: #rulesGlobalName'."here the old compiler is <22>"
	self assert: (bytecode at: (index := index + 1)) = '63 	<70> self'.
	self assert: (bytecode at: (index := index + 1)) = '64 	<D4> send: globalWithTestingRules'.
	self assert: (bytecode at: (index := index + 1)) = '65 	<F5> send: setPreference:toValue:'.
	self assert: (bytecode at: (index := index + 1)) = '66 	<87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '67 	<40> pushLit: Preferences'.
	self assert: (bytecode at: (index := index + 1)) = '68 	<23> pushConstant: #rulesAccessSelector'.
	self assert: (bytecode at: (index := index + 1)) = '69 	<76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '70 	<F5> send: setPreference:toValue:'.
	self assert: (bytecode at: (index := index + 1)) = '71 	<87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '72 	<70> self'.
	self assert: (bytecode at: (index := index + 1)) = '73 	<46> pushLit: AutomaticMethodCategorizer'.
	self assert: (bytecode at: (index := index + 1)) = '74 	<CC> send: new'.
	self assert: (bytecode at: (index := index + 1)) = '75 	<E7> send: assertCategorizationOfAllMethodsWith:'.
	self assert: (bytecode at: (index := index + 1)) = '76 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '77 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '78 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '79 <8F 20 00 0A> closureNumCopied: 2 numArgs: 0 bytes 83 to 92'.
	self assert: (bytecode at: (index := index + 1)) = '83 	<40> pushLit: Preferences'.
	self assert: (bytecode at: (index := index + 1)) = '84 	<21> pushConstant: #rulesGlobalName'.
	self assert: (bytecode at: (index := index + 1)) = '85 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '86 	<F5> send: setPreference:toValue:'.
	self assert: (bytecode at: (index := index + 1)) = '87 	<87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '88 	<40> pushLit: Preferences'.
	self assert: (bytecode at: (index := index + 1)) = '89 	<23> pushConstant: #rulesAccessSelector'.
	self assert: (bytecode at: (index := index + 1)) = '90 	<11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '91 	<F5> send: setPreference:toValue:'.
	self assert: (bytecode at: (index := index + 1)) = '92 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '93 <E8> send: ensure:'.
	self assert: (bytecode at: (index := index + 1)) = '94 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '95 <78> returnSelf'.
! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'other-tests' stamp: 'JorgeRessia 4/9/2010 16:10'!
testDifferentBlocksWithSameArgumentName
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'exampleNestedBlock
												| b c z |
												b := [:a | 
														z := 2.
														z + a].
												c := [:a |
														z + a].
											^ (b value: 2) + (c value: 1)'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '13 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '15 <6A> popIntoTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '16 <12> pushTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '17 <8F 11 00 0A> closureNumCopied: 1 numArgs: 1 bytes 21 to 30'.
	self assert: (bytecode at: (index := index + 1)) = '21 	<77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '22 	<8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '25 	<8C 00 01> pushTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '28 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '29 	<B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '30 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '31 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '32 <12> pushTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '33 <8F 11 00 06> closureNumCopied: 1 numArgs: 1 bytes 37 to 42'.
	self assert: (bytecode at: (index := index + 1)) = '37 	<8C 00 01> pushTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '40 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '41 	<B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '42 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '43 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '44 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '45 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '46 <CA> send: value:'.
	self assert: (bytecode at: (index := index + 1)) = '47 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '48 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '49 <CA> send: value:'.
	self assert: (bytecode at: (index := index + 1)) = '50 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '51 <7C> returnTop'.! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'other-tests' stamp: 'JorgeRessia 4/9/2010 16:10'!
testFinalizationOfEquals

	"this is a compilation test for ObjectFinalizerTests>>testFinalizationOfEquals"
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testFinalizationOfEquals

	
	| finalizationProbe o1 o2
	forAnyTwoEqualObjects
	ofDifferentIdentity
	registeringAnActionAtFinalizationForEachObject
	thenForcingFinalizationOfObjects
	implyBothRegisteredActionsAreExecuted |

	finalizationProbe := Set new.
	o1 := 1 copy.
	o2 := 1 copy.
	forAnyTwoEqualObjects := [o1 = o2].
	ofDifferentIdentity := [o1 ~~ o2].
	registeringAnActionAtFinalizationForEachObject := [
		o1 toFinalizeSend: #add: to: finalizationProbe	with: 1.
		o2 toFinalizeSend: #add: to: finalizationProbe	with: 2].
	thenForcingFinalizationOfObjects := [
		o1 := o2 := nil. Smalltalk garbageCollect].
	implyBothRegisteredActionsAreExecuted := [finalizationProbe size = 2].

	self
		assert: forAnyTwoEqualObjects;
		assert: ofDifferentIdentity;
		should: [
			registeringAnActionAtFinalizationForEachObject value.
			thenForcingFinalizationOfObjects value.
			implyBothRegisteredActionsAreExecuted value].
'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '49 <8A 02> push: (Array new: 2)'.
	self assert: (bytecode at: (index := index + 1)) = '51 <6E> popIntoTemp: 6'.
	self assert: (bytecode at: (index := index + 1)) = '52 <40> pushLit: Set'.
	self assert: (bytecode at: (index := index + 1)) = '53 <CC> send: new'.
	self assert: (bytecode at: (index := index + 1)) = '54 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '55 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '56 <D1> send: copy'.
	self assert: (bytecode at: (index := index + 1)) = '57 <8E 00 06> popIntoTemp: 0 inVectorAt: 6'.
	self assert: (bytecode at: (index := index + 1)) = '60 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '61 <D1> send: copy'.
	self assert: (bytecode at: (index := index + 1)) = '62 <8E 01 06> popIntoTemp: 1 inVectorAt: 6'.
	self assert: (bytecode at: (index := index + 1)) = '65 <16> pushTemp: 6'.
	self assert: (bytecode at: (index := index + 1)) = '66 <8F 10 00 08> closureNumCopied: 1 numArgs: 0 bytes 70 to 77'.
	self assert: (bytecode at: (index := index + 1)) = '70 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '73 	<8C 01 00> pushTemp: 1 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '76 	<B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '77 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '78 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '79 <16> pushTemp: 6'.
	self assert: (bytecode at: (index := index + 1)) = '80 <8F 10 00 08> closureNumCopied: 1 numArgs: 0 bytes 84 to 91'.
	self assert: (bytecode at: (index := index + 1)) = '84 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '87 	<8C 01 00> pushTemp: 1 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '90 	<E2> send: ~~'.
	self assert: (bytecode at: (index := index + 1)) = '91 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '92 <6A> popIntoTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '93 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '94 <16> pushTemp: 6'.
	self assert: (bytecode at: (index := index + 1)) = '95 <8F 20 00 12> closureNumCopied: 2 numArgs: 0 bytes 99 to 116'.
	self assert: (bytecode at: (index := index + 1)) = '99 	<8C 00 01> pushTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '102 	<23> pushConstant: #add:'. "here the old compiler is <24>"
	self assert: (bytecode at: (index := index + 1)) = '103 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '104 	<76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '105 	<83 64> send: toFinalizeSend:to:with:'. "here the old compiler is <83 63>"
	self assert: (bytecode at: (index := index + 1)) = '107 	<87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '108 	<8C 01 01> pushTemp: 1 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '111 	<23> pushConstant: #add:'. "here the old compiler is <24>"
	self assert: (bytecode at: (index := index + 1)) = '112 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '113 	<77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '114 	<83 64> send: toFinalizeSend:to:with:'. "here the old compiler is <83 63>"
	self assert: (bytecode at: (index := index + 1)) = '116 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '117 <6B> popIntoTemp: 3'.
	self assert: (bytecode at: (index := index + 1)) = '118 <16> pushTemp: 6'.
	self assert: (bytecode at: (index := index + 1)) = '119 <8F 10 00 0A> closureNumCopied: 1 numArgs: 0 bytes 123 to 132'.
	self assert: (bytecode at: (index := index + 1)) = '123 	<73> pushConstant: nil'.
	self assert: (bytecode at: (index := index + 1)) = '124 	<8D 01 00> storeIntoTemp: 1 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '127 	<8E 00 00> popIntoTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '130 	<45> pushLit: Smalltalk'. "here the old compiler is <46>"
	self assert: (bytecode at: (index := index + 1)) = '131 	<D6> send: garbageCollect'. "here the old compiler is <D5>"
	self assert: (bytecode at: (index := index + 1)) = '132 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '133 <6C> popIntoTemp: 4'.
	self assert: (bytecode at: (index := index + 1)) = '134 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '135 <8F 10 00 05> closureNumCopied: 1 numArgs: 0 bytes 139 to 143'.
	self assert: (bytecode at: (index := index + 1)) = '139 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '140 	<C2> send: size'.
	self assert: (bytecode at: (index := index + 1)) = '141 	<77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '142 	<B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '143 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '144 <6D> popIntoTemp: 5'.
	self assert: (bytecode at: (index := index + 1)) = '145 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '146 <88> dup'.
	self assert: (bytecode at: (index := index + 1)) = '147 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '148 <E7> send: assert:'.
	self assert: (bytecode at: (index := index + 1)) = '149 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '150 <88> dup'.
	self assert: (bytecode at: (index := index + 1)) = '151 <12> pushTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '152 <E7> send: assert:'.
	self assert: (bytecode at: (index := index + 1)) = '153 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '154 <13> pushTemp: 3'.
	self assert: (bytecode at: (index := index + 1)) = '155 <14> pushTemp: 4'.
	self assert: (bytecode at: (index := index + 1)) = '156 <15> pushTemp: 5'.
	self assert: (bytecode at: (index := index + 1)) = '157 <8F 30 00 09> closureNumCopied: 3 numArgs: 0 bytes 161 to 169'.
	self assert: (bytecode at: (index := index + 1)) = '161 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '162 	<C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '163 	<87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '164 	<11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '165 	<C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '166 	<87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '167 	<12> pushTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '168 	<C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '169 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '170 <E8> send: should:'.
	self assert: (bytecode at: (index := index + 1)) = '171 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '172 <78> returnSelf'.! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'other-tests' stamp: 'TestRunner 4/6/2010 13:39'!
testFreeTypeCacheTestSetUp
	
	"In this example there are pops of literal vars"
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'setUp

	cache := FreeTypeCache new.
	font1 := FreeTypeFont basicNew.
	font2 := FreeTypeFont basicNew.
	font3 := FreeTypeFont basicNew.
	font1XGlyph := (GlyphForm extent: 100@100 depth: 32)
		advance: 100;
		linearAdvance: 10000;
		yourself.
	font1YGlyph := (GlyphForm extent: 100@100 depth: 32)
		advance: 100;
		linearAdvance: 10000;
		yourself.
	font1ZGlyph := (GlyphForm extent: 100@100 depth: 32)
		advance: 100;
		linearAdvance: 10000;
		yourself.
	fullCache := FreeTypeCache new.
	fullCache 
		maximumSize: (10*(fullCache sizeOf: font1YGlyph))..
	1 to: 10 do:[:i |
		fullCache atFont: font1 charCode: i type: FreeTypeCacheGlyph put: font1YGlyph]. 
'
	in: FreeTypeCacheTest
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '77 <40> pushLit: FreeTypeCache'.
	self assert: (bytecode at: (index := index + 1)) = '78 <CC> send: new'.
	self assert: (bytecode at: (index := index + 1)) = '79 <61> popIntoRcvr: 1'.
	self assert: (bytecode at: (index := index + 1)) = '80 <41> pushLit: FreeTypeFont'.
	self assert: (bytecode at: (index := index + 1)) = '81 <D2> send: basicNew'.
	self assert: (bytecode at: (index := index + 1)) = '82 <64> popIntoRcvr: 4'.
	self assert: (bytecode at: (index := index + 1)) = '83 <41> pushLit: FreeTypeFont'.
	self assert: (bytecode at: (index := index + 1)) = '84 <D2> send: basicNew'.
	self assert: (bytecode at: (index := index + 1)) = '85 <82 08> popIntoRcvr: 8'.
	self assert: (bytecode at: (index := index + 1)) = '87 <41> pushLit: FreeTypeFont'.
	self assert: (bytecode at: (index := index + 1)) = '88 <D2> send: basicNew'.
	self assert: (bytecode at: (index := index + 1)) = '89 <82 09> popIntoRcvr: 9'.
	self assert: (bytecode at: (index := index + 1)) = '91 <43> pushLit: GlyphForm'.
	self assert: (bytecode at: (index := index + 1)) = '92 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '93 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '94 <BB> send: @'.
	self assert: (bytecode at: (index := index + 1)) = '95 <25> pushConstant: 32'.
	self assert: (bytecode at: (index := index + 1)) = '96 <F6> send: extent:depth:'.
	self assert: (bytecode at: (index := index + 1)) = '97 <88> dup'.
	self assert: (bytecode at: (index := index + 1)) = '98 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '99 <E7> send: advance:'.
	self assert: (bytecode at: (index := index + 1)) = '100 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '101 <88> dup'.
	self assert: (bytecode at: (index := index + 1)) = '102 <28> pushConstant: 10000'.
	self assert: (bytecode at: (index := index + 1)) = '103 <E9> send: linearAdvance:'.
	self assert: (bytecode at: (index := index + 1)) = '104 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '105 <DA> send: yourself'.
	self assert: (bytecode at: (index := index + 1)) = '106 <65> popIntoRcvr: 5'.
	self assert: (bytecode at: (index := index + 1)) = '107 <43> pushLit: GlyphForm'.
	self assert: (bytecode at: (index := index + 1)) = '108 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '109 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '110 <BB> send: @'.
	self assert: (bytecode at: (index := index + 1)) = '111 <25> pushConstant: 32'.
	self assert: (bytecode at: (index := index + 1)) = '112 <F6> send: extent:depth:'.
	self assert: (bytecode at: (index := index + 1)) = '113 <88> dup'.
	self assert: (bytecode at: (index := index + 1)) = '114 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '115 <E7> send: advance:'.
	self assert: (bytecode at: (index := index + 1)) = '116 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '117 <88> dup'.
	self assert: (bytecode at: (index := index + 1)) = '118 <28> pushConstant: 10000'.
	self assert: (bytecode at: (index := index + 1)) = '119 <E9> send: linearAdvance:'.
	self assert: (bytecode at: (index := index + 1)) = '120 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '121 <DA> send: yourself'.
	self assert: (bytecode at: (index := index + 1)) = '122 <67> popIntoRcvr: 7'.
	self assert: (bytecode at: (index := index + 1)) = '123 <43> pushLit: GlyphForm'.
	self assert: (bytecode at: (index := index + 1)) = '124 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '125 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '126 <BB> send: @'.
	self assert: (bytecode at: (index := index + 1)) = '127 <25> pushConstant: 32'.
	self assert: (bytecode at: (index := index + 1)) = '128 <F6> send: extent:depth:'.
	self assert: (bytecode at: (index := index + 1)) = '129 <88> dup'.
	self assert: (bytecode at: (index := index + 1)) = '130 <24> pushConstant: 100'.
	self assert: (bytecode at: (index := index + 1)) = '131 <E7> send: advance:'.
	self assert: (bytecode at: (index := index + 1)) = '132 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '133 <88> dup'.
	self assert: (bytecode at: (index := index + 1)) = '134 <28> pushConstant: 10000'.
	self assert: (bytecode at: (index := index + 1)) = '135 <E9> send: linearAdvance:'.
	self assert: (bytecode at: (index := index + 1)) = '136 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '137 <DA> send: yourself'.
	self assert: (bytecode at: (index := index + 1)) = '138 <66> popIntoRcvr: 6'.
	self assert: (bytecode at: (index := index + 1)) = '139 <40> pushLit: FreeTypeCache'.
	self assert: (bytecode at: (index := index + 1)) = '140 <CC> send: new'.
	self assert: (bytecode at: (index := index + 1)) = '141 <63> popIntoRcvr: 3'.
	self assert: (bytecode at: (index := index + 1)) = '142 <03> pushRcvr: 3'.
	self assert: (bytecode at: (index := index + 1)) = '143 <2B> pushConstant: 10'.
	self assert: (bytecode at: (index := index + 1)) = '144 <03> pushRcvr: 3'.
	self assert: (bytecode at: (index := index + 1)) = '145 <07> pushRcvr: 7'.
	self assert: (bytecode at: (index := index + 1)) = '146 <EC> send: sizeOf:'.
	self assert: (bytecode at: (index := index + 1)) = '147 <B8> send: *'.
	self assert: (bytecode at: (index := index + 1)) = '148 <ED> send: maximumSize:'.
	self assert: (bytecode at: (index := index + 1)) = '149 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '150 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '151 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '153 <2B> pushConstant: 10'.
	self assert: (bytecode at: (index := index + 1)) = '154 <B4> send: <='.
	self assert: (bytecode at: (index := index + 1)) = '155 <AC 10> jumpFalse: 173'.
	self assert: (bytecode at: (index := index + 1)) = '157 <03> pushRcvr: 3'.
	self assert: (bytecode at: (index := index + 1)) = '158 <04> pushRcvr: 4'.
	self assert: (bytecode at: (index := index + 1)) = '159 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '160 <4E> pushLit: FreeTypeCacheGlyph'.
	self assert: (bytecode at: (index := index + 1)) = '161 <07> pushRcvr: 7'.
	self assert: (bytecode at: (index := index + 1)) = '162 <83 8F> send: atFont:charCode:type:put:'.
	self assert: (bytecode at: (index := index + 1)) = '164 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '165 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '166 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '167 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '168 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '170 <2B> pushConstant: 10'.
	self assert: (bytecode at: (index := index + 1)) = '171 <A3 ED> jumpTo: 154'.
	self assert: (bytecode at: (index := index + 1)) = '173 <78> returnSelf'.! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testMethodArgument
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
											compile: 'testMethodArgument
															| temp block |
															temp := 0.
															block := [ [ temp ] ].
															temp := 1.
															block := block value.
															temp := 2.
															self assert: block value = 2'
											in: MockCompilationClass
											classified: nil
											notifying: nil
											ifFail: [])
											generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '17 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '19 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '20 <75> pushConstant: 0'.
	self assert: (bytecode at: (index := index + 1)) = '21 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '24 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '25 <8F 10 00 0A> closureNumCopied: 1 numArgs: 0 bytes 29 to 38'.
	self assert: (bytecode at: (index := index + 1)) = '29 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '30 	<8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 34 to 37'.
	self assert: (bytecode at: (index := index + 1)) = '34 		<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '37 		<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '38 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '39 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '40 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '41 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '44 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '45 <C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '46 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '47 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '48 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '51 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '52 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '53 <C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '54 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '55 <B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '56 <E0> send: assert:'.
	self assert: (bytecode at: (index := index + 1)) = '57 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '58 <78> returnSelf'.


! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testMethodTemp
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'testMethodTemp
													| block1 block2 |
													block1 := self methodArgument: 1.
													block2 := self methodArgument: 2.
													self assert: block1 value = 1.
													self assert: block2 value = 2'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '21 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '22 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '23 <E0> send: methodArgument:'.
	self assert: (bytecode at: (index := index + 1)) = '24 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '25 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '26 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '27 <E0> send: methodArgument:'.
	self assert: (bytecode at: (index := index + 1)) = '28 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '29 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '30 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '31 <C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '32 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '33 <B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '34 <E1> send: assert:'.
	self assert: (bytecode at: (index := index + 1)) = '35 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '36 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '37 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '38 <C9> send: value'.
	self assert: (bytecode at: (index := index + 1)) = '39 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '40 <B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '41 <E1> send: assert:'.
	self assert: (bytecode at: (index := index + 1)) = '42 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '43 <78> returnSelf'.

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testMethodWithOptimizedBlocksAndSameNameTemps
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'methodWithOptimizedBlocksA
	| s c |
	s := self isNil
			ifTrue: [| a | a := 1. a]
			ifFalse: [| a | a := 2. a].
	c := String new: s size.
	1 to: s size do:
		[:i| c at: i put: (s at: i)].
	^c'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '21 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '22 <D0> send: isNil'.
	self assert: (bytecode at: (index := index + 1)) = '23 <9B> jumpFalse: 28'.
	self assert: (bytecode at: (index := index + 1)) = '24 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '25 <6A> popIntoTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '26 <12> pushTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '27 <92> jumpTo: 31'.
	self assert: (bytecode at: (index := index + 1)) = '28 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '29 <6A> popIntoTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '30 <12> pushTemp: 2'.
	self assert: (bytecode at: (index := index + 1)) = '31 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '32 <41> pushLit: String'.
	self assert: (bytecode at: (index := index + 1)) = '33 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '34 <C2> send: size'.
	self assert: (bytecode at: (index := index + 1)) = '35 <CD> send: new:'.
	self assert: (bytecode at: (index := index + 1)) = '36 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '37 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '38 <81 43> storeIntoTemp: 3'.
	self assert: (bytecode at: (index := index + 1)) = '40 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '41 <C2> send: size'.
	self assert: (bytecode at: (index := index + 1)) = '42 <81 44> storeIntoTemp: 4'.
	self assert: (bytecode at: (index := index + 1)) = '44 <B4> send: <='.
	self assert: (bytecode at: (index := index + 1)) = '45 <AC 0F> jumpFalse: 62'.
	self assert: (bytecode at: (index := index + 1)) = '47 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '48 <13> pushTemp: 3'.
	self assert: (bytecode at: (index := index + 1)) = '49 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '50 <13> pushTemp: 3'.
	self assert: (bytecode at: (index := index + 1)) = '51 <C0> send: at:'.
	self assert: (bytecode at: (index := index + 1)) = '52 <C1> send: at:put:'.
	self assert: (bytecode at: (index := index + 1)) = '53 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '54 <13> pushTemp: 3'.
	self assert: (bytecode at: (index := index + 1)) = '55 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '56 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '57 <81 43> storeIntoTemp: 3'.
	self assert: (bytecode at: (index := index + 1)) = '59 <14> pushTemp: 4'.
	self assert: (bytecode at: (index := index + 1)) = '60 <A3 EE> jumpTo: 44'.
	self assert: (bytecode at: (index := index + 1)) = '62 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '63 <7C> returnTop'

	
	

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'other-tests' stamp: 'TestRunner 4/6/2010 13:39'!
testModulePrimitive
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
	compile: 'copyBitsAgain
	"Primitive. See BitBlt|copyBits, also a Primitive. Essential. See Object
	documentation whatIsAPrimitive."

	<primitive: ''primitiveCopyBits'' module: ''BitBltPlugin''>
	self primitiveFailed'
	in: BitBlt
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '<primitive: ''primitiveCopyBits'' module: ''BitBltPlugin''>'.
	self assert: (bytecode at: (index := index + 1)) = '21 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '22 <D1> send: primitiveFailed'.
	self assert: (bytecode at: (index := index + 1)) = '23 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '24 <78> returnSelf'.! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'test - array compilation' stamp: 'JorgeRessia 4/9/2010 16:11'!
testMultiElementArray
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'method
	^{1. 2. 3. 4. 5. 6 }'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '29 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '30 <77> pushConstant: 2'.
	self assert: (bytecode at: (index := index + 1)) = '31 <20> pushConstant: 3'.
	self assert: (bytecode at: (index := index + 1)) = '32 <21> pushConstant: 4'.
	self assert: (bytecode at: (index := index + 1)) = '33 <22> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '34 <23> pushConstant: 6'.
	self assert: (bytecode at: (index := index + 1)) = '35 <8A 86> pop 6 into (Array new: 6)'.
	self assert: (bytecode at: (index := index + 1)) = '37 <7C> returnTop'.
! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testReturnBlockInMethod
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
											compile: 'methodArgument: anObject
														^ [ anObject ]'
											in: MockCompilationClass
											classified: nil
											notifying: nil
											ifFail: [])
											generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '13 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '14 <8F 10 00 02> closureNumCopied: 1 numArgs: 0 bytes 18 to 19'.
	self assert: (bytecode at: (index := index + 1)) = '18 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '19 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '20 <7C> returnTop'.


! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testSetUp
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'setUp
												super setUp.
												collection := OrderedCollection new'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '21 <70> self'.
	bytecode := aCompiledMethod symbolic asString subStrings: '22 <85 00> superSend: setUp'.
	bytecode := aCompiledMethod symbolic asString subStrings: '24 <87> pop'.
	bytecode := aCompiledMethod symbolic asString subStrings: '25 <41> pushLit: OrderedCollection'.
	bytecode := aCompiledMethod symbolic asString subStrings: '26 <CC> send: new'.
	bytecode := aCompiledMethod symbolic asString subStrings: '27 <81 00> storeIntoRcvr: 0'.
	bytecode := aCompiledMethod symbolic asString subStrings: '29 <70> self'.
	bytecode := aCompiledMethod symbolic asString subStrings: '30 <7C> returnTop'.
! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'test - array compilation' stamp: 'JorgeRessia 4/9/2010 16:11'!
testSimpleArray
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'method
	^{1}'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '13 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '14 <8A 81> pop 1 into (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '16 <7C> returnTop'.
! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'other-tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testSupportTestSourceRangeAccessForInjectInto
	
	| aCompiledMethod aClosureCompiledMethod bytecode index codeString closureBytecode |
	codeString := 'supportTestSourceRangeAccessForInjectInto: method source: source selectionSequence: selections
	| evaluationCount sourceMap debugTokenSequence debugCount |
	DebuggerMethodMap voidMapCache.
	evaluationCount := 0.
	sourceMap := method debuggerMap abstractSourceMap.
	debugTokenSequence := selections collect: [:string| Scanner new scanTokens: string].
	debugCount := 0.
	thisContext
		runSimulated: [(1 to: 2)
						withArgs:
							{	0.
								[:sum :each|
								 evaluationCount := evaluationCount + 1.
								 sum + each]}
						executeMethod: method]
		contextAtEachStep:
			[:ctxt| | range debugTokens |
			(ctxt method == method
			and: [
				(ctxt willSend
					and: [(#(closureCopy:copiedValues: blockCopy: new: at: braceWith:with:) includes: ctxt selectorToSendOrSelf) not])
				
				or: [(ctxt willStore
					and: [(ctxt isBlock and: [ctxt pc = ctxt startpc]) not
					and: [(ctxt isBlock not
						and: [(method usesClosureBytecodes and: [ctxt abstractPC = 2])]) not]])
				or: [ctxt willReturn]]]) ifTrue:
				[debugTokens := debugTokenSequence at: (debugCount := debugCount + 1) ifAbsent: [#(bogusToken)].
				 self assert: (sourceMap includesKey: ctxt abstractPC).
				 range := sourceMap at: ctxt abstractPC ifAbsent: [(1 to: 0)].
				 self assert: (Scanner new scanTokens: (source copyFrom: range first to: range last)) = debugTokens]].
	self assert: evaluationCount = 2'.
	aCompiledMethod := (Compiler new 
									compile: codeString
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
	
		aClosureCompiledMethod := (ClosureCompiler new 
									compile: codeString
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString.
	closureBytecode := aClosureCompiledMethod symbolic asString.
	
	self assert: bytecode = closureBytecode.
	! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testToDoArgument
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'testToDoArgument
													1 to: 5 do: [ :index |
														collection add: [ index ] ].
													self assertValues: #(1 2 3 4 5)'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '29 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '30 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '32 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '33 <B4> send: <='.
	self assert: (bytecode at: (index := index + 1)) = '34 <AC 12> jumpFalse: 54'.
	self assert: (bytecode at: (index := index + 1)) = '36 <00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '37 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '38 <8F 10 00 02> closureNumCopied: 1 numArgs: 0 bytes 42 to 43'.
	self assert: (bytecode at: (index := index + 1)) = '42 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '43 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '44 <E1> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '45 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '46 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '47 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '48 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '49 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '51 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '52 <A3 EB> jumpTo: 33'.
	self assert: (bytecode at: (index := index + 1)) = '54 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '55 <22> pushConstant: #(1 2 3 4 5)'.
	self assert: (bytecode at: (index := index + 1)) = '56 <E3> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '57 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '58 <78> returnSelf'
! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testToDoArgumentNotInlined
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'testToDoArgumentNotInlined
													| block |
													block := [ :index |
														collection add: [ index ] ].
													1 to: 5 do: block.
													self assertValues: #(1 2 3 4 5)'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '33 <8F 01 00 0A> closureNumCopied: 0 numArgs: 1 bytes 37 to 46'.
	self assert: (bytecode at: (index := index + 1)) = '37 	<00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '38 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '39 	<8F 10 00 02> closureNumCopied: 1 numArgs: 0 bytes 43 to 44'.
	self assert: (bytecode at: (index := index + 1)) = '43 		<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '44 		<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '45 	<E0> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '46 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '47 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '48 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '49 <21> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '50 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '51 <F2> send: to:do:'.
	self assert: (bytecode at: (index := index + 1)) = '52 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '53 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '54 <23> pushConstant: #(1 2 3 4 5)'.
	self assert: (bytecode at: (index := index + 1)) = '55 <E4> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '56 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '57 <78> returnSelf'
! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testToDoInsideTemp
	"there seems to be a better indexzation of the temps we have one less"
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testToDoInsideTemp
														1 to: 5 do: [ :index | 
																			| temp | 
																			temp := index. 
																			collection add: [ temp ] ].
														self assertValues: #(1 2 3 4 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '29 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '30 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '32 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '33 <B4> send: <='.
	self assert: (bytecode at: (index := index + 1)) = '34 <AC 1B> jumpFalse: 63'.
	self assert: (bytecode at: (index := index + 1)) = '36 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '38 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '39 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '40 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '43 <00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '44 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '45 <8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 49 to 52'.
	self assert: (bytecode at: (index := index + 1)) = '49 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '52 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '53 <E1> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '54 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '55 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '56 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '57 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '58 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '60 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '61 <A3 E2> jumpTo: 33'.
	self assert: (bytecode at: (index := index + 1)) = '63 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '64 <22> pushConstant: #(1 2 3 4 5)'.
	self assert: (bytecode at: (index := index + 1)) = '65 <E3> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '66 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '67 <78> returnSelf'.

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testToDoInsideTempNotInlined
	"Some instructions are the same but we have a different number at he begining, and the storeTemp and popIntoTemp issue"
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testToDoInsideTempNotInlined
														| block |
														block := [ :index | 
																		| temp | 
																		temp := index. 
																		collection add: [ temp ] ].
														1 to: 5 do: block.
														self assertValues: #(1 2 3 4 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '33 <8F 01 00 0D> closureNumCopied: 0 numArgs: 1 bytes 37 to 49'.
	self assert: (bytecode at: (index := index + 1)) = '37 	<73> pushConstant: nil'.
	self assert: (bytecode at: (index := index + 1)) = '38 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '39 	<69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '40 	<00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '41 	<11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '42 	<8F 10 00 02> closureNumCopied: 1 numArgs: 0 bytes 46 to 47'.
	self assert: (bytecode at: (index := index + 1)) = '46 		<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '47 		<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '48 	<E0> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '49 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '50 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '51 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '52 <21> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '53 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '54 <F2> send: to:do:'.
	self assert: (bytecode at: (index := index + 1)) = '55 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '56 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '57 <23> pushConstant: #(1 2 3 4 5)'.
	self assert: (bytecode at: (index := index + 1)) = '58 <E4> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '59 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '60 <78> returnSelf'



! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testToDoOutsideTemp
	"there seems to be a better indexzation of the temps we have one less"
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testToDoOutsideTemp
													| temp |
													1 to: 5 do: [ :index | 
													temp := index. 
													collection add: [ temp ] ].
													self assertValues: #(5 5 5 5 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '29 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '31 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '32 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '33 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '35 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '36 <B4> send: <='.
	self assert: (bytecode at: (index := index + 1)) = '37 <AC 18> jumpFalse: 63'.
	self assert: (bytecode at: (index := index + 1)) = '39 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '40 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '43 <00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '44 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '45 <8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 49 to 52'.
	self assert: (bytecode at: (index := index + 1)) = '49 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '52 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '53 <E1> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '54 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '55 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '56 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '57 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '58 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '60 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '61 <A3 E5> jumpTo: 36'.
	self assert: (bytecode at: (index := index + 1)) = '63 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '64 <22> pushConstant: #(5 5 5 5 5)'.
	self assert: (bytecode at: (index := index + 1)) = '65 <E3> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '66 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '67 <78> returnSelf'


! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:11'!
testToDoOutsideTempNotInlined
	"there seems to be a better indexzation of the temps we have one more"
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testToDoOutsideTempNotInlined
														| block temp |
														block := [ :index | 
																	temp := index. 
																	collection add: [ temp ] ].
														1 to: 5 do: block.
														self assertValues: #(5 5 5 5 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '33 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '35 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '36 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '37 <8F 11 00 10> closureNumCopied: 1 numArgs: 1 bytes 41 to 56'.
	self assert: (bytecode at: (index := index + 1)) = '41 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '42 	<8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '45 	<00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '46 	<11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '47 	<8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 51 to 54'.
	self assert: (bytecode at: (index := index + 1)) = '51 		<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '54 		<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '55 	<E0> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '56 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '57 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '58 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '59 <21> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '60 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '61 <F2> send: to:do:'.
	self assert: (bytecode at: (index := index + 1)) = '62 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '63 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '64 <23> pushConstant: #(5 5 5 5 5)'.
	self assert: (bytecode at: (index := index + 1)) = '65 <E4> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '66 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '67 <78> returnSelf'

	

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'other-tests' stamp: 'JorgeRessia 4/9/2010 16:12'!
testUniqueBlockIndeces
	
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
									compile: 'testIndexOf
	| tmp index collection |
	collection := self collectionMoreThan1NoDuplicates.
	tmp := collection size.
	collection reverseDo: 
		[ :each | 
		each = self elementInForIndexAccessing ifTrue: [ index := tmp ].
		tmp := tmp - 1 ].
	self assert: (collection indexOf: self elementInForIndexAccessing) = index'
									in: MockCompilationClass
									classified: nil
									notifying: nil
									ifFail: [])
									generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '33 <8A 02> push: (Array new: 2)'.
	self assert: (bytecode at: (index := index + 1)) = '35 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '36 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '37 <D0> send: collectionMoreThan1NoDuplicates'.
	self assert: (bytecode at: (index := index + 1)) = '38 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '39 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '40 <C2> send: size'.
	self assert: (bytecode at: (index := index + 1)) = '41 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '44 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '45 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '46 <8F 11 00 14> closureNumCopied: 1 numArgs: 1 bytes 50 to 69'.
	self assert: (bytecode at: (index := index + 1)) = '50 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '51 	<70> self'.
	self assert: (bytecode at: (index := index + 1)) = '52 	<D1> send: elementInForIndexAccessing'.
	self assert: (bytecode at: (index := index + 1)) = '53 	<B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '54 	<9D> jumpFalse: 61'.
	self assert: (bytecode at: (index := index + 1)) = '55 	<8D 00 01> storeIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '58 	<8D 01 01> storeIntoTemp: 1 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '61 	<8C 00 01> pushTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '64 	<76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '65 	<B1> send: -'.
	self assert: (bytecode at: (index := index + 1)) = '66 	<8D 00 01> storeIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '69 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '70 <E2> send: reverseDo:'.
	self assert: (bytecode at: (index := index + 1)) = '71 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '72 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '73 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '74 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '75 <D1> send: elementInForIndexAccessing'.
	self assert: (bytecode at: (index := index + 1)) = '76 <E3> send: indexOf:'.
	self assert: (bytecode at: (index := index + 1)) = '77 <8C 01 01> pushTemp: 1 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '80 <B6> send: ='.
	self assert: (bytecode at: (index := index + 1)) = '81 <E4> send: assert:'.
	self assert: (bytecode at: (index := index + 1)) = '82 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '83 <78> returnSelf'.! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:12'!
testWhileModificationAfter
	"Different integers in the bytecode, some of them"
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testWhileModificationAfter
													| index |
													index := 0.
													[ index < 5 ] whileTrue: [
															collection add: [ index ].
															index := index + 1 ].
													self assertValues: #(5 5 5 5 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '29 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '31 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '32 <75> pushConstant: 0'.
	self assert: (bytecode at: (index := index + 1)) = '33 <8E 00 00> popIntoTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '36 <8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '39 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '40 <B2> send: <'.
	self assert: (bytecode at: (index := index + 1)) = '41 <AC 16> jumpFalse: 65'.
	self assert: (bytecode at: (index := index + 1)) = '43 <00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '44 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '45 <8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 49 to 52'.
	self assert: (bytecode at: (index := index + 1)) = '49 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '52 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '53 <E1> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '54 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '55 <8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '58 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '59 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '60 <8E 00 00> popIntoTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '63 <A3 E3> jumpTo: 36'.
	self assert: (bytecode at: (index := index + 1)) = '65 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '66 <22> pushConstant: #(5 5 5 5 5)'.
	self assert: (bytecode at: (index := index + 1)) = '67 <E3> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '68 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '69 <78> returnSelf'

	
	

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:12'!
testWhileModificationAfterNotInlined
	"The bytecodes integers are different in some cases."
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testWhileModificationAfterNotInlined
														| index block |
														index := 0.
														block := [ 
															collection add: [ index ].
															index := index + 1 ].
														[ index < 5 ] whileTrue: block.
														self assertValues: #(5 5 5 5 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '33 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '35 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '36 <75> pushConstant: 0'.
	self assert: (bytecode at: (index := index + 1)) = '37 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '40 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '41 <8F 10 00 15> closureNumCopied: 1 numArgs: 0 bytes 45 to 65'.
	self assert: (bytecode at: (index := index + 1)) = '45 	<00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '46 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '47 	<8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 51 to 54'.
	self assert: (bytecode at: (index := index + 1)) = '51 		<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '54 		<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '55 	<E0> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '56 	<87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '57 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '60 	<76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '61 	<B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '62 	<8D 00 00> storeIntoTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '65 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '66 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '67 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '68 <8F 10 00 06> closureNumCopied: 1 numArgs: 0 bytes 72 to 77'.
	self assert: (bytecode at: (index := index + 1)) = '72 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '75 	<21> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '76 	<B2> send: <'.
	self assert: (bytecode at: (index := index + 1)) = '77 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '78 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '79 <E2> send: whileTrue:'.
	self assert: (bytecode at: (index := index + 1)) = '80 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '81 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '82 <23> pushConstant: #(5 5 5 5 5)'.
	self assert: (bytecode at: (index := index + 1)) = '83 <E4> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '84 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '85 <78> returnSelf'

	
	

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:12'!
testWhileModificationBefore
	"The bytecodes integers are different in some cases."
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testWhileModificationBefore
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [ 
		index := index + 1.
		collection add: [ index ] ].
	self assertValues: #(5 5 5 5 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '29 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '31 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '32 <75> pushConstant: 0'.
	self assert: (bytecode at: (index := index + 1)) = '33 <8E 00 00> popIntoTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '36 <8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '39 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '40 <B2> send: <'.
	self assert: (bytecode at: (index := index + 1)) = '41 <AC 16> jumpFalse: 65'.
	self assert: (bytecode at: (index := index + 1)) = '43 <8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '46 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '47 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '48 <8E 00 00> popIntoTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '51 <00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '52 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '53 <8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 57 to 60'.
	self assert: (bytecode at: (index := index + 1)) = '57 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '60 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '61 <E1> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '62 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '63 <A3 E3> jumpTo: 36'.
	self assert: (bytecode at: (index := index + 1)) = '65 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '66 <22> pushConstant: #(5 5 5 5 5)'.
	self assert: (bytecode at: (index := index + 1)) = '67 <E3> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '68 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '69 <78> returnSelf'

	
	

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:12'!
testWhileModificationBeforeNotInlined
	"The bytecodes integers are different in some cases."
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testWhileModificationBeforeNotInlined
														| index block |
														index := 0.
														block := [ 
																index := index + 1.
																collection add: [ index ] ].
														[ index < 5 ] whileTrue: block.
														self assertValues: #(5 5 5 5 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '33 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '35 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '36 <75> pushConstant: 0'.
	self assert: (bytecode at: (index := index + 1)) = '37 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '40 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '41 <8F 10 00 14> closureNumCopied: 1 numArgs: 0 bytes 45 to 64'.
	self assert: (bytecode at: (index := index + 1)) = '45 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '48 	<76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '49 	<B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '50 	<8E 00 00> popIntoTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '53 	<00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '54 	<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '55 	<8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 59 to 62'.
	self assert: (bytecode at: (index := index + 1)) = '59 		<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '62 		<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '63 	<E0> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '64 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '65 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '66 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '67 <8F 10 00 06> closureNumCopied: 1 numArgs: 0 bytes 71 to 76'.
	self assert: (bytecode at: (index := index + 1)) = '71 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '74 	<21> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '75 	<B2> send: <'.
	self assert: (bytecode at: (index := index + 1)) = '76 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '77 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '78 <E2> send: whileTrue:'.
	self assert: (bytecode at: (index := index + 1)) = '79 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '80 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '81 <23> pushConstant: #(5 5 5 5 5)'.
	self assert: (bytecode at: (index := index + 1)) = '82 <E4> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '83 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '84 <78> returnSelf'

	
	

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:12'!
testWhileWithTemp
	"The bytecodes integers are different in some cases."
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testWhileWithTemp
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [
		| temp |
		temp := index := index + 1.
		collection add: [ temp ] ].
	self assertValues: #(1 2 3 4 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '29 <75> pushConstant: 0'.
	self assert: (bytecode at: (index := index + 1)) = '30 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '31 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '32 <20> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '33 <B2> send: <'.
	self assert: (bytecode at: (index := index + 1)) = '34 <AC 19> jumpFalse: 61'.
	self assert: (bytecode at: (index := index + 1)) = '36 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '38 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '39 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '40 <76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '41 <B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '42 <81 40> storeIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '44 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '47 <00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '48 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '49 <8F 10 00 04> closureNumCopied: 1 numArgs: 0 bytes 53 to 56'.
	self assert: (bytecode at: (index := index + 1)) = '53 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '56 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '57 <E1> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '58 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '59 <A3 E2> jumpTo: 31'.
	self assert: (bytecode at: (index := index + 1)) = '61 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '62 <22> pushConstant: #(1 2 3 4 5)'.
	self assert: (bytecode at: (index := index + 1)) = '63 <E3> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '64 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '65 <78> returnSelf'

	
	

! !

!NewCompilerWithChangesFunctionalTests methodsFor: 'tests' stamp: 'JorgeRessia 4/9/2010 16:12'!
testWhileWithTempNotInlined
	"The bytecodes integers are different in some cases."
	| aCompiledMethod bytecode index |
	aCompiledMethod := (ClosureCompiler new 
										compile: 'testWhileWithTempNotInlined
	| index block |
	index := 0.
	block := [
		| temp |
		temp := index := index + 1.
		collection add: [ temp ] ].
	[ index < 5 ] whileTrue: block.
	self assertValues: #(1 2 3 4 5)'
	in: MockCompilationClass
	classified: nil
	notifying: nil
	ifFail: [])
	generate.
									
	bytecode := aCompiledMethod symbolic asString subStrings: '
'.
	index := 0.
	self assert: (bytecode at: (index := index + 1)) = '33 <8A 01> push: (Array new: 1)'.
	self assert: (bytecode at: (index := index + 1)) = '35 <69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '36 <75> pushConstant: 0'.
	self assert: (bytecode at: (index := index + 1)) = '37 <8E 00 01> popIntoTemp: 0 inVectorAt: 1'.
	self assert: (bytecode at: (index := index + 1)) = '40 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '41 <8F 10 00 14> closureNumCopied: 1 numArgs: 0 bytes 45 to 64'.
	self assert: (bytecode at: (index := index + 1)) = '45 	<73> pushConstant: nil'.
	self assert: (bytecode at: (index := index + 1)) = '46 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '49 	<76> pushConstant: 1'.
	self assert: (bytecode at: (index := index + 1)) = '50 	<B0> send: +'.
	self assert: (bytecode at: (index := index + 1)) = '51 	<8D 00 00> storeIntoTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '54 	<69> popIntoTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '55 	<00> pushRcvr: 0'.
	self assert: (bytecode at: (index := index + 1)) = '56 	<11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '57 	<8F 10 00 02> closureNumCopied: 1 numArgs: 0 bytes 61 to 62'.
	self assert: (bytecode at: (index := index + 1)) = '61 		<10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '62 		<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '63 	<E0> send: add:'.
	self assert: (bytecode at: (index := index + 1)) = '64 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '65 <68> popIntoTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '66 <11> pushTemp: 1'.
	self assert: (bytecode at: (index := index + 1)) = '67 <8F 10 00 06> closureNumCopied: 1 numArgs: 0 bytes 71 to 76'.
	self assert: (bytecode at: (index := index + 1)) = '71 	<8C 00 00> pushTemp: 0 inVectorAt: 0'.
	self assert: (bytecode at: (index := index + 1)) = '74 	<21> pushConstant: 5'.
	self assert: (bytecode at: (index := index + 1)) = '75 	<B2> send: <'.
	self assert: (bytecode at: (index := index + 1)) = '76 	<7D> blockReturn'.
	self assert: (bytecode at: (index := index + 1)) = '77 <10> pushTemp: 0'.
	self assert: (bytecode at: (index := index + 1)) = '78 <E2> send: whileTrue:'.
	self assert: (bytecode at: (index := index + 1)) = '79 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '80 <70> self'.
	self assert: (bytecode at: (index := index + 1)) = '81 <23> pushConstant: #(1 2 3 4 5)'.
	self assert: (bytecode at: (index := index + 1)) = '82 <E4> send: assertValues:'.
	self assert: (bytecode at: (index := index + 1)) = '83 <87> pop'.
	self assert: (bytecode at: (index := index + 1)) = '84 <78> returnSelf'

	
	

! !

TestCase subclass: #PragmaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!PragmaTest methodsFor: 'accessing' stamp: 'ms 9/4/2006 00:25'!
expectedFailures

	Smalltalk at: #ExternalFunction ifAbsent:[^#(#testApicall #testCdecl #testCdeclNoModule)].
	^#()! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/19/2006 00:12'!
methodApicall
	^'methodApicall: aHWND
		<apicall: Win32HDC ''GetDC'' (Win32Window bool bool*) module: ''user32.dll''>
		^self externalCallFailed'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/19/2006 00:15'!
methodCdecl
	^'XCloseDisplay: aDisplay
		<cdecl: void ''XCloseDisplay'' (X11Display*) module:''X11''>
		^self externalCallFailed'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/25/2006 08:36'!
methodCdeclNoModule
	^'ffiTestShort: c1 with: c2 with: c3 with: c4
		"FFITester ffiTestShort: $A with: 65 with: 65.0 with: $A"
		<cdecl: short ''ffiTestShorts'' (short short short short)>
		^self externalCallFailed'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/16/2006 21:03'!
methodDoublePragma
	^'methodDoublePragma
		<hello: 5>
		<hello: 2>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/16/2006 20:56'!
methodDoublePrimitive
	^'methodDoublePrimitive
		<primitive: 5>
		<primitive: 2>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/26/2006 22:53'!
methodNoPragma
	^'methodNoPragma: aNum
		^aNum'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/16/2006 21:04'!
methodPragmaAfterBeforTemps
	^'methodPragmaAfterBeforTemps
		<hello: 5>
		| aTemp |
		<world: #ok>
		<blue: true>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/20/2006 20:49'!
methodPragmaTwoParam
	^'methodDoublePragma
		<hello: 5 by: 2>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/25/2006 07:56'!
methodPragmaUnarayMessage
	^'methodPragmaUnarayMessage
		<hello>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/16/2006 21:05'!
methodPrimitive
	^'methodPrimitive
		<primitive: 4>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/16/2006 21:05'!
methodPrimitivePragma
	^'methodPrimitivePragma
		<hello: 1>
		<primitive: 4>
		<hello: 1>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/22/2006 13:31'!
methodPrimitiveString
	^'methodPrimitiveString
		<primitive: ''aFunctionName''>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/22/2006 13:33'!
methodPrimitiveStringModule
	^'methodPrimitiveStringModule
		<primitive: ''aFunctionName'' module: ''aModuleName''>'! !

!PragmaTest methodsFor: 'method-tested' stamp: 'ms 7/16/2006 21:06'!
methodSinglePragma
	^'methodSinglePragma
		<hello: 5>'! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:13'!
testApicall
	| aRBMethode |
	aRBMethode := ClosureCompiler new parse: self methodApicall in: self class notifying: [nil].
	
	"self assert: ((aRBMethode compiledMethod literalAt: 1) isKindOf: ExternalLibraryFunction)."
	self assert: (aRBMethode compiledMethod primitive = 120)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:13'!
testCdecl
	| aRBMethode |
	aRBMethode := ClosureCompiler new parse: self methodCdecl in: self class notifying: [nil].
	
	"self assert: ((aRBMethode compiledMethod literalAt: 1) isKindOf: ExternalLibraryFunction)."
	self assert: (aRBMethode compiledMethod primitive = 120)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:20'!
testCdeclNoModule
	| aRBMethode |
	aRBMethode := ClosureCompiler new parse: self methodCdeclNoModule in: self class notifying: [nil].
	
	"self assert: ((aRBMethode compiledMethod literalAt: 1) isKindOf: ExternalLibraryFunction)."
	self assert: (aRBMethode compiledMethod primitive = 120)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:13'!
testDoublePragma
	| aRBMethode |
	"self debug: #testDoublePragma"
	aRBMethode := ClosureCompiler new parse: self methodDoublePragma in: self class notifying: [nil].
	
	self assert: (aRBMethode compiledMethod pragmas first keyword = #hello:).
	self assert: (aRBMethode compiledMethod pragmas second keyword = #hello:)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:13'!
testDoublePrimitive
	"self debug: #testDoublePrimitive"
	self should: [ClosureCompiler new parse: self methodDoublePrimitive in: self class notifying: [^nil]] raise: Warning! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:14'!
testIsPrimitve
	| aRBMethode |

	aRBMethode := ClosureCompiler new parse: self methodPrimitive in: self class notifying: [nil].
	
	self assert: aRBMethode isPrimitive! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:14'!
testNoPragma
	"self debug: #testDoublePrimitive"
	self shouldnt: [ClosureCompiler new parse: self methodNoPragma in: self class notifying: nil] raise: Error! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:15'!
testPragmaAfterBeforTemp
	"self debug: #testPragmaAfterBeforTemp"
	| aRBMethode |
	aRBMethode := ClosureCompiler new parse: self methodPragmaAfterBeforTemps in: self class notifying: nil.


	self assert: (aRBMethode compiledMethod pragmas first keyword = #hello:).
	self assert: (aRBMethode compiledMethod pragmas second keyword = #world:)
	! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:15'!
testPragmaTwoParam
	"self debug: #testPragmaAfterBeforTemp"
	| aRBMethode |
	aRBMethode := ClosureCompiler new parse: self methodPragmaTwoParam in: self class notifying: nil.


	self assert: (aRBMethode compiledMethod pragmas first keyword = #hello:by:)
	! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:15'!
testPragmaUnarayMessage
	| aRBMethode |

	aRBMethode := ClosureCompiler new parse: self methodPragmaUnarayMessage in: self class notifying: [nil].
	
	self assert: (aRBMethode compiledMethod pragmas first keyword = #hello)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:15'!
testPrimitiveNumber
	| aRBMethode |

	aRBMethode := ClosureCompiler new parse: self methodPrimitive in: self class notifying: [nil].
	
	self assert: (aRBMethode compiledMethod primitive = 4)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:15'!
testPrimitivePragmaNumber
	| aRBMethode |

	aRBMethode := ClosureCompiler new parse: self methodPrimitivePragma in: self class notifying: [^nil].
	
	self assert: (aRBMethode compiledMethod primitive = 4)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:15'!
testPrimitiveString
	| aRBMethode |

	aRBMethode := ClosureCompiler new parse: self methodPrimitiveString in: self class notifying: [nil].
	
	self assert: (aRBMethode compiledMethod primitive = 117)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:15'!
testPrimitiveStringModule
	| aRBMethode |

	aRBMethode := ClosureCompiler new parse: self methodPrimitiveStringModule in: self class notifying: [nil].
	
	self assert: (aRBMethode compiledMethod primitive = 117)! !

!PragmaTest methodsFor: 'testing' stamp: 'marcus.denker 10/6/2008 10:15'!
testSinglePragma
	| aRBMethode |
	aRBMethode := ClosureCompiler new parse: self methodSinglePragma in: self class notifying: [nil].
	self assert: (aRBMethode compiledMethod pragmas first keyword = #hello:)
	! !

TestCase subclass: #SourceCode2BytecodeTest
	instanceVariableNames: 'instVar'
	classVariableNames: 'ClassVar'
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!SourceCode2BytecodeTest commentStamp: 'kwl 10/14/2006 10:43' prior: 0!
I provide at least one test which corresponds to a message sent by InstructionStream>>#interpretNextInstructionFor: to its client.!

!SourceCode2BytecodeTest methodsFor: 'compiling' stamp: 'kwl 10/14/2006 13:52'!
compile2methodNode: sourceStream 
	"Compile code without logging the source in the changes file"
	| methodNode |
	methodNode := ClosureCompiler new
				from: sourceStream
				class: self class
				classified: nil
				context: nil
				notifying: nil;
				
				translate: sourceStream
				noPattern: false
				ifFail: [^ nil].
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: #(0 0 0 0 )! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:53'!
testDoDup
	| selector methodNode scanner |
	selector := (methodNode := self compile2methodNode: 'duplicateTopBytecode 3 + 4; yourself') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self assert: scanner peekInstruction selector == #doDup description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:01'!
testDoPop
	| selector methodNode scanner |
	selector := (methodNode := self compile2methodNode: 'popStackBytecode 3 + 4') selector.
	scanner := InstructionStream on: methodNode method.
	3
		timesRepeat: [scanner nextInstruction].
	self assert: scanner peekInstruction selector == #doPop description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:11'!
testPrimAdd
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimAdd 3 + 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#+. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:32'!
testPrimAt
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimAt self at: 3') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#at:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:38'!
testPrimAtEnd
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimSize self atEnd') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#atEnd. false. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:30'!
testPrimAtPut
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimAtPut self at: 3 put: 4') selector.
	scanner := InstructionStream on: methodNode method.
	3
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#at:put:. false. 2}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:27'!
testPrimBitAnd
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimBitAnd 3 bitAnd: 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#bitAnd:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:28'!
testPrimBitOr
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimBitOr 3 bitOr: 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#bitOr:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:24'!
testPrimBitShift
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimBitShift 3 bitShift: 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#bitShift:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'ms 5/18/2007 09:34'!
testPrimBlockCopy
	| selector methodNode scanner did aBoolean |
	aBoolean := Preferences compileBlocksAsClosures.
	Preferences setPreference: #compileBlocksAsClosures toValue: false.
	[selector := (methodNode := self compile2methodNode: 'bytecodePrimBlockCopy [nil] value') selector.
	scanner := InstructionStream on: methodNode method.]
		ensure:[Preferences setPreference: #compileBlocksAsClosures toValue: aBoolean].
		
	2 timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#blockCopy:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:44'!
testPrimClass
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimClass self class') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#class. false. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:17'!
testPrimDivide
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimDivide 3 / 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#/. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:57'!
testPrimDoWith
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodeDoWith self do: #something') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#do:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:16'!
testPrimEqual
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimEqual 3 = 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#'='. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:15'!
testPrimGreaterOrEqual
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimGreaterOrEqual 3 >= 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#'>='. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:14'!
testPrimGreaterThan
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimGreaterThan 3 > 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#>. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:39'!
testPrimIdentity
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimIdentity 3 == 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#==. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:14'!
testPrimLessOrEqual
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimLessOrEqual 3 <= 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#<=. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:13'!
testPrimLessThan
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimLessThan 3 < 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#<. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:21'!
testPrimMakePoint
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimMakePoint 3 @ 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#'@'. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:19'!
testPrimMod
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimMod 3 \\ 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#\\. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:17'!
testPrimMultiply
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimMultiply 3 * 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#'*'. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:59'!
testPrimNew
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimNew super new') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#new. true. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:00'!
testPrimNewWith
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodeNewWith self new: 3') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#new:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:36'!
testPrimNext
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimSize self next') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#next. false. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:38'!
testPrimNextPut
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimNextPut self nextPut: 3') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#nextPut:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:16'!
testPrimNotEqual
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimNotEqual 3 ~= 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#~=. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:01'!
testPrimPointX
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimPointX self x') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#x. false. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:01'!
testPrimPointY
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimPointY self y') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#y. false. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:26'!
testPrimQuo
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimQuo 3 // 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#//. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:32'!
testPrimSize
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimSize self size') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#size. false. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:12'!
testPrimSubtract
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimSubtract 3 - 4') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#-. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:55'!
testPrimValue
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodePrimValue self value') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#value. false. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:57'!
testPrimValueWith
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodeValueWith self value: 3') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#value:. false. 1}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 12:03'!
testPushActiveContextBytecode
	| selector methodNode scanner |
	selector := (methodNode := self compile2methodNode: 'pushActiveContextBytecode thisContext yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self assert: scanner peekInstruction selector == #pushActiveContext
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:35'!
testPushConstantFalseBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushConstantFalseBytecode false yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushConstant:
				and: [did arguments first == false])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:37'!
testPushConstantMinusOneBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushConstantMinusOneBytecode -1 yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushConstant:
				and: [did arguments first == -1])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:36'!
testPushConstantNilBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushConstantNilBytecode nil yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushConstant:
				and: [did arguments first == nil])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:39'!
testPushConstantOneBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushConstantOneBytecode 1 yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushConstant:
				and: [did arguments first == 1])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:33'!
testPushConstantTrueBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushConstantTrueBytecode true yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self assert: ((did := scanner peekInstruction) selector == #pushConstant:
					and: [did arguments first == true])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:39'!
testPushConstantTwoBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushConstantTwoBytecode 2 yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushConstant:
				and: [did arguments first == 2])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:38'!
testPushConstantZeroBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushConstantZeroBytecode 0 yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushConstant:
				and: [did arguments first == 0])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:33'!
testPushLiteralConstantBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushLiteralConstantBytecode #() yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self assert: ((did := scanner peekInstruction) selector == #pushConstant:
					and: [did arguments first = #()])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 10:42'!
testPushLiteralVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushLiteralVariableBytecode ClassVar yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushLiteralVariable:
				and: [did arguments first = (#ClassVar -> nil)])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:27'!
testPushReceiverBytecode
	| selector methodNode scanner |
	selector := (methodNode := self compile2methodNode: 'pushReceiverBytecode ^ self yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self assert: scanner peekInstruction selector == #pushReceiver
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:39'!
testPushReceiverVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushReceiverVariableBytecode instVar yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushReceiverVariable:
				and: [did arguments first == 1])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 20:11'!
testPushTemporaryVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'pushTemporaryVariableBytecode: t0 t0 yourself') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner peekInstruction) selector == #pushTemporaryVariable:
				and: [did arguments first == 0])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:48'!
testReturnFalseBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'returnFalseBytecode 3 + 4. ^ false') selector.
	scanner := InstructionStream on: methodNode method.
	4
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #methodReturnConstant:
				and: [did arguments first == false])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:49'!
testReturnNilBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'returnNilBytecode 3 + 4. ^ nil') selector.
	scanner := InstructionStream on: methodNode method.
	4
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #methodReturnConstant:
				and: [did arguments first == nil])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:47'!
testReturnReceiver
	| selector methodNode scanner |
	selector := (methodNode := self compile2methodNode: 'returnReceiver 3 + 4. ^ self') selector.
	scanner := InstructionStream on: methodNode method.
	4
		timesRepeat: [scanner nextInstruction].
	self assert: scanner peekInstruction selector == #methodReturnReceiver
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'ms 5/18/2007 09:40'!
testReturnTopFromBlock
	| selector methodNode scanner aBoolean |
	aBoolean := Preferences compileBlocksAsClosures.
	Preferences setPreference: #compileBlocksAsClosures toValue: false.
	[selector := (methodNode := self compile2methodNode: 'returnTopFromBlock ^[ia]') selector.
	scanner := InstructionStream on: methodNode method.]
		ensure:[Preferences setPreference: #compileBlocksAsClosures toValue: aBoolean].
	5
		timesRepeat: [scanner nextInstruction].
	self assert: scanner peekInstruction selector == #blockReturnTop
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:53'!
testReturnTopFromMethod
	| selector methodNode scanner |
	selector := (methodNode := self compile2methodNode: 'returnTopFromMethod ^ 3 + 4') selector.
	scanner := InstructionStream on: methodNode method.
	3
		timesRepeat: [scanner nextInstruction].
	self assert: scanner peekInstruction selector == #methodReturnTop
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 19:48'!
testReturnTrueBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'returnTrueBytecode 3 + 4. ^ true') selector.
	scanner := InstructionStream on: methodNode method.
	4
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #methodReturnConstant:
				and: [did arguments first == true])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 10:56'!
testStoreAndPopLiteralVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'storeAndPopLiteralVariableBytecode ClassVar := nil') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner nextInstruction; peekInstruction) selector == #popIntoLiteralVariable:
				and: [did arguments first = (#ClassVar -> nil)])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:39'!
testStoreAndPopReceiverVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'storeAndPopReceiverVariableBytecode instVar := self') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner nextInstruction; peekInstruction) selector == #popIntoReceiverVariable:
				and: [did arguments first == 1])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/12/2006 20:16'!
testStoreAndPopTemporaryVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'storeAndPopTemporaryVariableBytecode | t0 t1 | t1 := t0') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner nextInstruction; peekInstruction) selector == #popIntoTemporaryVariable:
				and: [did arguments first == 1])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 10:53'!
testStoreIntoLiteralVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'storeIntoLiteralVariableBytecode ^ (ClassVar := nil)') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner nextInstruction; peekInstruction) selector == #storeIntoLiteralVariable:
				and: [did arguments first = (#ClassVar -> nil)])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:40'!
testStoreIntoReceiverVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'storeIntoReceiverVariableBytecode ^ (instVar := self)') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner nextInstruction; peekInstruction) selector == #storeIntoReceiverVariable:
				and: [did arguments first == 1])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 10:51'!
testStoreIntoTemporaryVariableBytecode
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'storeIntoTemporaryVariableBytecode | t0 t1 | ^ (t1 := t0)') selector.
	scanner := InstructionStream on: methodNode method.
	self
		assert: ((did := scanner nextInstruction; peekInstruction) selector == #storeIntoTemporaryVariable:
				and: [did arguments first == 1])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:04'!
testSuperSend
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodeSuperSend super yourself') selector.
	scanner := InstructionStream on: methodNode method.
	1
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#yourself. true. 0}])
		description: 'Failed ' , selector! !

!SourceCode2BytecodeTest methodsFor: 'tests' stamp: 'kwl 10/14/2006 13:04'!
testSuperSendWith
	| selector methodNode scanner did |
	selector := (methodNode := self compile2methodNode: 'bytecodeSuperSendWith super new: 0') selector.
	scanner := InstructionStream on: methodNode method.
	2
		timesRepeat: [scanner nextInstruction].
	self
		assert: ((did := scanner peekInstruction) selector == #send:super:numArgs:
				and: [did arguments = {#new:. true. 1}])
		description: 'Failed ' , selector! !

TestCase subclass: #SqueakParserTest
	instanceVariableNames: 'rbMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 11/17/2006 16:54'!
assertCommentOn: rbNode

	rbNode peekInsideComment 
		do: [:each | self assert: each value = '"0 remove"'].
	rbNode peekBeforeComment do: 
			[:each | 
			self assert: each value ~= '"0 remove"'.
			self assert: (each value indexOf: $b) > 0].
	rbNode peekAfterComment do: 
			[:each | 
			self assert: each value ~= '"0 remove"'.
			self assert: (each value indexOf: $a) > 0]! !

!SqueakParserTest methodsFor: 'util' stamp: 'ms 7/15/2006 10:50'!
keyword: anObject
	"For test"
	^anObject copy! !

!SqueakParserTest methodsFor: 'util' stamp: 'ms 5/28/2007 14:06'!
methodDescribeWithAllComment: "36b" anObject "34a" And: a "35a"
	"This is a method to see where are comment
	 Comment mark 0 remove tell you that nobody can contain it except the node 
	 who contain the comment(e.g. between firstToken and lastToken
	"
	
	"21b"
	<hello: "0 remove" 'you' "0 remove" > "22a"
	
	"2b"
	| ok |
	
	"3b"
	[
	
	"4b"
	^anObject copy "5a"
	
	]. "6a"

	[ 
	"7b" 
	 :each 
	 "8b"
	 || temp | "30a"
	
	 "0 remove"
	].
	
	"9b"
	(ok := 3). "10a"
	
	"11b"
	#( 3 4 5). "12a"
	
	[
	"13b"
	| "14b" 
	 temp "15a"
	 "0 remove"
	|
	
	"16b"
	self "17a" 
	
	"0 remove"
	].

	"19b"
	nil. "20a"
	
	"23b"
	true not; "37b" whileTrue: [
		
		"31b"
		-6 "32a".
		
		^self
			
	]. "25a"
	
	"26b"
	3 + 3. "27a"
	
	"28b"
	^Object new. "29a"
	
	"0 remove"
	"0 remove"
	
	
	
	! !

!SqueakParserTest methodsFor: 'runing' stamp: 'ms 9/19/2006 23:18'!
setUp
	
	rbMethod := SqueakParser parseMethod: (SqueakParserTest>>#methodDescribeWithAllComment:And:) getSource.
	rbMethod addComment
	! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 5/28/2007 11:48'!
testCommentAtEnd
	| rbNode |
	rbNode := SqueakParser parseMethod: 'foo "foo"'.
	rbNode addComment.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 0.
	self assert: rbNode peekAfterComment size = 1.! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnAssignment
	| rbNode |
	rbNode := rbMethod body statements third.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnBlock
	| rbNode |
	rbNode := rbMethod body statements first.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode.
	rbNode := rbMethod body statements second arguments first.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 0.
	self assertCommentOn: rbNode.
	rbNode := rbMethod body statements second.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 1.
	self assert: rbNode peekBeforeComment size = 0.
	self assert: rbNode peekAfterComment size = 0.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 5/28/2007 14:30'!
testCommentOnCascade
	| rbNode |
	rbNode := rbMethod body statements seventh.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode.
	rbNode := rbMethod body statements seventh messages second arguments first.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 0.
	self assertCommentOn: rbNode.
	rbNode := rbMethod body statements seventh messages second arguments first 
				body statements 
				first.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnLiteral
	| rbNode |
	rbNode := rbMethod body statements fourth.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode.
	rbNode := rbMethod body statements sixth.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnMessage
	| rbNode |
	rbNode := rbMethod body statements eighth.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnMethod
	self assert: rbMethod comments notEmpty.
	self assert: rbMethod comments size = 3.
	self assert: rbMethod peekInsideComment size = 2.
	self assert: rbMethod peekBeforeComment size = 0.
	self assert: rbMethod peekAfterComment size = 1.
	self assertCommentOn: rbMethod! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnMethodArguments
	| rbNode |
	rbNode := rbMethod arguments first.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode.
	rbNode := rbMethod arguments second.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 0.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnMethodSequence
	| rbNode |
	rbNode := rbMethod body.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 0.
	self assertCommentOn: rbNode.
	rbNode := rbMethod body statements second body.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 0.
	self assertCommentOn: rbNode.
	rbNode := rbMethod body statements second body temporaries first.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 0.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnPragmas
	| rbNode |
	rbNode := rbMethod pragmas first.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 4.
	self assert: rbNode peekInsideComment size = 2.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnReturn
	| rbNode |
	rbNode := rbMethod body statements ninth.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnSequence
	| rbNode |
	rbNode := rbMethod body statements fifth body.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 1.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 0.
	self assertCommentOn: rbNode.
	rbNode := rbMethod body statements fifth.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 1.
	self assert: rbNode peekInsideComment size = 1.
	self assert: rbNode peekBeforeComment size = 0.
	self assert: rbNode peekAfterComment size = 0.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 9/20/2006 20:19'!
testCommentOnTempStatement
	| rbNode |
	rbNode := rbMethod body statements fifth body temporaries first.
	self assert: rbNode comments notEmpty.
	self assert: rbNode comments size = 2.
	self assert: rbNode peekInsideComment size = 0.
	self assert: rbNode peekBeforeComment size = 1.
	self assert: rbNode peekAfterComment size = 1.
	self assertCommentOn: rbNode! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 7/13/2006 15:33'!
testEmptyStatement
	"self debug: #testEmptyStatement"

	self shouldnt: [SqueakParser parseDoIt: 'Object new..' ] raise: Error.
	self shouldnt: [SqueakParser parseDoIt: '..Object new' ] raise: Error.
	self shouldnt: [SqueakParser parseDoIt: 'Object new..Object new' ] raise: Error.
	
	self assert: ((SqueakParser parseDoIt: 'Object new..') class = RBDoItNode).
	self assert: ((SqueakParser parseDoIt: '..Object new') class = RBDoItNode).
	self assert: ((SqueakParser parseDoIt: 'Object new..Object new') class = RBDoItNode)! !

!SqueakParserTest methodsFor: 'testing' stamp: 'ms 7/15/2006 10:51'!
testMethodPattern
	"self debug: #testEmptyStatement"

	self shouldnt: [SqueakParser parseMethodPattern: (self class>>#keyword:) getSource ] raise: Error.

! !

TestCase subclass: #SqueakTokenTest
	instanceVariableNames: 'aToken'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!SqueakTokenTest methodsFor: 'running' stamp: 'ms 11/17/2006 17:10'!
setUp

	| ast |
	ast := SqueakParser parseMethod: 'zork "boo" | e | ', String cr, ' e := 3 + 4.', String cr, '^e'.
	aToken := ast firstToken! !

!SqueakTokenTest methodsFor: 'testing' stamp: 'ms 11/17/2006 18:17'!
testIsComment
	
	self assert: (aToken isComment not).
	self assert: (aToken next isComment not).
	self assert: (aToken next next isComment)! !

!SqueakTokenTest methodsFor: 'testing' stamp: 'ms 11/17/2006 18:00'!
testIsSignificant
	
	self assert: (aToken isSignificant).
	self assert: (aToken next isSignificant not).
	self assert: (aToken next next isSignificant not)! !

!SqueakTokenTest methodsFor: 'testing' stamp: 'ms 11/17/2006 18:07'!
testNext
	
	self assert: (aToken next isKindOf: SqueakToken).! !

!SqueakTokenTest methodsFor: 'testing' stamp: 'ms 11/17/2006 18:25'!
testPrevious
	
	self assert: (aToken previous == nil).
	self assert: (aToken next previous isKindOf: SqueakToken)! !

TestCase subclass: #VariableNodeDataTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!VariableNodeDataTest methodsFor: 'tests' stamp: 'jorgeRessia 10/9/2009 14:33'!
testCreation

	| data1 data2 node|
	node := RBVariableNode named: 'test'.
	data1 := VariableNodeData for: node.
	data2 := VariableNodeData for: node.
	
	self assert: data1 == data2! !

!VariableNodeDataTest methodsFor: 'tests' stamp: 'jorgeRessia 10/9/2009 14:39'!
testReset

	| data1 data2 node|
	node := RBVariableNode named: 'test'.
	data1 := VariableNodeData for: node.
	data2 := VariableNodeData for: node.
	
	self assert: data1 == data2.
	
	VariableNodeData resetData.
	
	data2 := VariableNodeData for: node.
	
	self deny: data1 == data2! !

Object subclass: #BytecodeGenerator
	instanceVariableNames: 'seqOrder orderSeq seqBytes jumps literals lastLiteral currentSeqId currentSeqNum bytes lastSpecialReturn instrMaps instrMap maxTemp stacks stack primNum numArgs properties methodTemps'
	classVariableNames: 'BytecodeTable Bytecodes SpecialConstants SpecialSelectors'
	poolDictionaries: ''
	category: 'NewCompiler-Bytecodes'!

!BytecodeGenerator commentStamp: 'ajh 5/23/2003 10:59' prior: 0!
I generate bytecodes in response to 'instructions' messages being sent to me.  I rewrite jumps at the end so their jump offsets are correct (see #bytecodes).  For example, to create a compiled method that compares first instVar to first arg and returns 'yes' or 'no' (same example as in IRBuilder), do:

	BytecodeGenerator new
		numArgs: 1;
		pushInstVar: 1;
		pushTemp: 1;
		send: #>;
		if: false goto: #else;
		pushLiteral: 'yes';
		returnTop;
		label: #else;
		pushLiteral: 'no';
		returnTop;
		compiledMethod

You can send #ir to the compiledMethod to decompile to its IRMethod, and you can send #methodNode to either to decompile to its parse tree.
!

!BytecodeGenerator class methodsFor: 'initialize' stamp: 'ajh 3/6/2003 22:44'!
bytecodeTableFrom: specArray
	"SpecArray is an array of either
	(index selector) or
	(index1 index2 selector)."

	| contiguous |
	Bytecodes := IdentityDictionary new: 256.
	BytecodeTable := Array new: 256.
	contiguous := 0.
	specArray do: [ :spec |
		(spec at: 1) = contiguous ifFalse: [self error: 'Non-contiguous table entry'].
		spec size = 2 ifTrue: [
			Bytecodes at: (spec at: 2) put: (spec at: 1).
			BytecodeTable at: (spec at: 1) + 1 put: (spec at: 2).
			contiguous := contiguous + 1.
		] ifFalse: [
			spec size = 3 ifFalse: [self error: 'bad spec size'].
			Bytecodes at: (spec at: 3) put: ((spec at: 1) to: (spec at: 2)).
			(spec at: 1) to: (spec at: 2) do: [ :i |
				BytecodeTable at: i + 1 put: (spec at: 3).
			].
			contiguous := contiguous + ((spec at: 2) - (spec at: 1)) + 1.
		].
	].
	^ BytecodeTable! !

!BytecodeGenerator class methodsFor: 'initialize' stamp: 'ajh 3/6/2003 22:40'!
initialize

	self initializeBytecodeTable.
	self initializeSpecialSelectors.
	self initializeSpecialConstants.
! !

!BytecodeGenerator class methodsFor: 'initialize' stamp: 'jre 9/25/2009 16:39'!
initializeBytecodeTable
	"BytecodeWriteStream initialize"
	"Defines all the bytecode instructions for the Compiler and the Interpreter.
	The following bytecode tuple format is:

	#(bytecode bytecodeSelector)

	bytecodeSelector is the method in the Interpreter that gets executed for the given bytecode.
	Common Send selector position within the specialSelectorsArray is hard code in the Interpreter, see senders of Interpreter specialSelector:."

	^ self bytecodeTableFrom:
	#(
		(  0  15 pushReceiverVariableBytecode)
		( 16  31 pushTemporaryVariableBytecode)
		( 32  63 pushLiteralConstantBytecode)
		( 64  95 pushLiteralVariableBytecode)
		( 96 103 storeAndPopReceiverVariableBytecode)
		(104 111 storeAndPopTemporaryVariableBytecode)
		(112 pushReceiverBytecode)
		(113 pushConstantTrueBytecode)
		(114 pushConstantFalseBytecode)
		(115 pushConstantNilBytecode)
		(116 pushConstantMinusOneBytecode)
		(117 pushConstantZeroBytecode)
		(118 pushConstantOneBytecode)
		(119 pushConstantTwoBytecode)
		(120 returnReceiver)
		(121 returnTrue)
		(122 returnFalse)
		(123 returnNil)
		(124 returnTopFromMethod)
		(125 returnTopFromBlock)
		(126 unknownBytecode)
		(127 unknownBytecode)
		(128 extendedPushBytecode)
		(129 extendedStoreBytecode)
		(130 extendedStoreAndPopBytecode)
		(131 singleExtendedSendBytecode)
		(132 doubleExtendedDoAnythingBytecode)
		(133 singleExtendedSuperBytecode)
		(134 secondExtendedSendBytecode)
		(135 popStackBytecode)
		(136 duplicateTopBytecode)
		(137 pushActiveContextBytecode)
		"(138 143 experimentalBytecode)"
		(138 pushConsArray)
		(139 experimentalBytecode)
		(140 pushRemoteTempInVectorAt)
		(141 storeRemoteTempInVectorAt)
		(142 storePopRemoteTempInVectorAt)
		(143 PushClosureCopyNumCopiedValuesNuumArgsJumpSize)
		(144 151 shortUnconditionalJump)
		(152 159 shortConditionalJump)
		(160 167 longUnconditionalJump)
		(168 171 longJumpIfTrue)
		(172 175 longJumpIfFalse)

		"176-191 were sendArithmeticSelectorBytecode"
		(176 bytecodePrimAdd)
		(177 bytecodePrimSubtract)
		(178 bytecodePrimLessThan)
		(179 bytecodePrimGreaterThan)
		(180 bytecodePrimLessOrEqual)
		(181 bytecodePrimGreaterOrEqual)
		(182 bytecodePrimEqual)
		(183 bytecodePrimNotEqual)
		(184 bytecodePrimMultiply)
		(185 bytecodePrimDivide)
		(186 bytecodePrimMod)
		(187 bytecodePrimMakePoint)
		(188 bytecodePrimBitShift)
		(189 bytecodePrimDiv)
		(190 bytecodePrimBitAnd)
		(191 bytecodePrimBitOr)	

		"192-207 were sendCommonSelectorBytecode"
		(192 bytecodePrimAt)
		(193 bytecodePrimAtPut)
		(194 bytecodePrimSize)
		(195 bytecodePrimNext)
		(196 bytecodePrimNextPut)
		(197 bytecodePrimAtEnd)
		(198 bytecodePrimEquivalent)
		(199 bytecodePrimClass)
		(200 bytecodePrimBlockCopy)
		(201 bytecodePrimValue)
		(202 bytecodePrimValueWithArg)
		(203 bytecodePrimDo)
		(204 bytecodePrimNew)
		(205 bytecodePrimNewWithArg)
		(206 bytecodePrimPointX)
		(207 bytecodePrimPointY)

		(208 255 sendLiteralSelectorBytecode)
	)
! !

!BytecodeGenerator class methodsFor: 'initialize' stamp: 'ajh 3/6/2003 22:45'!
initializeSpecialConstants

	SpecialConstants := {true. false. nil. -1. 0. 1. 2}! !

!BytecodeGenerator class methodsFor: 'initialize' stamp: 'ajh 3/6/2003 22:40'!
initializeSpecialSelectors
	"Create a map from specialSelector -> bytecode offset from sendAdd (the first one)"

	| array |
	SpecialSelectors := IdentityDictionary new.
	array := self specialSelectorsArray.  "Smalltalk specialObjectsArray at: 24"
	1 to: array size by: 2 "skip numArgs" do: [:i |
		SpecialSelectors at: (array at: i) put: i - 1 / 2].
! !

!BytecodeGenerator class methodsFor: 'initialize' stamp: 'ajh 3/15/2003 15:43'!
specialConstants

	^ SpecialConstants! !

!BytecodeGenerator class methodsFor: 'initialize' stamp: 'ajh 3/6/2003 22:45'!
specialSelectorsArray

	^ #(#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1 #* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1 #at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0 #blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0)! !

!BytecodeGenerator methodsFor: 'private' stamp: 'ajh 3/6/2003 22:48'!
addLastLiteral: object

	lastLiteral ifNil: [^ lastLiteral := object].
	(lastLiteral literalEqual: object)
		ifFalse: [self error: 'there can only be one last literal'].! !

!BytecodeGenerator methodsFor: 'private' stamp: 'kwl 6/25/2006 20:06'!
addLiteral: object

	literals add: object.
	^ literals identityIndexOf: object! !

!BytecodeGenerator methodsFor: 'old style blocks' stamp: 'md 10/8/2004 16:01'!
blockReturnTop

	self saveLastJump: #return.

	self nextPut: (Bytecodes at: #returnTopFromBlock).
! !

!BytecodeGenerator methodsFor: 'results' stamp: 'ajh 5/22/2003 13:06'!
bytecodes

	| stream |
	[ orderSeq
		inject: false
		into: [:changed :seqId | (self updateJump: seqId) | changed]
	] whileTrue.

	stream := (ByteArray new: 100) writeStream.
	orderSeq do: [:seqId |
		(instrMaps at: seqId) do: [:assoc |
			assoc key "instr" bytecodeIndex: stream position + assoc value.
		].
		stream nextPutAll: (seqBytes at: seqId).
	].
	^ stream contents! !

!BytecodeGenerator methodsFor: 'results' stamp: 'md 2/21/2006 14:14'!
compiledMethod

	^ self compiledMethodWith: #(0 0 0 0)! !

!BytecodeGenerator methodsFor: 'results' stamp: 'pmm 8/16/2006 20:51'!
compiledMethodWith: trailer
	^self compiledMethodWith: trailer using: CompiledMethod! !

!BytecodeGenerator methodsFor: 'results' stamp: 'JB 3/25/2010 13:20'!
compiledMethodWith: trailer using: aCompiledMethodClass
	| cm |
	cm := (aCompiledMethodClass
		primitive: (self primNum > 0
			ifTrue: [self primNum]
			ifFalse: [self quickMethodPrim])
		numArgs: self numArgs
		numTemps: (self methodTemps size)
		stackSize: self stackSize
		literals: self literals
		bytecodes: self bytecodes
		trailer: trailer).
	cm isClosureCompiled: Preferences compileBlocksAsClosures.
	cm properties: self properties.
	^cm.! !

!BytecodeGenerator methodsFor: 'accessing default' stamp: 'ms 4/20/2007 13:49'!
defaultStackCounter
	
	^StackCount! !

!BytecodeGenerator methodsFor: 'private' stamp: 'jorgeRessia 11/9/2009 10:43'!
distanceFrom: fromSeqId goto: toSeqId

	| distance from to |
	self halt.
	from := seqOrder at: fromSeqId.
	to := seqOrder at: toSeqId ifAbsent: [^ self].
	from + 1 = to ifTrue: [^ self].  "fall through, no jump needed"

	from < to ifTrue: [ "jump forward"
		distance := (from + 1 to: to - 1) inject: 0 into: [:size :i | 
				size + (seqBytes at: (orderSeq at: i)) size].
		^distance.
	] ifFalse: [ "jump backward"
		distance := ((to to: from - 1) inject: 0 into: [:size :i |
				size + (seqBytes at: (orderSeq at: i)) size])
			+ bytes size.
		^distance.
	].
! !

!BytecodeGenerator methodsFor: 'private' stamp: 'jorgeRessia 11/9/2009 11:24'!
from: fromSeqId goto: toSeqId

	| distance from to |
	from := seqOrder at: fromSeqId.
	to := seqOrder at: toSeqId ifAbsent: [^ self].
	from + 1 = to ifTrue: [^ self].  "fall through, no jump needed"

	from < to ifTrue: [ "jump forward"
		distance := (from + 1 to: to - 1) inject: 0 into: [:size :i | 
				size + (seqBytes at: (orderSeq at: i)) size].
		self jumpForward: distance.
	] ifFalse: [ "jump backward"
		distance := ((to to: from - 1) inject: 0 into: [:size :i |
				size + (seqBytes at: (orderSeq at: i)) size])
			+ bytes size.
		self jumpBackward: distance.
	].
! !

!BytecodeGenerator methodsFor: 'private' stamp: 'ajh 5/22/2003 13:22'!
from: fromSeqId if: bool goto: toSeqId otherwise: otherwiseSeqId

	| distance from to otherwise |
	from := seqOrder at: fromSeqId.
	to := seqOrder at: toSeqId ifAbsent: [^ self jump: 0 if: bool].  "not done yet"
	otherwise := seqOrder at: otherwiseSeqId ifAbsent: [^ self jump: 0 if: bool].  "not done yet"
	from < to ifFalse: [self errorConditionalJumpBackwards].
	from + 1 = otherwise ifFalse: [self errorFallThroughSequenceNotNext].
	distance := (from + 1 to: to - 1)
		inject: 0
		into: [:size :i | size + (seqBytes at: (orderSeq at: i)) size].
	self jump: distance if: bool.
! !

!BytecodeGenerator methodsFor: 'old style blocks' stamp: 'md 10/8/2004 16:01'!
fromBlock: curId goto: seqId

	| distance from to |

	from := seqOrder at: curId.
	to := seqOrder at: seqId ifAbsent: [^ self].
	distance := (from + 1 to: to - 1) inject: 0 into: [:size :i | 
				size + (seqBytes at: (orderSeq at: i)) size].
	distance > 1023 ifTrue: [self error: 'forward jump too big'].
	self nextPut: (Bytecodes at: #longUnconditionalJump) first + (distance // 256) + 4.
	self nextPut: distance \\ 256.! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 5/22/2003 12:22'!
goto: seqId

	stacks at: seqId put: (stack linkTo: (stacks at: seqId ifAbsentPut: [nil])).

	self saveLastJump: (Message
		selector: #from:goto:
		arguments: {currentSeqId. seqId}).
	self from: currentSeqId goto: seqId.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 5/22/2003 13:26'!
if: bool goto: seqId

	| otherwiseSeqId |
	otherwiseSeqId := self newDummySeqId.
	self if: bool goto: seqId otherwise: otherwiseSeqId.
	self label: otherwiseSeqId.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 5/22/2003 12:26'!
if: bool goto: seqId1 otherwise: seqId2

	stack pop.
	stacks at: seqId1 put: (stack linkTo: (stacks at: seqId1 ifAbsentPut: [nil])).
	stacks at: seqId2 put: (stack linkTo: (stacks at: seqId2 ifAbsentPut: [nil])).

	self saveLastJump: (Message
		selector: #from:if:goto:otherwise:
		arguments: {currentSeqId. bool. seqId1. seqId2}).
	self from: currentSeqId if: bool goto: seqId1 otherwise: seqId2.
! !

!BytecodeGenerator methodsFor: 'initialize' stamp: 'JB 3/25/2010 13:28'!
initialize

	literals := LiteralList new.
	"The following dicts are keyed by sequence id given by client in label: (and gotos)."
	seqOrder := IdentityDictionary new.  "seqId -> seq order num"
	seqBytes := IdentityDictionary new.  "seqId -> seq bytecodes"
	jumps := IdentityDictionary new.  "seqId -> last jump instr"
	instrMaps := IdentityDictionary new.  "seqId -> (clientInstr -> bytecode pos)"
	stacks := IdentityDictionary new.  "seqId -> stackCount"
	maxTemp := 0.
	primNum := 0.
	numArgs := 0.
	currentSeqNum := 0.
	orderSeq := OrderedCollection new.  "reverse map of seqOrder"
	methodTemps  := OrderedCollection new.

	"starting label in case one is not provided by client"
	self label: self newDummySeqId.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ms 4/20/2007 13:53'!
initializeStackCounter
	^ self defaultStackCounter new! !

!BytecodeGenerator methodsFor: 'private' stamp: 'awe 6/22/2008 12:35'!
jump: distance if: condition

	| hi |
	distance = 0 ifTrue: [
		"jumps to fall through, no-op"
		^ self nextPut: (Bytecodes at: #popStackBytecode)].
	condition ifTrue: [
		hi := distance // 256.
		hi < 4 ifFalse: [self error: 'true jump too big'].
		self nextPut: (Bytecodes at: #longJumpIfTrue) first + hi.
		self nextPut: distance \\ 256.
	] ifFalse: [
		distance <= 8 ifTrue: [
			self nextPut: (Bytecodes at: #shortConditionalJump) first + distance - 1.
		] ifFalse: [
			hi := distance // 256.
			hi < 4 ifFalse: [self error: 'false jump too big'].
			self nextPut: (Bytecodes at: #longJumpIfFalse) first + hi.
			self nextPut: distance \\ 256.
		].
	]	
! !

!BytecodeGenerator methodsFor: 'private' stamp: 'ajh 7/19/2004 12:12'!
jumpBackward: distance

	| dist |
	distance = 0 ifTrue: [^ self].  "no-op"
	dist := 1024 - distance - 2.
	dist < 0 ifTrue: [self error: 'back jump too big'].
	self nextPut: (Bytecodes at: #longUnconditionalJump) first + (dist // 256).
	self nextPut: dist \\ 256.
! !

!BytecodeGenerator methodsFor: 'private' stamp: 'ajh 3/24/2003 17:46'!
jumpForward: distance

	distance = 0 ifTrue: [^ self].  "no-op"
	distance <= 8 ifTrue: [
		self nextPut: (Bytecodes at: #shortUnconditionalJump) first + distance - 1.
	] ifFalse: [
		distance > 1023 ifTrue: [self error: 'forward jump too big'].
		self nextPut: (Bytecodes at: #longUnconditionalJump) first + (distance // 256) + 4.
		self nextPut: distance \\ 256.
	].
! !

!BytecodeGenerator methodsFor: 'old style blocks' stamp: 'md 10/8/2004 16:01'!
jumpOverBlock: seqId

	stacks at: seqId put: (stack linkTo: (stacks at: seqId ifAbsentPut: [nil])).
	
	
	self saveLastJump: (Message
		selector: #fromBlock:goto:
		arguments: {currentSeqId. seqId}).
	
	self fromBlock: currentSeqId goto: seqId.! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ms 4/20/2007 13:53'!
label: seqId 
	(currentSeqId notNil and: [(jumps at: currentSeqId) isNil]) 
		ifTrue: 
			["make previous implicit goto explicit"

			self goto: seqId].
	lastSpecialReturn := nil.
	currentSeqId := seqId.
	currentSeqNum := currentSeqNum + 1.
	seqOrder at: seqId put: currentSeqNum.
	orderSeq at: currentSeqNum ifAbsentPut: [seqId].
	bytes := seqBytes at: seqId ifAbsentPut: [OrderedCollection new].
	jumps at: seqId ifAbsentPut: [nil].
	instrMap := instrMaps at: seqId ifAbsentPut: [OrderedCollection new].
	stack := stacks at: seqId ifAbsentPut: [self initializeStackCounter]! !

!BytecodeGenerator methodsFor: 'results' stamp: 'md 2/21/2006 14:14'!
literals

	literals := literals asArray copyWith: MethodProperties new.

	^ lastLiteral 
		ifNil: [literals copyWith: nil ] 
		ifNotNil: [literals copyWith: lastLiteral]! !

!BytecodeGenerator methodsFor: 'mapping' stamp: 'ajh 3/13/2003 13:00'!
mapBytesTo: instr
	"Associate next byte with instr"

	instrMap add: instr -> (bytes size + 1)! !

!BytecodeGenerator methodsFor: 'accessing' stamp: 'JB 3/25/2010 13:25'!
methodTemps
^methodTemps.! !

!BytecodeGenerator methodsFor: 'accessing' stamp: 'JorgeRessia 12/11/2009 13:51'!
methodTemps: aCollection 
	methodTemps := aCollection! !

!BytecodeGenerator methodsFor: 'private' stamp: 'ajh 5/22/2003 13:28'!
newDummySeqId

	^ Object new! !

!BytecodeGenerator methodsFor: 'private' stamp: 'ajh 3/13/2003 13:00'!
nextPut: byte

	bytes add: byte! !

!BytecodeGenerator methodsFor: 'results' stamp: 'ajh 3/13/2003 18:27'!
numArgs

	^ numArgs! !

!BytecodeGenerator methodsFor: 'initialize' stamp: 'ajh 3/13/2003 18:21'!
numArgs: n

	numArgs := n! !

!BytecodeGenerator methodsFor: 'results' stamp: 'ajh 3/13/2003 18:03'!
numTemps

	^ maxTemp! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 3/13/2003 17:48'!
popTop

	stack pop.

	self nextPut: (Bytecodes at: #popStackBytecode).
! !

!BytecodeGenerator methodsFor: 'results' stamp: 'ajh 3/13/2003 18:27'!
primNum

	^ primNum! !

!BytecodeGenerator methodsFor: 'initialize' stamp: 'ajh 3/13/2003 18:21'!
primitiveNode: aPrimitiveNode

	literals isEmpty ifFalse: [self error: 'init prim before adding instructions'].
	aPrimitiveNode spec ifNotNil: [literals add: aPrimitiveNode spec].
	primNum := aPrimitiveNode num.
! !

!BytecodeGenerator methodsFor: 'accessing' stamp: 'md 7/12/2006 16:40'!
properties
	^ properties ifNil: [ properties := MethodProperties new ].! !

!BytecodeGenerator methodsFor: 'accessing' stamp: 'md 7/10/2005 22:21'!
properties: propDict
	properties := propDict.! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'MarcusDenker 3/29/2010 11:35'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs2 jumpSize: jumpSize

	"143 	10001111 llllkkkk jjjjjjjj iiiiiiii	Push Closure Num Copied llll Num Args kkkk BlockSize jjjjjjjjiiiiiiii"
	numCopied timesRepeat: [stack pop].
	"stack push."
	"numArgs timesRepeat: [stack push]."
	"stacks at: currentSeqId put: (stack linkTo: (stacks at: currentSeqId ifAbsentPut: [nil]))."
		
	(jumpSize < 0 or: [jumpSize > 65535]) ifTrue:
		[^self error: 'block size jumpSize out of range 0-65535'].
	(numCopied < 0 or: [numCopied > 15]) ifTrue:
		[^self error: 'num copied out of range 0-15'].
	(numArgs2 < 0 or: [numArgs2 > 15]) ifTrue:
		[^self error: 'num args out of range 0-15'].
	self
		nextPut: (Bytecodes at: #PushClosureCopyNumCopiedValuesNuumArgsJumpSize);
		nextPut: numArgs2 + (numCopied bitShift: 4);
		nextPut: (jumpSize bitShift: -8);
		nextPut: (jumpSize bitAnd: 16rFF)

! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'jorgeRessia 11/3/2009 16:33'!
pushConsArray: size
	stack push.
	(size < 0 or: [size > 127]) ifTrue: [self error: 'The array size is out of range. Should be 0 - 127'].
	"138 	10001010 1kkkkkkk 	Pop kkkkkkk into: (Array new: kkkkkkk)"
	
	self 
		nextPut: (Bytecodes at: #pushConsArray);
		nextPut: size + 128.
	

! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 3/13/2003 17:48'!
pushDup

	stack push.

	self nextPut: (Bytecodes at: #duplicateTopBytecode).
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 3/13/2003 17:49'!
pushInstVar: instVarIndex

	| interval |
	stack push.

	interval := Bytecodes at: #pushReceiverVariableBytecode.
	instVarIndex <= interval size ifTrue: [
		^ self nextPut: (interval at: instVarIndex).
	].
	instVarIndex <= 64 ifTrue: [
		self nextPut: (Bytecodes at: #extendedPushBytecode).
		^ self nextPut: (0 "instVar" << 6) + instVarIndex - 1.
	].
	instVarIndex <= 256 ifFalse: [self error: 'can''t reference more than 256 inst vars'].
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: 2 "pushInstVar" << 5.
	self nextPut: instVarIndex - 1.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'kwl 6/25/2006 19:56'!
pushLiteral: object

	| index interval |
	stack push.

	(index := SpecialConstants identityIndexOf: object ifAbsent: 0) > 0 ifTrue: [
		^ self nextPut: (Bytecodes at: #pushConstantTrueBytecode) + index - 1].

	(index := literals literalIndexOf: object ifAbsent: 0) > 0 ifFalse: [
		index := self addLiteral: object].

	interval := Bytecodes at: #pushLiteralConstantBytecode.
	(index <= interval size) ifTrue: [
		^ self nextPut: (interval at: index)
	].
	index <= 64 ifTrue: [
		self nextPut: (Bytecodes at: #extendedPushBytecode).
		^ self nextPut: 2 "lit constant" << 6 + index - 1
	].
	index > 256 ifTrue: [self error: 'too many literals (>256)'].
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: 3 "lit constant" << 5.
	self nextPut: index - 1.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'kwl 6/25/2006 19:58'!
pushLiteralVariable: object

	| index interval |
	stack push.

	object isVariableBinding
		ifFalse: [self error: 'not a literal variable'].

	(index := literals literalIndexOf: object ifAbsent: 0) > 0 ifFalse: [
		index := self addLiteral: object].

	interval := Bytecodes at: #pushLiteralVariableBytecode.
	(index <= interval size) ifTrue: [
		^ self nextPut: (interval at: index)
	].
	index <= 64 ifTrue: [
		self nextPut: (Bytecodes at: #extendedPushBytecode).
		^ self nextPut: 3 "literal variable" << 6 + index - 1
	].
	index > 256 ifTrue: [self error: 'too many literals (>256)'].
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: 1 "lit variable" << 7.
	self nextPut: index - 1.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'jorgeRessia 11/3/2009 16:33'!
pushNewArray: size
	stack push.
	(size < 0 or: [size > 127]) ifTrue: [self error: 'The array size is out of range. Should be 0 - 127'].
	"138 	10001010 0kkkkkkk 	Push kkkkkkk into: (Array new: kkkkkkk)"
	
	self 
		nextPut: (Bytecodes at: #pushConsArray);
		nextPut: size.
	

! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'JorgeRessia 12/27/2009 19:04'!
pushReceiver
	stack push.
	self nextPut: (Bytecodes at: #pushReceiverBytecode)! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'jorgeRessia 11/3/2009 16:39'!
pushRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	stack push.
	
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		["140 	10001100 kkkkkkkk jjjjjjjj 	Push Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
		 self
			nextPut: ( Bytecodes at: #pushRemoteTempInVectorAt);
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self error: 'remoteTempIndex is out of range 0 to 255'].
	tempVectorIndex >= 256 ifTrue:
		[^self error: 'tempVectorIndex is out of range 0 to 255']! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'JorgeRessia 12/11/2009 13:22'!
pushTemp: index

	| interval |
	index = 0 ifTrue: [^self pushReceiver].
	stack push.
	maxTemp := index max: maxTemp.

	interval := Bytecodes at: #pushTemporaryVariableBytecode.
	index <= interval size ifTrue: [
		^ self nextPut: (interval at: index).
	].
	index <= 64 ifFalse: [self error: 'too many temp vars (>64)'].
	self nextPut: (Bytecodes at: #extendedPushBytecode).
	self nextPut: (1 "temp" << 6) + index - 1.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 3/13/2003 17:51'!
pushThisContext

	stack push.

	self nextPut: (Bytecodes at: #pushActiveContextBytecode).
! !

!BytecodeGenerator methodsFor: 'results' stamp: 'md 10/6/2005 16:50'!
quickMethodPrim

	| i |
	self numArgs = 0 ifFalse: [^ 0].
	lastSpecialReturn ifNil: [^ 0].
	(seqBytes  size <= 2) ifFalse: [^ 0].
	"seqBytes  size = 1 ifFalse: [^ 0]."
	^ lastSpecialReturn selector caseOf: {
		[#returnReceiver] -> [256].
		[#returnConstant:] -> [
			(i := SpecialConstants indexOf: lastSpecialReturn argument) > 0
				ifTrue: [256 + i] ifFalse: [0]].
		[#returnInstVar:] -> [263 + lastSpecialReturn argument]
	  }! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 7/2/2004 13:44'!
remoteReturn

	self saveLastJump: #return.

	self send: #privRemoteReturnTo:.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'md 7/19/2005 23:11'!
returnConstant: obj

	self saveLastJump: #return.
	
	bytes size = 0 ifTrue: [
		lastSpecialReturn := Message selector: #returnConstant: argument: obj].
 	
	obj caseOf: {
		[true] -> [self nextPut: (Bytecodes at: #returnTrue)].
		[false] -> [self nextPut: (Bytecodes at: #returnFalse)].
		[nil] -> [self nextPut: (Bytecodes at: #returnNil)]
	} otherwise: [
		self pushLiteral: obj.
		self returnTop.
	]
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'md 7/19/2005 23:29'!
returnInstVar: index

	self saveLastJump: #return.
	
	bytes size = 0 ifTrue: [
		lastSpecialReturn := Message selector: #returnInstVar: argument: index].

	self pushInstVar: index.
	self returnTop.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 5/22/2003 14:02'!
returnReceiver

	self saveLastJump: #return.

	bytes size = 0 ifTrue: [
		lastSpecialReturn := Message selector: #returnReceiver].

	self nextPut: (Bytecodes at: #returnReceiver).
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 5/22/2003 14:02'!
returnTop

	self saveLastJump: #return.

	self nextPut: (Bytecodes at: #returnTopFromMethod).
! !

!BytecodeGenerator methodsFor: 'private' stamp: 'ajh 5/22/2003 12:23'!
saveLastJump: message

	jumps at: currentSeqId put: {bytes size. message}.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 3/16/2003 14:43'!
send: selector

	| index nArgs |
	nArgs := selector numArgs.
	stack pop: nArgs.

	SpecialSelectors at: selector ifPresent: [:i |
		^ self nextPut: (Bytecodes at: #bytecodePrimAdd) + i].

	index := self addLiteral: selector.
	(index <= 16 and: [nArgs <= 2]) ifTrue: [
		"short send"
		^ self nextPut: (Bytecodes at: #sendLiteralSelectorBytecode) first + (nArgs * 16) + index - 1
	].
	(index <= 32 and: [nArgs <= 7]) ifTrue: [
		"extended (2-byte) send"
		self nextPut: (Bytecodes at: #singleExtendedSendBytecode).
		^ self nextPut: nArgs * 32 + index - 1
	].
	(index <= 64 and: [nArgs <= 3]) ifTrue: [
		"new extended (2-byte)"
		self nextPut: (Bytecodes at: #secondExtendedSendBytecode).
		^ self nextPut: nArgs * 64 + index - 1
	].
	"long (3-byte) send"
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: nArgs.
	self nextPut: index - 1.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'md 2/27/2006 17:03'!
send: selector toSuperOf: behavior

	| index nArgs |
	nArgs := selector numArgs.
	stack pop: nArgs.

	self addLastLiteral: behavior binding.  
	index := self addLiteral: selector.
	(index <= 32 and: [nArgs <= 7]) ifTrue: [
		"extended (2-byte) send"
		self nextPut: (Bytecodes at: #singleExtendedSuperBytecode).
		^ self nextPut: nArgs * 32 + index - 1
	].
	"long (3-byte) send"
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: 1 << 5 "super" + nArgs.
	self nextPut: index - 1.
! !

!BytecodeGenerator methodsFor: 'results' stamp: 'ajh 3/13/2003 18:03'!
stackSize

	^ (stacks collect: [:s | s length]) max! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 3/9/2003 20:36'!
storeInstVar: index

	index <= 64 ifTrue: [
		self nextPut: (Bytecodes at: #extendedStoreBytecode).
		^ self nextPut: (0 "instVar" << 6) + index - 1.
	].
	index <= 256 ifFalse: [self error: 'can''t reference more than 256 inst vars'].
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: 5 "storeInstVar" << 5.
	self nextPut: index - 1.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'md 10/4/2005 17:42'!
storeIntoLiteralVariable: object

	| index |
	
	index := self addLiteral: object.   

	index <= 64 ifTrue: [
		self nextPut: (Bytecodes at: #extendedStoreBytecode).
		^ self nextPut: (3 "instVar" << 6) + index - 1.
	].
	index <= 256 ifFalse: [self error: 'can''t reference more than 256 inst vars'].
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: 7 "storeLiteralVar" << 5.
	self nextPut: index - 1.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ajh 3/13/2003 18:00'!
storePopInstVar: index

	| interval |
	stack pop.

	interval := Bytecodes at: #storeAndPopReceiverVariableBytecode.
	index <= interval size ifTrue: [
		^ self nextPut: (interval at: index)
	].
	index <= 64 ifTrue: [
		self nextPut: (Bytecodes at: #extendedStoreAndPopBytecode).
		^ self nextPut: (0 "instVar" << 6) + index - 1.
	].
	index <= 256 ifFalse: [
		self error: 'can''t reference more than 256 inst vars'].
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: 6 "storePopInstVar" << 5.
	self nextPut: index - 1.
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'ms 12/3/2006 20:17'!
storePopIntoLiteralVariable: assoc

	| index |
	
	index := self addLiteral: assoc.
	
	index <= 64 ifTrue: [
		stack pop.
		self nextPut: (Bytecodes at: #extendedStoreAndPopBytecode).
		^ self nextPut: (3 "temp" << 6) + index - 1.
	].
	index <= 256 ifFalse: [self error: 'can''t reference more than 256 inst vars'].
	self nextPut: (Bytecodes at: #doubleExtendedDoAnythingBytecode).
	self nextPut: 7 "storeLiteralVar" << 5.
	self nextPut: index - 1.
	self popTop
! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'jorgeRessia 11/3/2009 16:38'!
storePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex

	stack pop.
	
	"142 	10001110 kkkkkkkk jjjjjjjj 	Pop and Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		[self
			nextPut: ( Bytecodes at: #storePopRemoteTempInVectorAt);
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self error: 'remoteTempIndex out of range 0 to 255'].
	tempVectorIndex >= 256 ifTrue:
		[^self error: 'tempVectorIndex out of range range 0 to 255']! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'JorgeRessia 2/7/2010 20:37'!
storePopTemp: index

	| interval |
	stack pop.
	maxTemp := index max: maxTemp.

	interval := Bytecodes at: #storeAndPopTemporaryVariableBytecode.
	index <= interval size ifTrue: [
		^ self nextPut: (interval at: index )
	].
	index <= 64 ifTrue: [
		self nextPut: (Bytecodes at: #extendedStoreAndPopBytecode).
		^ self nextPut: (1 "temp" << 6) + index - 1.
	].
	self error: 'too many temps (>64)'! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'jre 9/29/2009 12:14'!
storeRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	"141 	10001101 kkkkkkkk jjjjjjjj 	Store Temp At kkkkkkkk In Temp Vector At: jjjjjjjj"
	(tempIndex >= 0 and: [tempIndex < 256
	 and: [tempVectorIndex >= 0 and: [tempVectorIndex < 256]]]) ifTrue:
		[self
			nextPut: (Bytecodes at: #storeRemoteTempInVectorAt);
			nextPut: tempIndex;
			nextPut: tempVectorIndex.
		 ^self].
	tempIndex >= 256 ifTrue:
		[^self error: 'remoteTempIndex out of range 0 to 255'].
	tempVectorIndex >= 256 ifTrue:
		[^self error: 'tempVectorIndex out of range 0 to 255']! !

!BytecodeGenerator methodsFor: 'instructions' stamp: 'JorgeRessia 12/11/2009 13:09'!
storeTemp: index
	maxTemp := index max: maxTemp.
	index <= 64 ifFalse: [self error: 'too many temps (>64)'].
	self nextPut: (Bytecodes at: #extendedStoreBytecode).
	self nextPut: (1 "temp" << 6) + index - 1.
! !

!BytecodeGenerator methodsFor: 'private' stamp: 'ajh 6/22/2003 14:41'!
updateJump: seqId
	"Recalculate final jump bytecodes.  Return true if jump bytecodes SIZE has changed, otherwise return false"

	| pair s1 |
	pair := jumps at: seqId.
	pair last == #return ifTrue: [^ false].  "no jump, a return"
	bytes := seqBytes at: seqId.
	s1 := bytes size.
	bytes removeLast: (bytes size - pair first).
	pair last sendTo: self.
	^ s1 ~= bytes size! !

Object subclass: #ClosureCompiledObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Standalone'!

!ClosureCompiledObject class methodsFor: 'compiling' stamp: 'md 11/23/2005 11:49'!
compile: code classified: cat notifying: requestor trailer: bytes ifFail: failBlock
	"Compile code without logging the source in the changes file"

	| methodNode |
	methodNode  := self compilerClass new
				compile: code
				in: self
				classified: category 
				notifying: requestor
				ifFail: failBlock.
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: bytes.! !

!ClosureCompiledObject class methodsFor: 'compiling' stamp: 'md 7/16/2003 15:57'!
compilerClass
	^ClosureCompiler! !

Object variableSubclass: #ClosureEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Hacks'!

!ClosureEnvironment commentStamp: 'ajh 6/24/2004 03:33' prior: 0!
An environment is a collection of temporary variable values that have escaped the original method context and placed in this environment because blocks existed in the method that reference these variables (and blocks may out live their creating context). Nested blocks create nested environments when temp vars are introduced at multiple levels and referenced at lower levels. So each environment has a parent environment in its first slot. The top environment has the original receiver in it first slot (if referenced by an inner block).

A block consists of its outer environment and a method to execute while the outer environment is in the receiver position.

A block that remote returns from its home context holds the home environment in its outer environment. The remote return unwinds the call stack to the context that created the home context.
!

!ClosureEnvironment methodsFor: 'comparing' stamp: 'ajh 6/24/2004 03:54'!
= other

	self class == other class ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	1 to: self size do: [:i |
		(self at: i) = (other at: i) ifFalse: [^ false].
	].
	^ true! !

!ClosureEnvironment methodsFor: 'testing' stamp: 'ajh 6/24/2004 03:56'!
hash
	"Answer an integer hash value for the receiver such that,
	  -- the hash value of an unchanged object is constant over time, and
	  -- two equal objects have equal hash values"

	| hash |

	hash := self species hash.
	self size <= 10 ifTrue:
		[self do: [:elem | hash := hash bitXor: elem hash]].
	^hash bitXor: self size hash! !

!ClosureEnvironment methodsFor: '*newcompiler' stamp: 'ajh 7/7/2004 16:53'!
inspectorClass

	^ ClosureEnvInspector! !

!ClosureEnvironment methodsFor: 'handling' stamp: 'ajh 6/29/2004 14:33'!
return: value
	"Find thisContext sender that is owner of self and return from it"

	| home |
	home := thisContext findContextSuchThat: [:ctxt | ctxt myEnv == self].
	home return: value! !

Object subclass: #ClosureStaticStats
	instanceVariableNames: 'methodsByEmbeddedBlocks blocksByFreeVars homeFunctionsByEscapingEnvs problemMethods'
	classVariableNames: 'LastStats'
	poolDictionaries: ''
	category: 'NewCompiler-Extras'!

!ClosureStaticStats commentStamp: 'ajh 5/21/2004 14:52' prior: 0!
After recompiling the image under the new closure compiler (using Recompiler), use this to find distribution of:
number of closures per method,
number of free vars per closure.
number of indirect free vars per closure.
number of indirect temp vars per method with closure(s).
number of indirect temp vars per method.

 ClosureStaticStats new run inspect.

 ClosureStaticStats lastStats.
!

!ClosureStaticStats class methodsFor: 'as yet unclassified' stamp: 'ajh 5/20/2004 02:20'!
lastStats

	^ LastStats! !

!ClosureStaticStats methodsFor: 'as yet unclassified' stamp: 'ajh 5/20/2004 02:18'!
allMethodsDo: methodBlock

	| count |
	count := 0.
	Smalltalk allClassesDo: [:class | count := count +
		({class. class class} collect: [:behavior |
			behavior methodDictionary size]) sum].
	
	'Checking ', count printString, ' methods'
		displayProgressAt: Sensor cursorPoint from: 0 to: count
		during: [:bar | | m | m := 0.
			Smalltalk allClassesDo: [:class |
				{class. class class} do: [:behavior |
					behavior methodDictionary do: [:meth |
						methodBlock value: meth.
						bar value: (m := m + 1)]]]].
! !

!ClosureStaticStats methodsFor: 'as yet unclassified' stamp: 'ajh 7/1/2004 10:47'!
initBags

	methodsByEmbeddedBlocks := Bag new.
	blocksByFreeVars := Bag new.
	homeFunctionsByEscapingEnvs := Bag new.

	problemMethods := OrderedCollection new.
! !

!ClosureStaticStats methodsFor: 'printing' stamp: 'ajh 7/1/2004 10:47'!
longPrintOn: stream

	| list |
	list := [:bag | (0 to: 9) collect: [:i | bag valuesAndCounts at: i ifAbsent: [0]]].

	stream nextPutAll: 'Methods: '.
	stream print: methodsByEmbeddedBlocks size; cr.
	stream nextPutAll: 'by num closures: '.
	stream print: (list value: methodsByEmbeddedBlocks); cr; cr.

	stream nextPutAll: 'Home methods/blocks: '.
	stream print: homeFunctionsByEscapingEnvs size; cr.
	stream nextPutAll: 'by having own env: '.
	stream print: (list value: homeFunctionsByEscapingEnvs); cr; cr.

	stream nextPutAll: 'Closures: '.
	stream print: blocksByFreeVars size; cr.
	stream nextPutAll: 'by num free vars: '.
	stream print: (list value: blocksByFreeVars); cr.
! !

!ClosureStaticStats methodsFor: 'running' stamp: 'ajh 7/8/2004 19:19'!
run
	"scan all methods collecting stats"

	self initBags.
	self allMethodsDo: [:meth |
		| blockMeths |
		blockMeths := meth allEmbeddedBlockMethods.
		methodsByEmbeddedBlocks add: blockMeths size.
		blockMeths size > 0 ifTrue: [
			homeFunctionsByEscapingEnvs add: meth ast scope hasEscapingEnv asBit].
		[blockMeths do: [:bm | | ast |
			ast := bm ast.
			bm containsBlockClosures ifTrue: [
				homeFunctionsByEscapingEnvs add: ast scope hasEscapingEnv asBit].
			blocksByFreeVars add: ast freeVars size.
		]] on: Error do: [problemMethods add: meth].
	].
	LastStats := self.
! !

Object subclass: #Decompiler2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Bytecodes'!

!Decompiler2 commentStamp: 'ajh 3/25/2003 00:28' prior: 0!
This mirrors the old Decompiler interface delegating the real work to BytecodeDecompiler then IRDecompiler.!

!Decompiler2 methodsFor: 'compiling' stamp: 'ajh 3/13/2003 21:09'!
decompile: aMethod
	"Answer a MethodNode that is the root of the parse tree for the argument, aMethod.  Selector will be 'unknown' and inst vars will be 'instVarN'.  selector and class can be placed in resulting MethodNode later"

	^self
		decompile: nil
		in: nil
		method: aMethod
! !

!Decompiler2 methodsFor: 'public access' stamp: 'ajh 3/13/2003 21:09'!
decompile: aSelector in: aClass 
	"See Decompiler|decompile:in:method:. The method is found by looking up 
	the message, aSelector, in the method dictionary of the class, aClass."

	^self
		decompile: aSelector
		in: aClass
		method: (aClass compiledMethodAt: aSelector)! !

!Decompiler2 methodsFor: 'public access' stamp: 'ms 6/15/2007 14:08'!
decompile: selector in: aClass method: aMethod
	"Answer a MethodNode that is the root of the parse tree for the 
	argument, aMethod, which is the CompiledMethod associated with the 
	message, aSelector. Variables are determined with respect to the 
	argument, aClass."

	| ird methodNode |
	ird := IRDecompiler new.
	ird scope: aClass parseScope newMethodScope.
	(ird scope addTemp: 'self') markArg.
	methodNode := ird decompileIR: aMethod ir.
	selector ifNotNil: [[methodNode selector: selector] on: Error do: []].
	^ methodNode! !

!Decompiler2 methodsFor: 'public access' stamp: 'md 2/27/2006 12:33'!
decompileBlock: aBlock
	"Answer a BlockNode, not done yet... return nil."
	^nil.
	
	
	"ird := IRDecompiler new.
	ird scope: nil parseScope newBlockScope.
	^ (ird decompileIR: aBlock ir) asBlock"! !

!Decompiler2 methodsFor: 'initialize-release' stamp: 'ajh 3/15/2003 15:57'!
withTempNames: tempNameArray
! !

Object subclass: #FakeDecompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Bytecodes'!

!FakeDecompiler methodsFor: 'compiling' stamp: 'marcus.denker 6/9/2009 18:26'!
decompile: aMethod
	"Answer a MethodNode that is the root of the parse tree for the argument, aMethod.  Selector will be 'unknown' and inst vars will be 'instVarN'.  selector and class can be placed in resulting MethodNode later"

	^self
		decompile: aMethod selector  
		in:  aMethod methodClass
		method: aMethod
! !

!FakeDecompiler methodsFor: 'public access' stamp: 'marcus.denker 6/9/2009 18:27'!
decompile: aSelector in: aClass 
	"See Decompiler|decompile:in:method:. The method is found by looking up 
	the message, aSelector, in the method dictionary of the class, aClass."

	^self
		decompile: aSelector
		in: aClass
		method: (aClass compiledMethodAt: aSelector)! !

!FakeDecompiler methodsFor: 'public access' stamp: 'marcus.denker 6/9/2009 18:27'!
decompile: selector in: aClass method: aMethod
	"Answer a MethodNode that is the root of the parse tree for the 
	argument, aMethod, which is the CompiledMethod associated with the 
	message, aSelector. Variables are determined with respect to the 
	argument, aClass."

	| source |
	^ (source := aMethod getSourceFromFile)
		ifNil: [Decompiler new decompile: selector in: aClass method: aMethod ]
		ifNotNil: [aMethod parserClass new parse: source class: aMethod methodClass]! !

!FakeDecompiler methodsFor: 'public access' stamp: 'marcus.denker 6/9/2009 18:27'!
decompileBlock: aBlock
	"Answer a BlockNode, not done yet... return nil."
	^nil.
	
	
	"ird _ IRDecompiler new.
	ird scope: nil parseScope newBlockScope.
	^ (ird decompileIR: aBlock ir) asBlock"! !

!FakeDecompiler methodsFor: 'initialize-release' stamp: 'marcus.denker 6/9/2009 18:26'!
withTempNames: tempNameArray
	"ignored... fake decompiler has corrent temp names by default"! !

Object subclass: #IRBuilder
	instanceVariableNames: 'ir tempMap jumpBackTargetStacks jumpAheadStacks currentSequence sourceMapNodes sourceMapByteIndex jumpAheadTargetBlockIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRBuilder commentStamp: 'kwl 5/12/2006 18:29' prior: 0!
I provide a simple interface for constructing an IRMethod.  For example, to create an ir method that compares first instVar to first arg and returns 'yes' or 'no' (same example as in BytecodeGenerator), do:

	IRBuilder new
		numRargs: 2;
		addTemps: #(self a z);		"rcvr, arg, & extra temp (not used here)"
		pushTemp: #self;
		pushInstVar: 1;
		pushTemp: #a;
		send: #>;
		jumpAheadTo: #else if: false;
		pushLiteral: 'yes';
		returnTop;
		jumpAheadTarget: #else;
		pushLiteral: 'no';
		returnTop;
		ir

Sending #compiledMethod to an ir method will generate its compiledMethod.  Sending #methodNode to it will decompile to its parse tree.
!

!IRBuilder methodsFor: 'private' stamp: 'ajh 3/13/2003 13:20'!
add: instr

	"Associate instr with current parse node or byte range"
	instr sourceNode: self sourceNode.
	instr bytecodeIndex: self sourceByteIndex.
	^ currentSequence add: instr! !

!IRBuilder methodsFor: 'decompiling' stamp: 'ajh 6/22/2003 14:44'!
addJumpBackTarget: label to: sequence

	(jumpBackTargetStacks at: label ifAbsentPut: [OrderedCollection new])
		addLast: sequence! !

!IRBuilder methodsFor: 'private' stamp: 'md 7/11/2005 22:20'!
addLiteral: aSymbol

	ir addLiteral: aSymbol! !

!IRBuilder methodsFor: 'private' stamp: 'md 7/12/2005 00:21'!
addLiterals: aSymbol

	ir addLiterals: aSymbol! !

!IRBuilder methodsFor: 'initialize' stamp: 'md 11/16/2004 15:18'!
addTemp: tempKey

	self addTemps: {tempKey}! !

!IRBuilder methodsFor: 'initialize' stamp: 'jorgeRessia 11/5/2009 14:48'!
addTemps: newKeys

	| keys i new |
	keys := ir tempKeys.
	i := keys size - 1. "zero-based (index 0 equals receiver)"
	new := OrderedCollection new.
	newKeys do: [:key |
		tempMap at: key ifAbsentPut: [
			new add: key.
			i := i + 1]
	].
	ir tempKeys: keys, new.! !

!IRBuilder methodsFor: 'instr - old blocks' stamp: 'md 9/26/2005 13:09'!
blockReturnTop
	| retInst newSequence |
	retInst := IRInstruction blockReturnTop.
	self  add:retInst.
	newSequence := IRSequence new  orderNumber:currentSequence orderNumber  +1.
	newSequence  method:ir.
	currentSequence last isJumpOrReturn 
		 ifFalse:[self  add:(IRJump new  destination:newSequence)].
	currentSequence := newSequence.
	retInst  successor:currentSequence! !

!IRBuilder methodsFor: 'accessing' stamp: 'md 10/11/2004 15:19'!
currentSequence
	^currentSequence! !

!IRBuilder methodsFor: 'accessing' stamp: 'jorgeRessia 11/4/2009 09:23'!
incrementJumpAheadTargetBlockIndex

	^jumpAheadTargetBlockIndex := jumpAheadTargetBlockIndex + 1! !

!IRBuilder methodsFor: 'private' stamp: 'jorgeRessia 11/4/2009 09:22'!
initialize
	ir := IRMethod new.
	tempMap := Dictionary new.
	jumpAheadStacks := IdentityDictionary new.
	jumpBackTargetStacks := IdentityDictionary new.
	sourceMapNodes := OrderedCollection new.	"stack"

	"Leave an empty sequence up front (guaranteed not to be in loop)"
	ir  startSequence:((IRSequence new  orderNumber:0)  method:ir).
	currentSequence := (IRSequence new  orderNumber:1)  method:ir.
	ir startSequence  add:(IRJump new  destination: currentSequence).
	jumpAheadTargetBlockIndex := 0! !

!IRBuilder methodsFor: 'results' stamp: 'ajh 3/10/2003 15:51'!
ir

	^ ir! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 2/27/2005 17:19'!
jumpAheadTarget: labelSymbol
	"Pop latest jumpAheadTo: with this labelSymbol and have it point to this new instruction sequence"

	| jumpInstr |
	self startNewSequence.
	jumpInstr := (jumpAheadStacks at: labelSymbol ifAbsent: [
			self error: 'Missing jumpAheadTo: ', labelSymbol printString]) removeLast.
	jumpInstr destination: currentSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'jorgeRessia 11/4/2009 13:13'!
jumpAheadTargetBlock: labelSymbol
	"Pop latest jumpAheadTo: with this labelSymbol and have it point to this new instruction sequence"

	| jumpInstr |
	jumpInstr := (jumpAheadStacks at: labelSymbol ifAbsent: [
			self error: 'Missing jumpAheadTo: ', labelSymbol printString]) removeLast.
	jumpInstr destination: currentSequence.
	"self startNewSequence.
	jumpInstr := (jumpAheadStacks at: labelSymbol ifAbsent: [
			self error: 'Missing jumpAheadTo: ', labelSymbol printString]) removeLast.
	jumpInstr destination: currentSequence."
! !

!IRBuilder methodsFor: 'accessing' stamp: 'jorgeRessia 11/4/2009 09:23'!
jumpAheadTargetBlockIndex

	^jumpAheadTargetBlockIndex! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/22/2003 14:44'!
jumpAheadTo: labelSymbol
	"Jump to the sequence that will be created when jumpAheadTarget: labelSymbol is sent to self.  This is and its corresponding target is only good for one use.  Other jumpAheadTo: with the same label will be put on a stack and superceed existing ones until its jumpAheadTarget: is called."

	"jumpAheadTarget: label will pop this and replace destination with its basic block"
	(jumpAheadStacks at: labelSymbol ifAbsentPut: [OrderedCollection new])
		addLast: (self add: IRJump new).
	self startNewSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/22/2003 14:44'!
jumpAheadTo: labelSymbol if: boolean
	"Conditional jump to the sequence that will be created when jumpAheadTarget: labelSymbol is sent to self.  This and its corresponding target is only good for one use.  Other jumpAheadTo:... with the same label will be put on a stack and superceed existing ones until its jumpAheadTarget: is called."

	| instr |
	"jumpAheadTarget: label will pop this and replace destination with its basic block"
	(jumpAheadStacks at: labelSymbol ifAbsentPut: [OrderedCollection new])
		addLast: (instr := self add: (IRJumpIf new boolean: boolean)).
	self startNewSequence.
	instr otherwise: currentSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/22/2003 14:44'!
jumpBackTarget: labelSymbol
	"Remember this basic block for a future jumpBackTo: labelSymbol.  Stack up remembered targets with same name and remove them from stack for each jumpBackTo: called with same name."

	self startNewSequence.
	(jumpBackTargetStacks at: labelSymbol ifAbsentPut: [OrderedCollection new])
		addLast: currentSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/22/2003 14:25'!
jumpBackTo: labelSymbol
	"Pop last remembered position with this label and write an unconditional jump to it"

	| sequence |
	sequence := (jumpBackTargetStacks at: labelSymbol ifAbsent: [self error: 'Missing jumpBackTarget: ', labelSymbol printString]) removeLast.
	self add: (IRJump new destination: sequence).
	self startNewSequence.
! !

!IRBuilder methodsFor: 'instr - old blocks' stamp: 'md 10/8/2004 15:59'!
jumpOverBlockTo: labelSymbol
	"Conditional jump to the sequence that will be created when jumpAheadTarget: labelSymbol is sent to self.  This and its corresponding target is only good for one use.  Other jumpAheadTo:... with the same label will be put on a stack and superceed existing ones until its jumpAheadTarget: is called."

	| instr |
	"jumpAheadTarget: label will pop this and replace destination with its basic block"
	(jumpAheadStacks at: labelSymbol ifAbsentPut: [OrderedCollection new])
		addLast: (instr := self add: (IRJumpOverBlock new)).
	self startNewSequence.
	instr blockSequence: currentSequence.
! !

!IRBuilder methodsFor: 'mapping' stamp: 'ajh 3/13/2003 13:17'!
mapToByteIndex: index
	"decompiling"

	sourceMapByteIndex := index! !

!IRBuilder methodsFor: 'mapping' stamp: 'ajh 6/22/2003 14:45'!
mapToNode: object
	"new instructions will be associated with object"

	sourceMapNodes addLast: object! !

!IRBuilder methodsFor: 'accessing' stamp: 'JorgeRessia 12/11/2009 13:46'!
methodTemps: aCollection
	ir methodTemps: aCollection! !

!IRBuilder methodsFor: 'initialize' stamp: 'ajh 6/25/2004 11:24'!
numRargs: n

	ir numRargs: n.
! !

!IRBuilder methodsFor: 'mapping' stamp: 'ajh 6/22/2003 14:25'!
popMap

	sourceMapNodes removeLast! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 3/10/2003 01:09'!
popTop

	self add: IRInstruction popTop! !

!IRBuilder methodsFor: 'initialize' stamp: 'ajh 3/10/2003 14:10'!
primitiveNode: primNode

	ir primitiveNode: primNode! !

!IRBuilder methodsFor: 'accessing' stamp: 'md 7/10/2005 22:37'!
properties: aDict
	ir properties: aDict! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/27/2004 21:38'!
pushBlock: irMethod

	self add: (IRInstruction pushBlock: irMethod)! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/27/2004 21:38'!
pushBlockMethod: irMethod

	self add: (IRInstruction pushBlockMethod: irMethod)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jre 9/29/2009 16:01'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs jumpSize: jumpSize
	
	self add: (IRInstruction pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs jumpSize: jumpSize)! !

!IRBuilder methodsFor: 'instructions' stamp: 'TestRunner 1/3/2010 10:00'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs jumpTo: labelSymbol
	
	| jumpSize irInstruction |
	self startNewSequence.
	irInstruction := IRInstruction pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs.
	self add: irInstruction.
	(jumpAheadStacks at: labelSymbol ifAbsentPut: [OrderedCollection new]) addLast: irInstruction.
	irInstruction blockSequence: currentSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'jre 9/29/2009 15:39'!
pushConsArray: size

	self add: (IRInstruction pushConsArray: size)! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 3/10/2003 01:09'!
pushDup

	self add: IRInstruction pushDup! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 6/13/2005 13:59'!
pushInstVar: instVarIndex
	"Receiver must be on top"


	self add: (IRInstruction pushInstVar: instVarIndex).

"
	self pushLiteral: instVarIndex.
	self send: #privGetField:.
"! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 7/5/2005 15:52'!
pushLiteral: object
	
	self add: (IRInstruction pushLiteral: object)! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 7/5/2005 15:52'!
pushLiteralVariable: object
	
	self add: (IRInstruction pushLiteralVariable: object)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jre 9/29/2009 15:39'!
pushNewArray: size

	self add: (IRInstruction pushNewArray: size)! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 4/21/2005 11:38'!
pushReceiver

	self add: (IRInstruction pushReceiver)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jorgeRessia 10/11/2009 10:59'!
pushRemoteTemp: index 
	self add: (IRInstruction pushTemp: index)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jre 9/29/2009 15:41'!
pushRemoteTemp: tempIndex inVectorAt: tempVectorIndex

	self add: (IRInstruction pushRemoteTemp: tempIndex inVectorAt: tempVectorIndex)! !

!IRBuilder methodsFor: 'instructions' stamp: 'JorgeRessia 12/11/2009 20:07'!
pushTemp: key
	
	| index |
	index := tempMap at: key.
	self add: (IRInstruction pushTemp: index)! !

!IRBuilder methodsFor: 'instructions' stamp: 'JorgeRessia 12/27/2009 15:29'!
pushTemp: key in: aScope
	
	| index |
	index := (aScope scopeIndexedVarFor: key name) index.
	self add: (IRInstruction pushTemp: index)
	
! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 4/21/2005 12:06'!
pushThisContext

	self add: (IRInstruction pushThisContext)! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/26/2004 13:47'!
pushThisEnv

	self add: (IRInstruction pushTemp: -1)! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 3/15/2003 01:55'!
remoteReturn

	self add: IRInstruction remoteReturn.
	self startNewSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 3/15/2003 01:55'!
returnTop

	self add: IRInstruction returnTop.
	self startNewSequence.
! !

!IRBuilder methodsFor: 'instructions' stamp: 'JorgeRessia 3/30/2010 19:52'!
send: selector
	self add: (IRInstruction send: selector)! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 3/10/2003 01:09'!
send: selector toSuperOf: behavior

	self add: (IRInstruction send: selector toSuperOf: behavior)! !

!IRBuilder methodsFor: 'mapping' stamp: 'ajh 3/13/2003 13:19'!
sourceByteIndex
	"decompiling"

	^ sourceMapByteIndex! !

!IRBuilder methodsFor: 'mapping' stamp: 'ajh 6/22/2003 21:03'!
sourceNode

	^ sourceMapNodes isEmpty
		ifTrue: [nil]
		ifFalse: [sourceMapNodes last]! !

!IRBuilder methodsFor: 'private' stamp: 'JorgeRessia 3/30/2010 19:50'!
startNewSequence
	"End current instruction sequence and start a new sequence to add instructions to.  If ending block just falls through to new block then add an explicit jump to it so they stay linked"

	| newSequence |
	currentSequence isEmpty  ifTrue:[^ self].	"block is still empty, continue using it"
	newSequence := IRSequence new  orderNumber:currentSequence orderNumber  +1.
	newSequence  method:ir.
	currentSequence last isJumpOrReturn
		ifFalse: [ self add: ( IRJump new destination: newSequence ) ].
	( currentSequence last isReturn and: [currentSequence first isPushClosureCopy] )
		 ifTrue: [self add: ( IRJump new destination: newSequence)].
	currentSequence := newSequence! !

!IRBuilder methodsFor: 'instructions' stamp: 'jorgeRessia 11/4/2009 13:15'!
storeInstVar: instVarIndex
	"receiver must be on top with new field value underneath"

	self add: (IRInstruction storeInstVar: instVarIndex).

	"self pushLiteral: instVarIndex.
	self send: #privStoreIn:field:."
! !

!IRBuilder methodsFor: 'instructions' stamp: 'md 7/5/2005 15:52'!
storeIntoLiteralVariable: object
	
	self add: (IRInstruction storeIntoLiteralVariable: object)! !

!IRBuilder methodsFor: 'instructions' stamp: 'JorgeRessia 1/6/2010 15:48'!
storePopInstVar: instVarIndex
	"receiver must be on top with new field value underneath"

	self add: (IRInstruction storePopInstVar: instVarIndex).


! !

!IRBuilder methodsFor: 'instructions' stamp: 'JorgeRessia 1/6/2010 13:55'!
storePopIntoLiteralVariable: object
	
	self add: (IRInstruction storePopIntoLiteralVariable: object)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jre 9/29/2009 16:00'!
storePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	
	self add: (IRInstruction storePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jorgeRessia 11/3/2009 18:22'!
storePopTemp: key

	| index |

	index := tempMap at: key.
	self add: (IRInstruction storePopTemp: index)! !

!IRBuilder methodsFor: 'instructions' stamp: 'JorgeRessia 12/27/2009 15:29'!
storePopTemp: key in: aScope 
	
	| index |
	index := (aScope scopeIndexedVarFor: key name) index.
	self add: (IRInstruction storePopTemp: index)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jre 9/29/2009 16:00'!
storeRemoteTemp: tempIndex inVectorAt: tempVectorIndex
	
	self add: (IRInstruction storeRemoteTemp: tempIndex inVectorAt: tempVectorIndex)! !

!IRBuilder methodsFor: 'instructions' stamp: 'jorgeRessia 11/9/2009 09:35'!
storeTemp: key

	| index |
	index := tempMap at: key.
	self add: (IRInstruction storeTemp: index)! !

!IRBuilder methodsFor: 'instructions' stamp: 'JorgeRessia 12/27/2009 15:29'!
storeTemp: key in: aScope
	
	| index |
	index := (aScope scopeIndexedVarFor: key name) index.
	self add: (IRInstruction storeTemp: index)
! !

!IRBuilder methodsFor: 'instructions' stamp: 'ajh 6/26/2004 13:48'!
storeThisEnv

	self add: (IRInstruction storeTemp: -1)! !

!IRBuilder methodsFor: 'decompiling' stamp: 'ajh 3/21/2003 01:48'!
testJumpAheadTarget: label

	jumpAheadStacks at: label ifPresent: [:stack |
		[stack isEmpty] whileFalse: [self jumpAheadTarget: label]
	]! !

Object subclass: #IRInterpreter
	instanceVariableNames: 'ir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRInterpreter commentStamp: 'ajh 3/24/2003 23:55' prior: 0!
I visit each IRInstruction in an IRMethod in order.  Each instruction sends its instruction message to me upon being visited.  See my 'instructions' method category for complete list of instructions.  Subclasses should override them.!

IRInterpreter subclass: #IRDecompiler
	instanceVariableNames: 'stack sp scope currentInstr valueLabelMap mapEmptyStatement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRDecompiler commentStamp: 'ajh 3/25/2003 00:37' prior: 0!
I interpret IRMethod instructions and generate a Smalltalk abstract syntax tree rooted at a RBMethodNode.

This is implemented like a shift-reduce parser.  Each instruction either causes a node to be pushed on the stack (shift), or causes one or more nodes to be popped and combined into a single node which is push back on the stack (reduce).  Most reduction is done at the "label: labelNum" instruction where it tries to reduce jump structures into control messages like #ifTrue:, whileFalse:, etc.

Several pseudo nodes (RBPseudoNode and subclasses) are used to represent basic instructions that have not been reduced to real AST nodes yet.
!

!IRDecompiler class methodsFor: 'as yet unclassified' stamp: 'ajh 6/5/2003 12:34'!
dummySelector: numArgs
	"Answer a dummy selector with number of args"

	| sel |
	sel := 'unknown'.
	1 to: numArgs do: [:i |
		sel := sel, 'with:'].
	^ sel asSymbol! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:06'!
Assignment

	| node |
	(node := self stackDown) isAssignment ifTrue: [^ node].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'md 11/12/2004 14:06'!
Block

	| node |
	(node := self stackDown) isBlock ifTrue: [^ node].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:05'!
Dup

	| node |
	(node := self stackDown) isDup ifTrue: [^ node].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 20:50'!
Goto

	| node |
	(node := self stackDown) isGoto ifTrue: [^ node].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:05'!
Goto: seqNum

	| goto |
	(goto := self Goto) destination = seqNum ifTrue: [^ goto].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:05'!
GotoOrReturn: seqNum

	| goto |
	goto := self Goto.
	(goto destination = seqNum or: [goto isRet]) ifTrue: [^ goto].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:05'!
If

	| node |
	(node := self stackDown) isIf ifTrue: [^ node].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:05'!
IfGoto: seqNum otherwise: seqNum2

	| if |
	((if := self If) destination = seqNum and: [if otherwise = seqNum2])
		ifTrue: [^ if].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:04'!
Label

	| node |
	(node := self stackDown) isLabel ifTrue: [^ node].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:04'!
Label: seqNum

	| label |
	(label := self Label) destination = seqNum ifTrue: [^ label].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:04'!
Pop

	| node |
	(node := self stackDown) isPop ifTrue: [^ node].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:04'!
Send

	| node |
	(node := self stackDown) isPseudoSend ifTrue: [^ node].
	self abort! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/10/2007 13:50'!
Sequence
	| node seq i goto |
	seq := RBSequenceNode statements: #().
	i := self spIndex.
	[node := stack at: i.
	node isSequence 
		ifTrue: 
			[seq addNodesFirst: node statements.
			node := stack at: (i := i - 1)].
	(node isLabel and: [i > 1]) 
		ifFalse: 
			[sp := i.
			^ seq].
	goto := stack at: (i := i - 1).
	goto isGoto and: [goto destination = node destination]] 
			whileTrue: [i := i - 1].
	sp := i + 1.
	^ seq! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 7/12/2007 22:43'!
Sequence2
	| node seq i block temps label |
	seq := RBSequenceNode statements: #().
	i := self spIndex.
	node := stack at: i.
	[(node isLabel and: [(stack at: i - 1) isGoto] and:[node destination = (stack at: i - 1) destination])
		ifTrue:[
			i := i - 2.
			node := stack at: i].
	(node isLabel not and: [i > 1])] whileTrue: 
			[
			node isSequence 
				ifTrue: [seq addNodesFirst: node statements]
				ifFalse: [seq addNodeFirst: node].
			i := i - 1.
			node := stack at: i].
	sp := i.
	label := self Label.
	block := self Block.
	self stackPush: block.
	self stackPush: label.
	"Add the temporaries find"
	temps := scope tempVars asArray allButFirst.
	temps := temps select: [:each | ((block arguments 
							collect: [:var | var binding])  includes: each) not].
	seq temporaries: (temps collect: [:var | self newVar: var]).
	^ seq! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:03'!
SequenceBackTo: labelNum 
	| node seq i goto |
	seq := RBSequenceNode statements: #().
	i := self spIndex.
	[node := stack at: i.
	node isSequence 
		ifTrue: 
			[seq addNodesFirst: node statements.
			node := stack at: (i := i - 1)].
	(node isLabel and: [i > 1]) 
		ifFalse: 
			[sp := i.
			^ seq].
	node destination = labelNum 
		ifTrue: 
			[sp := i.
			^ seq].
	goto := stack at: (i := i - 1).
	goto isGoto and: [goto destination = node destination]] 
			whileTrue: [i := i - 1].
	sp := i + 1.
	^ seq! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 7/19/2007 12:21'!
SequenceOtherwise
	| node seq i |
	seq := RBSequenceNode statements: #().
	i := self spIndex.
	node := stack at: i.
	node isSequence ifTrue: [
			seq addNodesFirst: node statements.
			self stackDown]
		ifFalse:[node isLabel ifFalse:[self abort]].
	^ seq! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:03'!
Value

	| node |
	node := self ValueOrNone.
	node ifNil: [self abort].
	^ node! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:02'!
ValueOrNone
	| node i label |
	i := self spIndex.
	[node := stack at: i.
	node isValue 
		ifTrue: 
			[label ifNotNil: [valueLabelMap at: node put: label].
			sp := i - 1.
			^ node].
	(node isLabel and: [i > 1]) ifFalse: [^ nil].
	label := node.
	node := stack at: (i := i - 1).
	node isGoto and: [node destination = label destination]] 
			whileTrue: [i := i - 1].
	^ nil! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 21:01'!
abort

	| spWas |
	spWas := sp.
	sp := nil.
	Abort signal! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 9/8/2007 02:30'!
addReturn: statements from: goto

		| ret |
		statements last isReturn ifTrue:[^self].
		ret := RBReturnNode value: statements last.
		Preferences compileBlocksAsClosures ifTrue:[
			scope isHome ifFalse: [ret homeBinding: scope outerEnvScope thisEnvVar]].
		goto mapInstr sourceNode: ret.
		statements atLast: 1 put: ret.! !

!IRDecompiler methodsFor: 'init' stamp: 'ms 7/5/2007 20:42'!
addTempToScope: ir 

	"Temp may be created only if they are not used in the method"
	0 to: ir numRargs - 1 do: [:i | (scope 
		rawVarAt: i 
		ifNone: [
			scope capturedVars do: [:each | 
				each index = i ifTrue:[
					scope tempVarAt: scope capturedVars size + scope tempVars size.
					^self]].
			scope tempVarAt: i]) markArg]! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 7/10/2007 16:07'!
block: method env: envRefNode

	self stackPush: (IRDecompiler new
		scope: (scope newBlockScope "capturedVars: vars");
		decompileIR: method ir)
		asBlock! !

!IRDecompiler methodsFor: 'old blocks' stamp: 'md 11/15/2004 15:38'!
blockReturnTop

	self goto: #return.
! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 9/7/2007 21:34'!
captureEmptyStatement
	| by replace node |
	
	[by := self Goto destination.
	replace := self Label destination.
	replace = 0 ifTrue: [self abort]] 
			on: Abort
			do: [^ false].
	mapEmptyStatement at: by put: replace.
	sp := nil.
	^ true! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 6/20/2007 00:53'!
cascade

	| messages selector args rcvr |
	messages := OrderedCollection new.
	"last message"
	selector := self Send selector.
	args := OrderedCollection new.
	selector numArgs timesRepeat: [args addFirst: self Value].
	messages addFirst: selector -> args.

	"rest of messages"
	[(rcvr := self ValueOrNone) isNil] whileTrue: [
		self Pop.
		selector := self Send selector.
		args := OrderedCollection new.
		selector numArgs timesRepeat: [args addFirst: self Value].
		self Dup.
		messages addFirst: selector -> args.
	].

	messages := messages collect: [:assoc |
		RBMessageNode
			receiver: rcvr
			selector: assoc key
			arguments: assoc value].
	self stackPush: (RBCascadeNode messages: messages).
! !

!IRDecompiler methodsFor: 'init' stamp: 'ms 9/6/2007 03:52'!
decompileIR: ir 
	| sequenceNode temps args goto seq value method |
	scope isBlockScope 
		ifTrue:[(scope addTemp: 'parent env') markArg]
		ifFalse:[(scope addTemp: 'self') markArg].
	ir tempKeys do: [:temp | scope tempVarAt: temp].
	0 to: ir numRargs - 1 do: [:i | (scope tempVarAt: i) markArg].
	self interpret: ir.
	
	self addTempToScope: ir.
	self label: #return.
	self Label: #return.
	(self endCase: #lastReturn) ifFalse:[self Label: #return.].
	goto := self Goto.
	value := self ValueOrNone.
	seq := self Sequence.
	self removeClosureCreation: seq.
	sp = 1 ifFalse: [stack explore. self error: 'error'].
	value ifNotNil: [seq addNode: value].
	sequenceNode := (self newBlock: seq return: goto) body.
	temps := scope compactIndexTemps asArray.
	ir tempKeys: temps.
	args := (temps first: ir numRargs) allButFirst.
	args := args collect: [:var | self newVar: var].
	temps := temps allButFirst: ir numRargs.
	sequenceNode temporaries: (temps collect: [:var | self newVar: var]), 
		((scope capturedVars select:[:var | var name ~= 'self' and: [var sourceTemp == nil]]) 
			collect:[:var | self newVar: var]).
	method := (RBMethodNode new)
				selectorParts: (self 
							newSelectorParts: (self class dummySelector: args size));
				arguments: args;
				body: sequenceNode;
				primitiveNode: ir primitiveNode;
				scope: scope.
	sequenceNode parent: method.
	Preferences compileBlocksAsClosures 
		ifFalse: [ASTFixDecompileBlockScope new visitNode: method].
	^ method! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 9/6/2007 01:57'!
endAndOr2: seqNum

	| goto seq p if2 test else o if1 seqValue elseTest otherwise |
	[
		goto := self Goto.
		seqValue := self ValueOrNone.
		seq := self Sequence.
		p := self Label destination.
		if2 := self IfGoto: seqNum otherwise: p.
		elseTest := self Value.
		else := self SequenceBackTo: goto destination.
		o := self Label destination.
		o = goto destination ifTrue: [self abort].
		if1 := self IfGoto: seqNum otherwise: o.
		test := self Value.
	] on: Abort do: [^ false].

	if1 boolean = if2 boolean 
		ifFalse: [
			otherwise := RBSequenceNode statements: #().
			otherwise addNode: (self newLiteral: if2 boolean).
			self stackPush: (RBMessageNode
				receiver: test 
				selector: (if2 boolean ifTrue: [#ifTrue:ifFalse:] ifFalse: [#ifFalse:ifTrue:]) 
				arguments: {self newBlock: (else addNode: elseTest).
					self newBlock: otherwise}).]
		ifTrue:[self stackPush: (RBMessageNode
			receiver: test
			selector: (if2 boolean ifTrue: [#or:] ifFalse: [#and:])
			arguments: {self newBlock: (else addNode: elseTest)})].
	stack addLast: if2.
	self label: p.
	stack addLast: seq.
	seqValue ifNotNil: [stack addLast: seqValue].
	stack addLast: goto.
	^ true
! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 6/17/2007 16:05'!
endAndOr: seqNum

	| o test branches if body block sel1 sel2 if2 |
	branches := OrderedCollection new.
	[
		(if2 := self If) otherwise = seqNum ifFalse: [self abort].
		[	test := self Value.
			body := self Sequence.
			branches add: {body. test}.
			o := self Label destination.
			(if := self If) otherwise = o ifFalse: [self abort].
			if destination = seqNum
		] whileFalse: [
			if boolean = if2 boolean ifFalse: [self abort].
			if destination = if2 destination ifFalse: [self abort].
		].
		if boolean = if2 boolean ifTrue: [self abort].
		test := self Value.
	] on: Abort do: [^ false].

	if boolean
		ifTrue: [sel1 := #or:. sel2 := #and:]
		ifFalse: [sel1 := #and:. sel2 := #or:].
	block := self newBlock: (branches first first addNode: branches first second).
	branches allButFirstDo: [:pair |
		block := self newBlock: (pair first addNode: (RBMessageNode
				receiver: pair second
				selector: sel2
				arguments: {block})).
	].
	self stackPush: (RBMessageNode
		receiver: test
		selector: sel1
		arguments: {block}).
	stack addLast: if2.
	^ true! !

!IRDecompiler methodsFor: 'old blocks' stamp: 'ms 9/8/2007 02:48'!
endBlock: seqNum

	| blockSeq block goto startBlock |
	[
		goto := self GotoOrReturn: seqNum.
		(goto isRet 
			or:[goto mapInstr notNil 
				and: [goto mapInstr isBlockReturnTop]]) ifFalse: [self abort].
		sp = 0 ifTrue: [self abort].
		blockSeq := self Sequence2.
		startBlock := self Label.
		block := self Block.
		(goto isRet not
			and:[goto mapInstr notNil] 
			and: [goto mapInstr isBlockReturnTop]
			and: [block successor ~= seqNum]) ifTrue:[
				self stackPush: block.
				self stackPush: startBlock.
				self stackPush: blockSeq. 
				self stackPush: goto.
				self abort].
		self Send.
	] on: Abort do: [^ false].

	self stackPush: (self newBlock: blockSeq return: goto).	
	stack last arguments: block arguments.
	"No extra scope is need if we don't use any temporaries and arguments.
	so we remove them"
	(stack last arguments isEmpty and: [stack last body temporaries isEmpty])
		ifTrue:[ASTReplaceVariableScope replace: stack last scope: scope outerScope ].
	scope := scope outerScope.
	currentInstr := nil.
	self goto: block successor.
	^ true! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 7/19/2007 16:06'!
endCase: seqNum

	| otherwiseGoto goto node otherwiseValue otherwiseSeq n branchValue branchSeq f caseValue caseSeq rcvr branches message seqEnd afterOterwise seq afterOterwiseValue |
	branches := OrderedCollection new.
	[	"otherwise"
		otherwiseGoto := self Goto.
		node := self stackDown.
		node isSequence ifTrue: [(node statements size = 1 
			and:[node statements first isSend] 
			and: [
				node := node statements first. 
				node selector == #caseError]) ifFalse: [
					otherwiseSeq := node] ].
		(node isPop or: [node isSend and: [node selector == #caseError]]) ifTrue: [
			node isPop ifTrue: [node := self Send].
			node selector == #caseError ifFalse: [self abort].
		] ifFalse: [
			sp := sp + 1.  "stackUp"
			
			seqNum == #lastReturn 
				ifFalse: [
					otherwiseValue := self ValueOrNone.
					otherwiseSeq := self Sequence]
				ifTrue: [
					afterOterwiseValue := self ValueOrNone.
					otherwiseSeq := RBSequenceNode statements: #().
					afterOterwise := self SequenceOtherwise].
		].
		n := self Label destination.
		"last case branch"
		seqNum == #lastReturn 
			ifFalse: [goto := self GotoOrReturn: seqNum]
			ifTrue: [
				seqEnd := n.
				goto := self GotoOrReturn: n.
				otherwiseGoto := goto].
		branchValue := self ValueOrNone.
		branchSeq := self Sequence.
		(stack at: sp) isPop ifTrue: [self stackDown].
		f := self Label destination.
		
		"last case"
		self IfGoto: n otherwise: f.
		self Send selector == #= ifFalse: [self abort].
		caseValue := self Value.
		caseSeq := self Sequence.
		otherwiseSeq ifNil: [self Dup].
		branches addFirst: ({caseSeq. caseValue} -> {branchSeq. branchValue. goto}).

		[(rcvr := self ValueOrNone) isNil] whileTrue: [
			"case branch"
			n := self Label destination.
			seqNum == #lastReturn 
				ifFalse: [goto := self GotoOrReturn: seqNum]
				ifTrue: [goto := self GotoOrReturn: seqEnd].
			branchValue := self ValueOrNone.
			branchSeq := self Sequence.
			self Pop.
			f := self Label destination.
			"case"
			self IfGoto: n otherwise: f.
			self Send selector == #= ifFalse: [self abort].
			caseValue := self Value.
			caseSeq := self Sequence.
			self Dup.
			branches addFirst: ({caseSeq. caseValue} -> {branchSeq. branchValue. goto}).
		].
	] on: Abort do: [^ false].

	branches := branches collect: [:assoc |
		assoc key second
			ifNotNil: [assoc key first addNode: assoc key second].
		assoc value second
			ifNotNil: [assoc value first addNode: assoc value second].
		RBMessageNode
			receiver: (self newBlock: assoc key first return: nil)
			selector: #->
			arguments:
				{self newBlock: assoc value first return: assoc value third}
	].
	message := otherwiseSeq
		ifNil: [
			RBMessageNode
				receiver: rcvr
				selector: #caseOf:
				arguments: {RBArrayNode statements: branches}]
		ifNotNil: [
			otherwiseValue
				ifNotNil: [otherwiseSeq addNode: otherwiseValue].
			RBMessageNode
				receiver: rcvr
				selector: #caseOf:otherwise:
				arguments: 
					{RBArrayNode statements: branches.
					self newBlock: otherwiseSeq return: otherwiseGoto}.
		].
	self stackPush: message.
	seqNum == #lastReturn ifTrue: [
		self popTop.
		seq := self Sequence.
		afterOterwise ifNotNil:[seq statements addAllLast: afterOterwise statements].
		self stackPush: seq.
		afterOterwiseValue ifNotNil:[self stackPush: afterOterwiseValue].
		branchValue := 1].
	branchValue ifNil: [self popTop].
	self stackPush: otherwiseGoto.
	^ true! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 7/15/2007 23:33'!
endIfNil: seqNum

	| goto branch o if rcvr value |
	[
		goto := self Goto.
		value := self Value.
		branch := self Sequence.
		self Pop.
		o := self Label destination.
		if := self IfGoto: seqNum otherwise: o.
		self Send selector == #== ifFalse: [self abort].
		(self Value isLiteral: [:v | v isNil]) ifFalse: [self abort].
		self Dup.
		rcvr := self Value.
	] on: Abort do: [^ false].

	branch addNode: value.
	self stackPush: (RBMessageNode
		receiver: rcvr
		selector: (if boolean ifTrue: [#ifNotNil:] ifFalse: [#ifNil:])
		arguments: {self newBlock: branch return: goto}).
	self goto: seqNum.
	^ true! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 9/6/2007 00:23'!
endIfThen2: seqNum

	| goto branch o if test value gotoNum branch2 |
	[
		goto := self Goto.
		(goto mapInstr ~= nil 
			and: [goto mapInstr isJump]
			and: [goto mapInstr destination size = 1]  
			and: [goto mapInstr destination last isJump]) 
				ifTrue: [gotoNum := goto 
					mapInstr destination last destination orderNumber]
				ifFalse:[self abort].
		(currentInstr ~= nil 
			and: [currentInstr isJump] 
			and: [currentInstr destination orderNumber = goto destination])
				ifFalse: [self abort].
		value := self Value.
		branch := self Sequence.
		o := self Label destination.
		seqNum = gotoNum 
			ifFalse:[if := self IfGoto: gotoNum otherwise: o]
			ifTrue:[self abort].
		test := self Value.
	] on: Abort do: [^ false].
	
	value ifNotNil: [branch addNode: value].
	branch2 := RBSequenceNode statements: #().
	branch2 addNode: (self newLiteral: if boolean).
	self stackPush: (self simplify: (RBMessageNode
		receiver: test
		selector: (if boolean ifTrue: [#ifFalse:ifTrue:] ifFalse: [#ifTrue:ifFalse:])
		arguments: {self newBlock: branch return: goto.
			self newBlock: branch2})).
	self goto: goto destination.
	^true! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 9/7/2007 21:47'!
endIfThen3: seqNum

	| goto branch o if test value |
	[
		goto := self Goto.
		(goto destination == seqNum or: [self isExplicitReturn: goto])
			ifFalse: [self abort].
		goto isRet ifTrue: [value := self Value].
		branch := self Sequence.
		o := self Label destination.
		if := self If.
		((if destination = seqNum 
			or: [if destination = (mapEmptyStatement at: seqNum ifAbsent:[seqNum])])
				and: [if otherwise = o])
			ifFalse:[self abort].
		test := self Value.
	] on: Abort do: [^ false].
	

	value ifNotNil: [branch addNode: value].
	self stackPush: (self simplify: (RBMessageNode
		receiver: test
		selector: (if boolean ifTrue: [#ifFalse:] ifFalse: [#ifTrue:])
		arguments: {self newBlock: branch return: goto})).
	self popTop.
	self goto: seqNum.
	^ true! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 7/19/2007 16:07'!
endIfThen: seqNum

	| goto branch o if test value |
	[
		goto := self Goto.
		(goto destination == seqNum or: [self isExplicitReturn: goto])
			ifFalse: [self abort].
		goto isRet ifTrue: [value := self Value].
		branch := self Sequence.
		o := self Label destination.
		if := self IfGoto: seqNum otherwise: o.
		test := self Value.
	] on: Abort do: [^ false].
	

	value ifNotNil: [branch addNode: value].
	self stackPush: (self simplify: (RBMessageNode
		receiver: test
		selector: (if boolean ifTrue: [#ifFalse:] ifFalse: [#ifTrue:])
		arguments: {self newBlock: branch return: goto})).
	self popTop.
	self goto: seqNum.
	^ true! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 9/8/2007 02:48'!
endIfThenElse: seqNum

	| goto2 else d goto1 then o if test value2 value1 |
	[
		goto2 := self Goto.
		value2 := self ValueOrNone.
		else := self Sequence.
		d := self Label destination.
		goto1 := self Goto.
		((self isExplicitReturn: goto2) or: [goto2 destination == goto1 destination]) ifFalse: [self abort].
		value1 := self ValueOrNone.
		then := self Sequence.
		o := self Label destination.
		if := self IfGoto: d otherwise: o.
		test := self Value.
	] on: Abort do: [^ false].

	value2 ifNotNil: [else addNode: value2].
	value1 ifNotNil: [then addNode: value1].
	(self isExplicitReturn: goto1) ifTrue:[self addReturn: then statements from: goto1].
	(self isExplicitReturn: goto2) ifTrue:[self addReturn: else statements from: goto2].
	self stackPush: (self simplify: (else isEmpty
		ifTrue: [RBMessageNode
			receiver: test
			selector: (if boolean ifTrue: [#ifFalse:] ifFalse: [#ifTrue:])
			arguments: {self newBlock: then return: goto1}]
		ifFalse: [RBMessageNode
			receiver: test
			selector: (if boolean
				ifTrue: [#ifFalse:ifTrue:]
				ifFalse: [#ifTrue:ifFalse:])
			arguments: {
				self newBlock: then return: goto1.
				self newBlock: else return: goto2}])).
	value1 ifNil: [self popTop].
	currentInstr := goto1 mapInstr.
	self stackPush: goto1.
	(else statements isEmpty and:
	 [stack anySatisfy: [:n | n isIf and: [n destination = d]]]
	) ifTrue: [
		self label: d.
		currentInstr := goto2 mapInstr.
		self stackPush: goto2.
	].
	^ true! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 9/6/2007 04:29'!
endToDo: seqNum

	| start limit incr iter step loopBlock o if test limitExpr init |
	[
		start := self Goto destination.
		limit := self Value.
		incr := self Assignment.
		iter := incr variable.
		(incr value isMessage and:
		 [incr value selector == #+ and:
		  [incr value receiver isVariable and: 
		   [incr value receiver binding == iter binding]]]
		) ifFalse: [self abort].
		step := incr value arguments first.
		loopBlock := self Sequence.
		o := self Label destination.
		if := self IfGoto: seqNum otherwise: o.
		test := self Value.
		(test isMessage and:
		 [(test selector == #<= or: [test selector == #>=]) and:
		  [(valueLabelMap at: test arguments first ifAbsent: [self abort]) destination = start]]
		) ifFalse: [self abort].
		limitExpr := test arguments first.
		limitExpr isAssignment ifTrue: [
			(limitExpr variable binding index == limit binding index 
				and:[limitExpr variable binding scope == limit binding scope]) ifFalse: [self abort].
			limitExpr := limitExpr value.
		].
		init := test receiver.
		(init isAssignment and: [init variable binding == iter binding])
			ifFalse: [self abort].
	] on: Abort do: [^ false].
	limit isVariable 
		ifTrue:[scope 
			removeTemp: limit binding 
			ifAbsent:[Preferences compileBlocksAsClosures 
				ifFalse:[scope removeTempFromOldBlock: limit]]].
	loopBlock := self newBlock: loopBlock.
	loopBlock arguments: {iter}.
	self stackPush: ((step isLiteral: [:c | c = 1])
		ifTrue: [RBMessageNode
				receiver: init value
				selector: #to:do:
				arguments: {limitExpr. loopBlock}]
		ifFalse: [RBMessageNode
				receiver: init value
				selector: #to:by:do:
				arguments: {limitExpr. step. loopBlock}]).
	self popTop.
	self goto: seqNum.
	^ true
! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 9/7/2007 21:48'!
endWhile2: seqNum

	| start loopBlock if test sequence o goto previousStack |
	[
		stack := (previousStack := stack) copy.
		start := (goto := self Goto) destination.
		self stackPush: goto.
		[self endIfThen3: start] whileTrue.
		start :=  self Goto destination.
		loopBlock := self Sequence.
		o := self Label destination.
		if := self IfGoto: seqNum otherwise: o.
		test := self Value.
		sequence := self SequenceBackTo: start.
		self Label: start.
		sp := sp + 1.  "stackUp"
	] on: Abort do: [stack := previousStack. ^ false].
	loopBlock isEmpty
		ifTrue:[self stackPush: (self simplify: (RBMessageNode
			receiver: (self newBlock: (sequence addNode: test))
			selector: (if boolean ifTrue: [#whileFalse] ifFalse: [#whileTrue])
			arguments: #()))]
		ifFalse:[self stackPush: (self simplify: (RBMessageNode
			receiver: (self newBlock: (sequence addNode: test))
			selector: (if boolean ifTrue: [#whileFalse:] ifFalse: [#whileTrue:])
			arguments: {self newBlock: loopBlock}))].
	self popTop.
	self goto: seqNum.
	^ true
! !

!IRDecompiler methodsFor: 'priv instructions' stamp: 'ms 9/6/2007 01:54'!
endWhile: seqNum

	| start loopBlock if test sequence o |
	[
		start := self Goto destination.
		loopBlock := self Sequence.
		o := self Label destination.
		if := self IfGoto: seqNum otherwise: o.
		test := self Value.
		sequence := self SequenceBackTo: start.
		self Label: start.
		sp := sp + 1.  "stackUp"
	] on: Abort do: [^ false].
	loopBlock isEmpty
		ifTrue:[self stackPush: (self simplify: (RBMessageNode
			receiver: (self newBlock: (sequence addNode: test))
			selector: (if boolean ifTrue: [#whileFalse] ifFalse: [#whileTrue])
			arguments: #()))]
		ifFalse:[self stackPush: (self simplify: (RBMessageNode
			receiver: (self newBlock: (sequence addNode: test))
			selector: (if boolean ifTrue: [#whileFalse:] ifFalse: [#whileTrue:])
			arguments: {self newBlock: loopBlock}))].
	self popTop.
	self goto: seqNum.
	^ true
! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 8/8/2007 19:46'!
fixInnerFreeVar: aRcvrTemp

	| scopeInnerFreeVar |
	scopeInnerFreeVar := scope outerScope.
	[aRcvrTemp scope = scopeInnerFreeVar] whileFalse:[
		scopeInnerFreeVar hasInnerFreeVars: true.
		scopeInnerFreeVar := scopeInnerFreeVar outerScope].
	aRcvrTemp scope hasInnerFreeVars: true! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 8/9/2007 14:53'!
fixStack

	sp ifNotNil: [stack removeLast: (stack size - sp)].
	sp := nil.
! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ajh 3/23/2003 12:47'!
goto: seqNum

	self stackPush: (RBPseudoGotoNode new destination: seqNum).
! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ajh 3/20/2003 17:21'!
if: bool goto: seqNum1 otherwise: seqNum2

	self stackPush: (RBPseudoIfNode new
		boolean: bool;
		destination: seqNum1;
		otherwise: seqNum2)! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 9/7/2007 21:33'!
initialize

	stack := OrderedCollection new.
	scope := nil parseScope newMethodScope.  "in case never set"
	valueLabelMap := IdentityDictionary new.
	mapEmptyStatement := IdentityDictionary new
! !

!IRDecompiler methodsFor: 'interpret' stamp: 'ms 5/2/2007 10:44'!
interpretInstruction: irInstruction

	currentInstr := irInstruction.
	super interpretInstruction: irInstruction.
! !

!IRDecompiler methodsFor: 'interpret' stamp: 'ms 7/11/2007 01:01'!
interpretSequence: instructionSequence

	super interpretSequence: instructionSequence.
	"currentInstr := nil."
! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 7/14/2007 21:45'!
isExplicitReturn: goto

	Preferences compileBlocksAsClosures 
		ifTrue:[^ goto isRet 
			and: [goto mapInstr notNil] 
			and: [goto mapInstr isRemote or: [scope isBlockScope not]]]
		ifFalse: [^goto isRet and: [goto mapInstr isBlockReturnTop not]]! !

!IRDecompiler methodsFor: 'old blocks' stamp: 'ms 7/15/2007 00:55'!
jumpOverBlock: seqNum1  to: seqNum2
	| numArgs args oldscope pseudoBlock |

	oldscope := scope.
	self scope: (scope newBlockScope).
	oldscope tempVarAt: 0.
	(scope addObjectTemp: (oldscope tempVarAt: 0)).
	numArgs := stack last arguments first value.
	self stackPush: (pseudoBlock := RBPseudoBlockNode new).
	
	args := OrderedCollection new.
	numArgs timesRepeat: [ | var instr |
		instr :=  currentInstr blockSequence removeFirst.
 		var := oldscope tempVarAt: instr number.
		args add: (self newVar: var).
		var isUnused ifTrue: [oldscope removeTempFromOldBlock: var].
		scope addObjectTemp: var.
		currentInstr blockSequence first isPop 
			ifFalse: [
				currentInstr blockSequence sequence addFirst: (IRInstruction pushTemp: var index)]
			ifTrue:[currentInstr blockSequence removeFirst].
		
	].
	args := args reverse.
	pseudoBlock
		block: seqNum1;
		successor: seqNum2;
		arguments: args
	! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 9/8/2007 03:20'!
label: seqNum

	stack isEmpty ifTrue: [  "start"
		^ stack addLast: (RBPseudoLabelNode new destination: seqNum)].

	self captureEmptyStatement.
	"Reduce jump structures to one of the following if possible"
	[	(self endBlock: seqNum) or: [
		 (self endAndOr: seqNum) or: [
		  (self endAndOr2: seqNum) or: [
		   (self endIfThen: seqNum) or: [
		    (self endIfThen2: seqNum) or:[
		      (self endIfThenElse: seqNum) or: [
		       (self endCase: seqNum) or: [
		        (self endToDo: seqNum) or: [
		         (self endWhile: seqNum) or: [
			     (self endWhile2: seqNum) or: [
			      (self endIfNil: seqNum)]]]]]]]]]]
	] whileTrue.

	stack addLast: (RBPseudoLabelNode new destination: seqNum).
! !

!IRDecompiler methodsFor: 'private' stamp: 'ajh 3/20/2003 23:21'!
mapNode: node

	currentInstr ifNil: [^ self].
	node isPseudo
		ifTrue: [node mapInstr: currentInstr]
		ifFalse: [currentInstr sourceNode: node]! !

!IRDecompiler methodsFor: 'private' stamp: 'ajh 3/24/2003 12:07'!
newBlock: sequence

	^ self newBlock: sequence return: nil! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 7/14/2007 22:16'!
newBlock: sequence return: goto

	| statements block |
	statements := sequence statements.
	(goto notNil and: [self isExplicitReturn: goto]) ifTrue: [
		self addReturn: statements from: goto
	].
	sequence statements: statements.
	block := RBBlockNode body: sequence.
	sequence parent: block.
	Preferences compileBlocksAsClosures ifFalse: [block scope: scope].
	^block! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 9/6/2007 00:16'!
newLiteral: literal

	^ RBLiteralNode value: literal! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 5/2/2007 10:33'!
newSelectorParts: selector

	^ selector keywords collect: [:word |
		RBLiteralToken value: word]! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 5/2/2007 10:35'!
newVar: semVar

	^ RBVariableNode new
		identifierToken: (RBIdentifierToken value: semVar name start: 0);
		binding: semVar! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 7/11/2007 23:24'!
popTop

	| value |
	stack last ifNil: [^ stack removeLast].  "pop no-op from #simplifyTempAssign:"
	[stack last isLabel 
		and: [(stack atLast:2) isGoto] 
		and: [stack last destination = (stack atLast: 2) destination]]
			whileTrue: [
				stack removeLast.
				stack removeLast].
	stack last isValue ifTrue: [
		(stack atLast: 2) isSequence ifTrue: [
			value := stack removeLast.
			^ stack last addNode: value.
		] ifFalse: [(stack atLast: 2) isPseudo ifTrue: [
			value := stack removeLast.
			^ stack addLast: (RBSequenceNode statements: {value}).
		]].
	].
	stack addLast: RBPseudoPopNode new
! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ajh 6/27/2004 21:35'!
pushBlock: irMethod

	self block: irMethod env: nil! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ajh 6/27/2004 21:37'!
pushBlockMethod: irMethod

	"block will recognized when send: #createBlock:"
	self pushLiteral: irMethod! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ajh 6/22/2003 14:51'!
pushDup

	stack addLast: RBPseudoDupNode new! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 7/11/2007 11:14'!
pushInstVar: index
	
	self stackPush: (self newVar: (scope instanceScope instVar: index))
! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 9/6/2007 00:16'!
pushLiteral: object

	self stackPush: (self newLiteral: object).
! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 7/10/2007 18:50'!
pushLiteralVariable: object

	| var |
	var := scope lookupVar: object key asString.
	self stackPush: (self newVar: var)
! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 7/30/2007 11:56'!
pushTemp: tempIndex

	| var |
	var := scope basicTempVarAt: tempIndex.
	var isTemp ifTrue: [var cantBeCapture].
	self stackPush: (self newVar: var).! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ajh 6/22/2003 14:27'!
remoteReturn

	stack removeLast.  "pop home context free var"
	self goto: #return.
! !

!IRDecompiler methodsFor: 'init' stamp: 'ms 7/30/2007 13:58'!
removeClosureCreation: seq 
	(Preferences compileBlocksAsClosures 
		and: [seq statements size > 0]
		and: [seq statements first isClosureEnvironmentCreation]) ifTrue: [
			seq statements removeFirst.
			(seq statements size > 0
				and: [seq statements first isClosureEnvironmentRegistration])
				ifTrue: [seq statements removeFirst]].
			
	[Preferences compileBlocksAsClosures
		and: [seq statements size > 0]
		and: [seq statements first isClosureRegistrationAndCreation
			or: [seq statements first isSelfClosureRegistration]
			or: [seq statements first isTempClosureRegistration]]]
					whileTrue: [seq statements removeFirst]! !

!IRDecompiler methodsFor: 'instructions' stamp: 'md 11/12/2004 18:00'!
returnTop

	self goto: #return.
! !

!IRDecompiler methodsFor: 'accessing' stamp: 'ms 6/15/2007 13:25'!
scope

	^scope! !

!IRDecompiler methodsFor: 'init' stamp: 'ms 6/15/2007 13:24'!
scope: aLexicalScope

	scope := aLexicalScope! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 7/19/2007 15:13'!
send: selector

	| args rcvr |
	selector = #caseError ifTrue:[^self stackPush: (RBPseudoSendNode new selector: selector)].
	args := OrderedCollection new.
	[	selector numArgs timesRepeat: [args addFirst: self Value].
		rcvr := self Value.
	] on: Abort do: [
		[self stackPush: (RBPseudoSendNode new selector: selector).
		^self cascade] on: Abort do:[^false]
	].

	Preferences compileBlocksAsClosures 
			ifTrue: [ (rcvr isLiteral and: [selector = #createBlock:]) ifTrue: [
					 ^ self block: rcvr value env: args first]]
			ifFalse: [ (selector = #blockCopy:) ifTrue: [
					 ^ self stackPush: (RBPseudoSendNode new selector: selector; arguments: args)]].

	self stackPush: (self simplify: (RBMessageNode new
		receiver: rcvr
		selectorParts: (self newSelectorParts: selector)
		arguments: args)).
! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 7/10/2007 17:39'!
send: selector toSuperOf: behavior

	| args rcvr |
	args := OrderedCollection new.
	selector numArgs timesRepeat: [args addFirst: self Value].
	rcvr := self Value.
	(rcvr isVariable and: [rcvr name = 'self']) ifFalse: [self patternError].

	rcvr identifierToken: (SqueakToken value: 'super' start: 0).
	self stackPush: (RBMessageNode new
		receiver: rcvr
		selectorParts: (self newSelectorParts: selector)
		arguments: args).
! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 9/6/2007 20:42'!
simplify: mess
	"mess is a messageNode.  If it is a message created by the compiler convert it back to its normal form"

	| rcvr var |
"	(mess selector == #value and: [mess receiver isLiteral]) ifTrue: [
		^ self newVar: (GlobalVar new assoc: mess receiver value; scope: scope)
	]."

	(mess selector = #privSetInHolder: and: [mess arguments first isLiteral]) ifTrue: [
		^ RBAssignmentNode
			variable: (self newVar: (GlobalVar new assoc: mess arguments first value; scope: scope) markWrite)
			value: mess receiver
	].

	(mess selector = #privGetInstVar: and:
	 [mess arguments first isLiteral and:
	  [mess receiver isVariable]]) ifTrue: [
		rcvr := mess receiver binding.
		rcvr == scope receiverVar ifTrue: [
			^ self newVar: (scope receiverVarAt: mess arguments first value)].
		(rcvr isContextVar and: [mess arguments first value == 5]) ifTrue: [
			var := scope tempVarAt: -1.
			^self newVar: var].
		(rcvr isCaptured and:[rcvr sourceTemp = rcvr scope receiverVar])
			ifTrue:[
				self fixInnerFreeVar: rcvr.
				^self newVar: (rcvr scope receiverVarAt: mess arguments first value)].
		rcvr isEnv ifTrue: [^self newVar: (rcvr scope captureVarAt: mess arguments first value)]].

	(mess selector = #privStoreIn:instVar: and:
	 [mess arguments last isLiteral and:
	  [mess arguments first isVariable]]) ifTrue: [
		rcvr := mess arguments first binding.
		(mess receiver name = 'self' and: [rcvr isEnv]) 
			ifTrue:[scope captureSelf: mess arguments last value. 
				^mess].
		rcvr == scope  receiverVar ifTrue: [^ RBAssignmentNode
				variable: (self newVar: (scope receiverVarForAssignmentAt: mess arguments last value) markWrite) 
				value: mess receiver].
		(rcvr isCaptured and:[rcvr sourceTemp = rcvr scope receiverVar])
			ifTrue:[
				self fixInnerFreeVar: rcvr.
				^RBAssignmentNode
					variable: (self newVar: (rcvr scope receiverVarForAssignmentAt: mess arguments last value) markWrite) 
					value: mess receiver].
		mess isClosureEnvironmentRegistration
			ifTrue: [
				scope captureSelf: mess arguments last value.
				^mess].
		rcvr isEnv ifTrue:[
			mess receiver isTemp 
				ifTrue:[var := (scope 
					captureVarAt: mess arguments last value  
					sourceTemp: mess receiver binding) markWrite.]
				ifFalse:[var := (scope 
					captureVarAt: mess arguments last value sourceTemp: ((TempVar new)
								name: (scope captureVarName: mess arguments last value);
								index: mess arguments last value;
								scope: self;
								cantBeCapture)) markWrite
					].
			^ RBAssignmentNode
				variable: (self newVar: var)
				value: mess receiver]].
	^mess! !

!IRDecompiler methodsFor: 'private' stamp: 'ms 6/16/2007 19:41'!
simplifyTempAssign: assignment
	"If it is a assignment created by the compiler convert it back to its normal form"

	| mess |
	((mess := assignment value) isMessage and: 
	 [mess selector = #wrapInTempHolder and:
	  [mess receiver isLiteral: [:v | v isNil]]]
	) ifTrue: [
		^ nil  "no-op"
	].

	^ assignment! !

!IRDecompiler methodsFor: 'stack' stamp: 'ms 5/2/2007 20:59'!
spIndex
	^ sp ifNil: [sp := stack size]! !

!IRDecompiler methodsFor: 'stack' stamp: 'ajh 3/22/2003 19:24'!
stackDown

	| node |
	sp ifNil: [sp := stack size].
	sp = 0 ifTrue: [self abort].
	node := stack at: sp.
	sp := sp - 1.
	^ node! !

!IRDecompiler methodsFor: 'stack' stamp: 'ajh 6/22/2003 14:51'!
stackPush: node

	self fixStack.
	stack addLast: node.
	node ifNil: [^ self].  "no op"
	self mapNode: node.
! !

!IRDecompiler methodsFor: 'old blocks' stamp: 'ms 7/10/2007 18:05'!
storeInstVar: number

	| var |
	var := scope  instanceScope instVar: number.
	self stackPush: (RBAssignmentNode variable: (self newVar: var)  value:  self Value)! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 7/13/2007 00:46'!
storeIntoLiteralVariable: association

	| var |
	var := scope lookupVar: association key asString.
	self stackPush: (self simplifyTempAssign:
		(RBAssignmentNode variable: (self newVar: (var markWrite)) value: self Value))
! !

!IRDecompiler methodsFor: 'instructions' stamp: 'ms 7/29/2007 01:24'!
storeTemp: tempIndex

	| var |
	var := scope basicTempVarAt: tempIndex.
	var isCaptured ifFalse: [var cantBeCapture].
	var isTemp ifTrue:[
		var isArg: false].
	self stackPush: (self simplifyTempAssign:
		(RBAssignmentNode variable: (self newVar: (var markWrite)) value: self Value)).
! !

!IRInterpreter methodsFor: 'instructions' stamp: 'md 8/12/2005 13:30'!
blockReturnTop! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 13:26'!
goto: seqNum! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 13:26'!
if: bool goto: seqNum1 otherwise: seqNum2! !

!IRInterpreter methodsFor: 'interpret' stamp: 'jorgeRessia 11/4/2009 10:00'!
interpret: anIr
	ir := anIr.
	self interpretAll: anIr allSequences! !

!IRInterpreter methodsFor: 'interpret' stamp: 'jorgeRessia 11/4/2009 13:54'!
interpretAll: irSequences
	irSequences do: [:seq | self interpretSequence: seq]! !

!IRInterpreter methodsFor: 'interpret' stamp: 'JorgeRessia 12/20/2009 19:19'!
interpretInstruction: irInstruction
	irInstruction executeOn: self! !

!IRInterpreter methodsFor: 'interpret' stamp: 'jorgeRessia 11/3/2009 16:40'!
interpretSequence: instructionSequence
	self label: instructionSequence orderNumber.
	instructionSequence do: [:instr | self interpretInstruction: instr].
! !

!IRInterpreter methodsFor: 'instructions' stamp: 'md 7/29/2005 10:44'!
jumpOverBlock: blockSeq to: dest! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 13:25'!
label: seqNum! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 14:11'!
popTop! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 6/27/2004 21:34'!
pushBlock: irMethod! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 6/27/2004 21:26'!
pushBlockMethod: irMethod! !

!IRInterpreter methodsFor: 'instructions' stamp: 'jorgeRessia 10/1/2009 15:40'!
pushClosureCopyNumCopiedValues: numCopiedValues numArgs: numArgs jumpSize: jumpSize 
	! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 14:12'!
pushDup! !

!IRInterpreter methodsFor: 'instructions' stamp: 'md 10/10/2005 17:38'!
pushInstVar: aSmallInteger ! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/2/2003 16:08'!
pushLiteral: object! !

!IRInterpreter methodsFor: 'instructions' stamp: 'md 7/7/2005 14:17'!
pushLiteralVariable: object! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/2/2003 16:09'!
pushTemp: index! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/2/2003 16:10'!
remoteReturn! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/2/2003 16:08'!
returnTop! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/2/2003 16:11'!
send: selector! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/2/2003 16:11'!
send: selector toSuperOf: behavior! !

!IRInterpreter methodsFor: 'instructions' stamp: 'md 7/7/2005 14:17'!
storeLiteralVariable: index! !

!IRInterpreter methodsFor: 'instructions' stamp: 'ajh 3/2/2003 16:11'!
storeTemp: index! !

IRInterpreter subclass: #IRPrinter
	instanceVariableNames: 'stream indent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRPrinter commentStamp: 'ajh 3/25/2003 00:22' prior: 0!
I interpret IRMethod instructions and write them out to a print stream.!

!IRPrinter methodsFor: 'instructions' stamp: 'md 8/9/2005 17:08'!
blockReturnTop

	stream nextPutAll: 'blockReturnTop'.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 15:41'!
goto: seqNum

	stream nextPutAll: 'goto: '.
	seqNum printOn: stream.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 15:42'!
if: bool goto: seqNum1 otherwise: seqNum2

	stream nextPutAll: 'if: '.
	bool printOn: stream.
	stream nextPutAll: ' goto: '.
	seqNum1 printOn: stream.
	stream nextPutAll: ' else: '.
	seqNum2 printOn: stream.
! !

!IRPrinter methodsFor: 'initialize' stamp: 'ajh 3/9/2003 15:49'!
indent: tabs

	indent := tabs! !

!IRPrinter methodsFor: 'interpret' stamp: 'ajh 3/9/2003 15:48'!
interpretInstruction: irInstruction

	indent timesRepeat: [stream tab].
	super interpretInstruction: irInstruction.
	stream cr.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'md 8/10/2005 11:23'!
jumpOverBlock: blockSeq to: dest

	stream nextPutAll: 'jumpOverBlock: '.
	stream nextPutAll: ' block '.
	blockSeq  printOn: stream.
	stream nextPutAll: ' cont: '.
	dest  printOn: stream.! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/11/2003 00:36'!
label: seqNum

	"add tab and cr since this does not get called within interpretInstruction:"
	stream cr.  "extra cr just to space out sequences"
	indent timesRepeat: [stream tab].
	stream nextPutAll: 'label: '.
	seqNum printOn: stream.
	stream cr.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 15:42'!
popTop

	stream nextPutAll: 'popTop'! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 6/27/2004 21:44'!
pushBlock: irMethod

	stream nextPutAll: 'pushBlock:'.
	IRPrinter new
		indent: indent + 1;
		stream: stream;
		interpret: irMethod removeEmptyStart.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 6/27/2004 21:44'!
pushBlockMethod: irMethod

	stream nextPutAll: 'pushBlockMethod:'.
	IRPrinter new
		indent: indent + 1;
		stream: stream;
		interpret: irMethod removeEmptyStart.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 15:42'!
pushDup

	stream nextPutAll: 'pushDup'! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/21/2003 01:49'!
pushLiteral: object

	stream nextPutAll: 'pushLiteral: '.
	object isVariableBinding ifTrue: [^ stream nextPutAll: object key].
	object printOn: stream.

	((object isKindOf: BlockClosure) or: [object isKindOf: CompiledMethod])
		ifTrue: [
			IRPrinter new
				indent: indent + 1;
				stream: stream;
				interpret: object method ir removeEmptyStart].
! !

!IRPrinter methodsFor: 'instructions' stamp: 'md 8/10/2005 11:28'!
pushLiteralVariable: object

	stream nextPutAll: 'pushLiteralVariable: '.
	object isVariableBinding ifTrue: [^ stream nextPutAll: object key].
	object printOn: stream.! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 6/26/2004 18:37'!
pushTemp: index

	stream nextPutAll: 'pushTemp: '.
	index printOn: stream.
	index = 0 ifTrue: [stream nextPutAll: ' "receiver"'].
	index = -1 ifTrue: [stream nextPutAll: ' "thisEnv"'].
	index = -2 ifTrue: [stream nextPutAll: ' "thisContext"'].
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 15:43'!
remoteReturn

	stream nextPutAll: 'remoteReturn'.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 15:43'!
returnTop

	stream nextPutAll: 'returnTop'.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 15:44'!
send: selector

	stream nextPutAll: 'send: '.
	selector printOn: stream.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 3/9/2003 15:44'!
send: selector toSuperOf: behavior

	stream nextPutAll: 'send: '.
	selector printOn: stream.
	stream nextPutAll: ' toSuperOf: '.
	behavior printOn: stream.
! !

!IRPrinter methodsFor: 'instructions' stamp: 'ajh 6/26/2004 23:15'!
storeTemp: index

	stream nextPutAll: 'storeTemp: '.
	index printOn: stream.
	index = -1 ifTrue: [stream nextPutAll: ' "thisEnv"'].
! !

!IRPrinter methodsFor: 'initialize' stamp: 'ajh 3/9/2003 15:50'!
stream: stringWriteStream

	stream := stringWriteStream! !

IRInterpreter subclass: #IRTranslator
	instanceVariableNames: 'pending gen currentInstr trailerBytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRTranslator commentStamp: 'ajh 3/25/2003 00:26' prior: 0!
I interpret IRMethod instructions, sending the appropriate bytecode messages to my BytecodeGenerator (gen).  I hold some messages back in pending awaiting certain sequences of them that can be consolidated into single bytecode instructions, otherwise the pending messages are executed in order as if they were executed when they first appeared.!

!IRTranslator methodsFor: 'instructions' stamp: 'md 4/23/2005 17:15'!
addLiteral: literal
	gen addLiteral: literal.! !

!IRTranslator methodsFor: 'priv pending' stamp: 'ajh 6/22/2003 14:54'!
addPending: message

	pending addLast: currentInstr -> message! !

!IRTranslator methodsFor: 'instructions' stamp: 'md 10/8/2004 16:07'!
blockReturnTop

	self doPending.
	gen blockReturnTop.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'TestRunner 12/26/2009 09:31'!
calculateSizeFor: anIRPushClosureCopy 
	|instructions distance nextSequence aCollection allSequences|
	"distance := gen distanceFrom: anIRPushClosureCopy sequence goto: anIRPushClosureCopy destination."
	aCollection := OrderedCollection withAll: anIRPushClosureCopy sequence sequence.
	aCollection removeFirst.
	(aCollection last isSimpleJump 
						and: [(aCollection last sequence orderNumber < aCollection last destination orderNumber)
						and: [aCollection last destination orderNumber - aCollection last sequence orderNumber = 1]]) 
								ifTrue: [ aCollection removeLast].
	instructions := OrderedCollection withAll: aCollection.
	allSequences := anIRPushClosureCopy sequence method allSequences.
	anIRPushClosureCopy sequence orderNumber + 1 to: anIRPushClosureCopy destination orderNumber - 1
												do: [:index | aCollection := OrderedCollection withAll: (allSequences at: index) sequence. 
																(aCollection last isSimpleJump 
																and: [(aCollection last sequence orderNumber < aCollection last destination orderNumber)
																and: [aCollection last destination orderNumber - aCollection last sequence orderNumber = 1]]) ifTrue: [  aCollection removeLast].
																instructions addAll: aCollection ].
	"anIRPushClosureCopy hasInlinedClosures ifTrue: [ instructions removeLast ]."
	
	^(instructions inject: 0 into: [:size :eachIr | size + (self sizeFor: eachIr)])! !

!IRTranslator methodsFor: 'results' stamp: 'ajh 6/28/2004 11:23'!
compiledMethod

	^ gen compiledMethodWith: trailerBytes! !

!IRTranslator methodsFor: 'results' stamp: 'JorgeRessia 12/11/2009 13:50'!
compiledMethodUsing: aCompiledMethodClass
	gen methodTemps: ir methodTemps.
	^ gen compiledMethodWith: trailerBytes using: aCompiledMethodClass! !

!IRTranslator methodsFor: 'results' stamp: 'ajh 3/13/2003 18:28'!
compiledMethodWith: trailer

	^ gen compiledMethodWith: trailer! !

!IRTranslator methodsFor: 'results' stamp: 'pmm 8/16/2006 20:52'!
compiledMethodWith: trailer using: aCompiledMethodClass

	^ gen compiledMethodWith: trailer using: aCompiledMethodClass! !

!IRTranslator methodsFor: 'priv pending' stamp: 'jorgeRessia 11/4/2009 17:06'!
doPending
	"execute pending instructions"

	| assoc |
	[pending isEmpty] whileFalse: [
		assoc := pending removeFirst.
		gen mapBytesTo: assoc key "instr".
		assoc value "message" sendTo: gen.
	].
	gen mapBytesTo: currentInstr.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 12/26/2009 09:27'!
goto: seqNum
	self doPending.
	gen goto: seqNum.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'ajh 3/9/2003 22:09'!
if: bool goto: seqNum1 otherwise: seqNum2

	self doPending.
	gen if: bool goto: seqNum1 otherwise: seqNum2.
! !

!IRTranslator methodsFor: 'initialize' stamp: 'ajh 6/28/2004 11:27'!
initialize

	gen := BytecodeGenerator new.
	trailerBytes := #(0).
! !

!IRTranslator methodsFor: 'interpret' stamp: 'JorgeRessia 3/30/2010 19:52'!
interpret: ir
	ir optimize.	
	gen primitiveNode: ir primitiveNode.
	gen numArgs: ir numArgs.
	gen properties: ir properties.
	ir additionalLiterals do: [:lit | gen addLiteral: lit].
	super interpret: ir.
! !

!IRTranslator methodsFor: 'interpret' stamp: 'JorgeRessia 3/30/2010 19:52'!
interpretAll: irSequences
	irSequences withIndexDo: [:seq :i | seq orderNumber: i].
	super interpretAll: irSequences.
! !

!IRTranslator methodsFor: 'interpret' stamp: 'TestRunner 12/21/2009 10:24'!
interpretInstruction: irInstruction
	currentInstr := irInstruction.
	super interpretInstruction: irInstruction.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'md 10/27/2004 17:00'!
jumpOverBlock:  blockNum to: seqNum

	self doPending.
	gen jumpOverBlock: seqNum.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'ajh 3/9/2003 22:10'!
label: seqNum

	pending := OrderedCollection new.
	gen label: seqNum.
! !

!IRTranslator methodsFor: 'priv pending' stamp: 'ajh 6/5/2003 12:41'!
pendingMatches: blocks
	"Return true if each message at end of pending list satisfies its corresponding block.  The number of elements tested equals the number of blocks.  If not enough elements return false"

	| messages i |
	messages := pending collect: [:assoc | assoc value].
	blocks size > messages size ifTrue: [^ false].
	i := messages size - blocks size.
	blocks do: [:b |
		(b value: (messages at: (i := i + 1))) ifFalse: [^ false].
	].
	^ true! !

!IRTranslator methodsFor: 'priv pending' stamp: 'ajh 6/22/2003 21:06'!
pendingSelector

	pending isEmpty ifTrue: [^ nil].
	^ pending last value "message" selector! !

!IRTranslator methodsFor: 'priv pending' stamp: 'ajh 6/22/2003 21:06'!
pendingSelector: selector

	pending last value "message" setSelector: selector! !

!IRTranslator methodsFor: 'priv pending' stamp: 'ajh 6/22/2003 14:27'!
popPending

	^ pending removeLast value "message"! !

!IRTranslator methodsFor: 'instructions' stamp: 'ms 12/3/2006 18:18'!
popTop

	"if last was storeTemp,  storeInstVar storeIntoLiteralVariable then convert to storePopTemp, storePopInstVar storePopIntoLiteralVariable"
	#storeTemp: == self pendingSelector ifTrue: [
		^ self pendingSelector: #storePopTemp:].
	#storeInstVar: == self pendingSelector ifTrue: [
		^ self pendingSelector: #storePopInstVar:].
	#storeIntoLiteralVariable: == self pendingSelector ifTrue:[
		^self pendingSelector: #storePopIntoLiteralVariable:].
	"otherwise do normal pop"
	self doPending.
	gen popTop.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'ajh 6/28/2004 11:20'!
pushBlock: irMethod

	| meth block |
	meth := irMethod compiledMethodWith: trailerBytes.
	meth isBlockMethod: true.
	block := meth createBlock: nil.
	self addPending: (Message selector: #pushLiteral: argument: block)! !

!IRTranslator methodsFor: 'instructions' stamp: 'ajh 6/28/2004 11:20'!
pushBlockMethod: irMethod

	| meth |
	meth := irMethod compiledMethodWith: trailerBytes.
	meth isBlockMethod: true.
	self addPending: (Message selector: #pushLiteral: argument: meth)! !

!IRTranslator methodsFor: 'instructions' stamp: 'jorgeRessia 11/9/2009 10:28'!
pushClosureCopyNumCopiedValues: numCopiedValues numArgs: numArgs jumpSize: jumpSize 
	"gen from: currentInstr sequence orderNumber goto: currentInstr destination orderNumber."
	gen pushClosureCopyNumCopiedValues: numCopiedValues numArgs: numArgs jumpSize: (self calculateSizeFor: currentInstr)
	

	! !

!IRTranslator methodsFor: 'instructions' stamp: 'jb 3/25/2010 14:31'!
pushConsArray: aSize 
	
	gen pushConsArray: aSize 
! !

!IRTranslator methodsFor: 'instructions' stamp: 'ajh 3/9/2003 22:10'!
pushDup

	self doPending.
	gen pushDup.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'TestRunner 12/20/2009 21:51'!
pushInstVar: index

	self doPending.
	gen pushInstVar: index.
	"self addPending: (Message selector: #pushInstVar: argument: index)"
! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 1/4/2010 11:30'!
pushLiteral: object
	gen pushLiteral: object! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 1/6/2010 12:14'!
pushLiteralVariable: object
	gen pushLiteralVariable: object
	"self addPending: (Message selector: #pushLiteralVariable: argument: object)"! !

!IRTranslator methodsFor: 'instructions' stamp: 'jorgeRessia 10/2/2009 16:36'!
pushNewArray: aSize 
	
	gen pushNewArray: aSize 
! !

!IRTranslator methodsFor: 'instructions' stamp: 'jorgeRessia 10/2/2009 17:16'!
pushRemoteTemp: tempIndex inVectorAt: tempVectorIndex 
	gen pushRemoteTemp: tempIndex inVectorAt: tempVectorIndex! !

!IRTranslator methodsFor: 'instructions' stamp: 'TestRunner 12/21/2009 10:23'!
pushTemp: index

	index = 0 ifTrue: [^ gen pushReceiver ].

	(self pendingMatches: {
		[:m | m selector == #storePopTemp: and: [m argument = index]]}
		) ifTrue: [^ self pendingSelector: #storeTemp:].

	self doPending.

	index = -2 ifTrue: [^ gen pushThisContext].
	index = -1 ifTrue: [
		^ gen pushThisContext;
			pushLiteral: MethodContext myEnvFieldIndex;
			send: #privGetInstVar:].

	gen pushTemp: index.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'ajh 3/9/2003 22:12'!
remoteReturn

	self doPending.
	gen remoteReturn.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'md 7/19/2005 23:30'!
returnTop

	#pushReceiver == self pendingSelector ifTrue: [
		self pendingSelector: #returnReceiver.
		^ self doPending
	].
	#pushLiteral: == self pendingSelector ifTrue: [
		self pendingSelector: #returnConstant:.
		^ self doPending
	].
	#pushInstVar: == self pendingSelector ifTrue: [
		self pendingSelector: #returnInstVar:.
		^ self doPending
	].
	self doPending.
	gen returnTop.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'md 6/14/2005 15:04'!
send: selector

	"If get/set inst var, access it directly"
	| index |
	
	((#(privGetInstVar: #privStoreIn:instVar:) identityIncludes: selector) and:
	 [self pendingMatches: {
		[:m | m selector == #pushReceiver].
		[:m | m selector == #pushLiteral: and: [m argument isInteger]]}]
	) ifTrue: [
		index := self popPending argument.
		self popPending.  "pop pushReceiver"
		self addPending: (Message
			selector: (selector == #privGetInstVar:
				ifTrue: [#pushInstVar:] ifFalse: [#storeInstVar:])
			argument: index).
		(self pendingMatches: {
			[:m | m selector == #storePopInstVar: and: [m argument = index]].
			[:m | m selector == #pushInstVar: and: [m argument = index]]}
		) ifTrue: [
			self popPending.
			self pendingSelector: #storeInstVar:.
		].
		^ self
	].
	"otherwise do normal send"
	self doPending.
	gen send: selector.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'ajh 3/9/2003 22:14'!
send: selector toSuperOf: behavior

	self doPending.
	gen send: selector toSuperOf: behavior.
! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 12/25/2009 20:46'!
sequencesJumpsIn: aCollection

	^aCollection inject: 0 into: [:count :eachInst | (eachInst isPushClosureCopy) ifTrue: [count + 1] ifFalse: [count] ]! !

!IRTranslator methodsFor: 'private' stamp: 'jorgeRessia 10/11/2009 21:39'!
sizeFor: anIRInstruction 
	^anIRInstruction size! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 12/22/2009 10:12'!
storeInstVar: index 
	self doPending.
	gen storeInstVar: index
	"self addPending: (Message selector: #storeInstVar: argument: index)"! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 1/6/2010 13:56'!
storeIntoLiteralVariable: assoc

	self doPending.
	gen storeIntoLiteralVariable: assoc.
	
	"self addPending: (Message selector: #storeIntoLiteralVariable: argument: assoc)"! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 1/6/2010 15:35'!
storePopInstVar: index 
	self doPending.
	gen storePopInstVar: index
	"self addPending: (Message selector: #storeInstVar: argument: index)"! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 1/6/2010 13:59'!
storePopIntoLiteralVariable: assoc

	self doPending.
	gen storePopIntoLiteralVariable: assoc.
	
	"self addPending: (Message selector: #storeIntoLiteralVariable: argument: assoc)"! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 12/27/2009 16:30'!
storePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex 
	| array |
	self doPending.
	array := Array new: 2.
	array at: 1 put: tempIndex.
	array at: 2 put: tempVectorIndex.
	gen storePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex.
	self flag: 'I do not understand the idea behind this pending behavior'
	"self addPending: (Message selector: #storePopRemoteTemp:inVectorAt: arguments: array)"
	! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 12/21/2009 11:22'!
storePopTemp: index

	self doPending.
	gen storePopTemp: index! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 12/27/2009 16:30'!
storeRemoteTemp: tempIndex inVectorAt: tempVectorIndex 
	gen storeRemoteTemp: tempIndex inVectorAt: tempVectorIndex! !

!IRTranslator methodsFor: 'instructions' stamp: 'JorgeRessia 12/21/2009 10:41'!
storeTemp: index
	self flag: 'removed pending behavior'.
	gen storeTemp: index! !

!IRTranslator methodsFor: 'initialize' stamp: 'ajh 6/28/2004 11:23'!
trailer: bytes

	trailerBytes := bytes! !

Object subclass: #IRMethod
	instanceVariableNames: 'startSequence primitiveNode tempKeys numRargs compiledMethod properties additionalLiterals maxOrderNumber sourceMap methodTemps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRMethod commentStamp: 'ajh 5/23/2003 11:08' prior: 0!
I am a method in the IR (intermediate representation) language consisting of IRInstructions grouped by IRSequence (basic block).  The IRSequences form a control graph (therefore I only have to hold onto the starting sequence).  #compiledMethod will convert me to a CompiledMethod.  #methodNode will convert me back to a parse tree.
!

!IRMethod methodsFor: 'optimizing' stamp: 'ajh 3/10/2003 15:45'!
absorbConstantConditionalJumps

	startSequence absorbConstantConditionalJumps: IdentitySet new! !

!IRMethod methodsFor: 'optimizing' stamp: 'ajh 3/10/2003 15:45'!
absorbJumpsToSingleInstrs

	startSequence absorbJumpToSingleInstr: IdentitySet new! !

!IRMethod methodsFor: 'optimizing' stamp: 'ms 9/6/2007 20:12'!
absorbSinglePredecessor
	| predecessor |
	startSequence 
		detectSinglePredecessor: (predecessor := IdentityDictionary new)
		seen: IdentitySet new.
	startSequence collapseSinglePredecessor: predecessor seen: IdentitySet new! !

!IRMethod methodsFor: 'inlining' stamp: 'md 9/11/2005 18:52'!
addInstructionsAfter: aCollection
	| returningSeqs  lastInstr |
	aCollection ifEmpty: [^self].
	returningSeqs := self allSequences select: [:each | each last isReturn].
	lastInstr := returningSeqs last last.
	lastInstr addInstructionsBefore: aCollection.
	! !

!IRMethod methodsFor: 'inlining' stamp: 'md 7/14/2005 12:31'!
addInstructionsBefore: aCollection

	(self startSequence nextSequence first) addInstructionsBefore: aCollection.
	! !

!IRMethod methodsFor: 'accessing' stamp: 'md 7/11/2005 22:19'!
addLiteral: aSymbol
	
	additionalLiterals add: aSymbol.! !

!IRMethod methodsFor: 'accessing' stamp: 'md 7/12/2005 00:21'!
addLiterals: anArray
	
	additionalLiterals addAll: anArray.! !

!IRMethod methodsFor: 'accessing' stamp: 'md 7/10/2005 15:41'!
addTemps: newKeys
	
	tempKeys addAll: newKeys.! !

!IRMethod methodsFor: 'accessing' stamp: 'md 7/11/2005 22:19'!
additionalLiterals
	^additionalLiterals.! !

!IRMethod methodsFor: 'accessing' stamp: 'md 6/10/2005 16:07'!
allInstructions
	" return irNodes as a flat collection "

	| irInstructions |
	irInstructions := OrderedCollection new.
	startSequence withAllSuccessorsDo: [:seq | seq do: [:bc | irInstructions add: bc]].
	^irInstructions! !

!IRMethod methodsFor: 'accessing' stamp: 'md 6/13/2005 10:41'!
allInstructionsMatching: aBlock
	" return irNodes as a flat collection "

	| irInstructions |
	irInstructions := OrderedCollection new.
	startSequence withAllSuccessorsDo: [:seq | seq do: [:bc | (aBlock value: bc) ifTrue: [irInstructions add: bc]]].
	^irInstructions! !

!IRMethod methodsFor: 'accessing' stamp: 'md 6/13/2005 10:40'!
allSendInstructions
	^self allInstructionsMatching: [:bc | bc isSend].! !

!IRMethod methodsFor: 'accessing' stamp: 'ajh 3/9/2003 15:35'!
allSequences

	^ startSequence withAllSuccessors! !

!IRMethod methodsFor: 'accessing' stamp: 'md 6/13/2005 11:06'!
allTempAccessInstructions
	^self allInstructionsMatching: [:bc | bc isTempAccess].! !

!IRMethod methodsFor: 'accessing' stamp: 'md 6/13/2005 10:39'!
allTempReadInstructions
	^self allInstructionsMatching: [:bc | bc isTempRead].! !

!IRMethod methodsFor: 'accessing' stamp: 'md 6/13/2005 10:40'!
allTempWriteInstructions
	^self allInstructionsMatching: [:bc | bc isTempStore].! !

!IRMethod methodsFor: 'decompiling' stamp: 'ajh 6/28/2004 13:44'!
ast

	^ IRDecompiler new decompileIR: self! !

!IRMethod methodsFor: 'translating' stamp: 'pmm 8/25/2006 15:02'!
compiledMethod

	^ compiledMethod ifNil: [self compiledMethodWith: #(0 0 0 0)]! !

!IRMethod methodsFor: 'translating' stamp: 'jorgeRessia 11/2/2009 12:11'!
compiledMethodWith: trailer

	^self compiledMethodWith: trailer using: CompiledMethod! !

!IRMethod methodsFor: 'translating' stamp: 'pmm 8/16/2006 20:55'!
compiledMethodWith: trailer using: aCompiledMethodClass

	^ compiledMethod := IRTranslator new
		trailer: trailer;
		interpret: self;
		compiledMethodUsing: aCompiledMethodClass! !

!IRMethod methodsFor: 'initialize' stamp: 'jb 3/25/2010 14:21'!
initialize

	primitiveNode := PrimitiveNode null.
	tempKeys := OrderedCollection new.
	properties := MethodProperties new. 
	additionalLiterals := OrderedCollection new.
	methodTemps := OrderedCollection new.! !

!IRMethod methodsFor: 'accessing' stamp: 'md 11/15/2004 17:08'!
ir
	^self.! !

!IRMethod methodsFor: 'testing' stamp: 'md 6/21/2005 13:56'!
isSend
	^false.! !

!IRMethod methodsFor: 'printing' stamp: 'ajh 3/9/2003 15:53'!
longPrintOn: stream

	IRPrinter new
		indent: 0;
		stream: stream;
		interpret: self! !

!IRMethod methodsFor: 'optimizing' stamp: 'md 8/10/2005 11:45'!
maxOrderNumber
	maxOrderNumber ifNil: [
		maxOrderNumber := self startSequence orderNumber.
		self startSequence withAllSuccessorsDo: [:seq | maxOrderNumber := maxOrderNumber max: seq orderNumber].			
	].
	^ maxOrderNumber.! !

!IRMethod methodsFor: 'accessing' stamp: 'md 6/16/2005 15:02'!
method
	^self.! !

!IRMethod methodsFor: 'inlining' stamp: 'md 8/2/2005 15:07'!
methodForInlining
	^self removeReturnSelf removeEmptyStart.! !

!IRMethod methodsFor: 'accessing' stamp: 'JorgeRessia 12/11/2009 13:47'!
methodTemps
	^methodTemps! !

!IRMethod methodsFor: 'accessing' stamp: 'JorgeRessia 12/11/2009 13:47'!
methodTemps: aCollection
	methodTemps := aCollection! !

!IRMethod methodsFor: 'optimizing' stamp: 'md 9/26/2005 13:09'!
newSeq
	maxOrderNumber := self maxOrderNumber  +1.
	^ IRSequence new  orderNumber:maxOrderNumber! !

!IRMethod methodsFor: 'accessing' stamp: 'ajh 6/25/2004 10:53'!
numArgs

	^ self numRargs - 1! !

!IRMethod methodsFor: 'accessing' stamp: 'ajh 6/25/2004 10:53'!
numRargs

	^ numRargs! !

!IRMethod methodsFor: 'initialize' stamp: 'ajh 6/25/2004 10:53'!
numRargs: n

	numRargs := n! !

!IRMethod methodsFor: 'optimizing' stamp: 'JorgeRessia 1/3/2010 10:00'!
optimize
	"self removeEmptyStart.
	self absorbJumpsToSingleInstrs.
	self absorbConstantConditionalJumps.
	self absorbJumpsToSingleInstrs"! !

!IRMethod methodsFor: 'accessing' stamp: 'ajh 3/10/2003 18:10'!
primitiveNode

	^ primitiveNode! !

!IRMethod methodsFor: 'initialize' stamp: 'ajh 3/10/2003 23:08'!
primitiveNode: aPrimitiveNode

	primitiveNode := aPrimitiveNode! !

!IRMethod methodsFor: 'translating' stamp: 'ajh 3/10/2003 15:54'!
privCompiledMethod: aCompiledMethod

	compiledMethod := aCompiledMethod! !

!IRMethod methodsFor: 'accessing' stamp: 'md 7/10/2005 22:06'!
properties
	^properties! !

!IRMethod methodsFor: 'accessing' stamp: 'md 7/10/2005 22:06'!
properties: propDict
	properties := propDict.! !

!IRMethod methodsFor: 'optimizing' stamp: 'ajh 3/18/2003 19:25'!
removeEmptyStart

	startSequence size = 1 ifTrue: [
		"startSeq is just unconditional jump, forget it"
		startSequence := startSequence last destination].
! !

!IRMethod methodsFor: 'inlining' stamp: 'md 9/12/2005 12:00'!
removeReturn
	self allSequences last removeLast.! !

!IRMethod methodsFor: 'inlining' stamp: 'md 7/1/2005 17:34'!
removeReturnSelf
	self removeReturn.
	self allSequences last removeLast.! !

!IRMethod methodsFor: 'mapping' stamp: 'ajh 3/19/2003 13:38'!
sourceMap
	"Return a mapping from bytecode pcs to source code ranges"

	| start map |
	"Besides getting start position, make sure bytecodeIndices are filled in"
	start := self compiledMethod initialPC - 1.  
	map := OrderedCollection new.
	self allSequences do: [:seq |
		seq do: [:instr |  | node |
			((node := instr sourceNode) notNil and: 
			 [node debugHighlightStart notNil and:
			  [node debugHighlightStop notNil and:
			   [instr bytecodeIndex notNil]]]) ifTrue: [
				map add:
					instr bytecodeIndex + start
						-> (node debugHighlightStart to: node debugHighlightStop)]
		]
	].
	^ map! !

!IRMethod methodsFor: 'accessing' stamp: 'ajh 3/10/2003 17:53'!
startSequence

	^ startSequence! !

!IRMethod methodsFor: 'initialize' stamp: 'md 7/9/2005 22:36'!
startSequence: irSequence

	startSequence := irSequence.
	irSequence method: self.! !

!IRMethod methodsFor: 'accessing' stamp: 'ajh 6/25/2004 10:49'!
tempKeys

	^ tempKeys! !

!IRMethod methodsFor: 'initialize' stamp: 'ajh 6/25/2004 11:19'!
tempKeys: objects

	tempKeys := objects! !

!IRMethod methodsFor: 'accessing' stamp: 'ajh 6/25/2004 10:52'!
tempNames
	"All temp names in context order"

	| varNames |
	varNames := OrderedCollection new.
	self tempKeys do: [:var | | name |
		name := var asString.
		"vars are unique but inlined to:do: loop vars may have the same name, so munge the names to make them different"
		[varNames includes: name] whileTrue: [name := name, 'X'].
		varNames add: name.
	].
	^ varNames asArray! !

Object subclass: #IRSequence
	instanceVariableNames: 'sequence orderNumber method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRSequence methodsFor: 'copying' stamp: 'dr 9/10/2005 20:59'!
, otherCollection 
	^sequence, otherCollection! !

!IRSequence methodsFor: 'optimizing' stamp: 'JorgeRessia 1/3/2010 09:53'!
absorbConstantConditionalJumps: alreadySeen
	"Collapse sequences that look like:
			[if] goto s1
			...
		 s1:	pushConst: true/false
			goto s2
		 s2:	if true/false goto s3 else s4
	into:
			[if] goto s3/s4

	These sequences are produced by and:/or: messages"

	| seq bool if |
	self halt.
	(alreadySeen includes: self) ifTrue: [^ self].
	alreadySeen add: self.

	[(seq := self successorSequences) size > 0  "not return"
	  and: [(seq := seq first "destination") size = 2
	   and: [(seq first isConstant: [:obj | (bool := obj) isKindOf: Boolean])
	    and: [seq last isGoto
	     and: [(if := seq last destination first) isIf]]]]
	] whileTrue: [ "absorb"
		self last destination: (bool == if boolean
			ifTrue: [if destination]
			ifFalse: [if otherwise]).
	].

	self successorSequences do: [:instrs | instrs absorbConstantConditionalJumps: alreadySeen].
! !

!IRSequence methodsFor: 'optimizing' stamp: 'md 7/14/2005 11:56'!
absorbJumpToSingleInstr: alreadySeen
	"Collapse jumps to single return instructions into caller"

	| seqs seq |
	(alreadySeen includes: self) ifTrue: [^ self].
	alreadySeen add: self.

	[ (seqs := self successorSequences) size = 1  "unconditional jump..." 
	   and: [(seq := seqs first) size = 1  "...to single instruction..."
	    and: [seq successorSequences size < 2]
		and: [self last isBlockReturnTop not]] "...but don't collapse conditional jumps so their otherwiseSequences can stay right after them"
	] whileTrue: [ "replace goto with single instruction"
		self removeLast.
		seq do: [:instr | self add: instr copy].
	].

	seqs do: [:instrs | instrs absorbJumpToSingleInstr: alreadySeen].
! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:57'!
add: anInstruction

	sequence add: anInstruction.
	anInstruction sequence: self.
	^anInstruction.! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:57'!
add: instr after: another

	sequence add: instr after: another.
	instr sequence: self.
	^instr.! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:58'!
add: instr before: another
	sequence add: instr before: another.
	instr sequence: self.
	^instr.! !

!IRSequence methodsFor: 'adding' stamp: 'dr 9/11/2005 15:35'!
addAll: aCollection
	^sequence addAll: aCollection! !

!IRSequence methodsFor: 'adding' stamp: 'md 9/28/2005 17:55'!
addAllFirst: aCollection
	^sequence addAllFirst: aCollection.! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:58'!
addInstructions: aCollection
	
	^aCollection do: [:instr | self add: instr].! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 11:57'!
addInstructions: aCollection after: anInstruction
	
	^aCollection reverseDo: [:instr | self add: instr after: anInstruction].! !

!IRSequence methodsFor: 'adding' stamp: 'md 7/14/2005 12:29'!
addInstructions: aCollection before: anInstruction

	aCollection do: [:instr | self add: instr before: anInstruction].! !

!IRSequence methodsFor: 'adding' stamp: 'dr 9/10/2005 20:57'!
addLast: anInstruction
	^self add: anInstruction.! !

!IRSequence methodsFor: 'accessing' stamp: 'md 9/29/2005 11:25'!
after: o
	^sequence after: o! !

!IRSequence methodsFor: 'accessing' stamp: 'dr 9/10/2005 21:01'!
at: index
	^sequence at: index! !

!IRSequence methodsFor: 'optimizing' stamp: 'JorgeRessia 1/3/2010 09:50'!
collapseSinglePredecessor: predecessorList seen: alreadySeen

	| seqs  seq |
	(alreadySeen includes: self) ifTrue: [^ self].
	self halt.
	alreadySeen add: self.
	[(seqs := self successorSequences) size = 1 
		and: [(predecessorList at: (seq := seqs first) ifAbsent:[0]) = 1]
		and: [seq orderNumber > self orderNumber]]
			whileTrue:[
				self removeLast.
				seq do: [:instr | self add: instr copy]].

	seqs do: [:instrs | instrs collapseSinglePredecessor: predecessorList seen: alreadySeen].! !

!IRSequence methodsFor: 'enumerating' stamp: 'dr 9/10/2005 21:02'!
detect: aBlock
	^sequence detect: aBlock! !

!IRSequence methodsFor: 'optimizing' stamp: 'JorgeRessia 1/3/2010 09:53'!
detectSinglePredecessor: sequencesPredecessor seen: alreadySeen

	| seqs  |
	self halt.
	(alreadySeen includes: self) ifTrue: [^ self].
	alreadySeen add: self.
	seqs := self successorSequences.
	seqs do: [:seq | sequencesPredecessor 
				at: seq 
				put: (sequencesPredecessor at: seq ifAbsent:[0]) + 1].

	seqs do: [:instrs | instrs detectSinglePredecessor: sequencesPredecessor seen: alreadySeen].! !

!IRSequence methodsFor: 'enumerating' stamp: 'md 7/14/2005 12:24'!
do: aBlock
	^sequence do: aBlock.! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:31'!
first
	^sequence first! !

!IRSequence methodsFor: 'testing' stamp: 'md 7/14/2005 12:30'!
ifEmpty: aBlock
	^sequence ifEmpty: aBlock! !

!IRSequence methodsFor: 'testing' stamp: 'md 7/14/2005 12:30'!
ifNotEmpty: aBlock
	^sequence ifNotEmpty: aBlock! !

!IRSequence methodsFor: 'initialize-release' stamp: 'md 7/14/2005 11:56'!
initialize
	sequence := OrderedCollection new.! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:58'!
instructionsDo: aBlock

	^self withAllSuccessorsDo: [:seq | seq do: aBlock].! !

!IRSequence methodsFor: 'testing' stamp: 'md 7/14/2005 12:23'!
isEmpty
	^sequence isEmpty! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:23'!
last
	^sequence last! !

!IRSequence methodsFor: 'printing' stamp: 'md 7/14/2005 11:59'!
longPrintOn: stream

	[IRPrinter new
		indent: 0;
		stream: stream;
		interpretSequence: self
	] onDNU: #orderNumber do: [:ex | ex resume: ex receiver]! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:00'!
method

	^method! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:00'!
method: aIRMethod

	method := aIRMethod! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:58'!
nextSequence

	| sequences i |
	sequences := self withAllSuccessors.
	i := sequences findFirst: [:seq | seq orderNumber = self orderNumber].
	(i = 0 or: [i = sequences size]) ifTrue: [^ nil].
	^ sequences at: i + 1! !

!IRSequence methodsFor: 'testing' stamp: 'dr 9/10/2005 20:55'!
notEmpty
	^sequence notEmpty! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:00'!
orderNumber
	"Sequences are sorted by this number"

	^ orderNumber! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:00'!
orderNumber: num
	"Sequences are sorted by this number"

	orderNumber := num.! !

!IRSequence methodsFor: 'printing' stamp: 'md 7/14/2005 12:00'!
printOn: stream

	stream nextPutAll: 'an '.
	self class printOn: stream.
	stream space.
	stream nextPut: $(.
	self orderNumber printOn: stream.
	stream nextPut: $).
! !

!IRSequence methodsFor: 'replacing' stamp: 'md 7/14/2005 12:00'!
remove: aNode
	aNode sequence: nil.
	sequence remove: aNode ifAbsent: [self error].! !

!IRSequence methodsFor: 'removing' stamp: 'dr 9/10/2005 21:03'!
removeFirst
	^sequence removeFirst.! !

!IRSequence methodsFor: 'removing' stamp: 'md 7/14/2005 12:25'!
removeLast
	^sequence removeLast.! !

!IRSequence methodsFor: 'replacing' stamp: 'md 7/14/2005 12:01'!
replaceNode: aNode withNode: anotherNode 

	self add: anotherNode before: aNode.
	sequence remove: aNode ifAbsent: [self error].! !

!IRSequence methodsFor: 'replacing' stamp: 'md 7/14/2005 12:01'!
replaceNode: aNode withNodes: aCollection 

	self addInstructions: aCollection before: aNode.
	sequence remove: aNode ifAbsent: [self error].! !

!IRSequence methodsFor: 'enumerating' stamp: 'md 7/14/2005 12:28'!
reverseDo: aBlock
	^sequence reverseDo: aBlock.! !

!IRSequence methodsFor: 'enumerating' stamp: 'md 7/14/2005 12:28'!
select: aBlock
	^sequence select: aBlock.! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:32'!
sequence
	^sequence! !

!IRSequence methodsFor: 'manipulating' stamp: 'dr 9/10/2005 20:58'!
setSuccessor: suc
	"find the blockReturnTops, set successor "

	self withAllSuccessorsDo: [:succ | succ notEmpty ifTrue: [
		| last |
		last := succ last.
		last isBlockReturnTop ifTrue: [ 
			last successor: suc.
		]
	]].! !

!IRSequence methodsFor: 'accessing' stamp: 'md 7/14/2005 12:25'!
size
	^sequence size.! !

!IRSequence methodsFor: 'manipulating' stamp: 'md 7/14/2005 13:22'!
splitAfter: instruction

	| newSeq index next |
	next := self nextSequence.
	next := next
		ifNil: [self orderNumber + 1]
		ifNotNil: [(next orderNumber + self orderNumber) / 2].
	newSeq := self class new orderNumber: next.
	newSeq method: self method.
	"Split after instruction"
	index := sequence indexOf: instruction.
	(sequence last: sequence size - index) do: [:instr | newSeq add: instr].
	sequence := sequence first: index.
	sequence add: (IRJump new destination: newSeq).
	^ newSeq! !

!IRSequence methodsFor: 'manipulating' stamp: 'md 7/14/2005 13:22'!
splitAfterNoJump: instruction

	| newSeq next index |
	next := self nextSequence.
	next := next
		ifNil: [self orderNumber + 1]
		ifNotNil: [(next orderNumber + self orderNumber) / 2].
	newSeq := self class new orderNumber: next.
	newSeq method: self method.
	
	"Split after instruction"
	index := sequence indexOf: instruction.
	(sequence last: sequence size - index) do: [:instr | newSeq add: instr].
	sequence := sequence first: index.

	^ newSeq! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:59'!
successorSequences

	sequence isEmpty ifTrue: [^ #()].
	^ sequence last successorSequences! !

!IRSequence methodsFor: 'manipulating' stamp: 'md 9/23/2005 14:42'!
tranformToBlockSequence
	| last |
	" fix: if last jump --> follow jumps, remove returns and add blockReturnTop on leafs."

	self withAllSuccessorsDo: [:succ | 
		succ notEmpty ifTrue: [
			last := succ last.
			last isJump ifFalse: [ 
				last isReturn ifTrue: [succ removeLast].
				succ addLast: IRInstruction blockReturnTop.
			]
		].
		succ ifEmpty: [succ addLast: IRInstruction blockReturnTop].
	].! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:59'!
withAllSuccessors
	"Return me and all my successors sorted by sequence orderNumber"

	| list |
	list := OrderedCollection new: 20.
	self withAllSuccessorsDo: [:seq | list add: seq].
	^ list asSortedCollection: [:x :y | x orderNumber <= y orderNumber]! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:59'!
withAllSuccessorsDo: block
	"Iterate over me and all my successors only once"

	self withAllSuccessorsDo: block alreadySeen: IdentitySet new! !

!IRSequence methodsFor: 'successor sequences' stamp: 'md 7/14/2005 11:59'!
withAllSuccessorsDo: block alreadySeen: set
	"Iterate over me and all my successors only once"

	(set includes: self) ifTrue: [^ self].
	set add: self.
	block value: self.
	self successorSequences do: [:seq |
		seq ifNotNil: [seq withAllSuccessorsDo: block alreadySeen: set]].
! !

Object subclass: #LexicalScope
	instanceVariableNames: 'outerScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!LexicalScope commentStamp: 'ajh 3/24/2003 21:53' prior: 0!
I am a symbol table where variable names are associated with SemVars.  Each context (method/closure) get a fresh scope that inherits from its outer scope.!

LexicalScope subclass: #ClassScope
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ClassScope commentStamp: 'ajh 3/24/2003 21:44' prior: 0!
I include all variable enries for class, pool and global vars.!

!ClassScope methodsFor: 'initializing' stamp: 'ajh 2/25/2003 20:10'!
class: aBehavior

	class := aBehavior! !

!ClassScope methodsFor: 'lookup' stamp: 'ajh 2/25/2003 20:10'!
classEncoding

	^ class! !

!ClassScope methodsFor: 'levels' stamp: 'ajh 6/24/2004 04:03'!
instanceScope

	^ InstanceScope new
		vars: class allInstVarNames;
		outerScope: self! !

!ClassScope methodsFor: 'lookup' stamp: 'md 2/21/2006 14:10'!
lookupVar: name
	"Return a SemVar for my pool var with this name.  Return nil if none found"

	(class bindingOf: name asSymbol) ifNotNilDo: [:assoc | 
		^ GlobalVar new assoc: assoc; scope: self].
	^ nil
! !

!ClassScope methodsFor: 'levels' stamp: 'ajh 6/26/2004 17:56'!
newFunctionScope

	^ self instanceScope newFunctionScope! !

!ClassScope methodsFor: 'lookup' stamp: 'ajh 3/18/2003 15:42'!
possibleVarsFor: name continued: listOrNil
	"Return my pool var names that are close to name"

	name first isUppercase ifFalse: [^ listOrNil].
	^ class possibleVariablesFor: name continuedFrom: listOrNil! !

!ClassScope methodsFor: 'printing' stamp: 'ajh 2/25/2003 20:10'!
printOn: stream

	class printOn: stream.
	stream nextPutAll: ' parseScope'.
! !

!ClassScope methodsFor: 'lookup' stamp: 'md 2/21/2006 14:10'!
rawVar: name
	"Return a SemVar for my pool var with this name.  Return nil if none found"

	(class bindingOf: name asSymbol) ifNotNilDo: [:assoc | 
		^ GlobalVar new assoc: assoc; scope: self].
	^ nil
! !

LexicalScope subclass: #FunctionScope
	instanceVariableNames: 'thisContextVar thisEnvVar tempVars capturedVars isCapturedVarsRemap isHome hasInnerFreeVars hideTemps scopeIndexedVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!FunctionScope commentStamp: 'ajh 7/8/2004 18:33' prior: 0!
I am the symbol table (for declared temp vars) for methods and blocks (non-inlined closures). Scopes nest mirroring the block nesting (skipping inlined blocks like ifTrue: blocks). Variable references are looked up in the closest scope first then if not found searches the outer scope and so on. Temp variables found in an outer scope become captured in that outer scope. The emitPrologue: checks if any temp were captured and if so generates code that creates a ClosureEnvironment for those captured vars and copies any captured rargs (receiver and arguments) into it. This way MethodContexts are LIFO. Even a non-local (remote) return does not hold onto its home context, but rather holds onto its home context's environment. Upon return the caller stack is searched for the context that points to that home environment and returns to it. This allows stacks to be copied and blocks to still return to the correct context within the current thread.
!

FunctionScope subclass: #ContextDoItScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ContextDoItScope methodsFor: 'lookup' stamp: 'ajh 7/8/2004 17:06'!
captureVar: name
	"Don't convert temps to captured"

	^ self lookupVar: name! !

!ContextDoItScope methodsFor: 'parent env' stamp: 'ajh 7/8/2004 17:56'!
closestEnvScope
	"my temps are like inst vars, hence my own environment"

	^ self! !

!ContextDoItScope methodsFor: 'emitting' stamp: 'md 6/13/2005 13:58'!
emitEnvParentEnv: methodBuilder

	methodBuilder pushInstVar: (MethodContext allInstVarNames indexOf: #receiver).

	"return which scope my receiver points to"
	^ self outerEnvScope! !

!ContextDoItScope methodsFor: 'emitting' stamp: 'md 3/10/2006 15:55'!
emitLocalParentEnv: methodBuilder
	"local parent is held in receiver"

	"return which scope my receiver points to"
	^ self outerEnvScope! !

!ContextDoItScope methodsFor: 'emitting' stamp: 'md 6/13/2005 13:58'!
emitMyEnv: methodBuilder

	self flag: #myEnv.
	methodBuilder pushInstVar: MethodContext myEnvFieldIndex.! !

!ContextDoItScope methodsFor: 'initializing' stamp: 'ajh 7/8/2004 19:53'!
hideOuterTemps
	"Hide outer temps so they don't get captured (becuase they weren't captured and their values are not in the do-it env chain)"

	self outerScope tempsAreNoLongerAvailable! !

!ContextDoItScope methodsFor: 'scope' stamp: 'ajh 7/8/2004 17:15'!
isDoItScope

	^ true! !

!FunctionScope methodsFor: 'captured vars' stamp: 'ms 7/3/2007 15:45'!
addCaptured: name index: index

	self forceThisEnv.
	^ capturedVars add: (CapturedVar new
			name: name;
			index: index;
			scope: self)! !

!FunctionScope methodsFor: 'scope indexes' stamp: 'TestRunner 1/1/2010 11:19'!
addObjectScopeIndexedTemp: aTempVar
	^ scopeIndexedVars  add: aTempVar! !

!FunctionScope methodsFor: 'temp vars' stamp: 'JorgeRessia 12/27/2009 18:03'!
addObjectTemp: aTempVar
	^ tempVars add: aTempVar! !

!FunctionScope methodsFor: 'scope indexes' stamp: 'TestRunner 1/1/2010 11:19'!
addScopeIndexedTemp: name
	^ scopeIndexedVars add: (TempVar new
			name: name;
			index: scopeIndexedVars size; "zero-based; receiver is at 0"
			scope: self)! !

!FunctionScope methodsFor: 'parent env' stamp: 'ms 8/7/2007 11:36'!
addSlotForCapturedParentEnv

	| receiver |
	self hasInnerFreeVars ifFalse: [^ false].
	receiver := self receiverVar.
	capturedVars do: [:var | var sourceTemp = receiver ifTrue: [^ false]].
	^ true! !

!FunctionScope methodsFor: 'temp vars' stamp: 'JorgeRessia 12/27/2009 14:47'!
addTemp: name
	^ tempVars add: (TempVar new
			name: name;
			index: tempVars size; "zero-based; receiver is at 0"
			scope: self)! !

!FunctionScope methodsFor: 'initializing' stamp: 'ajh 7/8/2004 20:23'!
asDoItScope

	^ (self primitiveChangeClassTo: ContextDoItScope basicNew) hideOuterTemps! !

!FunctionScope methodsFor: 'lookup' stamp: 'JorgeRessia 12/27/2009 14:52'!
basicScopeIndexedVarFor: name
	
	^scopeIndexedVars at: name ifAbsent: [nil]

	
	! !

!FunctionScope methodsFor: 'decompiling' stamp: 'ms 7/29/2007 01:24'!
basicTempVarAt: tempIndex

	^self basicTempVarAt: tempIndex ifNone:[self createTemp: tempIndex]! !

!FunctionScope methodsFor: 'decompiling' stamp: 'ms 7/29/2007 01:23'!
basicTempVarAt: tempIndex ifNone: aBlock

	tempIndex = -2 ifTrue: [^ self thisContextVar].
	tempIndex = -1 ifTrue: [^ self thisEnvVar].
	
	^ tempVars detect: [:var | var index = tempIndex] ifNone: [
		Preferences compileBlocksAsClosures ifFalse:[
			self outerScope 
				ifNotNil:[self outerScope isFunctionScope 
					ifTrue:[^self outerScope tempVarAt: tempIndex ifNone: aBlock]]].
		aBlock valueWithPossibleArgument: self
	]! !

!FunctionScope methodsFor: 'captured vars' stamp: 'ms 7/29/2007 22:48'!
captureSelf: index

	| captVar var |
	var := self tempVarAt: 0.
	captVar := self addCaptured: var name index: index.
	captVar markArg.
	captVar sourceTemp: var.
	 ^captVar! !

!FunctionScope methodsFor: 'lookup' stamp: 'md 10/16/2004 20:56'!
captureVar: name
	"Return the ScopeVar with this name. If a temp move to captured."

	| var |

	capturedVars at: name ifPresent: [:v | ^ v].
	self hideTemps ifFalse: [
		tempVars at: name ifPresent: [:v | ^ self moveToCaptured: v]].
	(name = 'top env' and: [self isHome]) ifTrue: [^ self forceThisEnv].
	var := self outerScope captureVar: name.
	(var notNil and: [var isGlobal not]) ifTrue: [self hasInnerFreeVars: true].
	^ var! !

!FunctionScope methodsFor: 'lookup' stamp: 'ms 8/8/2007 00:44'!
captureVarAt: index 
	| var name |
	name := self captureVarName: index.
	var := self tempVarAt: index
						ifNone: [(TempVar new)
								name: name;
								index: index;
								scope: self;
								cantBeCapture].
	^self captureVarAt: index sourceTemp: var! !

!FunctionScope methodsFor: 'lookup' stamp: 'ms 8/8/2007 13:07'!
captureVarAt: index sourceTemp: aTempVar
	| captVar use name |
	
	^ capturedVars detect: [:each | each index = index]
		ifNone: 
			[
			name := self captureVarName: index.
			aTempVar name = 'self' ifTrue:[name := 'self'].
			use := aTempVar privUsage.
			aTempVar itCanBeCapture
				ifTrue: 
					[aTempVar isArg 
						ifTrue: 
							[captVar := self addCaptured: aTempVar name index: index.
							captVar sourceTemp: aTempVar]
						ifFalse: 
							[tempVars remove: aTempVar.
							aTempVar name: name.
							aTempVar becomeCaptured.
							capturedVars add: aTempVar.
							aTempVar index: index.
							captVar := aTempVar]]
				ifFalse:[
					aTempVar isArg 
						ifTrue: 
							[(capturedVars at: aTempVar  name ifAbsent:[
								captVar := self addCaptured: aTempVar name index: index.
								captVar sourceTemp: aTempVar.
								nil])
									ifNotNil:[captVar := self addCaptured: (self captureVarName: index) index: index].]
						ifFalse:[captVar := self addCaptured: name index: index]].
			captVar privUsage: use.
			captVar]! !

!FunctionScope methodsFor: 'lookup' stamp: 'ms 8/8/2007 13:10'!
captureVarForAssignmentAt: index 
	| var name |
	name := self captureVarName: index.
	var := self tempVarAt: index
				ifNone: 
					[(TempVar new)
						name: name;
						index: index;
						scope: self;
						cantBeCapture].
	(var isTemp and: [var isArg] )
		ifTrue: 
			[var := (TempVar new)
						name: name;
						index: index;
						scope: self;
						cantBeCapture].
	^ self captureVarAt: index sourceTemp: var! !

!FunctionScope methodsFor: 'lookup' stamp: 'ms 7/29/2007 01:19'!
captureVarName: index 
	^ String streamContents: 
			[:str | 
			self scopeLevel timesRepeat: [str nextPut: $c].
			index printOn: str]! !

!FunctionScope methodsFor: 'parent env' stamp: 'ms 8/20/2007 13:47'!
capturedParentEnv

	| receiver |
	self hasInnerFreeVars ifFalse: [^ nil].
	receiver := self receiverVar.
	self remapCaptureVarForParentEnv.
	capturedVars do: [:var | var sourceTemp = receiver ifTrue: [^ var]].
	"not added to captured list, but slot is created for it in emitCreateEnv.
	 It's not added since it was not captured directly by a variable reference in the code (only indirectly)"
	^ CapturedVar new
		name: 'env parent';
		index: 1;
		scope: self! !

!FunctionScope methodsFor: 'captured vars' stamp: 'ajh 6/25/2004 22:24'!
capturedVars

	^ capturedVars asSortedCollection: [:x :y | x index <= y index]! !

!FunctionScope methodsFor: 'parent env' stamp: 'ajh 7/8/2004 14:26'!
closestEnvScope
	"If self has its own env return self, otherwise return first outer scope with its own env"

	self hasEscapingEnv ifTrue: [^ self].
	^ self outerScope closestEnvScope! !

!FunctionScope methodsFor: 'decompiling' stamp: 'ms 9/6/2007 05:01'!
compactIndexTemps
	| lastIndex |
	lastIndex := self tempVars first index - 1.
	self tempVars do: [:each | each index: (lastIndex := lastIndex + 1)].
	^ self tempVars! !

!FunctionScope methodsFor: 'decompiling' stamp: 'ms 6/26/2007 02:54'!
createTemp: tempIndex

	| name |
	name := String streamContents: [:str |		
		self scopeLevel timesRepeat: [str nextPut: $t].
		tempIndex printOn: str].
	^tempVars add: 
		(TempVar new
			name: name;
			index: tempIndex;
			scope: self)! !

!FunctionScope methodsFor: 'emitting' stamp: 'ajh 7/8/2004 16:02'!
emitCreateEnv: methodBuilder
	"Create a heap environment for my captured vars"

	methodBuilder
		pushLiteral: ClosureEnvironment;
		pushLiteral: capturedVars size + self addSlotForCapturedParentEnv asBit;
		send: #new:.
	self thisEnvVar emitLocalStore: methodBuilder.
	methodBuilder popTop.
! !

!FunctionScope methodsFor: 'emitting' stamp: 'md 3/9/2006 12:04'!
emitEnvParentEnv: methodBuilder

	Preferences compileBlocksAsClosures ifTrue:  [
		methodBuilder pushInstVar: self capturedParentEnv index.
	].

	"return which scope my parent env points to"
	^ self outerEnvScope! !

!FunctionScope methodsFor: 'emitting' stamp: 'md 3/9/2006 12:03'!
emitLocalParentEnv: methodBuilder
	"local parent is held in receiver"

	Preferences compileBlocksAsClosures ifTrue:  [
		self receiverVar emitLocalValue: methodBuilder.
	].

	"return which scope my receiver points to"
	^ self outerEnvScope! !

!FunctionScope methodsFor: 'emitting' stamp: 'ms 8/20/2007 10:16'!
emitMoveCapturedRargs: methodBuilder

	self isParentEnvCaptured ifTrue: [
		self remapCaptureVarForParentEnv].
	self capturedVars do: [:var |
		| sourceTemp |
		sourceTemp := var sourceTemp.
		sourceTemp ifNotNil: [
			sourceTemp emitLocalValue: methodBuilder.
			self thisEnvVar emitLocalValue: methodBuilder.
			methodBuilder storeInstVar: var index; popTop]].

	self addSlotForCapturedParentEnv ifTrue: [
		self receiverVar emitLocalValue: methodBuilder.
		self thisEnvVar emitLocalValue: methodBuilder.
		methodBuilder storeInstVar: 1; popTop].
! !

!FunctionScope methodsFor: 'emitting' stamp: 'ajh 7/8/2004 17:12'!
emitMyEnv: methodBuilder

	thisEnvVar emitLocalValue: methodBuilder! !

!FunctionScope methodsFor: 'emitting' stamp: 'md 10/17/2004 14:14'!
emitPrologue: methodBuilder
	Preferences compileBlocksAsClosures ifTrue: [	
		self hasEscapingEnv ifFalse: [^ self].
		self emitCreateEnv: methodBuilder.
		self emitMoveCapturedRargs: methodBuilder.
	]
! !

!FunctionScope methodsFor: 'env' stamp: 'ms 6/17/2007 16:24'!
forceThisEnv
	"create local env (if not already)"

	thisEnvVar ifNotNil: [^ thisEnvVar].
	^ thisEnvVar := ThisEnvVar new
			name: 'thisEnv';
			index: -1;
			scope: self! !

!FunctionScope methodsFor: 'env' stamp: 'ajh 7/8/2004 14:30'!
hasEscapingEnv
	"has own env?"

	^ thisEnvVar notNil! !

!FunctionScope methodsFor: 'parent env' stamp: 'ajh 7/8/2004 15:38'!
hasInnerFreeVars
	"True if has inner scope that references to outer scope (non-global) variables. Indicates whether or not to add parent ref to local env"

	^ hasInnerFreeVars = true! !

!FunctionScope methodsFor: 'parent env' stamp: 'ajh 7/8/2004 15:37'!
hasInnerFreeVars: bool
	"True if has inner scope that references to outer scope (non-global) variables. Indicates whether or not to add parent ref to local env"

	hasInnerFreeVars := bool! !

!FunctionScope methodsFor: 'temp vars' stamp: 'ajh 7/8/2004 19:50'!
hideTemps
	"If true do not allow inner scopes to capture my temps. Used by do-it scopes, which are fetching from an existing context env which no longer has its temps"

	^ hideTemps = true! !

!FunctionScope methodsFor: 'initializing' stamp: 'JorgeRessia 12/27/2009 14:30'!
initialize

	tempVars := KeyedSet keyBlock: [:var | var name].
	scopeIndexedVars := KeyedSet keyBlock: [:var | var name].
	capturedVars := KeyedSet keyBlock: [:var | var name].
	isCapturedVarsRemap := false.
	thisContextVar := ThisContextVar new
		name: 'thisContext';
		index: -2;
		scope: self.
! !

!FunctionScope methodsFor: 'scope indexes' stamp: 'JorgeRessia 1/1/2010 10:31'!
insertScopeIndexedTemp: tempVar
	self halt.
	scopeIndexedVars add: tempVar.
	scopeIndexedVars do: [:var |
		var index >= tempVar index ifTrue: [
			var index: var index + 1]].
! !

!FunctionScope methodsFor: 'scope indexes' stamp: 'TestRunner 1/1/2010 11:20'!
insertScopeIndexedTempAfterArgs: tempVar
	|index|
	scopeIndexedVars add: tempVar.
	index := 0.
	tempVars do: [:var | var isArg ifTrue: [index := index max: var index ]].
	tempVar index: index + 1.
	scopeIndexedVars do: [:var |
		((var index >= tempVar index) and: [var name ~= tempVar name]) ifTrue: [
			var index: var index + 1]].
! !

!FunctionScope methodsFor: 'lookup' stamp: 'ms 7/3/2007 23:44'!
instVar: index

	^self captureVarAt: index! !

!FunctionScope methodsFor: 'lookup' stamp: 'ms 8/8/2007 13:06'!
instVarForAssignment: index 
	^ self captureVarForAssignmentAt: index! !

!FunctionScope methodsFor: 'scope' stamp: 'ajh 6/26/2004 13:57'!
isBlockScope

	^ self isMethodScope not! !

!FunctionScope methodsFor: 'scope' stamp: 'ajh 6/25/2004 15:18'!
isFunctionScope

	^ true! !

!FunctionScope methodsFor: 'scope' stamp: 'ajh 6/29/2004 16:38'!
isHome
	"the home scope is the one that returns (^) return from"

	^ isHome = true! !

!FunctionScope methodsFor: 'scope' stamp: 'ajh 6/29/2004 16:38'!
isHome: bool
	"the home scope is the one that returns (^) return from"

	isHome := bool! !

!FunctionScope methodsFor: 'scope' stamp: 'ajh 6/29/2004 16:38'!
isMethodScope

	^ self isHome! !

!FunctionScope methodsFor: 'scope' stamp: 'ms 8/20/2007 01:55'!
isParentEnvCaptured

	self hasInnerFreeVars ifFalse: [^false].
	^true! !

!FunctionScope methodsFor: 'lookup' stamp: 'md 3/10/2006 15:53'!
lookupVar: name
	"Return the ScopeVar with this name. If found in outer scope then move it to captured."

	capturedVars at: name ifPresent: [:v | ^ v].
	tempVars at: name ifPresent: [:v | ^ v].
	name = 'thisEnv' ifTrue: [^ self forceThisEnv].
	name = 'thisContext' ifTrue: [^ thisContextVar].
	(name = 'top env' and: [self isHome]) ifTrue: [^ nil]. "'top env' used by return node"
	
	Preferences compileBlocksAsClosures ifFalse: [	
			^ self outerScope rawVar: name.
	].
	
	^ self outerScope captureVar: name! !

!FunctionScope methodsFor: 'captured vars' stamp: 'ajh 10/28/2004 23:41'!
moveToCaptured: tempVar
	"tempVar has been captured by an inner scope, move it from temps to captured. If tempVar is an arg, keep a temp version of it and link them via sourceTemp. tempVar 'becomes' a captured var so parse tree var nodes will keep pointer to its var."

	| newTempVar |
	self forceThisEnv.
	tempVar isArg ifTrue: [
		newTempVar := tempVar copy.
		tempVars remove: tempVar.
		tempVars add: newTempVar.
		tempVar becomeCaptured.
		capturedVars add: tempVar.
		tempVar index: capturedVars size.
		tempVar sourceTemp: newTempVar.
	] ifFalse: [
		self removeTemp: tempVar.
		tempVar becomeCaptured.
		capturedVars add: tempVar.
		tempVar index: capturedVars size.
	].
	^ tempVar! !

!FunctionScope methodsFor: 'parent env' stamp: 'ajh 7/8/2004 14:26'!
outerEnvScope

	^ outerScope closestEnvScope! !

!FunctionScope methodsFor: 'scope' stamp: 'ajh 7/8/2004 14:19'!
popScope
	"Propogate free var usages to their outer vars, then return outer scope"

	^ self outerScope! !

!FunctionScope methodsFor: 'lookup' stamp: 'ajh 7/8/2004 16:10'!
possibleVarsFor: name continued: listOrNil
	"Return my var names that are close in spelling to name"

	| list |
	list := listOrNil.
	name first isLowercase ifTrue: [
		{tempVars. capturedVars} do: [:vars |
			list := name correctAgainstDictionary: vars continuedFrom: list]
	].
	^ self outerScope possibleVarsFor: name continued: list! !

!FunctionScope methodsFor: 'printing' stamp: 'ajh 3/20/2003 11:29'!
printOn: stream

	super printOn: stream.
	stream space.
	self scopeLevel printOn: stream.
! !

!FunctionScope methodsFor: 'lookup' stamp: 'ajh 10/28/2004 23:26'!
rawVar: name
	"Return the var with this name without capturing temps"

	capturedVars at: name ifPresent: [:v | ^ v].
	tempVars at: name ifPresent: [:v | ^ v].
	name = 'thisEnv' ifTrue: [^ self forceThisEnv].
	name = 'thisContext' ifTrue: [^ thisContextVar].
	^ self outerScope rawVar: name! !

!FunctionScope methodsFor: 'lookup' stamp: 'ms 7/5/2007 20:35'!
rawVarAt: index ifNone: aBlock
	"Return the var with the specific index"

	^tempVars detect: [:each | each index = index] ifNone: aBlock.! !

!FunctionScope methodsFor: 'temp vars' stamp: 'ajh 6/25/2004 17:12'!
receiverVar

	^ self tempVars first! !

!FunctionScope methodsFor: 'decompiling' stamp: 'ms 8/7/2007 11:42'!
receiverVarAt: instVarIndex

	^self outerScope hasEscapingEnv 
		ifTrue: [self outerScope instVar: instVarIndex]
		ifFalse: [self outerScope receiverVarAt: instVarIndex]! !

!FunctionScope methodsFor: 'decompiling' stamp: 'ms 8/8/2007 13:06'!
receiverVarForAssignmentAt: instVarIndex 
	^ self outerScope hasEscapingEnv 
		ifTrue: [self outerScope instVarForAssignment: instVarIndex]
		ifFalse: [self outerScope receiverVarForAssignmentAt: instVarIndex]! !

!FunctionScope methodsFor: 'parent env' stamp: 'ms 8/20/2007 10:16'!
remapCaptureVarForParentEnv

	| receiver receiverCaptured |
	isCapturedVarsRemap ifTrue: [^self].
	isCapturedVarsRemap := true.
	receiver := self receiverVar.
	(capturedVars anySatisfy: [:var | var sourceTemp = receiver and:[var index = 1]])
		ifFalse:[
			(capturedVars anySatisfy: [:var | var sourceTemp = receiver])
				ifTrue: [
					receiverCaptured := capturedVars detect: [:var | var sourceTemp = receiver].
					(capturedVars detect:[:var | var index = 1]) index: receiverCaptured index.
					receiverCaptured index: 1]
				ifFalse: [
					capturedVars  do: [:each | each index: each index + 1]]].! !

!FunctionScope methodsFor: 'temp vars' stamp: 'ajh 6/25/2004 22:05'!
removeTemp: tempVar

	tempVars remove: tempVar.
	tempVars do: [:var |
		var index > tempVar index ifTrue: [
			var index: var index - 1]].
! !

!FunctionScope methodsFor: 'temp vars' stamp: 'ms 7/13/2007 15:30'!
removeTemp: tempVar ifAbsent: aBlock

	tempVars remove: tempVar ifAbsent: aBlock.
	tempVars do: [:var |
		var index > tempVar index ifTrue: [
			var index: var index - 1]].
! !

!FunctionScope methodsFor: 'temp vars' stamp: 'ms 7/10/2007 14:25'!
removeTempFromOldBlock: tempVar

	tempVars remove: tempVar ifAbsent: [self outerScope removeTempFromOldBlock: tempVar]
! !

!FunctionScope methodsFor: 'lookup' stamp: 'JorgeRessia 12/27/2009 14:29'!
scopeIndexedVarFor: name
	
	scopeIndexedVars at: name ifPresent: [:var | ^ var].
	^self lookupVar: name
	
	! !

!FunctionScope methodsFor: 'decompiling' stamp: 'ms 7/3/2007 15:18'!
tempVarAt: tempIndex

	^self tempVarAt: tempIndex ifNone:[self createTemp: tempIndex]! !

!FunctionScope methodsFor: 'decompiling' stamp: 'ms 7/28/2007 13:58'!
tempVarAt: tempIndex ifNone: aBlock

	tempIndex = -2 ifTrue: [^ self thisContextVar].
	tempIndex = -1 ifTrue: [^ self thisEnvVar].
	Preferences compileBlocksAsClosures ifTrue:[
		capturedVars do:[:each | each index == tempIndex ifTrue: [^each]].
		].
	^ tempVars detect: [:var | var index = tempIndex] ifNone: [
		Preferences compileBlocksAsClosures ifFalse:[
			self outerScope 
				ifNotNil:[self outerScope isFunctionScope 
					ifTrue:[^self outerScope tempVarAt: tempIndex ifNone: aBlock]]].
		aBlock valueWithPossibleArgument: self
	]! !

!FunctionScope methodsFor: 'temp vars' stamp: 'ajh 6/25/2004 22:23'!
tempVars

	^ tempVars asSortedCollection: [:x :y | x index <= y index]! !

!FunctionScope methodsFor: 'temp vars' stamp: 'ajh 7/8/2004 19:52'!
tempsAreNoLongerAvailable
	"Hide my temps and outer temps so they don't get captured (becuase they weren't captured and their values are not in the do-it env chain)"

	hideTemps := true.
	self outerScope tempsAreNoLongerAvailable.
! !

!FunctionScope methodsFor: 'env' stamp: 'ajh 6/25/2004 17:11'!
thisContextVar

	^ thisContextVar! !

!FunctionScope methodsFor: 'env' stamp: 'ms 6/17/2007 16:29'!
thisEnvVar

	^ thisEnvVar ifNil:[self forceThisEnv ]! !

LexicalScope subclass: #GlobalScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!GlobalScope commentStamp: 'ajh 3/24/2003 21:52' prior: 0!
When the class is not known, use me to at least find global vars.!

!GlobalScope methodsFor: 'lookup' stamp: 'ajh 2/26/2003 13:42'!
classEncoding
	"subclass responsibility, default is nil"

	^ nil! !

!GlobalScope methodsFor: 'lookup' stamp: 'md 2/21/2006 14:11'!
lookupVar: name
	"subclass responsibility, default is to look up global vars"

	(ProtoObject bindingOf: name asSymbol) ifNotNilDo: [:assoc | 
		^ GlobalVar new assoc: assoc; scope: self].
	^ nil
! !

!GlobalScope methodsFor: 'lookup' stamp: 'ajh 3/12/2003 12:10'!
possibleVarsFor: name continued: listOrNil
	"subclass responsibility, default is to look up global vars"

	name first isLowercase ifTrue: [^ listOrNil].
	^ ProtoObject possibleVariablesFor: name continuedFrom: listOrNil! !

!GlobalScope methodsFor: 'lookup' stamp: 'md 2/21/2006 14:11'!
rawVar: name
	"subclass responsibility, default is to look up global vars"

	(ProtoObject bindingOf: name asSymbol) ifNotNilDo: [:assoc | 
		^ GlobalVar new assoc: assoc; scope: self].
	^ nil
! !

LexicalScope subclass: #InstanceScope
	instanceVariableNames: 'vars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!InstanceScope methodsFor: 'lookup' stamp: 'ajh 7/8/2004 14:55'!
closestEnvScope
	"If self has its own env return self, otherwise return first outer scope with its own env"

	^ self! !

!InstanceScope methodsFor: 'accessing' stamp: 'md 3/10/2006 12:17'!
emitEnvParentEnv: anIRBuilder 
	^self.! !

!InstanceScope methodsFor: 'lookup' stamp: 'ajh 6/28/2004 16:36'!
hasEscapingEnv

	^ true! !

!InstanceScope methodsFor: 'lookup' stamp: 'ms 7/3/2007 16:01'!
instVar: index

	^vars detect:[:each | each index == index]! !

!InstanceScope methodsFor: 'decompile' stamp: 'ms 8/8/2007 13:14'!
instVarForAssignment: instVarIndex 
	^ self instVar: instVarIndex! !

!InstanceScope methodsFor: 'decompile' stamp: 'ms 7/10/2007 17:58'!
instanceScope
	^self! !

!InstanceScope methodsFor: 'initializing' stamp: 'ajh 7/8/2004 20:26'!
isInstanceScope

	^ true! !

!InstanceScope methodsFor: 'lookup' stamp: 'ajh 6/24/2004 03:02'!
lookupVar: name
	"Return a SemVar for my pool var with this name.  Return nil if none found"

	^ vars at: name ifAbsent: [self outerScope lookupVar: name]! !

!InstanceScope methodsFor: 'lookup' stamp: 'ajh 6/24/2004 03:03'!
possibleVarsFor: name continued: listOrNil
	"Return my var names that are close in spelling to name"

	| list |
	list := name first isLowercase
		ifTrue: [name correctAgainstDictionary: vars continuedFrom: listOrNil]
		ifFalse: [listOrNil].
	^ self outerScope possibleVarsFor: name continued: list! !

!InstanceScope methodsFor: 'lookup' stamp: 'ajh 6/24/2004 03:04'!
rawVar: name
	"Return a ScopeVar for my inst var with this name.  Return nil if none found"

	^ vars at: name ifAbsent: [self outerScope rawVar: name]! !

!InstanceScope methodsFor: 'decompile' stamp: 'ms 7/27/2007 17:21'!
receiverVarAt: instVarIndex

	^self instVar: instVarIndex! !

!InstanceScope methodsFor: 'decompile' stamp: 'ms 8/8/2007 13:06'!
receiverVarForAssignmentAt: instVarIndex 
	^ self instVar: instVarIndex! !

!InstanceScope methodsFor: 'initializing' stamp: 'ajh 7/8/2004 18:16'!
tempsAreNoLongerAvailable
	"done"
! !

!InstanceScope methodsFor: 'initializing' stamp: 'ajh 6/24/2004 04:10'!
vars: names

	self vars: names offset: 0! !

!InstanceScope methodsFor: 'initializing' stamp: 'ajh 7/8/2004 16:22'!
vars: names offset: k

	vars := Dictionary new.
	names withIndexDo: [:name :index |
		vars at: name put:
			(CapturedVar new
				name: name;
				index: k + index;
				scope: self)
				markGiven].
! !

!LexicalScope methodsFor: 'adding' stamp: 'ajh 2/25/2003 22:44'!
addSelector: string

	^ string asSymbol! !

!LexicalScope methodsFor: 'lookup' stamp: 'ajh 6/25/2004 22:00'!
captureVar: name

	^ self lookupVar: name! !

!LexicalScope methodsFor: 'lookup' stamp: 'ajh 2/27/2003 00:40'!
classEncoding

	^ self outerScope classEncoding! !

!LexicalScope methodsFor: 'levels' stamp: 'ajh 7/8/2004 20:02'!
hasOuter: scope

	outerScope ifNil: [^ false].
	^ outerScope = scope or: [outerScope hasOuter: scope]! !

!LexicalScope methodsFor: 'decompiling' stamp: 'ms 7/11/2007 11:16'!
instanceScope

	^self outerScope instanceScope! !

!LexicalScope methodsFor: 'decompiling' stamp: 'ms 6/26/2007 14:11'!
isChildrenOf: aScope

	self outerScope == nil ifTrue: [^false].
	self outerScope = aScope ifTrue:[^true].
	^self outerScope isChildrenOf: aScope! !

!LexicalScope methodsFor: 'scope' stamp: 'ajh 7/8/2004 18:39'!
isDoItScope

	^ false! !

!LexicalScope methodsFor: 'scope' stamp: 'ajh 6/25/2004 15:20'!
isFunctionScope

	^ false! !

!LexicalScope methodsFor: 'scope' stamp: 'ajh 7/8/2004 20:26'!
isInstanceScope

	^ false! !

!LexicalScope methodsFor: 'lookup' stamp: 'ajh 2/25/2003 22:41'!
lookupSelector: name

	Symbol hasInterned: name ifTrue: [ :sym | ^ sym].
	^ nil! !

!LexicalScope methodsFor: 'lookup' stamp: 'ajh 3/11/2003 20:19'!
lookupVar: name
	"subclass responsibility"

	^ self outerScope lookupVar: name! !

!LexicalScope methodsFor: 'levels' stamp: 'ajh 6/25/2004 17:27'!
newBlockScope

	^ self newFunctionScope! !

!LexicalScope methodsFor: 'levels' stamp: 'ajh 6/25/2004 17:26'!
newFunctionScope

	^ FunctionScope new outerScope: self! !

!LexicalScope methodsFor: 'levels' stamp: 'ajh 6/29/2004 16:37'!
newMethodScope

	^ self newFunctionScope isHome: true! !

!LexicalScope methodsFor: 'levels' stamp: 'ajh 2/26/2003 13:44'!
outerScope

	^ outerScope! !

!LexicalScope methodsFor: 'initializing' stamp: 'ajh 2/26/2003 13:43'!
outerScope: aSemScope

	outerScope := aSemScope! !

!LexicalScope methodsFor: 'initializing' stamp: 'ajh 2/26/2003 20:01'!
parseScope

	^ self! !

!LexicalScope methodsFor: 'lookup' stamp: 'ajh 2/25/2003 22:40'!
possibleSelectorsFor: string

	^ Symbol possibleSelectorsFor: string! !

!LexicalScope methodsFor: 'lookup' stamp: 'ajh 2/25/2003 22:39'!
possibleVarsFor: string

	| list |
	list := self possibleVarsFor: string continued: nil.
	^ string correctAgainst: nil continuedFrom: list
! !

!LexicalScope methodsFor: 'lookup' stamp: 'ajh 3/11/2003 20:17'!
possibleVarsFor: name continued: listOrNil
	"subclass responsibility"

	^ self outerScope possibleVarsFor: name continued: listOrNil! !

!LexicalScope methodsFor: 'lookup' stamp: 'ajh 3/25/2003 23:38'!
rawVar: name
	"subclass responsibility"

	^ self outerScope rawVar: name! !

!LexicalScope methodsFor: 'old protocol' stamp: 'ajh 2/25/2003 20:09'!
requestor: editor
	"Old protocol, do nothing"
! !

!LexicalScope methodsFor: 'levels' stamp: 'ajh 3/20/2003 11:27'!
scopeLevel

	outerScope ifNil: [^ 0].
	^ outerScope scopeLevel + 1! !

Object subclass: #MockCompilationClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

Object subclass: #NewCompilerDocumentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Syntax'!

!NewCompilerDocumentation commentStamp: 'md 7/23/2005 09:21' prior: 0!
This class is used for collection documentation... e.g. for classes outside of NewCompiler
(e.g. Compiler). This will go away at some point.!

!NewCompilerDocumentation methodsFor: 'as yet unclassified' stamp: 'md 6/8/2006 15:57'!
compiler
'
Comment for class Compiler:

Closure Compiler
by Anthony Hannan 3/13/2003

The Compiler class (like before) serves as the interface to the compiler.  If Preferences compileUseNewCompiler is true it will run the new closure compiler.  The closure compiler classes reside in their own system category called "Compiler", which is broken down into four minor categories: "Compiler-Syntax", "Compiler-Semantics", "Compiler-IR", and "Compiler-Bytecodes".  The closure compiler also uses classes in "SmaCC-Runtime".

Like most compilers, the closure compiler translates source text into bytecodes in a sequence of phases or transformations.

Phase 1 - Scan and parse text into abstract syntax tree (AST)

SqueakScanner and SqueakParser in "Compiler-Syntax" transform a method or do-it text into a Refactory abstract syntax tree.  SqueakScanner and SqueakParser classes were automatically generated using the SmaCC parser generator from a token and grammar specification derived from the StScanner and StParser specifications that comes with SmaCC.

Phase 2 - Verify and annotate AST (semantic analysis)

SemanticChecker in "Compiler-Semantics" binds RBVariableNodes in the AST to temp, instance, or pool (class, pool, or global) SemVars, raising a notifier if no match is found.  The lookup is performed on a chain of SemScopes, one for the class, method and each nested closure.  Var usage (read/write/capture-in-closure) is tracked using a FiniteAutomaton.  The final usage state is used to determine unused temps and escaping temps (temps whose storage need to reside independent of the context since a block may assign to it after the context is gone).

Phase 3 - Translate AST to intermediate representation (IR)

SemanticTranslator in "Compiler-Semantics" visits each node in the AST and invokes the appropriate instruction message on IRBuilder in "Compiler-IR" resulting in an IRMethod.  An IRMethod consists of IRInstructions grouped by IRSequence (basic block).  Each IRInstruction represents a simple stack instruction like pushTemp: or send:.

Phase 4 - Optimize IR

Two simple optimization are applied to the IRMethod: absorbJumpsToSingleInstrs and absorbConstantConditionalJumps. The first eliminates jumps to returns and returns directly.  The second converts chained constant jumps created by and:/or: to single jumps directly to the target code.

Phase 5 - Translate IR to bytecodes (CompiledMethod)

IRTranslator in "Compiler-IR" visits each IR instruction and invokes the appropriate bytecode message on BytecodeGenerator in "Compiler-Bytecodes".  Certain combinations of IR instructions (like storeTemp: and popTop) are mapped to a single bytecode instructions.
'! !

Object subclass: #Parser2
	instanceVariableNames: 'source requestor scope doitFlag failBlock endOfMethodPattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Syntax'!

!Parser2 commentStamp: 'ajh 3/24/2003 21:36' prior: 0!
This mirrors the old Parser protocol but delegates to the real parser which is SqueakParser.!

!Parser2 class methodsFor: 'initialization' stamp: 'ajh 7/7/2004 13:49'!
initialize

	Smalltalk at: #ParseError put: SmaCCParserError.
! !

!Parser2 methodsFor: 'accessing' stamp: 'ajh 3/11/2003 12:16'!
classEncoding

	^ scope classEncoding! !

!Parser2 methodsFor: 'error correction' stamp: 'md 4/14/2007 00:37'!
correctSelector: messageNode
	"Correct the proposed selector in messageNode, correcting the original text if such action is indicated.  Fail if the proposedKeyword couldn't be converted into a valid selector.  Spots is an ordered collection of intervals within the test stream of the for each of the keyword parts."

	| alternatives aStream choice userSelection lines firstLine sel spots newSel |

	sel := messageNode selector.
	"If we can't ask the user, assume that the keyword will be defined later"
	self interactive ifFalse: [^ sel].

	spots := messageNode selectorParts collect: [:token | token sourceInterval].
	userSelection := requestor selectionInterval.
	requestor selectFrom: spots first first to: spots last last.
	requestor select.
	alternatives := messageNode owningScope possibleSelectorsFor: sel asString.

	aStream := WriteStream on: (String new: 200).
	aStream nextPutAll: (sel asString contractTo: 35); cr.
	firstLine := 1.
 	alternatives do: [:s | aStream nextPutAll: s; cr].
	aStream nextPutAll: 'cancel'.
	lines := Array with: firstLine with: (alternatives size + firstLine).
	
	choice := (PopUpMenu labels: aStream contents lines: lines)
		startUpWithCaption: 
'Unknown selector, please 
confirm, correct, or cancel'.

	(choice = 0) | (choice > (lines at: 2)) ifTrue: [^ self fail].

	requestor deselect.
	requestor selectInvisiblyFrom: userSelection first to: userSelection last.

	choice = 1 ifTrue: [^ sel].
	newSel := alternatives at: choice - 1.
	self substituteSelector: newSel in: messageNode.
	((sel last ~~ $:) and: [newSel last == $:]) ifTrue: [^ self fail].
	^ (messageNode owningScope lookupSelector: newSel)
		ifNil: [self halt: 'chosen selector expected to exist']
! !

!Parser2 methodsFor: 'error correction' stamp: 'ms 9/16/2006 18:32'!
correctVariable: variableNode
	"Correct the variableNode to a known variable, or declare it as a new
	variable if such action is requested.  We support declaring lowercase
	variables as temps, and uppercase variables as Globals or ClassVars,
	depending on whether the context is nil (class=UndefinedObject)."

	| varName spot alternatives aStream choice userSelection temp binding declareSize prevToken nextToken tokenChange |

	varName := variableNode name.
	"If we can't ask the user for correction, make it undeclared"
	self interactive ifFalse: [
		Transcript show: ' (' , varName , ' is Undeclared) '.
		varName := varName asSymbol.
		Undeclared at: varName put: nil.
		^ GlobalVar new assoc: (Undeclared associationAt: varName); scope: scope
	].

	spot := variableNode sourceInterval.
	temp := varName first isLowercase.
	"First check to see if the requestor knows anything about the variable"
	(temp and: [(binding := requestor bindingOf: varName) notNil])
		ifTrue: [^ GlobalVar new assoc: binding; scope: scope].
	userSelection := requestor selectionInterval.
	requestor selectFrom: spot first to: spot last.
	requestor select.

	alternatives := variableNode owningScope possibleVarsFor: varName.

	aStream := WriteStream on: (String new: 200).
	temp ifTrue: [
		declareSize := 1.
		aStream nextPutAll: 'declare temp'; cr.
	] ifFalse: [
		declareSize := 1.
		self classEncoding ifNotNil: [
			declareSize := declareSize + 1.  
			aStream nextPutAll: 'declare class variable'; cr].
		aStream nextPutAll: 'declare global'; cr.
	].
	alternatives do: [:name | aStream nextPutAll: name; cr].
	aStream nextPutAll: 'cancel'.

	choice := (PopUpMenu labels: aStream contents
				lines: {declareSize. declareSize + alternatives size})
		startUpWithCaption:
(('Unknown variable: ', varName, '
please correct, or cancel:') asText makeBoldFrom: 19 to: 19 + varName size).

	(choice = 0 or: [choice > (declareSize + alternatives size)]) ifTrue: [^ self fail].

	requestor deselect.
	requestor selectInvisiblyFrom: userSelection first to: userSelection last.
	temp ifTrue: [
		choice = 1 ifTrue: [^ self declareTempAndPaste: variableNode]
	] ifFalse: [
		declareSize = 1 ifTrue: [
			choice = 1 ifTrue: [^ self declareGlobal: variableNode].
		] ifFalse: [ "declareSize = 2"
			choice = 1 ifTrue: [^ self declareClassVar: variableNode].
			choice = 2 ifTrue: [^ self declareGlobal: variableNode].
		].
	].

	"Spelling correction"
	varName := alternatives at: choice - declareSize.
	prevToken := variableNode token previous.
	nextToken := variableNode token next.
	tokenChange := SqueakToken value: varName start: spot first prevToken: prevToken.
	nextToken previous: tokenChange.
	variableNode changeToken: tokenChange.
	self substituteWord: varName wordInterval: spot offset: 0.
	^ (variableNode owningScope lookupVar: varName)
		ifNil: [self halt: 'var should have been found']! !

!Parser2 methodsFor: 'error correction' stamp: 'ajh 3/20/2003 01:30'!
declareClassVar: variableNode

	self classEncoding theNonMetaClass
		addClassVarName: variableNode name asSymbol.
	^ (variableNode owningScope lookupVar: variableNode name)
		ifNil: [self halt: 'should be found']! !

!Parser2 methodsFor: 'error correction' stamp: 'ajh 3/20/2003 01:30'!
declareGlobal: variableNode

	Smalltalk at: variableNode name asSymbol put: nil.
	^ (variableNode owningScope lookupVar: variableNode name)
		ifNil: [self halt: 'should be found']! !

!Parser2 methodsFor: 'error correction' stamp: 'ms 9/17/2006 14:51'!
declareTempAndPaste: variableNode

	| name insertion theTextString methodBody pos start c var tempNode prev prevToken nextToken tokenChange |
	
	name := variableNode name.
	theTextString := requestor text string.
	methodBody := variableNode root body.
	methodBody temporaries notEmpty ifTrue: [
  		"Paste it after last temp"
		prev := pos := methodBody temporaries last stop + 1.
		prevToken := methodBody temporaries last token previous.
		nextToken := methodBody temporaries last token next.
		(theTextString at: pos) isSeparator ifTrue: [
			insertion := name, ' '.
			pos := pos + 1.  start := pos.
		] ifFalse: [
			insertion := ' ', name.
			start := pos + 1.
		].
		self substituteWord: insertion
			wordInterval: (pos to: pos - 1) offset: 0.
	] ifFalse: [
		"No bars - insert some with CR & tab"
		insertion := '| ', name, ' |', String cr.
		prev := pos := methodBody statements first start - 1.
		start := 0.
		[pos = 0 or: [(c := theTextString at: pos) = Character cr]] whileFalse: [
			c isSeparator ifTrue: [
				insertion := c asString, insertion.
				start := start + 1.
			].
			pos := pos - 1.
		].
		pos := pos + 1.
		self substituteWord: insertion
			wordInterval: (pos to: pos - 1) offset: 0.
		start := pos + 2 + start.
		
		prevToken := SqueakToken value: '|' start: start.
		methodBody parent lastTokenOfPatternMethod insertAfterMe: prevToken.
		nextToken := SqueakToken value: '|' start: start + 1.
		prevToken insertAfterMe: nextToken.
	].
	var := methodBody owningScope addTemp: name.
	"change token to be linked with the other"
	tokenChange := SqueakToken value: name  start: start prevToken: prevToken.
	nextToken previous: tokenChange.
	tempNode := RBVariableNode new
		identifierToken: tokenChange;
		binding: var.
	methodBody root adjustPositionsAfter: prev by: insertion size.
	methodBody temporaries: (methodBody temporaries copyWith: tempNode).
	^ (variableNode owningScope lookupVar: name)
		ifNil: [self halt: 'should have been found']! !

!Parser2 methodsFor: 'accessing' stamp: 'ajh 3/25/2003 23:45'!
encoder

	^ self! !

!Parser2 methodsFor: 'old protocol' stamp: 'ajh 3/11/2003 20:01'!
endOfLastToken

	^ endOfMethodPattern! !

!Parser2 methodsFor: 'error handling' stamp: 'ajh 3/6/2003 01:03'!
fail

	^ failBlock value! !

!Parser2 methodsFor: 'error handling' stamp: 'ajh 5/19/2004 17:31'!
interactive

	requestor == nil ifTrue: [^ false].
	(requestor isKindOf: SyntaxError) ifTrue: [^ false].
	(requestor respondsTo: #interactive) ifTrue: [^ requestor interactive].
	^ true! !

!Parser2 methodsFor: 'error handling' stamp: 'ms 1/7/2007 02:01'!
notify: string at: location

	requestor isNil
		ifTrue: [
			SyntaxErrorNotification
					inClass: (self classEncoding ifNil: [FakeClassPool])
					category: (self classEncoding ifNil: [FakeClassPool]) category
					withCode: 
						(source contents
							copyReplaceFrom: location
							to: location - 1
							with: string , ' ->')
					doitFlag: doitFlag]
		ifFalse: [requestor
					notify: string , ' ->'
					at: location
					in: source].
	^self fail! !

!Parser2 methodsFor: 'public access' stamp: 'ajh 3/11/2003 14:35'!
parse: sourceStreamOrString class: behavior

	^ self parse: sourceStreamOrString readStream class: behavior
		noPattern: false notifying: nil ifFail: [nil]! !

!Parser2 methodsFor: 'public access' stamp: 'md 11/22/2005 18:08'!
parse: sourceStream class: class category: aCategory noPattern: noPattern context: ctxt notifying: req ifFail: aBlock 
        "Answer a MethodNode for the argument, sourceStream, that is the root of 
        a parse tree. Parsing is done with respect to the argument, class, to find 
        instance, class, and pool variables; and with respect to the argument, 
        ctxt, to find temporary variables. Errors in parsing are reported to the 
        argument, req, if not nil; otherwise aBlock is evaluated. The argument 
        noPattern is a Boolean that is true if the the sourceStream does not 
        contain a method header (i.e., for DoIts)."
 
        	^ self parse: sourceStream class: class  noPattern: noPattern context: ctxt notifying: req ifFail: aBlock 
! !

!Parser2 methodsFor: 'public access' stamp: 'ajh 9/14/2002 09:28'!
parse: sourceStream class: behavior noPattern: noPattern context: context notifying: req ifFail: aBlock
	"Backwards compatibilty"

	context ifNotNil: [self error: 'Use Compiler-evaluate... instead'].
	^ self parse: sourceStream class: behavior noPattern: noPattern notifying: req ifFail: aBlock! !

!Parser2 methodsFor: 'public access' stamp: 'MarcusDenker 3/29/2010 13:34'!
parse: sourceStream class: parseScope noPattern: doitBool notifying: req ifFail: aBlock
	"Parse sourceStream into a embedded BlockNode if doitFlag is true (no method header) or a MethodNode if doitFlag is false.  Parsing is done with respect to parseScope to find non-local variables.  Errors in parsing are reported to req if not nil followed by executing the fail block."

	| parser |

	source := sourceStream.
	requestor := req.
	doitFlag := doitBool.
	scope := parseScope parseScope.
	failBlock := [^ aBlock value].

	parser := self realParserClass.

	^ [	| tree |
		tree := doitFlag 
			ifTrue: [parser parseDoIt: source contents]
			ifFalse: [parser parseMethod: source contents].
		[tree verifyIn: scope] on: SemanticWarning do: [:ex | ex correctIn: self]
	 ] on: UnhandledError do: [:uEx | | ex |
		ex := uEx exception.
		uEx pass.
		"(SmaCCParserError handles: ex)
			ifTrue: [self notify: ex description at: ex tag position]
			ifFalse: [uEx pass]"
	 ]! !

!Parser2 methodsFor: 'public access' stamp: 'ajh 3/6/2003 00:42'!
parseArgsAndTemps: aString notifying: req 
	"No initialization required.  Parse the argument, aString, notifying req if an error occurs. Otherwise, answer a two-element Array containing Arrays of strings (the argument names and temporary variable names)."

	aString == nil ifTrue: [^ #()].

	^ (self parse: aString readStream class: nil noPattern: false notifying: req ifFail: [^ nil]) tempNames! !

!Parser2 methodsFor: 'public access' stamp: 'ms 7/15/2006 15:35'!
parseMethodComment: aString setPattern: aBlock
	"Answer the method comment for the argument, aString. Evaluate aBlock with the methodNode containing the selector and arguments"

	| methodNode comments |
	methodNode := self realParserClass parseMethod: aString.
	endOfMethodPattern := methodNode methodPatternStop.
	aBlock value: methodNode.
	comments := methodNode comments.
	comments isEmpty ifTrue: [^ nil].
	^ comments first! !

!Parser2 methodsFor: 'public access' stamp: 'md 10/25/2007 15:34'!
parseSelector: aString 
	"Answer the message selector for the argument, aString, which should parse successfully up to the temporary declaration or the end of the method header."

	| methodNode |
	[methodNode := self realParserClass parseMethodPattern: aString.
	endOfMethodPattern := methodNode methodPatternStop.
	^ methodNode selector] on: SmaCCParserError do: [^nil].! !

!Parser2 methodsFor: 'error correction' stamp: 'ajh 3/12/2003 14:34'!
queryUninitializedTemp: variableNode

	| varStart varName |
	self interactive ifFalse: [^ self].
	varName := variableNode name.
	varStart := variableNode start.
	requestor selectFrom: varStart to: varStart + varName size - 1; select.
	((PopUpMenu labels:
'yes
no') startUpWithCaption:
		((varName , ' appears to be
undefined at this point.
Proceed anyway?') asText makeBoldFrom: 1 to: varName size))
		= 1 ifFalse: [^ self fail]! !

!Parser2 methodsFor: 'accessing' stamp: 'MarcusDenker 3/29/2010 13:25'!
realParserClass

	^ RBParser! !

!Parser2 methodsFor: 'error correction' stamp: 'ajh 3/15/2003 13:27'!
removeUnusedTemp: variableNode
	"Removing unused temp, variableNode, if verified by the user"

	| varName interval |
	self interactive ifFalse: [^ self].  "don't remove and continue"
	varName := variableNode name.
	((PopUpMenu labels: 'yes\no' withCRs) startUpWithCaption:
		((varName , ' appears to be
unused in this method.
OK to remove it?') asText makeBoldFrom: 1 to: varName size))
			= 1 ifFalse: [^ self].  "don't remove and continue"

	"Remove temp then continue"
	interval := variableNode sourceInterval.
	(requestor text at: interval last + 1) isSeparator ifTrue: [
		interval := interval first to: interval last + 1].
	self substituteWord: '' wordInterval: interval offset: 0.
	variableNode root adjustPositionsAfter: interval first by: 0 - interval size.
	variableNode parent removeTemporaryNamed: varName.
	^ self! !

!Parser2 methodsFor: 'accessing' stamp: 'ajh 3/10/2003 22:17'!
requestor
	"Return the source code editor"

	^ requestor! !

!Parser2 methodsFor: 'accessing' stamp: 'ajh 6/9/2002 19:47'!
requestor: editor
	"set the source code editor"

	requestor := editor! !

!Parser2 methodsFor: 'error correction' stamp: 'ms 9/17/2006 15:05'!
substituteSelector: newSel in: messageNode
	"Substitute the correctSelector into the (presuamed interactive) receiver."

	| offset newParts |
	newParts := OrderedCollection new.
	offset := 0.
	newSel keywords
	  with: (messageNode selectorParts)
	  do: [:word :tok |
		newParts add: ((SqueakToken value: word start: tok sourceInterval first + offset) substitueTo: tok).
		offset := self substituteWord: word wordInterval: tok sourceInterval offset: offset.
	  ].
	messageNode changeSelectorParts: newParts asArray.
! !

!Parser2 methodsFor: 'error correction' stamp: 'ajh 3/11/2003 23:22'!
substituteWord: correctWord wordInterval: spot offset: o
	"Substitute the correctSelector into the (presuamed interactive) receiver."

	requestor
		correctFrom: (spot first + o)
		to: (spot last + o)
		with: correctWord.
	^ o + correctWord size - spot size! !

!Parser2 methodsFor: 'error correction' stamp: 'ajh 3/19/2003 16:43'!
variable: varNode shadows: semVar

	self interactive ifFalse: [
		^ Transcript show: '(', varNode name, ' is shadowed)'].
	self notify: 'Name already defined' at: varNode start.
! !

Object subclass: #PrimitiveNode
	instanceVariableNames: 'primitiveNum spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-NodesExt'!

!PrimitiveNode commentStamp: 'ajh 3/24/2003 21:35' prior: 0!
I represent a primitive.  I am more than just a number if I am a named primitive.

Structure:

 num	<Integer>	Primitive number.
 spec	<Object>		Stored in first literal when num is 117 or 120.
!

!PrimitiveNode class methodsFor: 'initialization' stamp: 'JorgeRessia 1/10/2010 11:28'!
from: aPragmaNode

	^ self new initializeFrom: aPragmaNode! !

!PrimitiveNode class methodsFor: 'as yet unclassified' stamp: 'ajh 7/14/2001 12:47'!
null

	^ self new num: 0! !

!PrimitiveNode methodsFor: 'accessing' stamp: 'JorgeRessia 1/10/2010 11:44'!
initializeFrom: aPragmaNode

	primitiveNum := 0.
	spec := Array 
		with: (aPragmaNode arguments at: 2) name
		with: (aPragmaNode arguments at: 1) name
		with: 0 with: 0.
! !

!PrimitiveNode methodsFor: 'accessing' stamp: 'ajh 7/14/2001 12:37'!
num

	^ primitiveNum! !

!PrimitiveNode methodsFor: 'as yet unclassified' stamp: 'ajh 7/14/2001 12:23'!
num: n

	primitiveNum := n! !

!PrimitiveNode methodsFor: 'printing' stamp: 'ajh 3/12/2003 12:26'!
printOn: aStream

	aStream nextPutAll: 'primitive '; print: primitiveNum! !

!PrimitiveNode methodsFor: 'printing' stamp: 'ajh 3/19/2003 22:06'!
printPrimitiveOn: aStream 
	"Print the primitive on aStream"

	| primIndex primDecl |
	primIndex := primitiveNum.
	primIndex = 0 ifTrue: [^ self].
	primIndex = 120 ifTrue: [
		"External call spec"
		^ aStream print: spec].
	aStream nextPutAll: '<primitive: '.
	primIndex = 117 ifTrue: [
		primDecl := spec.
		aStream nextPut: $';
			nextPutAll: (primDecl at: 2);
			nextPut: $'.
		(primDecl at: 1) ifNotNil: [
			aStream nextPutAll: ' module: ';
				nextPut: $';
				nextPutAll: (primDecl at: 1);
				nextPut: $'].
	] ifFalse: [aStream print: primIndex].
	aStream nextPut: $>.
	(primIndex ~= 117 and: [primIndex ~= 120]) ifTrue: [
		Smalltalk at: #Interpreter ifPresent: [:cls |
			aStream nextPutAll: ' "', 
				((cls classPool at: #PrimitiveTable) at: primIndex + 1) , '" '
		].
	].
! !

!PrimitiveNode methodsFor: 'printing' stamp: 'ajh 3/19/2003 22:02'!
sourceText

	^ String streamContents: [:stream |
		self printPrimitiveOn: stream]! !

!PrimitiveNode methodsFor: 'accessing' stamp: 'ajh 7/14/2001 12:37'!
spec

	^ spec! !

!PrimitiveNode methodsFor: 'accessing' stamp: 'ajh 7/14/2001 12:30'!
spec: literal

	spec := literal! !

Object subclass: #RBTemporariesSortStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Extras'!

!RBTemporariesSortStrategy class methodsFor: 'as yet unclassified' stamp: 'JorgeRessia 11/24/2009 19:01'!
tempSortBlock
	"Answer a block that can sort a set of temporaries into a stable
	 order so that different compilations produce the same results."
	^[:t1 :t2| | be1 be2 bs1 bs2 |
	   t1 index < t2 index "simple sort by index."
	   or: [t1 index = t2 index "complex tie break" 
		  and: [t1 isRemote ~= t2 isRemote
				ifTrue: [t2 isRemote] "put direct temps before indirect temps"
				ifFalse: 
					[((be1 := t1 definingScope blockExtent) isNil
					  or: [(be2 := t2 definingScope blockExtent) isNil])
						ifTrue: [t1 name < t2 name] "only have the name left to go on"
						ifFalse: "put temps from outer scopes before those from inner scopes"
							[(bs1 := be1 first) < (bs2 := be2 first)
							 or: [bs1 = bs2 and: [t1 name < t2 name]]]]]]] "only have the name left to go on"! !

Object subclass: #Recompiler
	instanceVariableNames: 'problemMethods decompiler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Extras'!

!Recompiler commentStamp: 'ms 7/11/2007 23:46' prior: 0!
[Recompiler new inspect; recompileImage] forkAt: 30
[Recompiler new inspect; decompileAndRecompileImage] forkAt: 30
!

!Recompiler methodsFor: 'recompile' stamp: 'ms 8/6/2007 08:28'!
decompileAndRecompile: selector in: class
	"Recompile method in class. If method can't be recompiled (because of compile error) add it to problemMethods with general reason"

	| trailer methodNode newMethod oldMethod |
	oldMethod := class compiledMethodAt: selector.
	trailer := oldMethod trailer.
	methodNode := self decompiler decompile: selector in: class.
	selector == methodNode selector ifFalse: [
		^ self problem: 'selector changed' sel: selector in: class].
	newMethod := methodNode generate: trailer.
	newMethod = oldMethod ifFalse:[self error: 'Method are not the same'].
	class addSelectorSilently: selector withMethod: newMethod.
! !

!Recompiler methodsFor: 'recompile' stamp: 'ms 7/11/2007 23:45'!
decompileAndRecompileClass: class

	class compileAll.
	{class. class class} do: [:behavior |
		behavior selectorsDo: [:selector |
			[self decompileAndRecompile: selector in: behavior]
				on: Error
				do: [:ex | self problem: ex description sel: selector in: behavior]]]
! !

!Recompiler methodsFor: 'recompile' stamp: 'ms 7/10/2007 16:23'!
decompileAndRecompileImage
	"Recomiles all class/instance methods in image. Methods that can't be recompiled (because of compile error) are added to problemMethods and are not recompiled"

	"ProtoObject allSubclasses includes metaclasses"
	| m |
	m := 0.
	Smalltalk allClassesAndTraitsDo: [:class | m := m + 1].
	'Recompiling ', m printString, ' classes and traits'
		displayProgressAt: Sensor cursorPoint from: 0 to: m
		during: [:bar | | n |
			n := 0.
			Smalltalk allClassesDo: [:class |
				self decompileAndRecompileClass: class.
				bar value: (n := n + 1)].
			self decompileAndRecompileClass: ProtoObject.
		].
! !

!Recompiler methodsFor: 'accessing' stamp: 'ms 7/10/2007 16:15'!
decompiler
	^ decompiler ifNil: [decompiler := Decompiler2 new]! !

!Recompiler methodsFor: 'accessing' stamp: 'ms 7/10/2007 16:14'!
decompiler: anObject
	decompiler := anObject! !

!Recompiler methodsFor: 'problem methods' stamp: 'ms 7/10/2007 16:25'!
initialize

	problemMethods := OrderedCollection new.
! !

!Recompiler methodsFor: 'requestor interface' stamp: 'ajh 5/19/2004 17:32'!
interactive
	"Batch compiling, not interactive"

	^ false! !

!Recompiler methodsFor: 'requestor interface' stamp: 'ajh 5/19/2004 17:32'!
notify: aString at: anInteger in: aStream
	"Called from Parser2 on syntax error. Do nothing and let fail block handle it"
! !

!Recompiler methodsFor: 'problem methods' stamp: 'ajh 5/19/2004 18:16'!
problem: reason sel: selector in: class

	problemMethods add: {class. selector. reason}! !

!Recompiler methodsFor: 'recompile' stamp: 'JorgeRessia 12/31/2009 15:56'!
recompile: selector in: class
	"Recompile method in class. If method can't be recompiled (because of compile error) add it to problemMethods with general reason"

	| source oldMethod trailer methodNode newMethod |
	
	"do not recompile Traits methods here, they are recompiled 
	and reinstalled when the trait is recompiled"
	
	(class includesLocalSelector: selector) ifFalse: [^self].
		
	oldMethod := class compiledMethodAt: selector.
	"oldMethod isClosureCompiled ifTrue: [^ self]."
	source := class sourceCodeAt: selector.
	source ifNil: [^ self problem: 'no source' sel: selector in: class].
	trailer := oldMethod trailer.
	methodNode := ClosureCompiler new
		compile: source in: class notifying: self
		ifFail: [^ self problem: 'syntax error' sel: selector in: class].
	selector == methodNode selector ifFalse: [
		^ self problem: 'selector changed' sel: selector in: class].
	newMethod := methodNode generate: trailer.
	class addSelectorSilently: selector withMethod: newMethod.
! !

!Recompiler methodsFor: 'recompile' stamp: 'md 7/24/2007 16:23'!
recompile: selector inTrait: trait
	"Recompile method in class. If method can't be recompiled (because of compile error) add it to problemMethods with general reason"

	| source oldMethod trailer methodNode newMethod |
	
	"do not recompile Traits methods here, they are recompiled 
	and reinstalled when the trait is recompiled"
	
	(trait includesLocalSelector: selector) ifFalse: [^self].
		
	oldMethod := trait compiledMethodAt: selector.
	source := trait sourceCodeAt: selector.
	source ifNil: [^ self problem: 'no source' sel: selector in: trait].
	trailer := oldMethod trailer.
	methodNode := Compiler new
		compile: source in: trait notifying: self
		ifFail: [^ self problem: 'syntax error' sel: selector in: trait].
	selector == methodNode selector ifFalse: [
		^ self problem: 'selector changed' sel: selector in: trait].
	newMethod := methodNode generate: trailer.
	trait addSelectorSilently: selector withMethod: newMethod.
	
	"now update all the classes that have this trait imported"
	trait updateMethodDictionarySelector: selector.
! !

!Recompiler methodsFor: 'recompile' stamp: 'ajh 5/19/2004 23:29'!
recompileClass: class

	{class. class class} do: [:behavior |
		behavior selectorsDo: [:selector |
			[self recompile: selector in: behavior]
				on: Error
				do: [:ex | self problem: ex description sel: selector in: behavior]]]
! !

!Recompiler methodsFor: 'recompile' stamp: 'marcus.denker 10/3/2008 16:29'!
recompileImage
	"Recomiles all class/instance methods in image. Methods that can't be recompiled (because of compile error) are added to problemMethods and are not recompiled"

	"ProtoObject allSubclasses includes metaclasses"
	| m |
	m := 0.
	Smalltalk allClassesDo: [:class | m := m + 1].
	'Recompiling ', m printString, ' classes'
		displayProgressAt: Sensor cursorPoint from: 0 to: m
		during: [:bar | | n |
			n := 0.
			Smalltalk allClassesDo: [:class |
				self recompileClass: class.
				bar value: (n := n + 1)].
			self recompileClass: ProtoObject.
		].


	m := 0.
	Smalltalk allTraits do: [:class | m := m + 1].
	'Recompiling ', m printString, ' traits'
		displayProgressAt: Sensor cursorPoint from: 0 to: m
		during: [:bar | | n |
			n := 0.
			Smalltalk allTraits do: [:trait |
				self recompileTrait: trait.
				bar value: (n := n + 1)].
		].
	! !

!Recompiler methodsFor: 'recompile' stamp: 'md 7/24/2007 16:18'!
recompileTrait: trait

	{trait. trait classTrait} do: [:behavior |
		behavior selectorsDo: [:selector |
			[self recompile: selector inTrait: behavior]
				on: Error
				do: [:ex | self problem: ex description sel: selector in: behavior]]]
! !

Object subclass: #ScopeVar
	instanceVariableNames: 'scope usage'
	classVariableNames: 'UsageAutomaton'
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ScopeVar commentStamp: 'ajh 3/24/2003 22:38' prior: 0!
I am an entry in a SemScope that gets associated with variable nodes of the same name.  There a three different subclasses of vars: temp vars, field vars, and pool/global vars.!

ScopeVar subclass: #GlobalVar
	instanceVariableNames: 'assoc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!GlobalVar commentStamp: 'ajh 3/24/2003 21:53' prior: 0!
I am a global, pool, or class variable.!

!GlobalVar methodsFor: 'initializing' stamp: 'ajh 2/26/2003 17:31'!
assoc: anAssociation

	assoc := anAssociation! !

!GlobalVar methodsFor: 'emitting' stamp: 'JorgeRessia 1/6/2010 13:56'!
emitLocalPop: methodBuilder in: aScope
	self flag: #fixme.

	methodBuilder storePopIntoLiteralVariable: assoc.

	"methodBuilder pushLiteral: assoc.
	methodBuilder send: #privSetInHolder:."
! !

!GlobalVar methodsFor: 'emitting' stamp: 'md 10/4/2005 17:23'!
emitStore: methodBuilder from: refScope
	self flag: #fixme.

	methodBuilder storeIntoLiteralVariable: assoc.

	"methodBuilder pushLiteral: assoc.
	methodBuilder send: #privSetInHolder:."
! !

!GlobalVar methodsFor: 'emitting' stamp: 'md 7/9/2005 22:15'!
emitValue: methodBuilder from: refScope

	methodBuilder pushLiteralVariable: assoc.! !

!GlobalVar methodsFor: 'accessing' stamp: 'ajh 7/8/2004 16:25'!
isGlobal

	^ true! !

!GlobalVar methodsFor: 'accessing' stamp: 'ajh 7/2/2004 14:15'!
name

	^ assoc name! !

!GlobalVar methodsFor: 'accessing' stamp: 'ms 8/5/2006 14:35'!
value
	^assoc value! !

ScopeVar subclass: #LocalVar
	instanceVariableNames: 'name index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!LocalVar commentStamp: 'ajh 3/24/2003 21:54' prior: 0!
I am an argument or temporary variable of a method or block.!

LocalVar subclass: #CapturedVar
	instanceVariableNames: 'sourceTemp canBeCapture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!CapturedVar commentStamp: 'ajh 3/24/2003 21:52' prior: 0!
I'm a field var of some receiverVar.  if receiverVar is 'self' than I am an instance variable.  If receiverVar is a closure than I am a free variable (outer temp reference) and my outerVar is the outer reference var.!

!CapturedVar methodsFor: 'emitting' stamp: 'md 6/13/2005 14:01'!
emitEnvStore: methodBuilder

	self scope isDoItScope ifTrue: [self scope emitMyEnv: methodBuilder].
	methodBuilder storeInstVar: self index! !

!CapturedVar methodsFor: 'emitting' stamp: 'md 6/13/2005 13:58'!
emitEnvValue: methodBuilder

	self scope isDoItScope ifTrue: [self scope emitMyEnv: methodBuilder].
	methodBuilder pushInstVar: self index.
! !

!CapturedVar methodsFor: 'emitting' stamp: 'JorgeRessia 1/6/2010 15:51'!
emitLocalPop: methodBuilder in: aScope
	methodBuilder storePopInstVar: (aScope lookupVar: name) index.
! !

!CapturedVar methodsFor: 'emitting' stamp: 'md 3/10/2006 16:31'!
emitLocalStore: methodBuilder
	Preferences compileBlocksAsClosures ifTrue: [	
		self scope emitMyEnv: methodBuilder.	
	].
	methodBuilder storeInstVar: self index.
	
	
	! !

!CapturedVar methodsFor: 'emitting' stamp: 'md 3/10/2006 16:31'!
emitLocalValue: methodBuilder
	Preferences compileBlocksAsClosures ifTrue: [	
		self scope emitMyEnv: methodBuilder.
	].
	methodBuilder pushInstVar: self index.! !

!CapturedVar methodsFor: 'accessing' stamp: 'ajh 6/24/2004 15:15'!
isCaptured

	^ true! !

!CapturedVar methodsFor: 'accessing' stamp: 'ajh 6/25/2004 22:18'!
sourceTemp

	^ sourceTemp! !

!CapturedVar methodsFor: 'initializing' stamp: 'ajh 6/25/2004 22:18'!
sourceTemp: tempVarOrNil

	sourceTemp := tempVarOrNil! !

!LocalVar methodsFor: 'emitting' stamp: 'md 8/24/2006 12:11'!
emitEnvStore: methodBuilder from: refScope

	| nextParent |

	refScope = self scope ifTrue: [^ self emitEnvStore: methodBuilder].
	refScope isInstanceScope ifTrue: [^ self emitEnvStore: methodBuilder].

	"self is being referenced from an inner scope (refScope), emit its parent env and recurse"
	nextParent := refScope emitEnvParentEnv: methodBuilder.
	self emitEnvStore: methodBuilder from: nextParent.
! !

!LocalVar methodsFor: 'emitting' stamp: 'ms 7/1/2007 23:06'!
emitEnvValue: methodBuilder from: refScope

	| nextParent |

	(refScope = self scope or: [refScope isInstanceScope]) 
		ifTrue: [^ self emitEnvValue: methodBuilder].

	"self is being referenced from an inner scope (refScope), emit its parent env and recurse"
	nextParent := refScope emitEnvParentEnv: methodBuilder.
	self emitEnvValue: methodBuilder from: nextParent.
! !

!LocalVar methodsFor: 'emitting' stamp: 'JorgeRessia 12/5/2009 13:57'!
emitStore: methodBuilder from: refScope

	| nextParent |
	refScope = self scope ifTrue: [^ self emitLocalStore: methodBuilder in: refScope].
	
	"self is being referenced from an inner scope (refScope), emit its parent env and recurse"
	nextParent := refScope emitLocalParentEnv: methodBuilder.
	self emitEnvStore: methodBuilder from: nextParent.
! !

!LocalVar methodsFor: 'emitting' stamp: 'JorgeRessia 12/5/2009 14:23'!
emitValue: methodBuilder from: refScope

	| nextParent |

	refScope = self scope ifTrue: [^ self emitLocalValue: methodBuilder in: refScope].

	"self is being referenced from an inner scope (refScope), emit its parent env and recurse"
	nextParent := refScope emitLocalParentEnv: methodBuilder.
	self emitEnvValue: methodBuilder from: nextParent. 

	! !

!LocalVar methodsFor: 'accessing' stamp: 'ajh 3/18/2003 11:30'!
index

	^ index! !

!LocalVar methodsFor: 'initializing' stamp: 'jorgeRessia 11/5/2009 14:48'!
index: n
	index := n! !

!LocalVar methodsFor: 'testing' stamp: 'ms 7/31/2007 00:42'!
isLocal

	^true! !

!LocalVar methodsFor: 'read/write usage' stamp: 'ajh 7/8/2004 16:21'!
isUndefined

	^ usage isNil! !

!LocalVar methodsFor: 'read/write usage' stamp: 'ajh 6/28/2004 10:10'!
markArg
	"mark given"

	usage := #arg! !

!LocalVar methodsFor: 'accessing' stamp: 'ajh 6/23/2004 22:51'!
name

	^ name! !

!LocalVar methodsFor: 'initializing' stamp: 'jorgeRessia 11/14/2009 10:56'!
name: string
	name := string! !

LocalVar subclass: #RemoteTempVar
	instanceVariableNames: 'remoteVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!RemoteTempVar class methodsFor: 'instance creation' stamp: 'jorgeRessia 11/13/2009 21:10'!
named: aString scope: aScope 
	^self new initializeNamed: aString scope: aScope ! !

!RemoteTempVar methodsFor: 'accessing' stamp: 'jorgeRessia 11/13/2009 21:14'!
addTemp: aTempVar 
	aTempVar index: remoteVars size.
	remoteVars add: aTempVar.! !

!RemoteTempVar methodsFor: 'initializing' stamp: 'jorgeRessia 11/13/2009 21:15'!
initializeNamed: aString scope: aScope 
	
	name := aString.
	scope := aScope.
	remoteVars := OrderedCollection new.! !

!RemoteTempVar methodsFor: 'accessing' stamp: 'JorgeRessia 12/27/2009 16:12'!
isArg

	^false! !

LocalVar subclass: #TempVar
	instanceVariableNames: 'isArg canBeCapture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!TempVar methodsFor: 'comparing' stamp: 'ms 6/15/2007 14:02'!
= aTempVar

	^aTempVar class = self class 
		and: [aTempVar scope = self scope 
			and:[aTempVar index = self index] 
			and: [aTempVar isArg = self isArg] 
			and: [aTempVar name = self name] 
			and: [self privUsage = aTempVar privUsage]]

	! !

!TempVar methodsFor: 'initializing' stamp: 'ajh 6/29/2004 17:05'!
becomeCaptured
	"TempVar has to become a captured var so parse tree var nodes will point to the captured var. Use change-class instead of become for speed. In order to do this both TempVar and CapturedVar has to have the same number of inst vars"

	isArg "sourceTemp" := nil.
	self primitiveChangeClassTo: CapturedVar basicNew.
! !

!TempVar methodsFor: 'read/write usage' stamp: 'ms 7/28/2007 20:28'!
cantBeCapture

	canBeCapture := false! !

!TempVar methodsFor: 'emitting' stamp: 'md 3/10/2006 16:27'!
emitEnvStore: methodBuilder
	(Preferences compileBlocksAsClosures or: [self scope isDoItScope])
		ifTrue: [ self scope isDoItScope ifFalse: [self error: 'should have been captured'].
				  methodBuilder storeInstVar: (MethodContext instSize + self index).]
		ifFalse: [ self emitLocalStore: methodBuilder].! !

!TempVar methodsFor: 'emitting' stamp: 'ms 7/1/2007 23:07'!
emitEnvValue: methodBuilder

	(Preferences compileBlocksAsClosures or: [self scope isDoItScope]) 
		ifTrue: [
			self scope isDoItScope ifFalse: [self error: 'should have been captured'].
			methodBuilder pushInstVar: (MethodContext instSize + self index)]
		ifFalse: [self emitLocalValue: methodBuilder].! !

!TempVar methodsFor: 'emitting' stamp: 'jorgeRessia 11/3/2009 10:45'!
emitLocalPop: methodBuilder

	methodBuilder storePopTemp: self.
! !

!TempVar methodsFor: 'emitting' stamp: 'jorgeRessia 11/9/2009 16:01'!
emitLocalPop: methodBuilder in: aScope

	methodBuilder storePopTemp: self in: aScope
! !

!TempVar methodsFor: 'emitting' stamp: 'ajh 7/8/2004 14:10'!
emitLocalStore: methodBuilder

	methodBuilder storeTemp: self.
! !

!TempVar methodsFor: 'emitting' stamp: 'jorgeRessia 11/14/2009 11:06'!
emitLocalStore: methodBuilder in: aScope

	methodBuilder storeTemp: self in: aScope
! !

!TempVar methodsFor: 'emitting' stamp: 'jorgeRessia 11/9/2009 16:38'!
emitLocalValue: methodBuilder
	methodBuilder pushTemp: self.
! !

!TempVar methodsFor: 'emitting' stamp: 'JorgeRessia 12/5/2009 14:22'!
emitLocalValue: methodBuilder in: aScope
	methodBuilder pushTemp: self in: aScope.
! !

!TempVar methodsFor: 'emitting' stamp: 'jorgeRessia 11/9/2009 16:13'!
emitValue: methodBuilder from: aScope
	
	methodBuilder pushTemp: self in: aScope
! !

!TempVar methodsFor: 'comparing' stamp: 'ms 6/26/2007 03:04'!
hash

	^index! !

!TempVar methodsFor: 'initializing' stamp: 'ms 7/28/2007 23:41'!
initialize

	canBeCapture := true! !

!TempVar methodsFor: 'read/write usage' stamp: 'ajh 6/25/2004 22:11'!
isArg

	^ isArg = true! !

!TempVar methodsFor: 'read/write usage' stamp: 'ms 7/5/2007 19:57'!
isArg: aBool

	isArg := aBool! !

!TempVar methodsFor: 'accessing' stamp: 'ajh 6/23/2004 23:18'!
isTemp

	^ true! !

!TempVar methodsFor: 'read/write usage' stamp: 'ms 7/28/2007 20:30'!
itCanBeCapture

	^canBeCapture! !

!TempVar methodsFor: 'read/write usage' stamp: 'ms 6/15/2007 13:40'!
markArg

	isArg := true.
	usage := #arg! !

LocalVar subclass: #ThisContextVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ThisContextVar methodsFor: 'emitting' stamp: 'ajh 7/8/2004 14:12'!
emitLocalValue: methodBuilder

	methodBuilder pushThisContext.
! !

!ThisContextVar methodsFor: 'emitting' stamp: 'JorgeRessia 12/23/2009 09:11'!
emitLocalValue: methodBuilder in: aScope 

	self emitLocalValue: methodBuilder
! !

!ThisContextVar methodsFor: 'emitting' stamp: 'ms 7/10/2007 12:05'!
isContextVar

	^true! !

!ThisContextVar methodsFor: 'accessing' stamp: 'ajh 6/25/2004 16:52'!
isUndefined

	^ false! !

LocalVar subclass: #ThisEnvVar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ThisEnvVar methodsFor: 'emitting' stamp: 'ajh 7/8/2004 14:13'!
emitEnvValue: methodBuilder

	"do nothing, env is on top"
! !

!ThisEnvVar methodsFor: 'emitting' stamp: 'ajh 7/8/2004 14:14'!
emitLocalStore: methodBuilder

	methodBuilder storeThisEnv.
! !

!ThisEnvVar methodsFor: 'emitting' stamp: 'ajh 7/8/2004 14:14'!
emitLocalValue: methodBuilder

	methodBuilder pushThisEnv.
! !

!ThisEnvVar methodsFor: 'accessing' stamp: 'ms 7/3/2007 21:10'!
isEnv

	^true! !

!ThisEnvVar methodsFor: 'accessing' stamp: 'ajh 6/25/2004 17:54'!
isUndefined

	^ false! !

!ScopeVar methodsFor: 'accessing' stamp: 'ajh 3/16/2003 20:08'!
asString

	^ self name! !

!ScopeVar methodsFor: 'emitting' stamp: 'ajh 7/8/2004 10:47'!
emitStore: methodBuilder from: refScope

	self subclassResponsibility! !

!ScopeVar methodsFor: 'emitting' stamp: 'ajh 7/8/2004 10:47'!
emitValue: methodBuilder from: refScope

	self subclassResponsibility! !

!ScopeVar methodsFor: 'testing' stamp: 'ajh 6/23/2004 22:44'!
isCaptured

	^ false! !

!ScopeVar methodsFor: 'testing' stamp: 'ms 7/10/2007 12:04'!
isContextVar
	^false
! !

!ScopeVar methodsFor: 'testing' stamp: 'ms 7/3/2007 21:10'!
isEnv

	^ false! !

!ScopeVar methodsFor: 'testing' stamp: 'ajh 7/8/2004 16:25'!
isGlobal

	^ false! !

!ScopeVar methodsFor: 'testing' stamp: 'md 11/22/2005 16:29'!
isInstance
	^self scope isInstanceScope
! !

!ScopeVar methodsFor: 'testing' stamp: 'ms 7/31/2007 00:42'!
isLocal

	^false! !

!ScopeVar methodsFor: 'testing' stamp: 'md 11/22/2005 16:29'!
isRead
	^usage = #read
! !

!ScopeVar methodsFor: 'testing' stamp: 'ajh 3/18/2003 11:13'!
isTemp

	^ false! !

!ScopeVar methodsFor: 'read/write usage' stamp: 'ajh 6/25/2004 11:58'!
isUndefined

	^ false! !

!ScopeVar methodsFor: 'read/write usage' stamp: 'ajh 7/8/2004 16:18'!
isUnused

	^ usage isNil! !

!ScopeVar methodsFor: 'testing' stamp: 'md 11/22/2005 16:29'!
isWrite
	^usage = #write
! !

!ScopeVar methodsFor: 'read/write usage' stamp: 'ajh 7/8/2004 16:18'!
markGiven

	usage ifNil: [usage := #arg].! !

!ScopeVar methodsFor: 'read/write usage' stamp: 'ajh 7/8/2004 16:19'!
markRead

	(usage isNil or: [usage = #arg]) ifTrue: [usage := #read]! !

!ScopeVar methodsFor: 'read/write usage' stamp: 'ajh 7/8/2004 16:19'!
markWrite

	usage := #write! !

!ScopeVar methodsFor: 'accessing' stamp: 'ajh 6/23/2004 22:47'!
name

	^ self subclassResponsibility! !

!ScopeVar methodsFor: 'accessing' stamp: 'ajh 2/27/2003 00:38'!
printOn: stream

	stream nextPutAll: self name! !

!ScopeVar methodsFor: 'read/write usage' stamp: 'ajh 6/28/2004 10:13'!
privUsage

	^ usage! !

!ScopeVar methodsFor: 'read/write usage' stamp: 'ajh 6/28/2004 10:13'!
privUsage: usageSymbol

	usage := usageSymbol! !

!ScopeVar methodsFor: 'accessing' stamp: 'ajh 6/23/2004 22:52'!
scope

	^ scope! !

!ScopeVar methodsFor: 'initializing' stamp: 'ajh 7/8/2004 16:17'!
scope: aLexicalScope

	scope := aLexicalScope! !

Object subclass: #StackCount
	instanceVariableNames: 'start position length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Bytecodes'!

!StackCount commentStamp: 'ajh 3/25/2003 00:34' prior: 0!
This keeps track of the stack count for the BytecodeGenerator.!

!StackCount class methodsFor: 'instance creation' stamp: 'ajh 3/13/2003 01:49'!
new

	^ super new startAt: 0! !

!StackCount class methodsFor: 'as yet unclassified' stamp: 'ajh 3/13/2003 01:49'!
startAt: pos

	^ super new startAt: pos! !

!StackCount methodsFor: 'comparing' stamp: 'ajh 3/13/2003 01:39'!
= other

	^ self class == other class 
	  and: [start = other start
	  and: [position = other position
	  and: [length = other size]]]! !

!StackCount methodsFor: 'error handling' stamp: 'md 7/18/2005 09:59'!
errorStackOutOfSync: aStackCount 
	self error: 'stack not in sync!!'.! !

!StackCount methodsFor: 'comparing' stamp: 'ajh 3/13/2003 01:51'!
hash

	^ position hash bitXor: (length hash bitXor: start hash)! !

!StackCount methodsFor: 'results' stamp: 'ajh 3/13/2003 01:32'!
length

	^length! !

!StackCount methodsFor: 'results' stamp: 'jorgeRessia 11/1/2009 09:55'!
linkTo: stackOrNil

	stackOrNil ifNil: [^ self class startAt: self position].
	^stackOrNil
	"^ self position = stackOrNil start
		ifTrue: [stackOrNil]
		ifFalse: [self errorStackOutOfSync: stackOrNil]"! !

!StackCount methodsFor: 'affecting' stamp: 'jorgeRessia 11/3/2009 16:56'!
pop

	^ self pop: 1! !

!StackCount methodsFor: 'affecting' stamp: 'jorgeRessia 11/3/2009 16:59'!
pop: n

	(position := position - n) "< 0 
		ifTrue: [self error: 'Parse stack underflow']"! !

!StackCount methodsFor: 'results' stamp: 'ajh 3/13/2003 01:32'!
position

	^position! !

!StackCount methodsFor: 'printing' stamp: 'ajh 3/13/2003 01:38'!
printOn: aStream
	
	super printOn: aStream.
	aStream
		nextPutAll: ' start '; print: start;
		nextPutAll: ' stop '; print: position;
		nextPutAll: ' max '; print: length.
! !

!StackCount methodsFor: 'affecting' stamp: 'jorgeRessia 11/3/2009 16:54'!
push
	^ self push: 1! !

!StackCount methodsFor: 'affecting' stamp: 'jorgeRessia 11/3/2009 16:59'!
push: n
	(position := position + n) > length 
		ifTrue: [length := position]! !

!StackCount methodsFor: 'results' stamp: 'ajh 3/13/2003 01:32'!
size

	^length! !

!StackCount methodsFor: 'results' stamp: 'ajh 3/13/2003 01:36'!
start

	^ start! !

!StackCount methodsFor: 'initialize' stamp: 'ajh 3/13/2003 01:48'!
startAt: pos

	start := position := length := pos! !

Object subclass: #VariableNodeData
	instanceVariableNames: 'remoteNode writingScopes readingScopes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Extras'!

VariableNodeData class
	instanceVariableNames: 'variablesData'!

VariableNodeData class
	instanceVariableNames: 'variablesData'!

!VariableNodeData class methodsFor: 'access to cache' stamp: 'JorgeRessia 1/3/2010 09:06'!
for: aRBVariableNode
	^variablesData at: (aRBVariableNode hash bitXor: ((self scopeFor: aRBVariableNode) hash bitXor: aRBVariableNode definingScope uniqueIdentifier hash) ) ifAbsentPut: [self new initializeFor: aRBVariableNode] 
! !

!VariableNodeData class methodsFor: 'accessing' stamp: 'jorgeRessia 10/9/2009 14:40'!
initialize
	super initialize.
	self resetData! !

!VariableNodeData class methodsFor: 'accessing' stamp: 'jorgeRessia 10/9/2009 14:39'!
resetData
	variablesData := Dictionary new.! !

!VariableNodeData class methodsFor: 'access to cache' stamp: 'TestRunner 12/26/2009 09:35'!
scopeFor: aRBVariableNode
	| tempVar |
	tempVar := (aRBVariableNode owningScope lookupVar: aRBVariableNode name).
	tempVar isNil 
				ifTrue: [^nil]
				ifFalse: [^tempVar scope]
! !

!VariableNodeData methodsFor: 'initialization' stamp: 'TestRunner 12/30/2009 22:42'!
addReadWithin: scopeBlock "<BlockNode>" at: location "<Integer>"
	readingScopes ifNil: [readingScopes := Dictionary new].
	(readingScopes at: scopeBlock ifAbsentPut: [Set new]) add: location.
	remoteNode ifNotNil:
		[remoteNode addReadWithin: scopeBlock at: location]
	! !

!VariableNodeData methodsFor: 'initialization' stamp: 'jorgeRessia 10/9/2009 14:47'!
addWriteWithin: scopeBlock "<BlockNode>" at: location "<Integer>"
	writingScopes ifNil: [writingScopes := Dictionary new].
	(writingScopes at: scopeBlock ifAbsentPut: [Set new]) add: location.
	remoteNode ifNotNil:
		[remoteNode addReadWithin: scopeBlock at: location]! !

!VariableNodeData methodsFor: 'initialization' stamp: 'jorgeRessia 10/9/2009 14:50'!
beingAssignedToAnalyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"
	self halt.
	self addWriteWithin: scopeBlock at: rootNode locationCounter.
	"For analysis of optimized blocks also record the set of temporaries written to
	 within optimized blocks so that additional writes can be added at locations that
	 represent subsequent iterations of the loop. e.g. testInlineBlockCollectionSD1"
	assignmentPools keysAndValuesDo:
		[:outerScopeBlock :set|
		"definingScope can be nil in expr in expr ifNil: [:arg|...] expressions because
		 arg gets its definingScope set when [:arg|...] is analysed."
		outerScopeBlock actualScope
			= (definingScope
				ifNil: [scopeBlock]
				ifNotNil: [definingScope actualScope]) ifTrue:
			[set add: self]]
	! !

!VariableNodeData methodsFor: 'initialization' stamp: 'jorgeRessia 10/9/2009 14:24'!
initializeFor: aRBVariableNode

	! !

!VariableNodeData methodsFor: 'initialization' stamp: 'jorgeRessia 10/9/2009 14:52'!
isBlockArg
	^definingScope isBlock and: [definingScope arguments includes: self]! !

!VariableNodeData methodsFor: 'initialization' stamp: 'jorgeRessia 10/9/2009 14:53'!
isReferencedWithinBlockExtent: anInterval 
	readingScopes ~~ nil ifTrue:
		[readingScopes do:
			[:set "<Set of <Integer>>"|
			set do:
				[:location|
				 (anInterval rangeIncludes: location) ifTrue:
					[^true]]]].
	writingScopes ~~ nil ifTrue:
		[writingScopes do:
			[:set "<Set of <Integer>>"|
			set do:
				[:location|
				 (anInterval rangeIncludes: location) ifTrue:
					[^true]]]].
	^false! !

!VariableNodeData methodsFor: 'accessing' stamp: 'jorgeRessia 10/9/2009 16:11'!
readingScopes
	^readingScopes! !

!VariableNodeData methodsFor: 'accessing' stamp: 'jorgeRessia 10/11/2009 09:48'!
referenceScopesAndIndicesDo: aBinaryBlock
	"Evaluate aBinaryBlock with all read or write scopes and locations.
	 This is used to copy the reference information into RemoteTempVectorNodes"
	readingScopes ~~ nil ifTrue:
		[readingScopes keysAndValuesDo:
			[:scopeBlock "<BlockNode>" :set "<Set of <Integer>>"|
			set do: [:location| aBinaryBlock value: scopeBlock value: location]]].
	writingScopes ~~ nil ifTrue:
		[writingScopes keysAndValuesDo:
			[:scopeBlock "<BlockNode>" :set "<Set of <Integer>>"|
			set do: [:location| aBinaryBlock value: scopeBlock value: location]]]! !

!VariableNodeData methodsFor: 'accessing' stamp: 'jorgeRessia 10/9/2009 16:10'!
remoteNode
	^remoteNode! !

!VariableNodeData methodsFor: 'accessing' stamp: 'jorgeRessia 11/14/2009 10:11'!
remoteNode: aRemoteVectorNode 
	remoteNode := aRemoteVectorNode! !

!VariableNodeData methodsFor: 'accessing' stamp: 'jorgeRessia 10/9/2009 16:10'!
writingScopes
	^writingScopes! !

!UndefinedObject methodsFor: '*newcompiler' stamp: 'ajh 6/23/2004 20:40'!
parseScope

	^ GlobalScope new! !

Link subclass: #IRInstruction
	instanceVariableNames: 'sourceNode bytecodeIndex sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRInstruction commentStamp: 'ajh 6/27/2004 23:02' prior: 0!
I am an instruction in the IR (intermediate representation) language.  The IR serves as the intermediary between the Smalltalk language and the bytecode language.  It is easier to optimize and translate to/from this language than it is to optimize/translate directly from Smalltalk to bytecodes.  The IR is generic and simple consisting of just twelve instructions.  They are:

	goto: labelNum
	if: boolean goto: labelNum1 otherwise: labelNum2
	label: labelNum
	popTop
	pushDup
	pushLiteral: object
	pushBlock: irMethod
	pushBlockMethod: irMethod
	pushTemp: tempIndex
	remoteReturn
	returnTop
	send: selector
	send: selector toSuperOf: behavior
	storeTemp: tempIndex

Each instruction is reified as an instance of one of my eight subclasses and grouped by basic block (IRSequence) into an IRMethod.  IRInterpreter visits each instruction in a IRMethod responding to the above instruction messages sent to it.
!

IRInstruction subclass: #IRAccess
	instanceVariableNames: 'number name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRAccess methodsFor: 'testing' stamp: 'md 6/13/2005 12:01'!
isRead
	^self isStore not! !

!IRAccess methodsFor: 'accessing' stamp: 'md 6/12/2005 17:56'!
number

	^ number! !

!IRAccess methodsFor: 'accessing' stamp: 'md 6/12/2005 17:57'!
number: num

	number := num! !

IRAccess subclass: #IRInstVarAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRInstVarAccess commentStamp: 'md 11/10/2004 16:07' prior: 0!
when closures disabled, Field describes an instVar. With closures, it describes a 
fieldaccess with receiver to be accessed pushed first.!

!IRInstVarAccess methodsFor: 'testing' stamp: 'md 6/13/2005 11:10'!
isInstVarAccess
	^true.! !

!IRInstVarAccess methodsFor: 'testing' stamp: 'md 3/6/2006 09:14'!
varname
	name ifNil: [name := self method compiledMethod methodClass allInstVarNames at: self offset].
	^name.! !

IRInstVarAccess subclass: #IRInstVarRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRInstVarRead methodsFor: 'interpret' stamp: 'md 6/14/2005 15:02'!
executeOn: interpreter

	Preferences compileBlocksAsClosures 
		ifFalse: [ interpreter pushInstVar: number] 
		ifTrue: [  interpreter pushLiteral: number.
				  interpreter send: #privGetInstVar:. ]! !

!IRInstVarRead methodsFor: 'testing' stamp: 'md 6/13/2005 11:24'!
isRead
	^true.! !

!IRInstVarRead methodsFor: 'testing' stamp: 'md 6/13/2005 11:24'!
isStore
	^false.! !

IRInstVarAccess subclass: #IRInstVarStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRInstVarStore methodsFor: 'interpret' stamp: 'md 6/14/2005 15:04'!
executeOn: interpreter

	Preferences compileBlocksAsClosures 
		ifFalse: [interpreter storeInstVar: number] 
		ifTrue: [interpreter pushLiteral: number.
				interpreter send: #privStoreIn:instVar:].
		! !

!IRInstVarStore methodsFor: 'testing' stamp: 'md 6/13/2005 11:25'!
isRead
	^false! !

!IRInstVarStore methodsFor: 'testing' stamp: 'md 6/13/2005 11:25'!
isStore
	^true! !

IRInstVarStore subclass: #IRInstVarStorePop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRInstVarStorePop methodsFor: 'interpret' stamp: 'JorgeRessia 1/6/2010 15:36'!
executeOn: interpreter

	Preferences compileBlocksAsClosures 
		ifFalse: [interpreter storePopInstVar: number] 
		ifTrue: [interpreter pushLiteral: number.
				interpreter send: #privStoreIn:instVar:].
		! !

IRAccess subclass: #IRLiteralVariableAccess
	instanceVariableNames: 'association'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRLiteralVariableAccess methodsFor: 'accessing' stamp: 'md 7/9/2005 21:14'!
association: anAssociation
	association := anAssociation! !

!IRLiteralVariableAccess methodsFor: 'accessing' stamp: 'md 10/4/2005 16:45'!
isLiteralVariable
	^true! !

!IRLiteralVariableAccess methodsFor: 'accessing' stamp: 'md 10/4/2005 16:45'!
isLiteralVariableAccess
	^true! !

!IRLiteralVariableAccess methodsFor: 'accessing' stamp: 'md 10/4/2005 16:53'!
isLiteralVariableRead
	^self isLiteralVariableAccess and: [self isRead].! !

!IRLiteralVariableAccess methodsFor: 'accessing' stamp: 'md 10/4/2005 16:53'!
isLiteralVariableStore
	^self isLiteralVariableAccess and: [self isStore].! !

IRLiteralVariableAccess subclass: #IRLiteralVariableRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRLiteralVariableRead methodsFor: 'interpret' stamp: 'md 7/9/2005 21:18'!
executeOn: interpreter
	interpreter pushLiteralVariable: association
! !

!IRLiteralVariableRead methodsFor: 'testing' stamp: 'md 7/9/2005 21:17'!
isRead
	^true! !

!IRLiteralVariableRead methodsFor: 'testing' stamp: 'md 7/9/2005 21:17'!
isStore
	^false! !

IRLiteralVariableAccess subclass: #IRLiteralVariableStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRLiteralVariableStore methodsFor: 'interpret' stamp: 'md 7/9/2005 21:18'!
executeOn: interpreter
	interpreter storeIntoLiteralVariable: association! !

!IRLiteralVariableStore methodsFor: 'testing' stamp: 'md 7/9/2005 21:18'!
isRead
	^false! !

!IRLiteralVariableStore methodsFor: 'testing' stamp: 'md 7/9/2005 21:18'!
isStore
	^true! !

IRLiteralVariableStore subclass: #IRLiteralVariableStorePop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRLiteralVariableStorePop methodsFor: 'interpret' stamp: 'JorgeRessia 1/6/2010 13:58'!
executeOn: interpreter
	interpreter storePopIntoLiteralVariable: association! !

IRAccess subclass: #IRTempAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRTempAccess methodsFor: 'testing' stamp: 'md 2/26/2005 16:22'!
isSelf
	^self number = 0.! !

!IRTempAccess methodsFor: 'testing' stamp: 'md 2/22/2005 11:28'!
isTemp
	^true.! !

!IRTempAccess methodsFor: 'testing' stamp: 'md 6/12/2005 18:42'!
isTempAccess
	^true.! !

!IRTempAccess methodsFor: 'testing' stamp: 'md 6/13/2005 11:08'!
isTempRead
	^self isTempAccess and: [self isRead].! !

!IRTempAccess methodsFor: 'testing' stamp: 'md 6/13/2005 12:01'!
isTempStore
	^self isTempAccess and: [self isStore].! !

IRTempAccess subclass: #IRTempRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRTempRead methodsFor: 'interpret' stamp: 'md 6/12/2005 18:19'!
executeOn: interpreter
	interpreter pushTemp: number.! !

!IRTempRead methodsFor: 'testing' stamp: 'md 6/12/2005 18:21'!
isRead
	^true! !

!IRTempRead methodsFor: 'testing' stamp: 'md 6/13/2005 12:03'!
isStore
	^false! !

IRTempAccess subclass: #IRTempStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRTempStore methodsFor: 'interpret' stamp: 'jorgeRessia 11/3/2009 12:31'!
executeOn: interpreter
	interpreter storeTemp: number.
		! !

!IRTempStore methodsFor: 'testing' stamp: 'md 6/12/2005 18:22'!
isRead
	^false! !

!IRTempStore methodsFor: 'testing' stamp: 'md 6/13/2005 12:03'!
isStore
	^true! !

IRTempStore subclass: #IRTempStorePop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRTempStorePop methodsFor: 'interpret' stamp: 'jorgeRessia 11/5/2009 16:00'!
executeOn: interpreter

	interpreter storePopTemp: number.! !

IRInstruction subclass: #IRConstant
	instanceVariableNames: 'constant type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRConstant commentStamp: 'ajh 3/24/2003 23:56' prior: 0!
Instruction "pushLiteral: object"!

!IRConstant methodsFor: 'accessing' stamp: 'ajh 3/10/2003 00:43'!
constant

	^ constant! !

!IRConstant methodsFor: 'accessing' stamp: 'ajh 3/10/2003 00:43'!
constant: object

	constant := object! !

!IRConstant methodsFor: 'interpret' stamp: 'ajh 6/27/2004 21:41'!
executeOn: interpreter

	^ type caseOf: {
		[nil] -> [interpreter pushLiteral: constant].
		[#block] -> [interpreter pushBlock: constant].
		[#blockMethod] -> [interpreter pushBlockMethod: constant]
	 }! !

!IRConstant methodsFor: 'testing' stamp: 'md 11/26/2004 15:35'!
isConstant

	^ true! !

!IRConstant methodsFor: 'testing' stamp: 'ajh 3/10/2003 16:12'!
isConstant: valueTest

	^ valueTest value: constant! !

!IRConstant methodsFor: 'accessing' stamp: 'ajh 6/27/2004 21:39'!
type
	"type is nil, #block, or #blockMethod"

	^ type! !

!IRConstant methodsFor: 'accessing' stamp: 'ajh 6/27/2004 21:39'!
type: symbol
	"symbol is nil, #block, or #blockMethod"

	type := symbol! !

IRInstruction subclass: #IRDup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRDup commentStamp: 'ajh 3/24/2003 23:56' prior: 0!
Instruction "pushDup"!

!IRDup methodsFor: 'interpret' stamp: 'ajh 3/10/2003 00:46'!
executeOn: interpreter

	^ interpreter pushDup! !

!IRInstruction class methodsFor: 'instance creation - old style blocks' stamp: 'md 10/8/2004 16:05'!
blockReturnTop

	^ IRBlockReturnTop new
		! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 3/10/2003 01:07'!
goto: seq

	^ IRJump new
		destination: seq! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 3/10/2003 01:07'!
if: bool goto: seq1 otherwise: seq2

	^ IRJumpIf new
		boolean: bool;
		destination: seq1;
		otherwise: seq2! !

!IRInstruction class methodsFor: 'instance creation - old style blocks' stamp: 'md 8/10/2005 11:03'!
jumpOverBlock: block to: cont
	^ (IRJumpOverBlock new)
				blockSequence: block;
				destination: cont.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'md 6/29/2005 16:47'!
new
	^super basicNew.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/11/2009 19:44'!
popTop
	^ IRPop new! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 6/27/2004 22:58'!
pushBlock: irMethod

	^ IRConstant new
		constant: irMethod;
		type: #block! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 6/27/2004 21:40'!
pushBlockMethod: irMethod

	^ IRConstant new
		constant: irMethod;
		type: #blockMethod! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/2/2009 15:58'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs 
	
	^IRPushClosureCopy numCopiedValues: numCopied numArgs: numArgs  ! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/1/2009 15:11'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs jumpSize: jumpSize 
	
	^IRPushClosureCopy numCopiedValues: numCopied numArgs: numArgs jumpSize: jumpSize ! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jb 3/25/2010 14:29'!
pushConsArray: aSize 
	^IRPushConsArray sized: aSize ! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 3/10/2003 01:08'!
pushDup

	^ IRDup new! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'md 6/13/2005 13:58'!
pushInstVar: index

	^ IRInstVarRead new number: index.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 3/10/2003 01:08'!
pushLiteral: object

	^ IRConstant new
		constant: object! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'md 7/9/2005 21:20'!
pushLiteralVariable: object

	^ IRLiteralVariableRead new
		association: object.
	 ! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/11/2009 11:23'!
pushNewArray: aSize
	
	^IRPushNewArray sized: aSize ! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'md 4/21/2005 11:38'!
pushReceiver
	^IRInstruction pushTemp: 0! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/11/2009 17:30'!
pushRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex

	^IRPushRemoteTemp at: remoteTempIndex in: tempVectorIndex 
	! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'md 6/12/2005 18:22'!
pushTemp: index

	^ IRTempRead new
		number: index.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'md 4/21/2005 12:06'!
pushThisContext
	^IRInstruction pushTemp: -2! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 3/10/2003 01:08'!
remoteReturn

	^ IRReturn new
		isRemote: true! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 3/10/2003 01:08'!
returnTop

	^ IRReturn new
		isRemote: false! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 3/10/2003 01:08'!
send: selector

	^ IRSend new
		selector: selector! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'ajh 7/3/2004 19:10'!
send: selector toSuperOf: behavior

	behavior ifNil: [self error: 'super of nil does not exist'].
	^ IRSend new
		selector: selector;
		superOf: behavior! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'TestRunner 1/8/2010 16:54'!
storeInstVar: index
	^ IRInstVarStore new number: index.
	! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'md 7/9/2005 21:20'!
storeIntoLiteralVariable: object

	^ IRLiteralVariableStore new
		association: object! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'JorgeRessia 1/6/2010 15:51'!
storePopInstVar: index
	^ IRInstVarStorePop new number: index.
	! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'JorgeRessia 1/6/2010 13:55'!
storePopIntoLiteralVariable: object

	^ IRLiteralVariableStorePop new
		association: object! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/11/2009 16:42'!
storePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex 
	^IRStorePopRemoteTemp at: tempIndex in: tempVectorIndex! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'PF 8/4/2008 15:40'!
storePopTemp: index

	^ IRTempStorePop new
		number: index.! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/12/2009 11:19'!
storeRemoteTemp: tempIndex inVectorAt: tempVectorIndex 
	^IRStoreRemoteTemp at: tempIndex in: tempVectorIndex! !

!IRInstruction class methodsFor: 'instance creation' stamp: 'jorgeRessia 11/3/2009 12:31'!
storeTemp: index
	^ IRTempStore new
		number: index.! !

!IRInstruction methodsFor: 'adding' stamp: 'md 7/9/2005 22:41'!
addInstructionsAfter: aCollection
	sequence addInstructions: aCollection after: self.! !

!IRInstruction methodsFor: 'adding' stamp: 'md 7/9/2005 22:41'!
addInstructionsBefore: aCollection
	sequence addInstructions: aCollection before: self.! !

!IRInstruction methodsFor: 'mapping' stamp: 'ajh 3/13/2003 13:07'!
bytecodeIndex

	^ bytecodeIndex! !

!IRInstruction methodsFor: 'mapping' stamp: 'ajh 3/13/2003 13:14'!
bytecodeIndex: index

	bytecodeIndex := index! !

!IRInstruction methodsFor: 'mapping' stamp: 'md 9/1/2005 21:18'!
bytecodeOffset
	| startpc |
	startpc := self method compiledMethod initialPC.
	self bytecodeIndex ifNil: [^startpc].
	^self bytecodeIndex + startpc - 1.! !

!IRInstruction methodsFor: 'replacing' stamp: 'md 7/9/2005 22:41'!
delete
	sequence isNil ifTrue: [self error: 'This node doesn''t have a sequence'].
	sequence remove: self.! !

!IRInstruction methodsFor: 'interpret' stamp: 'ajh 3/6/2003 14:32'!
executeOn: interpreter
	"Send approriate message to interpreter"

	self subclassResponsibility! !

!IRInstruction methodsFor: 'testing' stamp: 'md 10/9/2004 20:14'!
isBlockReturnTop
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 11/26/2004 15:35'!
isConstant

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'ajh 3/10/2003 16:12'!
isConstant: valueTest

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:19'!
isGoto
	"is unconditional jump"

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:21'!
isIf

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'abc 1/2/2006 15:41'!
isInBlock
	| irs |
	irs := self method allInstructionsMatching: [:each | each isJumpOverBlock ].
	irs detect: [:each | each blockSequence == self sequence ] ifNone: [^false].
	^true! !

!IRInstruction methodsFor: 'testing' stamp: 'md 6/13/2005 11:10'!
isInstVarAccess
	^false.! !

!IRInstruction methodsFor: 'testing' stamp: 'md 6/13/2005 13:54'!
isInstVarRead
	^self isInstVarAccess and: [self isRead].! !

!IRInstruction methodsFor: 'testing' stamp: 'md 6/13/2005 13:54'!
isInstVarStore
	^self isInstVarAccess and: [self isStore].! !

!IRInstruction methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:22'!
isJump
	"goto or if"

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'ajh 3/10/2003 16:13'!
isJumpOrReturn

	^ self isJump or: [self isReturn]! !

!IRInstruction methodsFor: 'testing' stamp: 'abc 1/2/2006 15:14'!
isJumpOverBlock
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 10/4/2005 16:52'!
isLiteralVariable
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 10/4/2005 16:53'!
isLiteralVariableAccess
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 10/4/2005 16:53'!
isLiteralVariableRead
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 10/4/2005 16:53'!
isLiteralVariableStore
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'ms 7/10/2007 14:12'!
isPop

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'JorgeRessia 12/25/2009 20:44'!
isPushClosureCopy
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'jorgeRessia 11/2/2009 16:00'!
isPushNewArray
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'ajh 3/10/2003 16:09'!
isReturn

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 2/26/2005 16:22'!
isSelf
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 11/12/2004 15:57'!
isSend
	^false.! !

!IRInstruction methodsFor: 'testing' stamp: 'JorgeRessia 12/25/2009 22:55'!
isSimpleJump
	"goto or if"

	^ false! !

!IRInstruction methodsFor: 'testing' stamp: 'jorgeRessia 10/12/2009 11:08'!
isStorePopRemoteTemp
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 2/22/2005 11:28'!
isTemp
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 6/13/2005 11:05'!
isTempAccess
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 4/28/2005 14:26'!
isTempRead
	^false! !

!IRInstruction methodsFor: 'testing' stamp: 'md 4/28/2005 14:26'!
isTempStore
	^false! !

!IRInstruction methodsFor: 'accessing' stamp: 'md 7/9/2005 22:42'!
method
	^sequence method.! !

!IRInstruction methodsFor: 'replacing' stamp: 'md 10/11/2004 15:56'!
replaceNode: aNode withNode: anotherNode 
	self error: 'I don''t store other nodes'! !

!IRInstruction methodsFor: 'replacing' stamp: 'md 7/9/2005 22:41'!
replaceWith: aNode
	sequence isNil ifTrue: [self error: 'This node doesn''t have a sequence'].
	sequence replaceNode: self withNode: aNode! !

!IRInstruction methodsFor: 'replacing' stamp: 'md 7/9/2005 22:41'!
replaceWithInstructions: aCollection 

	sequence isNil ifTrue: [self error: 'This node doesn''t have a sequence'].
	sequence replaceNode: self withNodes: aCollection! !

!IRInstruction methodsFor: 'accessing' stamp: 'md 7/9/2005 22:38'!
sequence
	^sequence! !

!IRInstruction methodsFor: 'accessing' stamp: 'md 7/9/2005 22:39'!
sequence: aSeq
	sequence := aSeq! !

!IRInstruction methodsFor: 'accessing' stamp: 'jorgeRessia 10/11/2009 21:40'!
size

	^1! !

!IRInstruction methodsFor: 'mapping' stamp: 'ajh 3/6/2003 14:32'!
sourceNode

	^ sourceNode
	! !

!IRInstruction methodsFor: 'mapping' stamp: 'ajh 3/6/2003 14:32'!
sourceNode: parseNode

	sourceNode := parseNode
	! !

!IRInstruction methodsFor: 'accessing' stamp: 'ajh 3/6/2003 14:32'!
successorSequences
	"sent to last instruction in sequence which is expected to be a jump and return instruction"

	^ #()! !

IRInstruction subclass: #IRJump
	instanceVariableNames: 'destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRJump commentStamp: 'ajh 3/24/2003 23:56' prior: 0!
Instruction "goto: labelNum"!

!IRJump methodsFor: 'accessing' stamp: 'ajh 3/10/2003 23:08'!
destination

	^ destination! !

!IRJump methodsFor: 'accessing' stamp: 'jorgeRessia 11/4/2009 10:29'!
destination: aSequence

	destination := aSequence! !

!IRJump methodsFor: 'interpret' stamp: 'ajh 3/10/2003 00:47'!
executeOn: interpreter

	^ interpreter goto: destination orderNumber! !

!IRJump methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:19'!
isGoto
	"is unconditional jump"

	^ true! !

!IRJump methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:22'!
isJump
	"goto or if"

	^ true! !

!IRJump methodsFor: 'testing' stamp: 'JorgeRessia 12/25/2009 22:54'!
isSimpleJump
	"goto or if"

	^ true! !

!IRJump methodsFor: 'accessing' stamp: 'JorgeRessia 12/26/2009 09:26'!
size

	(sequence orderNumber > destination orderNumber )
					ifTrue: ["backwads jump" ^2].
	^1! !

!IRJump methodsFor: 'accessing' stamp: 'ajh 3/11/2003 00:02'!
successorSequences

	^ {destination}! !

IRJump subclass: #IRJumpIf
	instanceVariableNames: 'boolean otherwise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRJumpIf commentStamp: 'ajh 3/24/2003 23:56' prior: 0!
Instruction "if: boolean goto: labelNum1 otherwise: labelNum2"!

!IRJumpIf methodsFor: 'acessing' stamp: 'ajh 3/10/2003 00:43'!
boolean

	^ boolean! !

!IRJumpIf methodsFor: 'acessing' stamp: 'ajh 3/10/2003 00:43'!
boolean: bool

	boolean := bool! !

!IRJumpIf methodsFor: 'interpret' stamp: 'ajh 3/10/2003 00:47'!
executeOn: interpreter

	^ interpreter if: boolean goto: destination orderNumber otherwise: otherwise orderNumber! !

!IRJumpIf methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:19'!
isGoto
	"is unconditional jump"

	^ false! !

!IRJumpIf methodsFor: 'testing' stamp: 'ajh 3/11/2003 00:21'!
isIf

	^ true! !

!IRJumpIf methodsFor: 'testing' stamp: 'JorgeRessia 12/25/2009 22:55'!
isSimpleJump
	"goto or if"

	^ false! !

!IRJumpIf methodsFor: 'acessing' stamp: 'ajh 3/10/2003 00:43'!
otherwise

	^ otherwise! !

!IRJumpIf methodsFor: 'acessing' stamp: 'pmm 2/2/2007 18:05'!
otherwise: aSequence

	otherwise := aSequence! !

!IRJumpIf methodsFor: 'acessing' stamp: 'ajh 3/11/2003 00:02'!
successorSequences

	^ {destination. otherwise}! !

IRJump subclass: #IRJumpOverBlock
	instanceVariableNames: 'blockSequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRJumpOverBlock methodsFor: 'accessing' stamp: 'md 10/8/2004 15:18'!
blockSequence
	^blockSequence! !

!IRJumpOverBlock methodsFor: 'accessing' stamp: 'md 10/8/2004 15:18'!
blockSequence: instr
	blockSequence := instr.! !

!IRJumpOverBlock methodsFor: 'interpret' stamp: 'md 10/20/2004 20:44'!
executeOn: interpreter
	^ interpreter jumpOverBlock:  blockSequence orderNumber to: destination orderNumber! !

!IRJumpOverBlock methodsFor: 'testing' stamp: 'md 10/8/2004 15:19'!
isJumpOverBlock
	^true.! !

!IRJumpOverBlock methodsFor: 'interpret' stamp: 'JorgeRessia 12/25/2009 22:55'!
isSimpleJump
	"goto or if"

	^ false! !

!IRJumpOverBlock methodsFor: 'accessing' stamp: 'md 10/8/2004 15:18'!
successorSequences

	^ {destination. blockSequence} ! !

IRInstruction subclass: #IRPop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRPop commentStamp: 'ajh 3/24/2003 23:57' prior: 0!
Instruction "popTop"!

!IRPop methodsFor: 'interpret' stamp: 'ajh 3/10/2003 00:47'!
executeOn: interpreter

	^ interpreter popTop! !

!IRPop methodsFor: 'testing' stamp: 'ms 7/10/2007 14:12'!
isPop
	^true! !

IRInstruction subclass: #IRPushClosureCopy
	instanceVariableNames: 'numCopiedValues numArgs jumpSize blockSequence destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRPushClosureCopy class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/2/2009 15:59'!
numCopiedValues: aNumCopieValues numArgs: numberOfArguments 
	
	^self new initializeNumCopiedValues: aNumCopieValues numArgs: numberOfArguments  ! !

!IRPushClosureCopy class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/1/2009 15:12'!
numCopiedValues: aNumCopieValues numArgs: numberOfArguments jumpSize: aJumpSize 
	
	^self new initializeNumCopiedValues: aNumCopieValues numArgs: numberOfArguments jumpSize: aJumpSize ! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jorgeRessia 10/2/2009 16:02'!
blockSequence: anIRSequence 
	
	blockSequence := anIRSequence! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jorgeRessia 10/11/2009 20:45'!
destination
	^destination ! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'TestRunner 1/3/2010 10:00'!
destination: anIRSequence 
	destination := anIRSequence! !

!IRPushClosureCopy methodsFor: 'initializing' stamp: 'jorgeRessia 11/4/2009 11:05'!
executeOn: interpreter
	
	^interpreter pushClosureCopyNumCopiedValues: numCopiedValues numArgs: numArgs jumpSize: (self jumpSize)! !

!IRPushClosureCopy methodsFor: 'testing' stamp: 'jorgeRessia 11/9/2009 13:59'!
hasInlinedClosures
	^( destination orderNumber - sequence orderNumber ) > 2! !

!IRPushClosureCopy methodsFor: 'initializing' stamp: 'jorgeRessia 10/2/2009 16:01'!
initializeNumCopiedValues: aNumCopiedValues numArgs: numberOfArguments 
		
	numCopiedValues := aNumCopiedValues.
	numArgs := numberOfArguments.
	! !

!IRPushClosureCopy methodsFor: 'initializing' stamp: 'jorgeRessia 10/1/2009 15:14'!
initializeNumCopiedValues: aNumCopiedValues numArgs: numberOfArguments jumpSize: aJumpSize 
	
	numCopiedValues := aNumCopiedValues.
	numArgs := numberOfArguments.
	jumpSize := aJumpSize! !

!IRPushClosureCopy methodsFor: 'testing' stamp: 'JorgeRessia 12/25/2009 20:44'!
isPushClosureCopy
	^true! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jorgeRessia 10/1/2009 16:34'!
jumpSize
	^jumpSize! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jorgeRessia 10/1/2009 16:31'!
numArgs
	^numArgs! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jorgeRessia 10/1/2009 16:31'!
numCopiedValues
	^numCopiedValues! !

!IRPushClosureCopy methodsFor: 'accessing' stamp: 'jorgeRessia 10/11/2009 21:43'!
size

	^4! !

IRInstruction subclass: #IRPushConsArray
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRPushConsArray class methodsFor: 'as yet unclassified' stamp: 'jb 3/25/2010 14:29'!
sized: aSize

	^self new initializeSized: aSize! !

!IRPushConsArray methodsFor: 'accessing' stamp: 'jb 3/25/2010 14:26'!
executeOn: interpreter
	^interpreter pushConsArray: size! !

!IRPushConsArray methodsFor: 'accessing' stamp: 'jb 3/25/2010 14:26'!
initializeSized: aSmallInteger 
	size := aSmallInteger! !

!IRPushConsArray methodsFor: 'accessing' stamp: 'jb 3/25/2010 14:26'!
isPushConsArray
	^true! !

!IRPushConsArray methodsFor: 'accessing' stamp: 'jb 3/25/2010 14:26'!
size

	^2! !

IRInstruction subclass: #IRPushNewArray
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRPushNewArray class methodsFor: 'as yet unclassified' stamp: 'jorgeRessia 10/11/2009 11:23'!
sized: aSize

	^self new initializeSized: aSize! !

!IRPushNewArray methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 11:25'!
executeOn: interpreter
	^interpreter pushNewArray: size! !

!IRPushNewArray methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 11:24'!
initializeSized: aSmallInteger 
	size := aSmallInteger! !

!IRPushNewArray methodsFor: 'testing' stamp: 'jorgeRessia 11/2/2009 16:00'!
isPushNewArray
	^true! !

!IRPushNewArray methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 21:42'!
size

	^2! !

IRInstruction subclass: #IRPushRemoteTemp
	instanceVariableNames: 'remoteTempIndex tempVectorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRPushRemoteTemp class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/11/2009 17:31'!
at: remoteTempIndex in: tempVectorIndex 
	^self new initializeAt: remoteTempIndex in: tempVectorIndex ! !

!IRPushRemoteTemp methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 17:33'!
executeOn: interpreter
	^interpreter pushRemoteTemp: remoteTempIndex inVectorAt: tempVectorIndex
! !

!IRPushRemoteTemp methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 17:32'!
initializeAt: aRemoteTempIndex in: aTempVectorIndex 
	remoteTempIndex := aRemoteTempIndex.
	tempVectorIndex := aTempVectorIndex! !

!IRPushRemoteTemp methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 21:42'!
size

	^3! !

IRInstruction subclass: #IRReturn
	instanceVariableNames: 'isRemote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRReturn commentStamp: 'ajh 3/24/2003 23:57' prior: 0!
Instruction "returnTop" or "remoteReturn"!

IRReturn subclass: #IRBlockReturnTop
	instanceVariableNames: 'successor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRBlockReturnTop methodsFor: 'interpret' stamp: 'md 10/8/2004 16:04'!
executeOn: interpreter
	interpreter blockReturnTop.! !

!IRBlockReturnTop methodsFor: 'testing' stamp: 'md 10/8/2004 16:04'!
isBlockReturnTop

	^true.! !

!IRBlockReturnTop methodsFor: 'testing' stamp: 'md 10/21/2004 18:38'!
isRemote
	^false.! !

!IRBlockReturnTop methodsFor: 'accessing' stamp: 'md 10/8/2004 16:04'!
successor: anObject

	successor := anObject. ! !

!IRBlockReturnTop methodsFor: 'accessing' stamp: 'md 10/8/2004 16:04'!
successorSequences
	"sent to last instruction in sequence which is expected to be a jump and return instruction"

	^  { successor }! !

!IRReturn methodsFor: 'interpret' stamp: 'ajh 3/10/2003 00:48'!
executeOn: interpreter

	^ isRemote
		ifTrue: [interpreter remoteReturn]
		ifFalse: [interpreter returnTop]! !

!IRReturn methodsFor: 'accessing' stamp: 'ajh 3/10/2003 00:44'!
isRemote

	^ isRemote! !

!IRReturn methodsFor: 'accessing' stamp: 'ms 6/17/2007 00:32'!
isRemote: boolean

	isRemote := boolean! !

!IRReturn methodsFor: 'testing' stamp: 'ajh 3/10/2003 16:10'!
isReturn

	^ true! !

IRInstruction subclass: #IRSend
	instanceVariableNames: 'selector superOf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRSend commentStamp: 'ajh 3/24/2003 23:57' prior: 0!
Instruction "send: selector" or "send: selector toSuperOf: behavior"!

!IRSend methodsFor: 'interpret' stamp: 'TestRunner 1/6/2010 10:26'!
executeOn: interpreter
	^ superOf
		ifNil: [interpreter send: selector]
		ifNotNil: [interpreter send: selector toSuperOf: superOf]! !

!IRSend methodsFor: 'testing' stamp: 'md 11/12/2004 15:56'!
isMessageSend
	^true.! !

!IRSend methodsFor: 'testing' stamp: 'md 11/12/2004 15:57'!
isSend
	^true.! !

!IRSend methodsFor: 'testing' stamp: 'md 10/10/2005 17:37'!
isSuperSend
    ^superOf notNil! !

!IRSend methodsFor: 'accessing' stamp: 'md 6/23/2005 13:45'!
selector
	^selector! !

!IRSend methodsFor: 'accessing' stamp: 'ajh 3/10/2003 00:44'!
selector: symbol

	selector := symbol! !

!IRSend methodsFor: 'accessing' stamp: 'md 6/23/2005 13:49'!
senderselector
	^self method selector! !

!IRSend methodsFor: 'interpret' stamp: 'JorgeRessia 1/6/2010 11:19'!
size
	sourceNode isMessage ifFalse: [^1].
	(sourceNode arguments size > 2)
		ifTrue: [^2]
		ifFalse: [^1]! !

!IRSend methodsFor: 'accessing' stamp: 'ajh 3/10/2003 00:45'!
superOf

	^ superOf! !

!IRSend methodsFor: 'accessing' stamp: 'ajh 3/10/2003 00:45'!
superOf: behavior

	superOf := behavior! !

IRInstruction subclass: #IRStorePopRemoteTemp
	instanceVariableNames: 'tempIndex tempVectorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRStorePopRemoteTemp class methodsFor: 'instance creation' stamp: 'jorgeRessia 10/11/2009 16:43'!
at: tempIndex in: tempVectorIndex 
	^self new initializeAt: tempIndex in: tempVectorIndex ! !

!IRStorePopRemoteTemp methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 16:48'!
executeOn: interpreter
	^interpreter storePopRemoteTemp: tempIndex inVectorAt: tempVectorIndex! !

!IRStorePopRemoteTemp methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 16:44'!
initializeAt: aTempIndex in: aTempVectorIndex 
	tempIndex := aTempIndex.
	tempVectorIndex := aTempVectorIndex! !

!IRStorePopRemoteTemp methodsFor: 'testing' stamp: 'jorgeRessia 10/12/2009 11:07'!
isStorePopRemoteTemp
	^true! !

!IRStorePopRemoteTemp methodsFor: 'initializing' stamp: 'jorgeRessia 10/11/2009 21:41'!
size
	^3! !

!IRStorePopRemoteTemp methodsFor: 'accessing' stamp: 'jorgeRessia 10/12/2009 11:09'!
tempIndex
	^tempIndex! !

!IRStorePopRemoteTemp methodsFor: 'accessing' stamp: 'jorgeRessia 10/12/2009 11:09'!
tempVectorIndex
	^tempVectorIndex! !

IRInstruction subclass: #IRStoreRemoteTemp
	instanceVariableNames: 'tempIndex tempVectorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-IR'!

!IRStoreRemoteTemp class methodsFor: 'as yet unclassified' stamp: 'jorgeRessia 10/12/2009 11:15'!
at: tempIndex in: tempVectorIndex 
	^self new initializeAt: tempIndex in: tempVectorIndex ! !

!IRStoreRemoteTemp methodsFor: 'accessing' stamp: 'jorgeRessia 10/12/2009 11:23'!
executeOn: interpreter
	^interpreter storeRemoteTemp: tempIndex inVectorAt: tempVectorIndex! !

!IRStoreRemoteTemp methodsFor: 'accessing' stamp: 'jorgeRessia 10/12/2009 11:15'!
initializeAt: aTempIndex in: aTempVectorIndex 
	tempIndex := aTempIndex.
	tempVectorIndex := aTempVectorIndex! !

!IRStoreRemoteTemp methodsFor: 'accessing' stamp: 'jorgeRessia 10/12/2009 11:15'!
size
	^3! !

!RBSequenceNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	self temporaries 
			ifEmpty: [self statements 
							ifEmpty:[^nil] 
							ifNotEmpty:[| stat | 
				     					stat := OrderedCollection newFrom: self statements.
					 					[stat first firstToken = nil] 
												whileTrue: [stat removeFirst.
															stat ifEmpty:[^nil]].
										^stat first firstToken]]
			ifNotEmpty: [^self temporaries first firstToken]! !

!RBSequenceNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	self statements 
		ifEmpty:[self temporaries 
						ifEmpty:[^nil]
						ifNotEmpty:[^self temporaries last lastToken]] 
		ifNotEmpty:[ | stat | 
				      stat := OrderedCollection newFrom: self statements.
					 [stat last lastToken = nil] 
							whileTrue: [stat removeLast.
										stat ifEmpty:[self temporaries 
														ifEmpty:[^nil]
														ifNotEmpty:[^self temporaries last lastToken]]].
					^stat last lastToken]! !

!RBSequenceNode methodsFor: '*newcompiler-decorating' stamp: 'md 4/4/2007 17:37'!
peekAfterComment

	"| tokenStream token countNewLine |"
	self afterComment ifNil:[
		"countNewLine := 0."
		self afterComment: OrderedCollection new.
		"tokenStream := (SqueakTokenStream forwardOn: self lastToken) selectCommentNewLine.
		[token := tokenStream next.
		 token isNewLine ifTrue: [countNewLine := countNewLine + 1.]. 
		 tokenStream atEnd] 
				whileFalse: [countNewLine = 1 ifTrue: [token isComment ifTrue:[afterComment add: token eatToken]]].
		afterComment do: [:each | self comments add: (each start to: each stop)]"
	].
	^self afterComment! !

Notification subclass: #SemanticWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!SemanticWarning commentStamp: 'ajh 7/7/2004 17:36' prior: 0!
If a variable is not found or some other problem occurs during checking (ASTChecker) than a particular subclass instance of me is signal, usually causing a notification to the user. If not handled, the default handling is done, and compiling continues.!

!SemanticWarning methodsFor: 'as yet unclassified' stamp: 'ajh 3/12/2003 14:28'!
correctIn: compiler

	self subclassResponsibility! !

!SemanticWarning methodsFor: 'testing' stamp: 'ajh 3/11/2003 14:54'!
isResumable

	^ true! !

SemanticWarning subclass: #ShadowVariableWarning
	instanceVariableNames: 'variableNode shadowedVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ShadowVariableWarning commentStamp: 'ajh 3/24/2003 22:21' prior: 0!
I get signalled when a variable in a block or method scope shadows a variable of the same name in an outer scope.  The default action is to allow it.!

!ShadowVariableWarning methodsFor: 'as yet unclassified' stamp: 'ajh 3/19/2003 16:42'!
correctIn: compiler

	self resume: (compiler variable: self variableNode shadows: self shadowedVar)! !

!ShadowVariableWarning methodsFor: 'defaults' stamp: 'ajh 3/19/2003 13:34'!
defaultAction
	"allow variable to shadow previous/inst var of the same name"

	^ nil! !

!ShadowVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/19/2003 13:32'!
shadowedVar

	^ shadowedVar! !

!ShadowVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/19/2003 13:32'!
shadowedVar: semVar

	shadowedVar := semVar! !

!ShadowVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/19/2003 13:19'!
variableNode

	^ variableNode! !

!ShadowVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/19/2003 13:24'!
variableNode: aVariableNode

	variableNode := aVariableNode.
	messageText := 'Temp shadows: ', aVariableNode name.
! !

SemanticWarning subclass: #UndeclaredSelectorWarning
	instanceVariableNames: 'messageNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!UndeclaredSelectorWarning commentStamp: 'ajh 3/24/2003 22:23' prior: 0!
I get signalled when no selector is defined for a message send, indicating a possible mispelling.  My default action is to create a new selector.!

!UndeclaredSelectorWarning methodsFor: 'as yet unclassified' stamp: 'ajh 3/12/2003 14:28'!
correctIn: compiler

	self resume: (compiler correctSelector: self messageNode)! !

!UndeclaredSelectorWarning methodsFor: 'defaults' stamp: 'md 4/14/2007 00:37'!
defaultAction
	"create new selector"

	^ messageNode selector! !

!UndeclaredSelectorWarning methodsFor: 'accessing' stamp: 'ajh 3/11/2003 22:43'!
messageNode

	^ messageNode! !

!UndeclaredSelectorWarning methodsFor: 'accessing' stamp: 'md 4/14/2007 00:37'!
messageNode: aMessageNode

	messageNode := aMessageNode.
	messageText := 'Unknown selector: ', aMessageNode selector.
! !

SemanticWarning subclass: #UndeclaredVariableWarning2
	instanceVariableNames: 'variableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!UndeclaredVariableWarning2 commentStamp: 'ajh 3/24/2003 22:33' prior: 0!
I get signalled when an unknown variable it references.  My default action is to raise an warning.!

!UndeclaredVariableWarning2 methodsFor: 'as yet unclassified' stamp: 'ajh 3/12/2003 14:28'!
correctIn: compiler

	self resume: (compiler correctVariable: self variableNode)! !

!UndeclaredVariableWarning2 methodsFor: 'accessing' stamp: 'ajh 3/11/2003 12:05'!
variableNode

	^ variableNode! !

!UndeclaredVariableWarning2 methodsFor: 'accessing' stamp: 'ajh 3/11/2003 23:37'!
variableNode: aVariableNode

	variableNode := aVariableNode.
	messageText := 'Undeclared variable: ', aVariableNode name.
! !

SemanticWarning subclass: #UninitializedVariableWarning
	instanceVariableNames: 'variableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!UninitializedVariableWarning commentStamp: 'ajh 3/24/2003 22:34' prior: 0!
I get signalled when a temporary variable is used before it is assigned to.  My default action is to allow it since all temps get initialized to nil.!

!UninitializedVariableWarning methodsFor: 'as yet unclassified' stamp: 'ajh 3/12/2003 14:28'!
correctIn: compiler

	self resume: (compiler queryUninitializedTemp: self variableNode)! !

!UninitializedVariableWarning methodsFor: 'defaults' stamp: 'ajh 3/12/2003 13:37'!
defaultAction
	"unitialized temp will be initialized to nil, so ignore this warning if not handled"

	^ nil! !

!UninitializedVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/12/2003 13:25'!
variableNode

	^ variableNode! !

!UninitializedVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/12/2003 14:08'!
variableNode: aVariableNode

	variableNode := aVariableNode.
	messageText := 'Uninitialized temp: ', aVariableNode name.
! !

SemanticWarning subclass: #UnusedVariableWarning
	instanceVariableNames: 'variableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!UnusedVariableWarning commentStamp: 'ajh 3/24/2003 22:35' prior: 0!
I get signalled when a temporary variable is declared but never used.  My default action is to allow it since it is benign.!

!UnusedVariableWarning methodsFor: 'as yet unclassified' stamp: 'ajh 3/12/2003 14:28'!
correctIn: compiler

	self resume: (compiler removeUnusedTemp: self variableNode)! !

!UnusedVariableWarning methodsFor: 'defaults' stamp: 'ajh 3/12/2003 14:07'!
defaultAction
	"unused temp will be ignored, so ignore this warning if not handled"

	^ nil! !

!UnusedVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/12/2003 14:06'!
variableNode

	^ variableNode! !

!UnusedVariableWarning methodsFor: 'accessing' stamp: 'ajh 3/12/2003 14:07'!
variableNode: aVariableNode

	variableNode := aVariableNode.
	messageText := 'Unused temp: ', aVariableNode name.
! !

Set subclass: #LiteralSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Bytecodes'!

!LiteralSet commentStamp: 'ajh 3/25/2003 00:33' prior: 0!
Holds a unique set of literals.  Literal objects are equal if they are #= plus they are the same class.  This set uses this rule for finding elements.

Example:
	Set new add: 'anthony'; add: #anthony; size  "= 1"
	LiteralSet new add: 'anthony'; add: #anthony; size  "= 2"
!

!LiteralSet methodsFor: 'adding' stamp: 'ajh 12/9/2001 16:03'!
add: newObject
	"Include newObject as one of the receiver's elements.  If equivalent is already present don't add and return equivalent object"

	| index |
	newObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	^ (array at: index) 
		ifNil: [self atNewIndex: index put: newObject. newObject]
		ifNotNil: [array at: index]! !

!LiteralSet methodsFor: 'private' stamp: 'ajh 2/2/2002 19:16'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| element start finish |
	start := (anObject hash \\ array size) + 1.
	finish := array size.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil
					or: [element literalEqual: anObject])
					ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil
					or: [element literalEqual: anObject])
					ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

RBVariableNode subclass: #RBRemoteVectorNode
	instanceVariableNames: 'remoteTemps readNode writeNode scope index rootNode name varNodeData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Extras'!

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'jorgeRessia 11/15/2009 00:14'!
addRemoteTemp: aTempVariableNode 
	remoteTemps isNil ifTrue:
		[remoteTemps := OrderedCollection new].
	remoteTemps addLast: aTempVariableNode.
	aTempVariableNode referenceScopesAndIndicesDo:
		[:scopeBlock "<BlockNode>" :location "<Integer>"|
		 self addReadWithin: scopeBlock at: location].
	self flag: 'this code should never be executed'.
	"encoder supportsClosureOpcodes ifFalse:
		[encoder encodeLiteral: remoteTemps size.
		 readNode := encoder encodeSelector: #at:.
		 writeNode := encoder encodeSelector: #at:put:]"
	self updateDefiningScopeWith: aTempVariableNode.! !

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'jorgeRessia 11/10/2009 11:46'!
generateIRIn: aMethodBuilder 
	self flag: 'why is this?'.
	aMethodBuilder pushRemoteTemp: index.! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/27/2009 15:29'!
generateIRIn: aMethodBuilder in: aScope 
	 
	aMethodBuilder pushRemoteTemp: (aScope scopeIndexedVarFor: self name) index! !

!RBRemoteVectorNode methodsFor: 'testing' stamp: 'jorgeRessia 11/13/2009 21:12'!
includes: aTempVar 
	^remoteTemps anySatisfy: [:eachTemp | eachTemp name = aTempVar name]! !

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'jorgeRessia 10/9/2009 16:44'!
index
	^index! !

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'jorgeRessia 10/11/2009 10:34'!
index: anInteger
	index := anInteger! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 16:36'!
indexOf: aRBVariableNode 
	^(remoteTemps indexOf: aRBVariableNode) - 1! !

!RBRemoteVectorNode methodsFor: 'testing' stamp: 'JorgeRessia 12/30/2009 21:10'!
isCaptured
	^false! !

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'jorgeRessia 10/11/2009 09:53'!
isIndirectTempVector

	^true! !

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'jorgeRessia 10/11/2009 19:31'!
isRemote
	^true! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:37'!
name
	^name! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'TestRunner 12/26/2009 09:31'!
name: aString 
	name := aString! !

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'jorgeRessia 11/22/2009 10:47'!
name: varName index: i scope: level
	index := i.
	scope := level. 
	name := varName ! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 10:07'!
nodeToInitialize
	self flag: 'Again the code asking if we support the Closure opcodes'.
	^RBAssignmentNode
		variable: self
		value: (Preferences supportsClosureOpcodes
					ifTrue: [RBNewArrayNode new numElements: remoteTemps size])
					"ifFalse:
						[MessageNode new
							receiver: (encoder encodeVariable: 'Array')
							selector: #new:
							arguments: (Array with: (encoder encodeLiteral: remoteTemps size))
							precedence: 3
							from: encoder])"! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'TestRunner 12/27/2009 17:31'!
owningScope

	^remoteTemps first owningScope! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 19:35'!
remoteNode
	^self! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 11:19'!
remoteTemps
	^remoteTemps! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 10:52'!
rootNode
	^rootNode! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 10:51'!
rootNode: aRBMethodNode 
	rootNode := aRBMethodNode! !

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'jorgeRessia 10/11/2009 10:28'!
token

	^remoteTemps first token! !

!RBRemoteVectorNode methodsFor: 'accessing' stamp: 'JorgeRessia 12/20/2009 18:36'!
updateDefiningScopeWith: aTempVariableNode
	|parentScope definingScope | 
	definingScope := self definingScope.
	definingScope isNil ifTrue: [^self definingScope: aTempVariableNode definingScope].
	definingScope isMethod ifTrue: [^definingScope].
	parentScope := definingScope.
	[parentScope isMethod] whileFalse: [(parentScope == aTempVariableNode definingScope) ifTrue: [^definingScope].
											parentScope := parentScope parent].
	self definingScope: aTempVariableNode definingScope
! !

!RBRemoteVectorNode methodsFor: '*newcompiler' stamp: 'TestRunner 12/21/2009 16:00'!
varNodeData

	varNodeData isNil ifTrue: [varNodeData := VariableNodeData new].
	^varNodeData! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/10/2010 10:26'!
addReadWithin: scopeBlock "<BlockNode>" at: location "<Integer>"

	self varNodeData addReadWithin: scopeBlock at: location ! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/10/2010 10:26'!
addWriteWithin: scopeBlock "<BlockNode>" at: location "<Integer>"

	self varNodeData addWriteWithin: scopeBlock "<BlockNode>" at: location "<Integer>"! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/3/2010 09:07'!
analyseClosure: rootNode "<MethodNode>"
	"Analyse whether the temporary needs to be made remote
	 or not, and answer whether it was made remote.
	 A temp cannot be local if it is written to remotely,
	 or if it is written to after it is closed-over.  An exception
	 is an inlined block argument that appears to be written
	 remotely but is actually local to a block."
	
	| latestWrite variableData|
	variableData := self varNodeData.
	self isBlockArg ifTrue: [^false].
	self flag: 'this is added since for the test testWhileWithTemp the index is detected as remote when it should not be one.'.
	"variableData definingScope isMethod not ifTrue: [^false]."
	variableData remoteNode isNil ifFalse: [^false]. "If already remote, don't remote a second time"
	latestWrite := 0.
	((variableData writingScopes notNil
	 and: [variableData writingScopes associations anySatisfy: [:assoc|
			[:blockScope :refs|
			refs do: [:write| latestWrite := write max: latestWrite].
			"A temp cannot be local if it is written to remotely."
			blockScope actualScope ~~ self definingScope actualScope]
				value: assoc key value: assoc value]])
	or: [variableData readingScopes notNil
		and: [variableData readingScopes associations anySatisfy: [:assoc|
				[:blockScope :refs|
	
				"A temp cannot be local if it is written to after it is closed-over."
				 blockScope actualScope ~~ self definingScope actualScope
				 and: [refs anySatisfy: [:read| read < latestWrite]]]
					value: assoc key value: assoc value]]]) ifTrue:
		[  variableData remoteNode: (self definingScope addRemoteTemp: self rootNode: rootNode) .
		 ^true].
	^false! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/9/2009 14:52'!
analyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"
	^self addReadWithin: scopeBlock at: rootNode locationCounter! !

!RBVariableNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	^self token! !

!RBVariableNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	^self token! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'TestRunner 12/20/2009 18:44'!
beingAssignedToAnalyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"
	| variableData |
	variableData := self varNodeData.
	self addWriteWithin: scopeBlock at: rootNode locationCounter.
	"For analysis of optimized blocks also record the set of temporaries written to
	 within optimized blocks so that additional writes can be added at locations that
	 represent subsequent iterations of the loop. e.g. testInlineBlockCollectionSD1"
	assignmentPools keysAndValuesDo:
		[:outerScopeBlock :set|
		"definingScope can be nil in expr in expr ifNil: [:arg|...] expressions because
		 arg gets its definingScope set when [:arg|...] is analysed."
		outerScopeBlock actualScope
			= (self definingScope
				ifNil: [scopeBlock]
				ifNotNil: [self definingScope actualScope]) ifTrue:
			[set add: self]]! !

!RBVariableNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
binding

	^ self propertyAt: #binding ifAbsent: [nil].! !

!RBVariableNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
binding: aSemVar
	aSemVar ifNil: [^self removeProperty: #binding ifAbsent: []].
	self propertyAt: #binding put: aSemVar.! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 14:40'!
definingScope
	^ self propertyAt: #definingScope ifAbsent: [nil].
! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 18:31'!
definingScope: scopeBlock "<BlockNode>"
	^ self propertyAt: #definingScope put: scopeBlock.
! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/9/2009 16:24'!
generateIRIn: aMethodBuilder 
	self varNodeData remoteNode ~~ nil ifTrue:
		[^self varNodeData remoteNode generateIRIn: aMethodBuilder].
	self binding emitValue: aMethodBuilder from: self owningScope.
! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/13/2009 22:52'!
generateIRIn: aMethodBuilder in: aScope
	self varNodeData remoteNode ~~ nil ifTrue:
		[^self varNodeData remoteNode generateIRIn: aMethodBuilder in: aScope].
	self binding emitValue: aMethodBuilder from: self owningScope.
! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/25/2009 11:18'!
index
	^(self owningScope lookupVar: self name ) index! !

!RBVariableNode methodsFor: '*newcompiler-testing' stamp: 'jorgeRessia 11/20/2009 16:40'!
isArg

	^self binding isArg! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 14:43'!
isBlockArg
	^self varNodeData isBlockArg! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 15:26'!
isDefinedWithinBlockExtent: anInterval
	^anInterval rangeIncludes: self definingScope actualScope blockExtent first! !

!RBVariableNode methodsFor: '*newcompiler-testing' stamp: 'jorgeRessia 11/20/2009 16:40'!
isGlobal
	^self binding isGlobal! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/8/2009 15:43'!
isIndirectTempVector

	^false! !

!RBVariableNode methodsFor: '*newcompiler-testing' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInstance
	^self binding isInstance! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/9/2009 14:53'!
isReferencedWithinBlockExtent: anInterval 
	^self varNodeData isReferencedWithinBlockExtent: anInterval ! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/9/2009 16:13'!
isRemote
	^self varNodeData remoteNode notNil! !

!RBVariableNode methodsFor: '*newcompiler-testing' stamp: 'jorgeRessia 11/20/2009 16:40'!
isTemp
	^self binding isTemp! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 10:47'!
key

	^(self rootNode scope tempVars detect: [:var | var name == self name] )! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'ms 5/28/2007 13:47'!
peekBeforeComment
	| tokenStream tok countNewLine |
	self parent isMethod 
		ifFalse: [^ super peekBeforeComment]
		ifTrue: 
			[self beforeComment ifNil: 
					[self beforeComment: OrderedCollection new.
					tokenStream := SqueakTokenStream backwardOn: self firstToken previous.
					countNewLine:= 0.
					[tokenStream atEnd 
						ifFalse: [
							tok := tokenStream next.
							
							tok isNewLine ifTrue: [countNewLine := countNewLine + 1].
							(countNewLine > 0 and: [tok value = '|']) or: [tok isSignificant]]
						ifTrue:[true]] 
							whileFalse: [tok isComment ifTrue: [self beforeComment add: tok eatToken]].
					self beforeComment do: [:each | self comments add: (each start to: each stop)]].
			^ self beforeComment]! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 09:47'!
referenceScopesAndIndicesDo: aBinaryBlock
	self varNodeData referenceScopesAndIndicesDo: aBinaryBlock
	! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/11/2009 16:09'!
remoteNode
	^self varNodeData remoteNode! !

!RBVariableNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/21/2009 15:54'!
varNodeData
	^ self propertyAt: #varNodeData ifAbsentPut: [ VariableNodeData for: self].
! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:02'!
actualScope
	"Answer the actual scope for the receiver.  If this is an unoptimized block then it is its
	 actual scope, but if this is an optimized block then the actual scope is some outer block."
	^self actualScopeIfOptimized ifNil: [self]! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:31'!
actualScopeIfOptimized
	^self propertyAt: #actualScopeIfOptimized ifAbsent: [nil]! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/4/2009 14:06'!
actualScopeIfOptimized: aScope
	^self propertyAt: #actualScopeIfOptimized put: aScope! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/1/2010 12:46'!
addHoistedTemps: additionalTemporaries "<SequenceableCollection>"
	additionalTemporaries do:
		[:temp|
		temp definingScope ifNil:
			[temp definingScope: self]].
	body temporaries: ((body temporaries isNil or: [body temporaries isEmpty])
					ifTrue: [additionalTemporaries copy]
					ifFalse:
						[body temporaries last isIndirectTempVector
							ifTrue: [body temporaries allButLast, additionalTemporaries, { body temporaries last }]
							ifFalse: [body temporaries, additionalTemporaries]])! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'TestRunner 1/3/2010 09:14'!
addRemoteTemp: aTempVariableNode rootNode: rootNode "<MethodNode>" 
	"Add aTempVariableNode to my actualScope's sequence of
	 remote temps.  If I am an optimized block then the actual
	 scope is my actualScopeIfOptimized, otherwise it is myself."
	body temporaries isArray ifTrue:
		[body temporaries: body temporaries asOrderedCollection].
	self flag: 'here if the remoteTempNode is nil then this is another temp that has to be indexed inside the temp array'.
	self remoteTempNode isNil 
		ifTrue: [self remoteTempNode: (RBRemoteVectorNode new
								name: self remoteTempNodeName
								index: arguments size + body temporaries size
								scope: 0).
		self remoteTempNode rootNode: self.
		self actualScopeIfOptimized
			ifNil:
				[body temporaries addLast: self remoteTempNode.
				 "remoteTempNode definingScope: self"]
			ifNotNil: [
						self actualScopeIfOptimized addHoistedTemps: { self remoteTempNode }.
						"self actualScopeIfOptimized remoteTempNode: self remoteTempNode"]].
	self remoteTempNode addRemoteTemp: aTempVariableNode.
	"use remove:ifAbsent: because the deferred analysis for optimized
	 loops can result in the temp has already been hoised into the root."
	body temporaries remove: aTempVariableNode ifAbsent: [].
	^self remoteTempNode! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:13'!
analyseArguments: methodArguments temporaries: methodTemporaries rootNode: rootNode "<MethodNode>" "^<Sequence of: <TempVarNade>>"
	"Top level entry-point for analysing temps within the hierarchy of blocks in the receiver's method.
	 Answer the (possibly modified) sequence of temp vars.
	 Need to hoist temps out of macro-optimized blocks into their actual blocks.
	 Need to note reads and writes to temps from blocks other than their actual blocks to determine
	 whether blocks can be local (simple slots within a block/method context) or remote (slots in
	 indirection vectors that are shared between contexts by sharing indirection vectors).

	 The algorithm is based on numbering temporary reads and writes and block extents.
	 The index used for numbering starts at zero and is incremented on every block entry
	 and block exit.  So the following
		| a b blk r1 r2 t |
		a := 1. b := 2. t := 0.
		blk := [ | s | s := a + b. t := t + s].
		r1 := blk value.
		b := -100.
		r2 := blk value.
		r1 -> r2 -> t
	is numbered as
		method block 0 to: 6:
		| a b blk r1 r2 t |
		a w@1 := 1. b w@1 := 2. t w@1 := 0.
		blk w@5 := [entry@2 | s |
					 t  w@3 := t r@3 + a r@3 + b r@3
					] exit@4.
		r1 w@5 := blk r@5 value.
		b w@5 := nil.
		r2 w@5 := blk r@5 value.
		r1 r@5 -> r2 r@5 -> t r@5
	So:
		b and blk cannot be copied because for both there exists a write @5 that follows a
			read @4 within block 2 through 4
		t must be remote because there exists a write @3 within block (2 to: 4)
	Complications are introduced by optimized blocks.  In the following temp is written to
	after it is closed over by [ temp ] since the inlined block is executed more than once.
		| temp coll |
		coll := OrderedCollection new.
		1 to: 5 do: [ :index | 
			temp := index. 
			coll add: [ temp ] ].
		self assert: (coll collect: [:ea| ea value]) asArray = #(5 5 5 5 5)
	In the following i is local to the block and must be initialized each time around the loop
	but if the block is inlined it must be declared at method level.
		| col |
		col := OrderedCollection new.
		1 to: 3 do: [ :each | | i | i := each. col add: [ i ]. i := i + 1 ].
		self assert: (col collect: [ :each | each value ]) asArray = #(2 3 4)"
	self assert: (arguments isEmpty or: [arguments hasEqualElements: methodArguments]).
	arguments := methodArguments asArray. "won't change"
	self assert: (self temporaries isNil or: [self temporaries isEmpty or: [self temporaries hasEqualElements: methodTemporaries]]).
	self temporaries: OrderedCollection withAll: methodTemporaries.

	self assert: self optimized not. "the top-level block should not be optimized."
	self analyseTempsWithin: self rootNode: rootNode assignmentPools: Dictionary new.

	"The top-level block needs to reindex temporaries since analysis may have rearranged them.
	 This happens when temps are made remote and/or a remote node is added."
	self temporaries withIndexDo:
		[:temp :offsetPlusOne| temp index: arguments size + offsetPlusOne - 1].

	"Answer the (possibly modified) sequence of temps."
	^self temporaries asArray! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/10/2010 10:25'!
analyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"
	| effectiveScope blockStart optimized|
	
	"ASSUMING no optimizatin for now"
	
	self flag: 'This optimization evaluation is added here temporarly in order to behave in the same way as the old compiler.
				this must be fused with the message optimized and tested.'.
	"optimized :=  (self parent isMessage and: [self parent isOptimized])."
	optimized := self isInlined.
	effectiveScope := optimized
						ifTrue: [self actualScopeIfOptimized: scopeBlock]
						ifFalse: [self].

	optimized ifFalse: "if optimized this isn't an actual scope"
		[rootNode noteBlockEntry:
			[:entryNumber|
			 self blockExtent: ( (blockStart := entryNumber) to: 0 )]].

	"Need to enumerate a copy because closure analysis can add a statement
	 via ifHasRemoteTempNodeEnsureInitializationStatementExists:."
	body statements copy do:
		[:statement|
		 statement analyseTempsWithin: effectiveScope rootNode: rootNode assignmentPools: assignmentPools].

	optimized ifFalse: "if optimized this isn't an actual scope"
		[rootNode noteBlockExit:
			[:exitNumber|
			 self blockExtent: ( blockStart to: exitNumber )]].

	"Now that the analysis is done move any temps that need to be moved."
	self postNumberingProcessTempsWithin: effectiveScope rootNode: rootNode.

	"This is simply a nicety for compiler developers..."
	body temporaries do:
		[:temp| 
		(temp isIndirectTempVector and: [temp name includes: $?]) ifTrue:
			[temp name: temp definingScope remoteTempNodeName]].! !

!RBBlockNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	self arguments ifEmpty: [^self body firstToken] ifNotEmpty: [^self arguments first firstToken]! !

!RBBlockNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	^self body lastToken ifNil:[ self arguments ifEmpty:[^nil] ifNotEmpty:[^self arguments last firstToken]]! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/27/2009 19:10'!
basicOptimized

	^self propertyAt: #optimized ifAbsent: [false].! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/27/2009 19:26'!
becomeOptimized
	self optimized: true! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:04'!
blockExtent "^<Interval>"
	^self propertyAt: #blockExtent ifAbsent: [nil]! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:28'!
blockExtent: anInterval
	^self propertyAt: #blockExtent put: anInterval! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'ajh 6/28/2004 13:52'!
compiledMethod

	^ self ir compiledMethod! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'TestRunner 12/30/2009 23:16'!
computeCopiedValues: rootNode
	| referencedValues | 
	referencedValues := rootNode referencedValuesWithinBlockExtent: self blockExtent.
	^((referencedValues reject: [:temp| temp isDefinedWithinBlockExtent: self blockExtent])
		asSortedCollection: RBTemporariesSortStrategy tempSortBlock)
			asArray! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 18:59'!
constructClosureCreationNode
	self copiedValues: (self computeCopiedValues: self rootNode).
	Preferences compileBlocksAsClosures ifTrue:
		[^self closureCreationNode].
	"Without the bytecode we can still get by."
	"^MessageNode new
		receiver: (encoder encodeVariable: 'thisContext')
		selector: #closureCopy:copiedValues:
		arguments: (Array
						with: (encoder encodeLiteral: arguments size)
						with: (copiedValues isEmpty
								ifTrue: [NodeNil]
								ifFalse: [BraceNode new elements: copiedValues]))
		precedence: 3
		from: encoder"! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/22/2009 10:07'!
constructClosureCreationNode: rootNode

	self copiedValues: self computeCopiedValues: rootNode.
	Preferences compileBlocksAsClosures ifTrue:
		[^self closureCreationNode].
	"Without the bytecode we can still get by."
	"^MessageNode new
		receiver: (encoder encodeVariable: 'thisContext')
		selector: #closureCopy:copiedValues:
		arguments: (Array
						with: (encoder encodeLiteral: arguments size)
						with: (copiedValues isEmpty
								ifTrue: [NodeNil]
								ifFalse: [BraceNode new elements: copiedValues]))
		precedence: 3
		from: encoder"! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/5/2010 11:00'!
copiedValues
	^ self propertyAt: #copiedValues ifAbsentPut: [self computeCopiedValues: self rootNode].! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 19:02'!
copiedValues: aCollection
	^ self propertyAt: #copiedValues put: aCollection.! !

!RBBlockNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
freeNames
	"Filter out hidden ones that have space in there name such as 'top env'"

	^ ((self freeVars collect: [:var | var name])
		reject: [:name | name includes: $ ]) asSortedCollection! !

!RBBlockNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
freeVars
	"Return children variable node bindings that refer to variables outside my scope (ignoring global vars)"

	| freeVars |
	freeVars := Set new.
	self scope: self owningScope.
	self nodesDo: [:node | | var |
		(node isVariable or: [node isReturn and: [node binding notNil]]) ifTrue: [
			var := node binding.
			(self scope hasOuter: var scope) ifTrue: [
				var isGlobal ifFalse: [
					freeVars add: var]]]].
	^ freeVars! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'md 2/21/2006 14:41'!
generate
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."

	^self generate: #(0 0 0 0)! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'ajh 3/10/2003 20:23'!
generate: trailer

	^ self generateIR compiledMethodWith: trailer! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'md 4/8/2007 17:45'!
generateIR
	| irm |
	
	irm := ASTTranslator new translateBlockNode: self; ir.
	self privIR: irm.
	^irm.! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'pmm 8/16/2006 21:34'!
generateWith: trailer using: aCompiledMethodClass

	^ self generateIR compiledMethodWith: trailer using: aCompiledMethodClass! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/25/2009 16:58'!
ifHasRemoteTempNodeEnsureInitializationStatementExists: rootNode
	"If a remoteTempNode has been added ensure a statement exists to initialize it."
	self remoteTempNode ~~ nil ifTrue:
		[(body statements notEmpty
		  and: [body statements first isAssignment
		  and: [body statements first variable isTemp
		  and: [body statements first variable isIndirectTempVector]]])
			ifTrue: "If this is a decompiled tree, or if a temporary has been added later in
					the analysis then there already is a temp vector initialization node."
				[(body statements first variable ~~ self remoteTempNode) ifTrue:
					[body statements first variable become: self remoteTempNode].
				 body statements first value numElements: self remoteTempNode remoteTemps size]
			ifFalse:
				[body statements addFirst: (self remoteTempNode nodeToInitialize)]].! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'md 4/8/2007 17:48'!
ir
	^ self propertyAt: #ir ifAbsent: [self generateIR].! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/20/2009 22:29'!
isChildOf: aNode
	|parentNode|
	aNode isMethod ifTrue: [^true].
	parentNode := self parent.
	[ parentNode isMethod ] 
				whileFalse: [ parentNode = aNode ifTrue: [^true].
								parentNode := parentNode parent ].
	^false
! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/25/2009 13:33'!
isInlined
	self flag: 'We have to comment this code because the isRBToken was removed'. 
	(parent isMessage and: [parent isInlineAndOr]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineIf]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineIfNil]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineToDo]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineWhile]) ifTrue: [^ true].
	(parent isMessage and: [parent parent isArray and: [parent parent parent isMessage and: [parent parent parent isInlineCase]]]) ifTrue: [^ true].
	(parent isMessage and: [parent isInlineCase]) ifTrue: [^ true].  "otherwise branch"
	^ false! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/15/2009 16:03'!
isInsideOptimizedBlock
	"Is is optimized when it is enclosed in an inlined while loop or an inlined to:do: message call"
	|parentNode|
	parentNode := self parent.
	[ parentNode isMethod ] 
				whileFalse: [ (parentNode isMessage and: [parentNode isOptimizedLoop]) ifTrue: [^true].
								parentNode := parentNode parent ].
	^false
! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'md 2/27/2006 18:13'!
methodNodeFormattedAndDecorated: decorate
	"Answer a method node made from pretty-printed (and colorized, if decorate is true) 
	 source text."

	^ self method methodNodeFormattedAndDecorated: decorate.! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/1/2010 11:15'!
optimized
	"Is is optimized when it is enclosed in an inlined while loop or an inlined to:do: message call"
	^(self parent isMessage and: [self parent isOptimized]).

! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:27'!
optimized: aBoolean

	self propertyAt: #optimized put: aBoolean.! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/11/2009 16:58'!
optimizedBlockHoistTempsInto: scopeBlock "<BlockNode>"
	"This is a No-op for all nodes except non-optimized BlockNodes."
	"Let's assume the special > 0 guard in MessageNode>>analyseTempsWithin:forValue:encoder: is correct.
	 Then we can simply hoist our temps up."
	self assert: (arguments isNil or: [arguments size <= 1]).
	(arguments notNil and: [arguments notEmpty]) ifTrue:
		[scopeBlock addHoistedTemps: arguments.].
	body temporaries notEmpty ifTrue:
		[scopeBlock addHoistedTemps: body temporaries.
		"body temporaries: #()"]! !

!RBBlockNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
owningBlock

	^ self! !

!RBBlockNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
owningScope

	^ self scope ifNil: ["inlined" ^ parent owningScope]! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/25/2009 16:59'!
postNumberingProcessTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>"
	"A temp can be local (and copied) if it is not written to after it is captured.
	 A temp cannot be local if it is written to remotely.
	 Need to enumerate a copy of the temporaries because any temps becoming remote
	 will be removed from temporaries in analyseClosure: (and a single remote temp node
	 will get added)"
	body temporaries copy do:
		[:each|
		each isIndirectTempVector ifFalse:
			[each analyseClosure: rootNode]].

	"If this is an optimized node we need to hoist temporaries up into the relevant block scope."
	self optimized ifTrue:
		[self optimizedBlockHoistTempsInto: scopeBlock].

	"Now we may have added a remoteTempNode.  So we need a statement to initialize it."
	"self ifHasRemoteTempNodeEnsureInitializationStatementExists: rootNode."

	"Now add all arguments and locals to the pool so that copiedValues can be computed during sizing."
	rootNode
		addLocalsToPool: arguments;
		addLocalsToPool: body temporaries! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'md 4/8/2007 17:49'!
privIR: irMethod

	irMethod ifNil: [^self removeProperty: #ir ifAbsent: []].
	self propertyAt: #ir put: irMethod.! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 11/24/2009 13:29'!
remoteTempNode
	^self propertyAt: #remoteTempNode ifAbsent: [nil]! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/25/2009 16:56'!
remoteTempNode: aRemoteTempNode
	^self propertyAt: #remoteTempNode put: aRemoteTempNode! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/25/2009 19:05'!
remoteTempNodeName 
	"Answer a useful name for a RemoteTempVectorNode in the receiver."
	| prefix scope extent |
	prefix := self actualScopeIfOptimized ifNil: ['<'] ifNotNil: [ '<...'].
	scope := self.
	[extent := self blockExtent.
	 extent == nil
	 and: [scope actualScope ~~ scope]] whileTrue:
		[scope := scope actualScope].
	^extent
		ifNil: [prefix, '?-?>']
		ifNotNil:
			[prefix, extent first printString, '-',
				(extent last isZero
					ifTrue: ['?']
					ifFalse: [extent last printString]), '>']! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/9/2009 11:33'!
rootNode
	|rootNode|
	rootNode := self parent.
	[ rootNode isMethod ] whileFalse: [ rootNode := rootNode parent].
	^rootNode! !

!RBBlockNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
scope

	^ self propertyAt: #scope ifAbsent: [nil].! !

!RBBlockNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
scope: aSemClosureScope

	aSemClosureScope ifNil: [^self removeProperty: #scope ifAbsent: []].
	self propertyAt: #scope put: aSemClosureScope.! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/3/2010 08:59'!
uniqueIdentifier
	^self propertyAt: #uniqueIdentifier ifAbsent: [nil]! !

!RBBlockNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/3/2010 09:00'!
uniqueIdentifier: anInteger
	^self propertyAt: #uniqueIdentifier put: anInteger! !

!RBMessageNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 12/30/2009 21:02'!
analyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"
	"Assignments within optimized loops are tricky.  Because a loop repeats a
	 write to a temporary in an optimized loop effectively occurs after the loop.
	 To handle this collect the set of temps assigned to in optimized loops and
	 add extra writes after traversing the optimized loop constituents."
	| writtenToTemps |
	self isOptimizedLoop ifTrue:
		[{ receiver }, arguments do:
			[:node|
			(node notNil and: [node isBlock and: [node optimized]]) ifTrue:
				[assignmentPools at: node put: Set new]]].
	"receiver is nil in cascades"
	receiver == nil ifFalse:
		[receiver analyseTempsWithin: scopeBlock rootNode: rootNode assignmentPools: assignmentPools].
	self arguments do:
		[:node|
		node == nil ifFalse: "last argument of optimized to:do: can be nil"
			[node analyseTempsWithin: scopeBlock rootNode: rootNode assignmentPools: assignmentPools]].
	"Add assignments representing subsequent iterations
	 and redo the closure analysis for the written-to temps."
	self isOptimizedLoop ifTrue:
		[writtenToTemps := Set new.
		 { receiver }, arguments do:
			[:node|
			(node notNil and: [node isBlock and: [node optimized]]) ifTrue:
				[ (assignmentPools removeKey: node) do:
					[:temp|
					temp isBlockArg ifFalse: "ignore added assignments to to:do: loop args"
						[writtenToTemps add: temp.
						 temp addWriteWithin: node at: rootNode locationCounter]]]].
		 writtenToTemps isEmpty ifFalse:
			[(writtenToTemps asSortedCollection: ParseNode tempSortBlock) do:
				[:each| each analyseClosure: rootNode].
			 (writtenToTemps collect: [:each| each definingScope]) do:
				[:blockNode|
				self flag: 'we could later use this for removing the code in RBBlockNode for detecting were the remote temp vector should be assigned'.
				"blockNode ifHasRemoteTempNodeEnsureInitializationStatementExists: rootNode"]]]! !

!RBMessageNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	^self receiver firstToken! !

!RBMessageNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	self arguments ifEmpty:[^self selectorParts last] ifNotEmpty: [^self arguments last lastToken]! !

!RBMessageNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
debugHighlightStart

	^ self selectorParts first start! !

!RBMessageNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
debugHighlightStop

	^ self stopWithoutParentheses! !

!RBMessageNode methodsFor: '*newcompiler' stamp: 'ms 8/8/2007 20:11'!
isClosureEnvironmentCreation

	^receiver value = ClosureEnvironment and: [self selector == #new:] and: [arguments first value >= 0]! !

!RBMessageNode methodsFor: '*newcompiler' stamp: 'ms 7/31/2007 00:44'!
isClosureEnvironmentRegistration

	^(receiver isVariable 
		and: [receiver binding isLocal]
		and: [receiver binding index = -1]
		and: [self selector == #privStoreIn:instVar:] 
		and: [arguments first binding index == -2]) 
		and: [arguments second value == 5]! !

!RBMessageNode methodsFor: '*newcompiler' stamp: 'ms 7/27/2007 20:55'!
isClosureRegistrationAndCreation

	^receiver isClosureEnvironmentCreation 
		and: [self selector == #privStoreIn:instVar:] 
		and: [arguments first binding index == -2] 
		and: [arguments second value == 5]! !

!RBMessageNode methodsFor: '*newcompiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInline

	self isInlineAndOr ifTrue: [^ true].
	self isInlineCase ifTrue: [^ true].
	self isInlineIf ifTrue: [^ true].
	self isInlineIfNil ifTrue: [^ true].
	self isInlineToDo ifTrue: [^ true].
	self isInlineWhile ifTrue: [^ true].
	^ false! !

!RBMessageNode methodsFor: '*newcompiler-inline' stamp: 'JorgeRessia 11/25/2009 13:33'!
isInlineAndOr
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(self selectorParts allSatisfy: [ :each | #(and: or:) includes: each value ]) 
		ifFalse: [^ false].
	(self arguments allSatisfy: [ :each | each isBlock ])  ifFalse: [^ false].
	(self arguments allSatisfy: [ :each | each arguments isEmpty ])
			ifFalse: [
				self notify: 'and: (or:) takes zero-arg block'.
				^ false ].
	^ true! !

!RBMessageNode methodsFor: '*newcompiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineCase

	self isCascaded ifTrue: [^ false].
	(#(caseOf: caseOf:otherwise:) includes: self selector) ifFalse: [^ false].
	self arguments size = 2 ifTrue: [  "otherwise block"
		self arguments last isBlock ifFalse: [^ false]].
	self arguments first isArray ifFalse: [^ false].
	self arguments first statements do: [:assoc |
		(assoc isMessage and: [assoc selector == #->]) ifFalse: [^ false].
		assoc receiver isBlock ifFalse: [^ false].
		assoc receiver arguments isEmpty ifFalse: [self notify: 'caseOf: takes zero-arg blocks'. ^ false].
		assoc arguments first isBlock ifFalse: [^ false].
		assoc arguments first arguments isEmpty ifFalse: [self notify: 'caseOf: takes zero-arg blocks'].
	].
	^ true! !

!RBMessageNode methodsFor: '*newcompiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineIf

	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifTrue: ifFalse: ifTrue:ifFalse: ifFalse:ifTrue:) includes: self selector) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	self arguments do: [:block |
		block arguments isEmpty ifFalse: [
			self notify: 'ifTrue:ifFalse: takes zero-arg blocks'.
			^ false
		]
	].
	^ true! !

!RBMessageNode methodsFor: '*newcompiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineIfNil

	| assertNone assertOneOrNone |
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(ifNil: ifNotNil: ifNil:ifNotNil: ifNotNil:ifNil: ifNotNilDo:) includes: self selector) ifFalse: [^ false].
	self arguments do: [:node | node isBlock ifFalse: [^ false]].
	assertNone := [:block | 
		block arguments isEmpty ifFalse: [self notify: 'ifNil: takes zero-arg block'. ^ false]
	].
	assertOneOrNone := [:block | 
		block arguments size > 1 ifTrue: [self notify: 'ifNotNil: takes zero- or one-arg block'. ^ false]
	].
	self selector caseOf: {
		[#ifNil:] 		 	-> [assertNone value: self arguments first].
		[#ifNil:ifNotNil:] 	-> [assertNone value: self arguments first. 
							   assertOneOrNone value: self arguments last].
		[#ifNotNil:] 		  	-> [assertOneOrNone value: self arguments first].
		[#ifNotNilDo:] 		  	-> [assertOneOrNone value: self arguments first].
		[#ifNotNil:ifNil:] 	-> [assertOneOrNone value: self arguments first. 
							   assertNone value: self arguments last]
	}.
	^ true! !

!RBMessageNode methodsFor: '*newcompiler-inline' stamp: 'JorgeRessia 11/25/2009 13:20'!
isInlineToDo

	| block step |
	self receiver isBlock ifTrue: [^ false].
	self isCascaded ifTrue: [^ false].
	(#(to:do: to:by:do:) includes: self selector) ifFalse: [^ false].
	self arguments first isBlock ifTrue: [^ false].
	block := self arguments last.
	block isBlock ifFalse: [^ false].
	block arguments size = 1 ifFalse: [
		self notify: 'to:do: block must take one arg'. ^ false].
	(RBParseTreeSearcher new
		matches: block arguments first name , ' := `@object' do: [:n :a | true];
		executeTree: block initialAnswer: false) ifTrue: [^ false].
	self arguments size = 3 "to:by:do:" ifTrue: [
		step := self arguments second.
		step isLiteral ifFalse: [^ false].
		step value = 0 ifTrue: [self notify: 'by: step can''t be zero'. ^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*newcompiler-inline' stamp: 'jorgeRessia 11/20/2009 16:40'!
isInlineWhile

	self isCascaded ifTrue: [^ false].
	(#(whileFalse: whileTrue: whileFalse whileTrue) includes: self selector) ifFalse: [^ false].
	self receiver isBlock ifFalse: [^ false].
	self receiver arguments isEmpty ifFalse: [self notify: 'while receiver block must have no arguments'. ^ false].
	self arguments isEmpty ifFalse: [
		self arguments first isBlock ifFalse: [^ false].
		self arguments first arguments isEmpty ifFalse: [self notify: 'while takes a zero-arg block as its argument'. ^ false].
	].
	^ true! !

!RBMessageNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/1/2010 11:13'!
isOptimized
	^ (self isInlineToDo or: [self isInlineWhile]) or: [self isInlineIf]! !

!RBMessageNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 11/14/2009 08:50'!
isOptimizedLoop
	^ self isInlineToDo or: [self isInlineWhile]! !

!RBMessageNode methodsFor: '*newcompiler' stamp: 'ms 7/31/2007 00:45'!
isSelfClosureRegistration

	^(receiver isVariable 
		and: [receiver binding isLocal]
		and: [receiver binding name = 'self']
		and: [self selector == #privStoreIn:instVar:] 
		and: [arguments first binding index == -1]) 
		and: [arguments second value >= 1]! !

!SequenceableCollection methodsFor: '*newcompiler' stamp: 'kwl 6/25/2006 19:07'!
literalIndexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of anElement within the receiver. If the receiver does 
	not contain anElement, answer the result of evaluating the argument, 
	exceptionBlock."
	1 to: self size do:
		[:i | ((self at: i) literalEqual: anElement) ifTrue: [^ i]].
	^ exceptionBlock value! !

RBProgramNodeVisitor subclass: #ASTBlocksUniqueIdentifier
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTBlocksUniqueIdentifier methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/3/2010 08:58'!
acceptBlockNode: aBlockNode 

	aBlockNode uniqueIdentifier: index.
	self incrementIndex.! !

!ASTBlocksUniqueIdentifier methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/3/2010 08:59'!
acceptMethodNode: aMethodNode 

	aMethodNode uniqueIdentifier: index.
	self incrementIndex.! !

!ASTBlocksUniqueIdentifier methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/3/2010 09:05'!
for: aRBMethodNode 
	self visitNode: aRBMethodNode! !

!ASTBlocksUniqueIdentifier methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/3/2010 08:59'!
incrementIndex

	index := index + 1! !

!ASTBlocksUniqueIdentifier methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/3/2010 09:01'!
initialize

	index := 0! !

RBProgramNodeVisitor subclass: #ASTCheckAssignment
	instanceVariableNames: 'numberOfAssignment receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTCheckAssignment class methodsFor: 'as yet unclassified' stamp: 'ms 5/8/2007 18:59'!
check: aRBNode assagnmentTo: aReceiver

	^self new 
		receiver: aReceiver;
		visitNode: aRBNode; 
		isAssagning! !

!ASTCheckAssignment methodsFor: 'visitor-double dispatching' stamp: 'ms 5/8/2007 19:04'!
acceptAssignmentNode: anAssignmentNode

	anAssignmentNode variable = receiver 
		ifTrue:[numberOfAssignment := numberOfAssignment + 1].
	super acceptAssignmentNode: anAssignmentNode ! !

!ASTCheckAssignment methodsFor: 'initialize-release' stamp: 'ms 5/8/2007 18:57'!
initialize

	numberOfAssignment := 0! !

!ASTCheckAssignment methodsFor: 'initialize-release' stamp: 'ms 5/8/2007 19:05'!
isAssagning

	^numberOfAssignment > 0! !

!ASTCheckAssignment methodsFor: 'accessing' stamp: 'ms 5/8/2007 18:56'!
receiver: anObject
	receiver := anObject! !

RBProgramNodeVisitor subclass: #ASTChecker
	instanceVariableNames: 'scope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTChecker commentStamp: 'ajh 6/23/2004 19:43' prior: 0!
I visit each node in the abstract syntax tree while growing and shrinking a SemScope chain. Each method and block node is linked with its corresponding scope object, and each variable def and ref is linked with its corresponding ScopeVar. Exceptions are raised for undefined variable references and so on (see subclasses of SemanticWarning).
!

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'ajh 2/25/2003 19:43'!
acceptArrayNode: anArrayNode 
	anArrayNode statements do: [:each | self visitNode: each]! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/11/2003 18:21'!
acceptAssignmentNode: anAssignmentNode

	| var |
	self visitNode: anAssignmentNode value.
	var := (scope lookupVar: anAssignmentNode variable name)
		ifNil: [self undeclaredVariable: anAssignmentNode variable].
	var markWrite.
	anAssignmentNode variable binding: var.
! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'jorgeRessia 11/13/2009 21:17'!
acceptBlockNode: aBlockNode

	aBlockNode isInlined ifTrue: [^ self acceptInlinedBlockNode: aBlockNode].
	scope := scope newFunctionScope.
	aBlockNode scope: scope.
	(scope addTemp: 'parent env') markArg. "first temp is receiver"
	aBlockNode arguments do: [:node | (self declareVariableNode: node) markArg].
	self visitNode: aBlockNode body.
	scope := scope popScope.
! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'md 6/29/2005 12:20'!
acceptDoItNode: aDoItNode

	| doItReceiverName |
	doItReceiverName := scope isInstanceScope
		ifTrue: ['self']
		ifFalse: [(scope rawVar: 'theContext')
			ifNil: ['theContext']
			ifNotNil: ['the context']].

	scope := scope newMethodScope.
	"hack for Bytesurgeon: inlined code is a doit, yet we want access to self "
	aDoItNode byteSurgeon ifTrue: [(scope addTemp: 'self')].
	aDoItNode scope: scope.

	(scope addTemp: doItReceiverName) markArg. "first temp is receiver"
	self visitNode: aDoItNode body.
	scope := scope popScope.
! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/1/2010 10:13'!
acceptInlinedBlockNode: aBlockNode
	
	aBlockNode arguments do: [:node | (self declareVariableNode: node ) markWrite "given"].
	self visitNode: aBlockNode body.
! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'md 4/14/2007 00:36'!
acceptMessageNode: aMessageNode

	(aMessageNode isCascaded not or: [aMessageNode isFirstCascaded]) 
		ifTrue: [self visitNode: aMessageNode receiver].
	aMessageNode arguments do: [:each | self visitNode: each].
	"aMessageNode binding:"
		((scope lookupSelector: aMessageNode selector asString)
			ifNil: [self undeclaredSelector: aMessageNode])! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 11/24/2009 18:48'!
acceptMethodNode: aMethodNode

	scope := scope newMethodScope.
	aMethodNode scope: scope.
	(scope addTemp: 'self') markArg.  "first temp is receiver"
	aMethodNode arguments do: [:node | (self declareVariableNode: node) markArg].
	
	aMethodNode pragmas do: [:each | self visitNode: each].
	self visitNode: aMethodNode body.
	scope := scope outerScope.
! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/10/2010 12:08'!
acceptPragmaNode: aPragmaNode
	self flag: 'Something should be done regarding the prgamas, check lukas visitor'.
	"aPragmaNode method addPragma: aPragmaNode pragma."
	aPragmaNode isPrimitive ifTrue: [
		aPragmaNode parent primitiveNode: aPragmaNode primitive ]
	! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'ms 6/17/2007 00:30'!
acceptReturnNode: aReturnNode

	| var |
	self visitNode: aReturnNode value.
	var := scope lookupVar: 'top env'.  "nil var means local return"
	var ifNotNil: [var markRead].
	aReturnNode homeBinding: var.
! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/1/2010 10:45'!
acceptSequenceNode: aSequenceNode
	aSequenceNode temporaries do: [:node | self declareVariableNode: node].
	aSequenceNode statements do: [:each | self visitNode: each].
	aSequenceNode temporaries do: [:node |
		node binding isUnused ifTrue: [self unusedVariable: node]].
! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/1/2010 11:03'!
acceptVariableNode: aVariableNode

	| var name |
	
	name := aVariableNode name.
	name = 'super' ifTrue: [name := 'self'].
	var := (scope lookupVar: name)
		ifNil: [self undeclaredVariable: aVariableNode].
	var isUndefined
		ifTrue: [self uninitializedVariable: aVariableNode].
	var markRead.
	aVariableNode binding: var.! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'TestRunner 1/1/2010 11:19'!
declareVariableNode: aVariableNode

	| name var |
	name := aVariableNode name.
	var := scope rawVar: name.
	var ifNotNil: [
		var scope = scope ifTrue: [
			"Reuse same var"
			var := scope lookupVar: name.
		] ifFalse: [
			"Create new var that shadows outer one"
			self variable: aVariableNode shadows: var.
			var := scope addTemp: name.
		]
	] ifNil: [
		"new var"
		var := scope addTemp: name.
	].
	aVariableNode binding: var.
	^ var! !

!ASTChecker methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/1/2010 12:46'!
declareVariableNode: aVariableNode inOptimizedBlock: aBlockNode

	| name var |
	name := aVariableNode name.
	var := scope rawVar: name.
	var ifNotNil: [
		var scope = scope ifTrue: [
			(aBlockNode = var optimizedBlock) 
						ifTrue: ["Reuse same var" var := scope lookupVar: name.]
						ifFalse: [var := scope addTemp: name. var optimizedBlock: aBlockNode]
		] ifFalse: [
			"Create new var that shadows outer one"
			self variable: aVariableNode shadows: var.
			var := scope addTemp: name.
		]
	] ifNil: [
		"new var"
		var := scope addTemp: name.
	].
	aVariableNode binding: var.
	^ var! !

!ASTChecker methodsFor: 'initialize-release' stamp: 'ajh 6/23/2004 20:40'!
initialize

	scope := GlobalScope new.  "in case never initialized"! !

!ASTChecker methodsFor: 'initialize-release' stamp: 'ajh 2/26/2003 19:58'!
scope: aSemScope

	scope := aSemScope! !

!ASTChecker methodsFor: 'error handling' stamp: 'JorgeRessia 12/25/2009 09:58'!
undeclaredSelector: messageNode

	"^ UndeclaredSelectorWarning new
		messageNode: messageNode;
		signal"! !

!ASTChecker methodsFor: 'error handling' stamp: 'JorgeRessia 1/1/2010 12:46'!
undeclaredVariable: variableNode
	| varName |
	varName := variableNode name.
	varName := varName asSymbol.
	Undeclared at: varName put: nil.
	^ GlobalVar new assoc: (Undeclared associationAt: varName); scope: scope
	"^ UndeclaredVariableWarning2 new
		variableNode: variableNode;
		signal"! !

!ASTChecker methodsFor: 'error handling' stamp: 'JorgeRessia 12/25/2009 09:58'!
uninitializedVariable: variableNode

	"^ UninitializedVariableWarning new
		variableNode: variableNode;
		signal"! !

!ASTChecker methodsFor: 'error handling' stamp: 'JorgeRessia 12/25/2009 09:53'!
unusedVariable: variableNode

	"^ UnusedVariableWarning new
		variableNode: variableNode;
		signal"! !

!ASTChecker methodsFor: 'error handling' stamp: 'JorgeRessia 12/24/2009 11:05'!
variable: variableNode shadows: semVar

	"^ ShadowVariableWarning new
		variableNode: variableNode;
		shadowedVar: semVar;
		signal"! !

RBProgramNodeVisitor subclass: #ASTClosureScopeReindexer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTClosureScopeReindexer methodsFor: 'visiting' stamp: 'JorgeRessia 12/27/2009 16:17'!
acceptAssignmentNode: anAssignmentNode 
	self visitNode: anAssignmentNode value.
	self visitNode: anAssignmentNode variable.
! !

!ASTClosureScopeReindexer methodsFor: 'visiting' stamp: 'JorgeRessia 1/8/2010 16:48'!
acceptBlockNode: aBlockNode 
	| allTempsInScope remoteTempVar remoteTempVars aRemoteTempNode aScope replacedTemp indexPosition|
	aRemoteTempNode := aBlockNode remoteTempNode.
	aScope := aBlockNode owningScope.
	aBlockNode isInlined ifTrue: [^super acceptBlockNode: aBlockNode] .
	(aScope addScopeIndexedTemp: 'self') markArg.
	((aRemoteTempNode isNil not) and: [aScope isNil not])
		ifTrue: [ 
				remoteTempVar := RemoteTempVar 
											named: aRemoteTempNode name
											scope: aScope.
					allTempsInScope := OrderedCollection new.
					allTempsInScope addAll: aScope tempVars.
					remoteTempVars := OrderedCollection new.
					indexPosition := self remoteTempIndexIn: aScope.
					remoteTempVar index: indexPosition.
					replacedTemp := (aScope rawVarAt: indexPosition ifNone: [nil]).
					replacedTemp isNil ifFalse: [replacedTemp index: (aScope tempVars size)].
					aScope addObjectTemp: remoteTempVar.
					remoteTempVars do: [ :each | aScope addObjectTemp: each ].
					allTempsInScope do: [:eachTemp | (aRemoteTempNode includes: eachTemp) 
																				ifTrue: ["(remoteTempVar index > eachTemp index) ifTrue: [remoteTempVar index: eachTemp index]."
																						  aScope removeTemp: eachTemp.
																						  remoteTempVars add: eachTemp.
																						  remoteTempVar addTemp: eachTemp.
																						 ] ].
					"remoteTempVar index: (aScope tempVars size). 
					aScope addObjectTemp: remoteTempVar.
					remoteTempVars do: [ :each | aScope addObjectTemp: each ]."
				].
	aBlockNode arguments do: [:each | aScope addScopeIndexedTemp: each name].
	aBlockNode copiedValues do: [:each | aScope addScopeIndexedTemp: each name].
	aBlockNode body temporaries do: [:each | aScope addScopeIndexedTemp: each name].
	super acceptBlockNode: aBlockNode! !

!ASTClosureScopeReindexer methodsFor: 'visiting' stamp: 'JorgeRessia 12/27/2009 18:10'!
acceptMethodNode: aMethodNode
	(aMethodNode scope addScopeIndexedTemp: 'self') markArg.
	self reindex: (aMethodNode body temporaries detect: [:each | each isIndirectTempVector] ifNone: [nil]) in: aMethodNode scope.
	super acceptMethodNode: aMethodNode
	! !

!ASTClosureScopeReindexer methodsFor: 'visiting' stamp: 'JorgeRessia 1/5/2010 11:04'!
acceptVariableNode: aVariableNode
	|name aScope |
	((aVariableNode varNodeData remoteNode isNil) 
	and: [(((aVariableNode name = 'super') 
			or: [aVariableNode binding isNil not and: [aVariableNode binding isGlobal]])
			or: [(aVariableNode owningScope lookupVar: aVariableNode name) isCaptured])]) ifTrue: [^nil].
	
	aScope := aVariableNode owningScope.
	name := aVariableNode varNodeData remoteNode isNil 
									ifTrue: [aVariableNode name]
									ifFalse: [aVariableNode varNodeData remoteNode name].
		
	"this is not right, the indexes have to change regarding the order Args, copied temps, block temps"								
	aVariableNode enclosingBlock isMethod
						ifTrue: [^(aScope basicScopeIndexedVarFor: name) isNil ifTrue: [aScope addObjectScopeIndexedTemp: (aScope lookupVar: name)]].
						
	aVariableNode varNodeData remoteNode isNil
		ifTrue: [(aVariableNode owningScope basicScopeIndexedVarFor: aVariableNode name) isNil
						ifTrue: [aVariableNode owningScope addScopeIndexedTemp: aVariableNode name]]
		ifFalse: [self reindexRemote: aVariableNode ].
	
	! !

!ASTClosureScopeReindexer methodsFor: 'visiting' stamp: 'JorgeRessia 12/11/2009 12:49'!
reindex: aRemoteTempNode in: aScope 
	| allTempsInScope remoteTempVar remoteTempVars |
	aRemoteTempNode isNil 
		ifFalse: [ remoteTempVar := RemoteTempVar 
											named: aRemoteTempNode name
											scope: aScope.
					allTempsInScope := OrderedCollection new.
					allTempsInScope addAll: aScope tempVars.
					remoteTempVars := OrderedCollection new.
 					"remoteTempVar index: (aScope tempVars size).
					aScope addObjectTemp: remoteTempVar.
					remoteTempVars do: [ :each | aScope addObjectTemp: each ]."
					allTempsInScope do: [:eachTemp | (aRemoteTempNode includes: eachTemp) 
																				ifTrue: ["(remoteTempVar index > eachTemp index) ifTrue: [remoteTempVar index: eachTemp index]."
																						  aScope removeTemp: eachTemp.
																						  remoteTempVars add: eachTemp.
																						  remoteTempVar addTemp: eachTemp.
																						 ] ].
					remoteTempVar index: (aScope tempVars size). 
					aScope addObjectTemp: remoteTempVar.
					remoteTempVars do: [ :each | aScope addObjectTemp: each ].
				]! !

!ASTClosureScopeReindexer methodsFor: 'visiting' stamp: 'TestRunner 12/27/2009 18:43'!
reindexRemote: aVariableNode
	| allTempsInScope remoteTempVar remoteTempVars aRemoteTempNode aScope|
	aRemoteTempNode := aVariableNode varNodeData remoteNode.
	aScope := aVariableNode owningScope.
	(aScope basicScopeIndexedVarFor: aRemoteTempNode name) isNil 
	ifTrue: [
			remoteTempVar := RemoteTempVar 
							named: aRemoteTempNode name
							scope: aScope.
			aScope insertScopeIndexedTempAfterArgs: remoteTempVar]! !

!ASTClosureScopeReindexer methodsFor: 'visiting' stamp: 'jorgeRessia 11/13/2009 20:12'!
reindexTempsIn: aRBMethodNode 
	self visitNode: aRBMethodNode! !

!ASTClosureScopeReindexer methodsFor: 'private' stamp: 'JorgeRessia 12/11/2009 17:46'!
remoteTempIndexIn: aScope 
	^(aScope tempVars detect: [:each | each isArg and: [each index ~= 0]] ifNone: [^1]) index + 1.! !

RBProgramNodeVisitor subclass: #ASTCommenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptArrayNode: anArrayNode 
	anArrayNode peekAfterComment.
	anArrayNode peekBeforeComment.
	super acceptArrayNode: anArrayNode.
	anArrayNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptAssignmentNode: anAssignmentNode 
	anAssignmentNode peekAfterComment.
	anAssignmentNode peekBeforeComment.
	super acceptAssignmentNode: anAssignmentNode.
	anAssignmentNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptBlockNode: aBlockNode 
	aBlockNode peekAfterComment.
	aBlockNode peekBeforeComment.
	super acceptBlockNode: aBlockNode.
	aBlockNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptCascadeNode: aCascadeNode 
	aCascadeNode peekAfterComment.
	aCascadeNode peekBeforeComment.
	aCascadeNode messages 
		do: [:each | each arguments do: [:eachArg | self visitNode: eachArg]].
	aCascadeNode messages first isBlock 
		ifTrue: [self visitNode: aCascadeNode messages first body].
	aCascadeNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptLiteralNode: aLiteralNode 
	aLiteralNode peekAfterComment.
	aLiteralNode peekBeforeComment.
	aLiteralNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 10/14/2006 15:41'!
acceptMessageNode: aMessageNode 
	aMessageNode peekAfterComment.
	aMessageNode peekBeforeComment.
	aMessageNode arguments do: [:each | self visitNode: each].
	(aMessageNode isCascaded not or: [aMessageNode isFirstCascaded]) 
		ifTrue: [self visitNode: aMessageNode receiver].
	aMessageNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 5/28/2007 11:58'!
acceptMethodNode: aMethodNode

	super visitMethodArguments: aMethodNode arguments.
	aMethodNode peekAfterComment.
	aMethodNode pragmas do: [:each | super visitNode: each].
	super visitNode: aMethodNode body.
	aMethodNode peekInsideComment.
	aMethodNode peekBeforeComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptPragmaNode: aPragmaNode 
	aPragmaNode peekAfterComment.
	aPragmaNode peekBeforeComment.
	aPragmaNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptReturnNode: aReturnNode 
	aReturnNode peekAfterComment.
	aReturnNode peekBeforeComment.
	super acceptReturnNode: aReturnNode.
	aReturnNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptSequenceNode: aSequenceNode 
	aSequenceNode peekAfterComment.
	aSequenceNode temporaries ifNotEmpty: [aSequenceNode peekBeforeComment].
	super acceptSequenceNode: aSequenceNode.
	aSequenceNode temporaries ifEmpty: [aSequenceNode peekBeforeComment].
	aSequenceNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 20:19'!
acceptVariableNode: aVariableNode 
	aVariableNode peekAfterComment.
	aVariableNode peekBeforeComment.
	aVariableNode peekInsideComment! !

!ASTCommenter methodsFor: 'visitor-double dispatching' stamp: 'ms 9/20/2006 00:14'!
visitMethodArguments: aNodeCollection

	aNodeCollection reverse do: [:each | self visitNode: each]! !

RBProgramNodeVisitor subclass: #ASTDefiningScopeSetter
	instanceVariableNames: 'definingScope variableNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTDefiningScopeSetter methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 12/30/2009 23:01'!
acceptBlockNode: aBlockNode 
	|oldScope|
	oldScope := definingScope.
	definingScope := aBlockNode.
	aBlockNode arguments ifNotNil:
		[aBlockNode arguments do: [:temp| self visitNode: temp ]].
	aBlockNode body temporaries ifNotNil:
		[aBlockNode body temporaries do: [:temp| self visitNode: temp]].
	super acceptBlockNode: aBlockNode.
	definingScope := oldScope.
	aBlockNode arguments ifNotNil:
		[aBlockNode arguments do: [:temp| variableNodes removeKey: temp ]].
	aBlockNode body temporaries ifNotNil:
		[aBlockNode body temporaries do: [:temp| variableNodes removeKey: temp]].
	! !

!ASTDefiningScopeSetter methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 12/22/2009 11:14'!
acceptMessageNode: aMessageNode 
	self visitNode: aMessageNode receiver.
	aMessageNode arguments do: [:each | self visitNode: each]! !

!ASTDefiningScopeSetter methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 12/30/2009 22:27'!
acceptMethodNode: aMethodNode 
	|oldScope|
	oldScope := definingScope.
	definingScope := aMethodNode.
	aMethodNode arguments ifNotNil:
		[aMethodNode arguments do: [:temp| self visitNode: temp]].
	aMethodNode body temporaries ifNotNil:
		[aMethodNode body temporaries do: [:temp| self visitNode: temp]].
	super acceptBlockNode: aMethodNode.
	definingScope := oldScope.! !

!ASTDefiningScopeSetter methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 12/30/2009 23:11'!
acceptVariableNode: aVariableNode
	| alreadySeenVariableNode |
	alreadySeenVariableNode := variableNodes at: aVariableNode ifAbsent: [nil].
	alreadySeenVariableNode isNil 
								ifTrue: [aVariableNode definingScope: definingScope.
										 variableNodes at: aVariableNode put: aVariableNode]
								ifFalse: [ ( definingScope isChildOf: alreadySeenVariableNode definingScope) 
															ifTrue: [aVariableNode definingScope: alreadySeenVariableNode definingScope]
															ifFalse: [aVariableNode definingScope: definingScope]]! !

!ASTDefiningScopeSetter methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 12/20/2009 18:26'!
initialize

	variableNodes := Dictionary new! !

!ASTDefiningScopeSetter methodsFor: 'visitor-double dispatching' stamp: 'TestRunner 12/20/2009 18:43'!
setVariableNodesIn: aRBNode
	definingScope := aRBNode.
	self visitNode: aRBNode ! !

RBProgramNodeVisitor subclass: #ASTFixDecompileBlockScope
	instanceVariableNames: 'fixVariables stackBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTFixDecompileBlockScope methodsFor: 'visitor-double dispatching' stamp: 'ms 9/8/2007 15:34'!
acceptBlockNode: aBlockNode

	| tempsIndex tmpVar |
	aBlockNode isInlined ifTrue: [
		aBlockNode arguments do:[:each | 
			tmpVar := each binding scope tempVarAt: each binding index.
			tmpVar privUsage: each binding privUsage]].
	fixVariables := stackBlock push: Dictionary new.
	tempsIndex := IdentityDictionary new.
	
	"Find the parent temporaries"
	aBlockNode sequenceDefinedIn temporaries 
		do: [:each | tempsIndex at: each binding put: each].
	
	"Remove temporaries used outside the block"
	aBlockNode body temporaries do: [:each |
		tempsIndex at: each binding ifPresent: [:var |
			fixVariables at: each put: var]].
	fixVariables keys do: [:each | 
		aBlockNode body temporaries: (aBlockNode body temporaries copyWithout: each)].
	
	"Continue and it will fix all the varaibale node"
	super acceptBlockNode: aBlockNode.
	fixVariables := stackBlock pop.! !

!ASTFixDecompileBlockScope methodsFor: 'visitor-double dispatching' stamp: 'ms 6/17/2007 03:05'!
acceptVariableNode: aVariableNode
	
	"Change the variable node to use the parent temporaries"
	fixVariables at: aVariableNode 
		ifPresent:[:newVar | 
			aVariableNode identifierToken: (SqueakToken value:  newVar name start: 0).
			aVariableNode binding: newVar binding].! !

!ASTFixDecompileBlockScope methodsFor: 'initialize-release' stamp: 'ms 6/17/2007 02:28'!
initialize

	stackBlock := Stack new.
	fixVariables := stackBlock push: Dictionary new.
! !

RBProgramNodeVisitor subclass: #ASTReplaceVariableScope
	instanceVariableNames: 'scope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTReplaceVariableScope class methodsFor: 'as yet unclassified' stamp: 'ms 6/15/2007 12:13'!
replace: aNode scope: aScope

	self new
		scope: aScope;
		visitNode: aNode! !

!ASTReplaceVariableScope methodsFor: 'visitor-double dispatching' stamp: 'ms 6/17/2007 02:37'!
acceptBlockNode: aBlockNode

	(aBlockNode arguments isEmpty and: [aBlockNode body temporaries isEmpty])
		ifTrue: [super acceptBlockNode: aBlockNode]! !

!ASTReplaceVariableScope methodsFor: 'visitor-double dispatching' stamp: 'ms 7/14/2007 22:14'!
acceptVariableNode: aVariableNode
	
	((scope isChildrenOf:  aVariableNode binding scope) 
		or:[aVariableNode binding isContextVar]) ifTrue:[^self].
	aVariableNode binding scope: scope.
	aVariableNode binding: (scope tempVars 
		detect:[:each | each = aVariableNode binding]
		ifNone:[self error: aVariableNode name, ' can''t be found in this scope'])! !

!ASTReplaceVariableScope methodsFor: 'accessing' stamp: 'ms 6/15/2007 12:12'!
scope: aScope

	scope := aScope! !

RBProgramNodeVisitor subclass: #ASTTranslator
	instanceVariableNames: 'methodBuilder effectTranslator valueTranslator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTTranslator commentStamp: 'ajh 3/24/2003 22:19' prior: 0!
I visit an abstract syntax tree and generate IR (intermediate representation) instructions for each node by sending the appropriate message to my methodBuilder (an IRBuilder).  I hold onto my two subclasses one for generating instructions for value, the other for generating instructions for effect.!

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 3/30/2010 10:40'!
acceptArrayNode: anArrayNode 

	| elementNodes |
	elementNodes := anArrayNode children.
	elementNodes do: [:node | valueTranslator visitNode: node].
	methodBuilder pushConsArray: elementNodes size.! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/11/2010 20:24'!
acceptAssignmentNode: anAssignmentNode 
	|variable|
	(anAssignmentNode value isVariable and: [ anAssignmentNode value isRemote ])
								ifTrue: [valueTranslator emitStoreIntoTempFor: anAssignmentNode value in: anAssignmentNode owningScope]
								ifFalse: [valueTranslator visitNode: anAssignmentNode value.]. 
	"variable := anAssignmentNode owningScope rawVar: (anAssignmentNode variable binding name)."
	
	self flag: 'this should not be done here, the ir should deal with this if it is a store or not'.
	anAssignmentNode variable isRemote
					ifTrue: [(anAssignmentNode parent isMessage or: [ (anAssignmentNode parent isAssignment or: [anAssignmentNode enclosingBlock isInsideOptimizedBlock not and: [anAssignmentNode enclosingBlock body statements last = anAssignmentNode]])])
																ifTrue: [ valueTranslator emitStoreIntoTempFor: anAssignmentNode variable in: anAssignmentNode owningScope]
																ifFalse: [valueTranslator emitPopIntoTempFor: anAssignmentNode variable in: anAssignmentNode owningScope]
								]
					ifFalse: [ ((anAssignmentNode variable binding isCaptured and: [anAssignmentNode variable binding isInstance not])  or: [ anAssignmentNode parent isAssignment or: [ anAssignmentNode parent isMessage]])
															ifTrue: [anAssignmentNode variable binding emitStore: methodBuilder from: anAssignmentNode owningScope]
															ifFalse: [anAssignmentNode variable binding emitLocalPop: methodBuilder in: anAssignmentNode owningScope ] ].
! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'ajh 2/25/2003 00:51'!
acceptBlockNode: aBlockNode 
! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/10/2003 14:53'!
acceptCascadeNode: aCascadeNode 

	valueTranslator visitNode: aCascadeNode receiver.
	aCascadeNode messages allButLastDo: [:node |
		methodBuilder pushDup.
		effectTranslator visitNode: node.
	].
	valueTranslator visitNode: aCascadeNode messages last.
! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'ms 7/3/2007 13:40'!
acceptDoItNode: aDoItNode 

	self emitPrologue: aDoItNode.
	valueTranslator visitNode: aDoItNode body.
	aDoItNode body lastIsReturn ifFalse: [methodBuilder returnTop]! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 3/30/2010 12:25'!
acceptMessageNode: aMessageNode
	aMessageNode isInlineIf ifTrue: [^ self emitIfNode: aMessageNode].
	aMessageNode isInlineIfNil ifTrue: [^ self emitIfNilNode: aMessageNode].
	aMessageNode isInlineAndOr ifTrue: [^ self emitAndOrNode: aMessageNode].
	aMessageNode isInlineWhile ifTrue: [^ self emitWhileNode: aMessageNode].
	aMessageNode isInlineToDo ifTrue: [^ self emitToDoNode: aMessageNode].
	aMessageNode isInlineCase ifTrue: [^ self emitCaseNode: aMessageNode].
	^ self emitMessageNode: aMessageNode! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 12/26/2009 10:04'!
acceptMethodNode: aMethodNode
	|methodTemps|
	methodBuilder properties: aMethodNode properties.
	methodBuilder primitiveNode: aMethodNode primitiveNode.
	methodTemps := OrderedCollection new.
	methodTemps addAll: aMethodNode body temporaries.
	methodTemps addAll: aMethodNode arguments.
	methodBuilder methodTemps: methodTemps.
	self emitPrologue: aMethodNode.
	self createRemoteTempVectorIfRequiredFor: aMethodNode.
	effectTranslator visitNode: aMethodNode body.
	aMethodNode body lastIsReturn ifFalse: 
		[methodBuilder pushReceiver; returnTop]! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'ajh 7/8/2004 19:01'!
acceptReturnNode: aReturnNode

	valueTranslator visitNode: aReturnNode value.
	aReturnNode homeBinding ifNil: [
		methodBuilder returnTop.
	] ifNotNil: [
		aReturnNode homeBinding emitValue: methodBuilder from: aReturnNode owningScope.
		methodBuilder remoteReturn.
	].
! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'jorgeRessia 10/11/2009 17:05'!
acceptSequenceNode: aSequenceNode 

	aSequenceNode statements allButLastDo: [:n | effectTranslator visitNode: n].
	aSequenceNode statements notEmpty ifTrue: [self visitNode: aSequenceNode statements last].
! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'TestRunner 12/26/2009 11:08'!
createRemoteTempVectorIfRequiredFor: aBlockNode
	| arraySize arrayInitialization remoteVectorTemp |
	aBlockNode remoteTempNode isNil ifFalse:
			[ remoteVectorTemp := aBlockNode remoteTempNode.
			arraySize := aBlockNode remoteTempNode remoteTemps size.
			arrayInitialization := OrderedCollection with: (IRInstruction pushNewArray: arraySize)
				with: (IRInstruction storePopTemp: (aBlockNode owningScope rawVar: remoteVectorTemp name) index).
			
			methodBuilder currentSequence addAll: arrayInitialization
			]! !

!ASTTranslator methodsFor: 'inline messages' stamp: 'JorgeRessia 1/10/2010 10:10'!
emitAndOrNode: aMessageNode

	| arguments isOr |
	isOr := aMessageNode selector beginsWith: #or:.
	valueTranslator visitNode: aMessageNode receiver.
	arguments := aMessageNode arguments.
	
	arguments do: [ :each |
		methodBuilder jumpAheadTo: #else if: isOr.
		each becomeOptimized.
		self visitNode: each body ].
	
	self isValueTranslator ifTrue: [
		methodBuilder jumpAheadTo: #end].
	
	"there has to be a one-to-one correspondence between every jump and target"	
	arguments size timesRepeat: [ methodBuilder jumpAheadTarget: #else ].
	
	self isValueTranslator ifTrue: [
		methodBuilder pushLiteral: isOr.
		methodBuilder jumpAheadTarget: #end.
	].
! !

!ASTTranslator methodsFor: 'inline messages' stamp: 'JorgeRessia 1/10/2010 10:37'!
emitCaseNode: aMessageNode

	| cases assocMessageNode s |
	cases := aMessageNode arguments first statements.
	valueTranslator visitNode: aMessageNode receiver.
	1 to: cases size - 1 do: [:i |
		methodBuilder pushDup.
		assocMessageNode := cases at: i.
		valueTranslator visitNode: assocMessageNode receiver body.
		methodBuilder send: #=.
		methodBuilder jumpAheadTo: #next if: false.
		methodBuilder popTop.
		self visitNode: assocMessageNode arguments first body.
		methodBuilder jumpAheadTo: #end.
		methodBuilder jumpAheadTarget: #next.
	].
	aMessageNode arguments size = 2 ifTrue: [
		"last case with otherwise"
		assocMessageNode := cases last.
		valueTranslator visitNode: assocMessageNode receiver body.
		methodBuilder send: #=.
		methodBuilder jumpAheadTo: #next if: false.
		self visitNode: assocMessageNode arguments first body.
		methodBuilder jumpAheadTo: #end.
		methodBuilder jumpAheadTarget: #next.
		self visitNode: aMessageNode arguments last body.
	] ifFalse: [
		"last case without otherwise"
		methodBuilder pushDup.
		assocMessageNode := cases last.
		valueTranslator visitNode: assocMessageNode receiver body.
		methodBuilder send: #=.
		methodBuilder jumpAheadTo: #next if: false.
		methodBuilder popTop.
		self visitNode: assocMessageNode arguments first body.
		methodBuilder jumpAheadTo: #end.
		methodBuilder jumpAheadTarget: #next.
		methodBuilder send: #caseError.
		aMessageNode lastIsReturn ifTrue: [
			(s := aMessageNode owningScope) isBlockScope ifTrue: [
				(s lookupVar: 'top env') emitValue: methodBuilder from: aMessageNode owningScope.
				methodBuilder remoteReturn.
			] ifFalse: [
				methodBuilder returnTop.
			]
		] ifFalse: [
			self isEffectTranslator ifTrue: [methodBuilder popTop].
		].
	].

	"there has to be a one-to-one correspondence between every jump and target"	
	cases size timesRepeat: [methodBuilder jumpAheadTarget: #end].
! !

!ASTTranslator methodsFor: 'inline messages' stamp: 'JorgeRessia 1/10/2010 10:26'!
emitIfNilNode: aMessageNode

	| args selector |
	valueTranslator visitNode: aMessageNode receiver.
	args := aMessageNode arguments.
	(selector := aMessageNode selector) caseOf: {
		[#ifNil:] -> [self isValueTranslator ifTrue: [methodBuilder pushDup]].
		[#ifNil:ifNotNil:] -> [args last arguments ifNotEmpty: [args last arguments first binding emitLocalStore: methodBuilder in: args last owningScope ]].
		[#ifNotNil:] -> [args first arguments ifNotEmpty: [args first arguments first binding emitLocalStore: methodBuilder in: args first owningScope]].
		[#ifNotNilDo:] -> [args first arguments ifNotEmpty: [args first arguments first binding emitLocalStore: methodBuilder in: args first owningScope]].
		[#ifNotNil:ifNil:] -> [args first arguments ifNotEmpty: [args first arguments first binding emitLocalStore: methodBuilder in: args first owningScope]]
	}.
	methodBuilder pushLiteral: nil.
	methodBuilder send: #==.
	methodBuilder jumpAheadTo: #else if: (selector beginsWith: #ifNotNil).
	(self == valueTranslator and: [selector == #ifNil:])
		ifTrue: [methodBuilder popTop].
	args first becomeOptimized.
	self visitNode: args first body.
	(args size > 1 or: [self == valueTranslator and: [selector == #ifNotNil: or: [selector == #ifNotNilDo:]]])
		ifTrue: [methodBuilder jumpAheadTo: #end].
	methodBuilder jumpAheadTarget: #else.
	(args size > 1 or: [self isValueTranslator and: [selector == #ifNotNil: or: [selector == #ifNotNilDo:]]]) ifTrue: [
		args size > 1
			ifTrue: [args last becomeOptimized.
						self visitNode: args last body]
			ifFalse: [methodBuilder pushLiteral: nil].
		methodBuilder jumpAheadTarget: #end.
	].
! !

!ASTTranslator methodsFor: 'inline messages' stamp: 'JorgeRessia 1/10/2010 10:10'!
emitIfNode: aMessageNode

	| args |
	valueTranslator visitNode: aMessageNode receiver.
	methodBuilder jumpAheadTo: #else if: (aMessageNode selector beginsWith: #ifFalse:).
	args := aMessageNode arguments.
	args first becomeOptimized.
	self visitNode: args first body.
	(args size > 1 or: [self isValueTranslator]) ifTrue: [
		methodBuilder jumpAheadTo: #end].
	methodBuilder jumpAheadTarget: #else.
	(args size > 1 or: [self isValueTranslator]) ifTrue: [
		args size > 1
			ifTrue: [args last becomeOptimized.
						self visitNode: args last body]
			ifFalse: [methodBuilder pushLiteral: nil].
		methodBuilder jumpAheadTarget: #end.
	].
! !

!ASTTranslator methodsFor: 'inline messages' stamp: 'JorgeRessia 3/30/2010 12:28'!
emitMessageNode: aMessageNode

	aMessageNode isCascaded ifFalse: [
		valueTranslator visitNode: aMessageNode receiver].
	aMessageNode arguments do: [:each | 
		valueTranslator visitNode: each].
	aMessageNode isSuperSend
		ifTrue: [methodBuilder send: aMessageNode selector toSuperOf: aMessageNode owningScope classEncoding]
		ifFalse: [methodBuilder send: aMessageNode selector].
! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'ms 7/3/2007 13:35'!
emitPrologue: aBlockOrMethodNode

	methodBuilder numRargs: aBlockOrMethodNode arguments size + 1.
	methodBuilder addTemps: aBlockOrMethodNode scope tempVars.
	aBlockOrMethodNode scope emitPrologue: methodBuilder.
	! !

!ASTTranslator methodsFor: 'inline messages' stamp: 'TestRunner 1/1/2010 11:20'!
emitToDoNode: aMessageNode

	| limit step block iterator limitEmit |
	limit := aMessageNode arguments first.
	step := 1.
	aMessageNode arguments size = 3 ifTrue: [
		"to:by:do:"
		step := aMessageNode arguments second.
		step isLiteral ifFalse: [self error: 'should not have been inlined'].
		step := step value.
	].
	block := aMessageNode arguments last.
	block becomeOptimized.

	"push start. allocate and initialize iterator"
	valueTranslator visitNode: aMessageNode receiver.
	iterator := block arguments first binding.
	self flag: 'why we used to do a emitLocalStore?'.
	iterator emitLocalStore: methodBuilder in: block owningScope.
	"self halt.
	iterator emitLocalPop: methodBuilder.
	iterator emitLocalValue: methodBuilder."
	
	

	"push limit, store in a temp if it's an expression or a changing variable"
	valueTranslator visitNode: limit.
	limitEmit := [valueTranslator visitNode: limit].
	(limit isLiteral or: 
	 [limit isVariable and:
	  [ASTCheckAssignment check: block assagnmentTo: limit]]
	) ifFalse: [
		limit := {iterator. #limit}.  "must be unique throughout method"
		methodBuilder addTemp: limit.
		methodBuilder storeTemp: limit.
		limitEmit := [methodBuilder pushTemp: limit].
	].

	"loop"
	methodBuilder jumpBackTarget: #start.
	methodBuilder send: (step > 0 ifTrue: [#<=] ifFalse: [#>=]).
	methodBuilder jumpAheadTo: #done if: false.
	
	self createRemoteTempVectorIfRequiredFor: block.
	
	effectTranslator visitNode: block body.
	iterator emitValue: methodBuilder from: block owningScope.
	methodBuilder pushLiteral: step.
	methodBuilder send: #+.
	iterator emitLocalStore: methodBuilder in: block owningScope.
	self flag: 'Why do we do this here? this will end in a push of the limit constant'.
	limitEmit value.
	methodBuilder jumpBackTo: #start.
	methodBuilder jumpAheadTarget: #done.
! !

!ASTTranslator methodsFor: 'inline messages' stamp: 'JorgeRessia 1/3/2010 09:23'!
emitWhileNode: aMessageNode

	methodBuilder jumpBackTarget: #begin.
	valueTranslator visitNode: aMessageNode receiver body.
	aMessageNode selector caseOf: {
		[#whileTrue:]	-> [methodBuilder jumpAheadTo: #end if: false].
		[#whileTrue]	-> [methodBuilder jumpAheadTo: #end if: false].
		[#whileFalse:]	-> [methodBuilder jumpAheadTo: #end if: true].
		[#whileFalse]	-> [methodBuilder jumpAheadTo: #end if: true]
	}.
	aMessageNode receiver becomeOptimized.
	
	aMessageNode arguments isEmpty not ifTrue: [
				self createRemoteTempVectorIfRequiredFor: aMessageNode arguments first].
		
	aMessageNode arguments ifNotEmpty: [
		aMessageNode arguments first becomeOptimized.
		effectTranslator visitNode: aMessageNode arguments first body].
	methodBuilder jumpBackTo: #begin.
	methodBuilder jumpAheadTarget: #end.
! !

!ASTTranslator methodsFor: 'initialize' stamp: 'ms 10/31/2006 15:06'!
initialize

	methodBuilder := IRBuilder new.
	effectTranslator := self as: ASTTranslatorForEffect.
	valueTranslator := self as: ASTTranslatorForValue.
	effectTranslator instVarNamed: #effectTranslator put: effectTranslator.
	effectTranslator instVarNamed: #valueTranslator put: valueTranslator.
	valueTranslator instVarNamed: #valueTranslator put: valueTranslator.
! !

!ASTTranslator methodsFor: 'accessing' stamp: 'ajh 3/10/2003 17:59'!
ir

	^ methodBuilder ir! !

!ASTTranslator methodsFor: 'testing' stamp: 'pmm 7/19/2006 11:54'!
isEffectTranslator
	^self == effectTranslator! !

!ASTTranslator methodsFor: 'testing' stamp: 'pmm 7/19/2006 11:52'!
isValueTranslator
	^self == valueTranslator! !

!ASTTranslator methodsFor: 'visitor-double dispatching' stamp: 'ms 7/3/2007 13:35'!
translateBlockNode: aBlockNode 

	self emitPrologue: aBlockNode.
	valueTranslator visitNode: aBlockNode body.
	aBlockNode body lastIsReturn ifFalse: [methodBuilder returnTop]! !

!ASTTranslator methodsFor: 'visiting' stamp: 'JorgeRessia 12/30/2009 22:01'!
visitNode: aNode
	methodBuilder mapToNode: aNode.
	super visitNode: aNode.
	methodBuilder popMap.
! !

ASTTranslator subclass: #ASTTranslatorForEffect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTTranslatorForEffect commentStamp: 'ajh 3/24/2003 22:20' prior: 0!
I override some methods in my super to generate instructions for effect only.!

!ASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/10/2003 14:56'!
acceptArrayNode: anArrayNode 

	super acceptArrayNode: anArrayNode.
	methodBuilder popTop.
! !

!ASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'jorgeRessia 11/2/2009 11:45'!
acceptAssignmentNode: anAssignmentNode 
	super acceptAssignmentNode: anAssignmentNode.
	self flag: 'Why is there a pop after an assigment.?'.
	"methodBuilder popTop. "
! !

!ASTTranslatorForEffect methodsFor: 'visitor-double dispatching' stamp: 'ajh 3/10/2003 14:56'!
acceptCascadeNode: aCascadeNode 

	super acceptCascadeNode: aCascadeNode.
	methodBuilder popTop.
! !

!ASTTranslatorForEffect methodsFor: 'emit messages' stamp: 'ajh 3/10/2003 14:57'!
emitMessageNode: aMessageNode 

	super emitMessageNode: aMessageNode.
	methodBuilder popTop.
! !

ASTTranslator subclass: #ASTTranslatorForValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Semantics'!

!ASTTranslatorForValue commentStamp: 'ajh 3/24/2003 22:20' prior: 0!
I override some methods in my super to generate instructions for effect and value only.!

!ASTTranslatorForValue methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 3/30/2010 12:13'!
acceptBlockNode: aBlockNode
	| blockMethod args blockTemps copiedValues jumpSymbol pushClosueInstruction |
	Preferences compileBlocksAsClosures ifFalse:
			[ args := aBlockNode arguments collect: [ :each | each binding ].
			blockTemps := aBlockNode body temporaries collect: [ :each | each binding ].
			methodBuilder addTemps: args.
			methodBuilder addTemps: blockTemps.
			aBlockNode constructClosureCreationNode.
			self flag: 'this will only work wih temps what happen if we copy remotes and instvariables!!!!!!!!'.
			aBlockNode copiedValues do: [ :copiedValue | aBlockNode owningScope addTemp: copiedValue name ].	"Push New Array and Pop it into temp"
			
			
			aBlockNode copiedValues do:
					[ :copiedValue | copiedValue generateIRIn: methodBuilder in: aBlockNode parent owningScope ].
			jumpSymbol := ('jmp' , methodBuilder incrementJumpAheadTargetBlockIndex asString) asSymbol.
			pushClosueInstruction := methodBuilder pushClosureCopyNumCopiedValues: aBlockNode copiedValues size
				numArgs: aBlockNode arguments size
				jumpTo: jumpSymbol.	
		

		
		"The closure value primitives push the arguments and the copied values.
	 The compiler guarantees that any copied values come before all local temps.
	 So on closure activation we only need to push nils for the remaining temporaries."
			aBlockNode body temporaries do: [ :each | methodBuilder pushLiteral: nil ].
			self createRemoteTempVectorIfRequiredFor: aBlockNode.
			self visitNode: aBlockNode body.
			aBlockNode body lastIsReturn not ifTrue:
					[ | last |
					(methodBuilder currentSequence isEmpty not and: [ aBlockNode remoteTempNode isNil not ]) ifTrue:
							[ last := methodBuilder currentSequence last.
							last isStorePopRemoteTemp ifTrue:
									[ methodBuilder currentSequence remove: last.
									methodBuilder currentSequence add:
											(IRInstruction storeRemoteTemp: last tempIndex inVectorAt: last tempVectorIndex) ] ].
					methodBuilder blockReturnTop ].
			methodBuilder jumpAheadTargetBlock: jumpSymbol.	"methodBuilder jumpAheadTargetBlock: methodBuilder currentSequence.
		pushClosueInstruction jumpTo: methodBuilder currentSequence."
			^ self ].
	blockMethod := aBlockNode generateIR.
	aBlockNode freeVars isEmpty ifTrue:
			[ "Create block at compile time"
			methodBuilder pushBlock: blockMethod ]
		ifFalse:
			[ | outerScope "Create block at run time" envVar |
			outerScope := aBlockNode scope outerScope.
			envVar := outerScope hasEscapingEnv ifTrue: [ outerScope thisEnvVar ] ifFalse: [ outerScope receiverVar ].
			methodBuilder pushBlockMethod: blockMethod.
			envVar emitLocalValue: methodBuilder.
			methodBuilder send: #createBlock: ]! !

!ASTTranslatorForValue methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 11/25/2009 14:38'!
acceptLiteralArrayNode: aRBLiteralArrayNode 
	 
	methodBuilder pushLiteral: aRBLiteralArrayNode value.
! !

!ASTTranslatorForValue methodsFor: 'visitor-double dispatching' stamp: 'ajh 2/27/2003 18:18'!
acceptLiteralNode: aLiteralNode

	methodBuilder pushLiteral: aLiteralNode value.
! !

!ASTTranslatorForValue methodsFor: 'visitor-double dispatching' stamp: 'jorgeRessia 11/15/2009 10:24'!
acceptSequenceNode: aSequenceNode 
	super acceptSequenceNode: aSequenceNode.
	aSequenceNode statements isEmpty ifTrue: [
		methodBuilder pushLiteral: nil].
! !

!ASTTranslatorForValue methodsFor: 'visitor-double dispatching' stamp: 'TestRunner 1/1/2010 11:20'!
acceptVariableNode: aVariableNode
	aVariableNode isRemote 
			ifTrue: [ valueTranslator emitPushRemoteTemp: aVariableNode in: aVariableNode owningScope]
			ifFalse: [aVariableNode binding emitValue: methodBuilder from: aVariableNode owningScope]
	
	! !

!ASTTranslatorForValue methodsFor: 'visitor-double dispatching' stamp: 'JorgeRessia 1/1/2010 12:46'!
acceptVariableRemoteNode: aVariableRemoteNode

	methodBuilder storePopRemoteTemp: 0 inVectorAt: aVariableRemoteNode
	"aVariableRemoteNode binding emitValue: methodBuilder from: aVariableNode owningScope."
	
	! !

!ASTTranslatorForValue methodsFor: 'creation' stamp: 'JorgeRessia 12/27/2009 16:30'!
emitPopIntoTempFor: aRBVariableNode in: aScope 
	|indexInRemoteVector|
	indexInRemoteVector := aRBVariableNode remoteNode indexOf: aRBVariableNode.
	methodBuilder storePopRemoteTemp: indexInRemoteVector inVectorAt: ( aScope scopeIndexedVarFor: aRBVariableNode remoteNode name ) index - 1! !

!ASTTranslatorForValue methodsFor: 'emit messages' stamp: 'JorgeRessia 1/1/2010 12:46'!
emitPushRemoteTemp: aRBVariableNode 
	|indexInRemoteVector|
	indexInRemoteVector := aRBVariableNode remoteNode indexOf: aRBVariableNode.
	self flag: 'this behavior of adding or removing indexes has to disappear the variables should now this!!!!!!'.
	methodBuilder pushRemoteTemp: indexInRemoteVector inVectorAt: aRBVariableNode remoteNode index - 1! !

!ASTTranslatorForValue methodsFor: 'emit messages' stamp: 'JorgeRessia 12/27/2009 16:30'!
emitPushRemoteTemp: aRBVariableNode in: aScope
	|indexInRemoteVector|
	indexInRemoteVector := aRBVariableNode remoteNode indexOf: aRBVariableNode.
	self flag: 'this behavior of adding or removing indexes has to disappear the variables should now this!!!!!!'.
	methodBuilder pushRemoteTemp: indexInRemoteVector inVectorAt:  ( aScope scopeIndexedVarFor: aRBVariableNode remoteNode name ) index - 1! !

!ASTTranslatorForValue methodsFor: 'creation' stamp: 'JorgeRessia 12/27/2009 16:28'!
emitStoreIntoTempFor: aRBVariableNode in: aScope 
	|indexInRemoteVector|
	indexInRemoteVector := aRBVariableNode remoteNode indexOf: aRBVariableNode.
	methodBuilder storeRemoteTemp: indexInRemoteVector inVectorAt: ( aScope scopeIndexedVarFor: aRBVariableNode remoteNode name ) index - 1! !

!ASTTranslatorForValue methodsFor: 'emit messages' stamp: 'ajh 2/25/2003 16:50'!
emitToDoNode: aMessageNode

	super emitToDoNode: aMessageNode.
	methodBuilder pushLiteral: nil.
! !

!ASTTranslatorForValue methodsFor: 'emit messages' stamp: 'ajh 2/25/2003 16:49'!
emitWhileNode: aMessageNode

	super emitWhileNode: aMessageNode.
	methodBuilder pushLiteral: nil.
! !

OrderedCollection subclass: #LiteralList
	instanceVariableNames: 'equalitySet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Bytecodes'!

!LiteralList commentStamp: 'ajh 3/25/2003 00:31' prior: 0!
Holds a unique ordered collection of literals!

!LiteralList methodsFor: 'adding' stamp: 'ajh 3/6/2003 18:00'!
addLast: object
	"Only add if not already in list"

	(equalitySet includes: object) ifTrue: [^ object].
	equalitySet add: object.
	super addLast: object.
	^ object
! !

!LiteralList methodsFor: 'accessing' stamp: 'ajh 1/21/2003 12:21'!
indexOf: anElement startingAt: start ifAbsent: exceptionBlock

	start to: self size do:
		[:index | ((self at: index) literalEqual: anElement) ifTrue: [^ index]].
	^ exceptionBlock value! !

!LiteralList methodsFor: 'private' stamp: 'ajh 1/21/2003 12:21'!
setCollection: anArray

	super setCollection: anArray.
	equalitySet := LiteralSet new: anArray size.
! !

LongTestCase subclass: #CompilerRegressionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Tests'!

!CompilerRegressionTest commentStamp: 'md 3/22/2005 14:51' prior: 0!
These are tests that recompile the whole image. This takes a long time. But
if such a test runs to completion, we are sure that there are no errors.

These tests are disabled by default. To enable:

       CompilerRegressionTest runLongTestCases.

Disable:

       CompilerRegressionTest doNotRunLongTestCases.!

!CompilerRegressionTest methodsFor: 'testing' stamp: 'md 3/22/2005 15:56'!
testBytecodeDecompileToIR
	"decompile all the byteocde of all methods of all classes to IR"

	self shouldnt: [
		Smalltalk allClasses do: [:class |
				class methodDict values do: [:m |
							m ir.
				] displayingProgress: 'decompiling'
		]
	] raise: Error.! !

!CompilerRegressionTest methodsFor: 'testing' stamp: 'md 3/22/2005 15:56'!
testBytecodeDecompileToIRAndRegenerate
	"decompile all the byteocde of all methods of all classes to IR. Then it
      gnerates a new method using IRBuilder"

	self shouldnt: [
			Smalltalk allClasses do: [:class|
					class methodDict values do: [:m |
						(m ir) compiledMethodWith: #().
					] displayingProgress: 'recompiling'
			]
	] raise: Error.! !

!CompilerRegressionTest methodsFor: 'testing' stamp: 'md 3/22/2005 16:26'!
testBytecodeRecompile
	"recompile the image BC->IR->BC and install"

	| new |

	self shouldnt: [
			Smalltalk allClasses do: [:class|
					class methodDict keysAndValuesDo: [:s :m |
							new := (m ir) compiledMethodWith: m trailer.
							class methodDict at: s put: new.
					]
			]
	] raise: Error.! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/8/2007 01:35'!
= anOtherMessage

	self class = anOtherMessage class ifFalse:[^false].
	self arguments = anOtherMessage arguments ifFalse:[^false].
	self selector = anOtherMessage selector ifFalse:[^false].
	self lookupClass = anOtherMessage lookupClass ifFalse:[^false].
	^true! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/6/2007 03:09'!
isAccessTemp

	^#(#popIntoTemporaryVariable: #pushTemporaryVariable: #storeIntoTemporaryVariable:) includes: selector! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/6/2007 05:34'!
isConditionalJump

	^#jump:if: = selector! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/7/2007 23:25'!
isInstVar

	^#(
	#pushReceiverVariable: 
	#storeIntoReceiverVariable: 
	#popIntoReceiverVariable:) 
		includes: selector! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/6/2007 05:12'!
isJump

	^#(#jump: #jump:if:) includes: selector! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/7/2007 23:26'!
isLiteralVar

	^#(
	#popIntoLiteralVariable: 
	#pushLiteralVariable: 
	#storeIntoLiteralVariable:) 
		includes: selector! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/7/2007 23:14'!
isPopInto

	^#(#popIntoLiteralVariable: #popIntoReceiverVariable: popIntoTemporaryVariable:) 
		includes: selector! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/7/2007 23:23'!
isPush

	^#(#pushTemporaryVariable: 
	#pushReceiverVariable: 
	#pushReceiver 
	#pushLiteralVariable: 
	#pushConstant:
	#pushActiveContext) 
		includes: selector! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/7/2007 23:15'!
isStoreInto

	^#(#storeIntoLiteralVariable: #storeIntoReceiverVariable: storeIntoTemporaryVariable:) 
		includes: selector! !

!Message methodsFor: '*newcompiler' stamp: 'ms 9/7/2007 23:27'!
isTempVar

	^#(
	#popIntoTemporaryVariable: 
	#pushTemporaryVariable: 
	#storeIntoTemporaryVariable:) 
		includes: selector! !

InstructionStream subclass: #BytecodeDecompiler
	instanceVariableNames: 'irBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Bytecodes'!

!BytecodeDecompiler commentStamp: 'ajh 3/25/2003 00:26' prior: 0!
I interpret bytecode instructions, sending the appropriate instruction messages to my IRBuilder, resulting in an IRMethod.!

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 10/11/2004 15:21'!
blockReturnTop

	irBuilder blockReturnTop! !

!BytecodeDecompiler methodsFor: 'public access' stamp: 'md 2/25/2006 16:20'!
decompile: aCompiledMethod

	| ir |
	self method: aCompiledMethod pc: aCompiledMethod initialPC.
	irBuilder := IRBuilder new.
	irBuilder primitiveNode: aCompiledMethod primitiveNode.
	irBuilder numRargs: aCompiledMethod numArgs + 1.
	irBuilder addTemps: (0 to: aCompiledMethod numTemps).
	irBuilder properties: aCompiledMethod properties copy.

	aCompiledMethod isQuick
		ifTrue: [self quickMethod]
		ifFalse: [self interpret].
	ir := irBuilder ir.
	ir privCompiledMethod: aCompiledMethod.
	^ ir! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/10/2003 14:53'!
doDup

	irBuilder pushDup! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/10/2003 14:55'!
doPop

	irBuilder popTop! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 8/2/2005 17:11'!
interpretNextInstructionFor: client

	| byteIndex |
	byteIndex := pc - self method initialPC + 1.
	irBuilder mapToByteIndex: byteIndex.
	irBuilder testJumpAheadTarget: byteIndex.
	super interpretNextInstructionFor: client.
! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 9/29/2005 11:24'!
jump: dist

	| index seq instr newSeq seqs |
	index := pc + dist - self method initialPC + 1.
	dist >= 0 ifTrue: [
		"Maybe we are jumping over a non-closure Block." 
		(irBuilder currentSequence notEmpty and: [irBuilder currentSequence last isSend] and: [
			irBuilder currentSequence last selector == #blockCopy:]) ifTrue:
						[^irBuilder jumpOverBlockTo: index].
		"jump forward"
		^ irBuilder jumpAheadTo: index].

	"jump backward"
	seqs := irBuilder ir allSequences.
	seq := seqs findLast: [:s | s notEmpty and: [s first bytecodeIndex <= index]].
	seq := seqs at: seq.
	seq first bytecodeIndex = index ifTrue: [
		newSeq := seq.
	] ifFalse: [
		instr := seq detect: [:i | (seq after: i) bytecodeIndex = index].
		newSeq := seq splitAfter: instr.
	].
	irBuilder addJumpBackTarget: index to: newSeq.
	irBuilder jumpBackTo: index.
! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 13:59'!
jump: dist if: bool

	| index |
	index := pc + dist - self method initialPC + 1.
	dist >= 0 ifTrue: [
		"jump forward"
		^ irBuilder jumpAheadTo: index if: bool].

	self error: 'can only conditional jump forward'! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:34'!
methodReturnConstant: value

	self
		pushConstant: value;
		methodReturnTop! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:33'!
methodReturnReceiver

	self
		pushReceiver;
		methodReturnTop! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:31'!
methodReturnTop

	irBuilder returnTop! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 7/7/2005 14:12'!
popIntoLiteralVariable: offset

	self
		storeIntoLiteralVariable: offset;
		doPop! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:33'!
popIntoReceiverVariable: offset

	self
		storeIntoReceiverVariable: offset;
		doPop! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:34'!
popIntoTemporaryVariable: offset

	self
		storeIntoTemporaryVariable: offset;
		doPop! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:34'!
pushActiveContext

	irBuilder pushThisContext! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 3/29/2010 13:04'!
pushConstant: value
	irBuilder pushLiteral: value! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 7/9/2005 22:28'!
pushLiteralVariable: assoc

	irBuilder pushLiteralVariable: assoc.! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'MarcusDenker 3/29/2010 13:05'!
pushNewArrayOfSize: size
	irBuilder pushConsArray: size
! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:35'!
pushReceiver

	irBuilder pushReceiver! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 6/13/2005 13:58'!
pushReceiverVariable: offset

	Preferences compileBlocksAsClosures ifTrue: [self pushReceiver].
	irBuilder pushInstVar: offset + 1.
! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:36'!
pushTemporaryVariable: offset

	irBuilder pushTemp: offset + 1! !

!BytecodeDecompiler methodsFor: 'private' stamp: 'JorgeRessia 1/8/2010 12:04'!
quickMethod
	self halt.
	self method primitive = 256 ifTrue: [
		^ self methodReturnReceiver
	].
	self method isReturnSpecial ifTrue: [
		^ self methodReturnConstant: (BytecodeGenerator specialConstants at: self method primitive - 256)
	].
	self method isReturnField ifTrue: [
		self pushReceiverVariable: self method returnField.
		^ self methodReturnTop
	].
	self halt: 'quick method inconsistency'! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 6/20/2005 11:50'!
send: selector super: superFlag numArgs: numArgs

	selector == #privRemoteReturnTo: ifTrue: [^ irBuilder remoteReturn].
	superFlag
		ifTrue: [irBuilder send: selector toSuperOf: self method literals last value]
		ifFalse: [irBuilder send: selector]! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 7/7/2005 14:14'!
storeIntoLiteralVariable: value

	irBuilder storeIntoLiteralVariable: value! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'md 6/13/2005 14:01'!
storeIntoReceiverVariable: offset

	Preferences compileBlocksAsClosures ifTrue: [self pushReceiver].
	irBuilder storeInstVar: offset + 1.
! !

!BytecodeDecompiler methodsFor: 'instruction decoding' stamp: 'ajh 3/2/2003 11:39'!
storeIntoTemporaryVariable: offset

	irBuilder storeTemp: offset + 1! !

InstructionStream subclass: #InstructionCompare
	instanceVariableNames: 'otherStream bytecodeToInstruction1 bytecodeToInstruction2 mapTemp mapJump inst1 inst2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NewCompiler-Extras'!

!InstructionCompare class methodsFor: 'as yet unclassified' stamp: 'ms 9/6/2007 05:08'!
compaire: aMethod with: anOtherMethod 
	^ (self on: aMethod) compaireWith: anOtherMethod! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 02:07'!
bytceodeOffset1At: key
	^ (bytecodeToInstruction1 at: key) value! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 01:59'!
bytecode1At: key1 
	^ (bytecodeToInstruction1 at: key1) key! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 02:02'!
bytecode2At: key2 
	^ (bytecodeToInstruction2 at: key2) key! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 02:07'!
bytecodeOffset2At: key
	^ (bytecodeToInstruction2 at: key) value! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 02:08'!
checkJump
	mapJump keysAndValuesDo: 
			[:key1 :key2 | 
			((self bytecode1At: key1) = (self bytecode2At: key2) 
				or: 
					[self checkTempFor: (self bytecode1At: key1) and: (self bytecode2At: key2)]
				or: 
					[self 
						checkPopOptimizationNext1: [self bytecode1At: (self bytceodeOffset1At: key1)]
						next2: [self bytecode2At: (self bytecodeOffset2At: key2)]]
				or: 
					[(self bytecode1At: key1) isJump 
						and: [(self bytecode2At: key2) isJump]
						and: [(self bytecode1At: key1) sends: (self bytecode2At: key2) selector]
						and: 
							[(mapJump 
								at: (self bytecode1At: key1) argument + (self bytceodeOffset1At: key1)) 
									= ((self bytecode2At: key2) argument + (self bytecodeOffset2At: key2))]]) 
					ifFalse: [^ false]].
	^ true! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 11/7/2007 15:04'!
checkLiteral

	^(inst1 sends: inst2 selector) and: [(inst1 arguments 
		with: inst2 arguments 
		collect:[:arg1 :arg2 | arg1 literalEqual: arg2]) allSatisfy: [:each | each]]! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 01:50'!
checkPopOptimization

	^self checkPopOptimizationNext1: [self nextInstruction1 ] next2: [self nextInstruction2] ! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 01:50'!
checkPopOptimizationNext1: aBlock1 next2: aBlock2

	| popInst storeInst pushInst insts |
	((popInst := inst1) isPopInto and:[(storeInst := inst2) isStoreInto])
		ifTrue:[self atEnd ifTrue:[^false].
			pushInst := aBlock1 value.
			pushInst argument = popInst argument ifFalse:[^false].
			(insts := {pushInst. popInst. storeInst} allSatisfy: [:each | each isTemp])
				ifTrue:[^self temp: pushInst argument map: storeInst argument]]
		ifFalse:[((popInst := inst2) isPopInto and:[(storeInst := inst1) isStoreInto])
			ifTrue:[otherStream atEnd ifTrue:[^false].
				pushInst := aBlock2 value.
				pushInst argument = popInst argument ifFalse:[^false].
				(insts := {pushInst. popInst. storeInst} allSatisfy: [:each | each isTempVar])
					ifTrue:[^self temp: storeInst argument  map: pushInst argument]]
		  ifFalse:[^false]].
	
		(popInst argument = pushInst argument and: [popInst argument = storeInst argument]) ifFalse:[^false].
		(insts allSatisfy: [:each | each isInstVar]) ifTrue:[^true].
		(insts allSatisfy: [:each | each isLiteralVar]) ifTrue:[^true].
		^false	! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 01:03'!
checkTemp

	^ self checkTempFor: inst1 and: inst2! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 00:00'!
checkTempFor: instruction1 and: instruction2

	(instruction1 isAccessTemp and: [instruction2 isAccessTemp]
		and: [instruction2 sends: instruction1 selector]) 
			ifFalse: [^ false]
			ifTrue: [(self temp: instruction1 argument map: instruction2 argument) ifFalse: [^ false]].
	^ true! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 11/7/2007 15:01'!
compaireWith: anOtherMethod 
	otherStream := InstructionStream on: anOtherMethod.
	
	[self atEnd ~= otherStream atEnd ifTrue: [^ false].
	self atEnd] 
		whileFalse: [
			self nextInstruction1 = self nextInstruction2 ifFalse: [
				"check if the literal is equal (e.g. for Float nan)"
				self checkLiteral ifFalse:[
					"recodrde jump so we can post check the destination maping"
					self recordJump ifFalse: [
						"Check temp maping. Temp offset can be different"
						self checkTemp ifFalse: [
							"Some optimization from the compiler are missed"
							self checkPopOptimization ifFalse: [^ false]]]]]].
	^ self checkJump! !

!InstructionCompare methodsFor: 'initialize-release' stamp: 'ms 9/8/2007 01:25'!
initialize
	mapTemp := IdentityDictionary new.
	mapJump := IdentityDictionary new.
	bytecodeToInstruction1 := IdentityDictionary new.
	bytecodeToInstruction2 := IdentityDictionary new! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 01:23'!
nextInstruction1

	^inst1 := (bytecodeToInstruction1 at: self pc
							put: self nextInstruction -> self pc) key! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 01:22'!
nextInstruction2

	^inst2 := (bytecodeToInstruction2 at: otherStream pc
				 put: otherStream nextInstruction -> otherStream pc) key ! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/8/2007 01:16'!
recordJump
	(inst1 isJump and: [inst2 isJump] and: [inst1 sends: inst2 selector]) 
		ifTrue: 
			[mapJump at: inst1 argument + self pc put: inst2 argument + otherStream pc.
			^ true].
	^ false! !

!InstructionCompare methodsFor: 'as yet unclassified' stamp: 'ms 9/7/2007 23:29'!
temp: temp1 map: temp2 
	^ (mapTemp at: temp1 ifAbsentPut: [temp2]) = temp2! !

!RBReturnNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/8/2009 15:21'!
analyseTempsWithin: scopeBlock "<BlockNode>" rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"
	"Note we could do this:
		scopeBlock ~~ rootNode block ifTrue:
			[scopeBlock noteNonLocalReturn].
	 and pass up the flag in <BlockNode>>>analyseTempsWithin:rootNode:
	 which may be fast but will also give less information the debugger.
	 For now we consider clean blocks a premature optimization."
	self flag: 'consider clean blocks'.
	value analyseTempsWithin: scopeBlock rootNode: rootNode assignmentPools: assignmentPools! !

!RBReturnNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	^self value firstToken! !

!RBReturnNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	^self value lastToken! !

!RBReturnNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
binding

	^  self homeBinding! !

!RBReturnNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
homeBinding

	^ self propertyAt: #binding ifAbsent: [nil].! !

!RBReturnNode methodsFor: '*newcompiler-semantics' stamp: 'jorgeRessia 11/20/2009 16:40'!
homeBinding: aSemVar

	aSemVar ifNil: [^self removeProperty: #binding ifAbsent: []].
	self propertyAt: #binding put: aSemVar.! !

!RBLiteralValueNode methodsFor: '*newcompiler' stamp: 'JorgeRessia 1/10/2010 11:40'!
name
	^token value! !

!RBLiteralNode methodsFor: '*newcompiler' stamp: 'jorgeRessia 10/30/2009 15:37'!
analyseTempsWithin: scopeBlock "<BlockNode>"  rootNode: rootNode "<MethodNode>" assignmentPools: assignmentPools "<Dictionary>"! !

!RBLiteralNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicFirstToken
	
	^self token! !

!RBLiteralNode methodsFor: '*newcompiler-accessing-token' stamp: 'jorgeRessia 11/20/2009 16:40'!
basicLastToken
	
	^self token! !
Compiler initialize!
BytecodeGenerator initialize!
Parser2 initialize!
VariableNodeData initialize!
